var tscript=[
"rev:0.01 ", // overridden by #title2| below

"#color|#47d",
//"#kleckfile|090424-M00",
"#title|<span style='color:skyblue;font-weight:bold;font-size:160%;'>Scribe Editor Help</span>",	
"#title2|<span style='color:skyblue;font-size:100%;'>help doc rev 0.1 - rwc</span>",

//[0.1,999.98,"(music)"],	
//[999.99, 999.99, ""],
	
"h1|The Basics",
"<p>",
"Scribe files are written in JavaScript (hense the .js file extension).",
'The transcription statement is an array of 2 elements: [start-time, "display text"],',
'The old format is still supported [start-time, end-time, "display text"], but end-time is now ignored and can be deleted.',
'[12.1, "hello"], - Number 12.1 is a time in seconds. So highlight the text "hello" at the 12.1 seconds mark of the .mp3 or video.',
"</p>",

'<pre><code>// This is a comment and is not seen in the output</code>'
+'<br>[2.00,"Gordon\'s car"], <code>// this is ok</code>'
+'<br>[3.20,\'Sam\\\'s car\'], <code>  // also ok. The \\\ escapes the quote and is not displayed.</code>'
+'<br>[3.20,"another line], <code> // missing quote + comma = error</code></pre>',

'<pre><code>// Spaces and new lines do not affect output</code>'
+'<br>[2.00,"Gordon\'s car"],[3.20,"more text"], '
+'<br><br>   [3.20,"another line"],</pre>',
	
[2.00,"Gordon\'s car"],
[3.20,"more text"],
[3.20,"another line"],

'<pre><code>// Note: Scribe 1.04 (10th Oct 2021): Retired old format [start-time, stop-time, "text"]</code>'
+'<br><code>// New format is [start-time, "text"] since stop-time can be calculated by looking at next line.</code>'
+'<br>[2.00,"400 food"], <code>// At 2 secs the text is highlighted</code>'
+'<br>[3.00,"430 Elohim"], <code>// At 3 secs selection changes to 430 Elohim</code>'
+'<br>[4.00,5.00,"More Text"], <code>// At 4 secs.. This old format still works (backward compatible) but 5s stop-time is now ignored.</code>'
+'</pre>',
	
	
"h1|Formatting",
	
'<p>There are 2 types of scribe file lines:'
+'<br>1. Transcription info as described above - [12.12, "display text"],'
+'<br>2. String commands used to add formatting etc - "some text", '
+'<br>NOTE: use comments to add hidden coding notes - everything after // is ignored, and hidden in the scribe viewer. '
+'<br>Elements 1 &amp; 2 need to be separated by a comma or you get an error. </p>',
	
'Text strings must in double or single quotes. "string1", \'string2\', ' 
+'<br>Example: [12.1,"str1"], [13.1,\'str2\'], "str", \'str\', -- all valid scribe commands.  '
+'<br>A quoted string of one type can contain the other type. Otherwise escape the quote using \\ '
+"<br>\'my car\\\'s \"blue\" \', &nbsp;&nbsp;&nbsp;// is a valid string"
+'<br>"my car\'s \\\"blue\\\"",  &nbsp;&nbsp;&nbsp; // is also valid ',	

'<pre><code>// Add "h1|text", to add a heading and Table of Contents (top)</code><br>"h1|Formatting",</pre>',

'<pre><code>// Add "p", to create a paragraph. It just adds some space.</code>'
+'<br><code>// Scribe V1.06: An empty string will work too. So "p", = "",</code>'
+'<br>[2.00,"Gordon\'s car"],[3.20,"more text"], '
+'<br>"p",'
+'<br>[3.20,"another line"],</pre>',
	
[2.00,"Gordon\'s car"],
[3.20,"more text"],
"p",
[3.20,"another line"],

'<pre><code>// "bible|code|text", link to KleckFiles bible </code>'
+'<br>"bible|Isa 1:11|Isaiah Chapter 1 Verse 11",'
+'</pre>',	
"bible|Isa 1:11|Isaiah Chapter 1 Verse 11",	
		
'<pre><code>// "=", to mark the start &amp; end of a box around lines</code>'
+'<br>[3.20,"line 1"],'
+'<br>"=",'
+'<br>[5.20,"line 2"],'
+'<br>[6.20,"line 3"],'
+'<br>[7.20,"line 4"],'
+'<br>"=",'
+'<br>[8.20,"line 5"],'
+'</pre>',	

[3.20,"line 1"],
"=",
[5.20,"line 2"],
[6.20,"line 3"],
[7.20,"line 4"],
"=",
[8.20,"line 5"],
	
	
'<pre><code>// you can add "bible|ref|text", inside a box</code>'
+'<br><code>// you can add "text with H430" strongs that turn to links in a box</code>'
+'<br>[3.20,"line 1"],'
+'<br>"=",'
+'<br>"bible|gen 2|Genesis 2",'
+'<br>"Thus the heavensH8064 and the earthH776 were finished,H3615 and allH3605 the hostH6635 of them.",'
+'<br>"=",'
+'<br>[8.20,"line 5"],'
+'</pre>',	
	
[3.20,"line 1"],
"=",
"bible|gen 2|Genesis 2",
"Thus the heavensH8064 and the earthH776 were finished,H3615 and allH3605 the hostH6635 of them.",
"=",
[8.20,"line 5"],
	
	

"h1|Hyperlinks",	
	
'<pre><code>// "link|url|text", or "link|url", </code>'
+'<br>"link|http://kleckfiles.com|Go to www.kleckfiles.com",'
+'<br>"link|?editor_help.js|Reload this file",'
+'</pre>',
	
"link|http://kleckfiles.com|Go to www.kleckfiles.com",
"link|?editor_help.js|Reload this file",
	
'<pre><code>// "link|url1|url2|url3|text[1][2][3]{style}",</code>'
+'<br><code>// add as many URL as you want. link text in []. Container style {..} is optional. </code>'
+'<br>"link|*?editor_help.js|#|Commands: [reload file][top of file]{color:#eef;background-color:rgba(33,255,255,0.1);}",'
+'<br><code>// the * before a url will highlight the link item. </code>'
+'</pre>',	
	
"link|*?editor_help.js|#|Commands: [reload file][top of file]{color:#eef;background-color:rgba(33,255,255,0.1);}",

	
	
	
"h1|Advanced Code",	

'<pre><code>// Add HTML to your strings to format text.</code>'
+'<br>[2.00,"&lt;b&gt;this is bold text&lt;/b&gt;"], '
+'<br>[3.20,"another line"],'
+'<br>"This is free text with &lt;i&gt;italics&lt;/i&gt;",'
+'<br>"&lt;span style=\"color:#aaf\">This is blue text&lt;/span&gt;",'
+'</pre>',
	
[2.00,"<b>this is bold text</b>"],
[3.20,"another line"],
"This is free text with <i>italics</i>",
'<span style="color:#aaf">This is blue text</span>',
	
'<pre><code>// # commands</code>'
+'<br>"#color|#47d", <code>// sets the window base color -- #rgb or #rrggbb (Hex values)</code>'
+'<br>"#kleckfile|090424-M00", <code>// loads a KleckFiles media file (audio &amp; video)</code>'
+'</pre>',
	
'<pre>'
+'<code>// #title commands set the page title text.  </code>'
+'<br><code>// Symbol %title% if found will be replaced by the media title </code>'
+'<br>"#title|title text here - %title%",'
+'<br>"#title2|title 2 text here",'
+'<br><br><code>// Optionally include HTML &amp; CSS formatting. </code>'
+'<br>"#title|&lt;span style=\'color:skyblue;font-weight:bold;font-size:160%;\'&gt;Scribe Editor Help&lt;/span&gt;",	'
+'<br>"#title2|&lt;span style=\'color:skyblue;font-size:100%;\'&gt;help doc rev 0.1 - rwc&lt;/span&gt;",'
+'</pre>',
	
	
'<pre>'
+'<code>// Useful for inserting/reusing parts of another transcription</code>'
+'<br>"timeFudge|0", <code>// Set this to say 500.0 and everything that follows has 500 secs added to it.</code>'
+'</pre>',	
	
'<pre>'
+'<code>// Break long transcriptions into parts.</code>'
+'<br>"part|label", <code>// Set at top and anywhere you want to break a long document into sections.</code>'
+'</pre>',
	
	
""];
