﻿// Kleck file list 1.0 
// Initial Alpha Release: 2/02/2020 -- Released 1st Mar 2020
// Atribs: "A.B.C.D" ; A.B=Index into Color Map; C=1 Skip Autoplay (non-playlist)
// D = Scribe status = 1 m/c trans | 2 editing | 3 published | >3 same as 1
// File ID | Attrib | File Size | YouTube Link |  Rel Dir | Filename |  
// 27/5/2022 
//   C && 1 Skip Autoplay (non-playlist) -- Used in old system
//   C && 2 Alt title available (see Cory YT Channel list KF_EXTRA.js
//   C && 4 -- available

var _currentURL = document.location.href.split("?");

// Boolean: Portable Device Detection
var isMobile = Boolean(navigator.userAgent.match(/Android|webOS|iPhone|iPad|iPod|BlackBerry|BB|PlayBook|IEMobile|Mobile|Windows Phone|Kindle|Silk|Opera Mini/i));

// This web page is either http: https: (run from online) or file: (run offline on the PC)
var isHTTP = Boolean(window.location.protocol.substring(0, 4) == "http");

function GetUncapped() {
	// local?
	if (!isHTTP) return true; 
	// Parameter '=' found?
	if (_currentURL.length > 1 && _currentURL[1].split('&').includes('=')) return true;
   // <script src="html/KleckFilesData.js?v=4.01.18(a)&="> parameter "="
	var scripts = document.getElementsByTagName('script');
	var script = scripts[scripts.length - 1]; // this file will be the last entry
	var scriptURLs = script.src.split("?");
	if (scriptURLs.length > 1 && scriptURLs[1].split('&').includes('=')) return true;
	// not found 
	return false;
}

// Uncapped kleckfiles for local or "=" param
var isUncapped = GetUncapped();

// This hits the Internet ? Which is bad for fast offline work
// take a snapshot now -- on page load -- since they would need to refresh to go online (page load)
//var isOnline = window.navigator.onLine;



// PlayList Name | YT Address | [vid ref List]
// https://www.youtube.com/playlist?list=PL292DB98CF44AC084
// https://material.io/design/color/the-color-system.html#tools-for-picking-colors
var PlayLists = [
[ "You Are Exiles Complete DVD" , '', // "list=PLsqO5KBlCPjfdpSFE2rqoFQd1cv-uY4Ul",
 [ "170615-02"]],  
    
[ "Queen of Heaven - Mystery Babylon (Complete)" , '', //"list=PL292DB98CF44AC084",
 [ "120921-01", "120921-02", "120921-03", "120908", "140302", "160528", "160529-01"],
 [ 2, 4 ] // imgBar group terminator pos
 //[ "", "", "120921-03", "", "140302", "", ""] // imgbar group terminator
], 

[ "Destruction of America, Kingdom Divided, & Queen of Heaven", '', //'list=PLhQQPxoMFQIU3-c_wqxI7RhbSBa6Za8sR', //"list=PLAC04CF5D715B1FF5" or https://youtube.com/playlist?list=PLhQQPxoMFQIU3-c_wqxI7RhbSBa6Za8sR
 [ "130728", "111130", "111126-02", "111203", "111204-02", "111204-01", "111204-03", "111206", "120921-01", "120921-02", 
   "120921-03", "120902-01", "120923", "140114", "160529-01", "160529-02", "170407-P02",
   "170803", "170808", "170815-01", "170913", "170915", "170926", "120612-P03"],
 [ 7, 12, 15, 22 ] // imgBar group terminator pos
],
    
[ "Manifestations of the Hive Mind in the Real World", '', //"list=PLsqO5KBlCPjciE1J3362pReAy1sz10BHT",
 [ "130929", "130602", "120907", "130718", "120911", "130728", "131020", "120905-01", "120501", "120915",
   "120611", "111011", "120207", "140129", "140228", "140302", "140303", "160528", "160529-01", "170222-02",
   "170313-02", "170407-P02", "170516", "170520" ],
 [ 6, 12, 16 ] // imgBar group terminator pos
],
    
[ "Be4TheFire FULL Presentation (1 Hour)", "list=PL2E9F6AEAD63939E1",
 [ "120812-B01", "120812-B02", "120813-B03",
   "120814-B05", "120831-B06", "120901-B07", "120901-B08", "120903-B09", "120908-B10", "120908-B11",
   "120909-B13", "120910-B14", "120913-B15", "120914-B16", "140114", "160528", "160529-01" ],
 [ 13 ] // imgbar terminators
], 
    
//[ "Be4TheFire Website Playlist", "list=PL2E9F6AEAD63939E1",
// [ "120812-B01", "120812-B02", "120813-B03",
//   "120814-B05", "120831-B06", "120901-B07", "120901-B08", "120903-B09", "120908-B10", "120908-B11",
//   "120909-B13", "120910-B14", "120913-B15", "120914-B16"]], 
 
[ "Wheat & Tares / Sheep & Goats Explained", '', //"list=PLsqO5KBlCPjcTvQcYPzzJic_U47LfTTLd",
 [ "120909", "120901", "120910-02", "120911", "120913-01", "120207", "140302", "140303", "160528", "160529-01", "171210" ],
 [ 5, 9 ]
],
    
[ "The Antichrist Evidence: Barack Obama", '', //"list=PLsqO5KBlCPjd84XbpQcrjxlxT1yJaqLYt",
 [ "130213", "130214", "130112", "170407-P02", "170803", "171017", 
   "130127", "121012", "120905-01", "120916", "130206",  //"Deleted",
   "170808", "160528", "160529-01", "171118" ],
 [ 2, 5, 10 ]
],
    
[ "The ABC's of Exposing Satanic Symbolism", '', //"list=PLsqO5KBlCPjfwdpkocY_yOTqHf_eN0GAS",
  [ "130708", "130709", "130710", "130712", "130714-01", "130718", "130614-01", "130614-02", "170222-02" ],
[ 5 ]
], 
    
[ "The Hidden Spiritual World", '', //"list=PLsqO5KBlCPjecNVcQnKzvnuGCxDnX2Frd",
 [ "130614-01", "130614-02", "130718", "131015", "131020", "140114", "140223", "140228", "140302", "140303", 
   "160528", "160529-01", "170222-02", "170313-02", "170407-P02",
   "170529-01", "170601-01", "170919", "171017", "171104", "171105", "171112" ],
[ 4, 8, 11, 16 ]],
    
[ "The Vatican, Mary Worship, & Catholicism Exposed", '', //"list=PLsqO5KBlCPjfYN_LcAWccIxiW4HdieF_N",
 [ "130820", "130823-01", "130823-02", "130826", "130828" ]],
    
[ "Breath of Life DVD", '', //"list=PLsqO5KBlCPjcLOAAAw1jugK7bKMQJNZyW",
 [ "131003", "131004-01", "131004-02", "131004-03" ]], 
    
[ "The Whole Story Video Series", '', //"list=PLsqO5KBlCPjfdpSFE2rqoFQd1cv-uY4Ul",
 [ "170131-01", "170204", "170313-02", "170418", "170408-02", "170419-02", "170516", "170520", "170529-01", "170529-02",
   "170601-02", "170615-02", "170826", "170926"],
[ 5, 10 ]], 
    
[ "Shipping Container ALL Videos", '', //"list=PLsqO5KBlCPjfU5liH5jJLpSKJwrHVybAf",
 [ "170529-01", "170622", "170703-02", "170710", "170721-01", "170802-01", "170802-02", "170804", 
   "170806", "170814", "170819-01", "170831", "170903", "170906", "170907", "170909", "170911",
   "170913", "170915", "170917", "170921-02", "170926", "170930", "171001", "171002", "171007", 
   "171123", "171210" ],
[ 2, 8, 15, 18, 22 ]],
    
[ "Intro for New Subs: SYSTEM of CONTROL", '', //"list=PLsqO5KBlCPjfn-ShP-PHc6BvlXcRQIHTa", // Vid#1 found 171022 (added to KleckFiles)
 [ "171022", "171023-01", "171023-02", "171024", "171026-01", "171027", "171104" ]],
    
[ "Mystery SOLVED!!", '', //"list=PLsqO5KBlCPjdLDltLinQlj9e_D__r0ooE",
 [ "180813", "180817", "180821", "180904", "180905", "180810" ]],
    
[ "HERE is ALL the PROOF", '', //"list=PLsqO5KBlCPjf4hWQqGtmVjkcCpW8wvV0X",
 [ "180810", "180813"]],  
    
[ "JustaMessenger series", "list=PL649FB566437C77C0",
 [ "090424-M00","090424-M01","090424-M02","090424-M03","090424-M04","090424-M05",
   "090424-M06","090424-M07","090424-M08","090424-M09","090424-M10","090424-M11"]],
   
[ "Legal Series", '', //"list=PLNfDBl2sbmPATZF9Qsz7uG1bWsYFBpkIw", 
 [ "190715", "190716", "190718", "190720", "190722"]], 

[ "Michael's Playlist", '', //"list=PLNfDBl2sbmPAo0b1yn16gDXyYQV2uj9B_", 
 [ "170222-02", "131011", "170410-03", "170423-02", "170420", "170419-02",
   "170721-02", "140310", "180207", "180304-01", "180323-P04", "180622-02", "170115-P05"],
[ 4, 9 ]],

[ "THE DEFINITIVE Playlist", '', //"list=PLNfDBl2sbmPD7UPJtmFe11STtkh20K_9u", 
 [ "210423", "210424", "210428"]],

[ "MAN in OUR IMAGE series", '', //"list=PLNfDBl2sbmPCa6SR_D3ZzBJOpBAUadO8B", 
 [ "210405-01", "210405-02", "210405-03", "210406-01", "210406-02", "210407-01",
   "210407-02"]],
	
[ "The Enemy is at the Gate series", '', //"list=PLNfDBl2sbmPCa6SR_D3ZzBJOpBAUadO8B", 
 [ "140823", "140824", "140826-01", "140826-02", "140827-01", "140827-02",
   "140828", "140829-01", "140829-02", "140830", "140831", "140901", "140902" ]]

//[ "3rd Party Videos", "list=PLNfDBl2sbmPDRDcRXwKc0bVIJlQWpV97f", 
// [ "190709-P01", "170407-P02", "120612-P03" ]]     
];

	
var JumpBtns = [ // 1=Jump, 2=Filter; Text, Color[x,y]
   [1, "GoTo Latest", 6,2 ], 
];

function GetFileAttrib(idx, ret) {
   ret.length = 0;
   if (KleckFiles[idx][1].length >= DefaultAttrib.length) {
      var ss = KleckFiles[idx][1].split('.');
      if (ss.length >= 4) {
        try { 
          // Get the color -- "" if no color 
          var ci0 = parseInt(ss[0]);  // color index part 1
          var ci1 = parseInt(ss[1]);  // color index part 2
			 ret[0] = ColorMap[ci0][ci1]; 
          ret[1] = ss[2] === "1";   // 1 = play skip flaf (true)
		    ret[2] = ColorMap_UseWhiteText(ci0, ci1);   // true if use white 
		  }
        catch(err) { 
			  ret[0] = ""; 
		  }	
      }     
   }
   return ret.length;
}
var DefaultAttrib = "0.0.0.0";


// Only 2 surviving Playlists on YoutTube -- JustaMessenger & Be4TheFire



var KleckFiles = 
[
	
//==== JustaMessenger ====

["090424-M00", "1.2.0.3", "251.36|18.8 MB", "akCmiJotiSw", "JustaMessenger", "090424-M00 JustaMessenger.mp4"],
["090424-M01", "1.2.0.3", "568.56|28.4 MB", "JFMYCULm6-U", "JustaMessenger", "090424-M01 JustaMessenger Part 1.mp4"],
["090424-M02", "1.2.0.3", "610.22|30.3 MB", "2MO3bqC5X3s", "JustaMessenger", "090424-M02 JustaMessenger Part 2.mp4"],
["090424-M03", "1.2.0.3", "517.06|25.9 MB", "HLuVHIuc7fM", "JustaMessenger", "090424-M03 JustaMessenger Part 3.mp4"],
["090424-M04", "1.2.0.3", "558.39|25.2 MB", "NcZojqSSzeU", "JustaMessenger", "090424-M04 JustaMessenger Part 4.mp4"],
["090424-M05", "1.2.0.3", "579.06|26.3 MB", "vPjs3iCLtvU", "JustaMessenger", "090424-M05 JustaMessenger Part 5.mp4"],
["090424-M06", "1.2.0.3", "558.46|26.5 MB", "7DjqC-zOCpg", "JustaMessenger", "090424-M06 JustaMessenger Part 6.mp4"],
["090424-M07", "1.2.0.3", "579.06|35.4 MB", "Jc2QdnSy16c", "JustaMessenger", "090424-M07 JustaMessenger Part 7.mp4"],
["090424-M08", "1.2.0.3", "599.77|26.7 MB", "eVPrrxEdY8Y", "JustaMessenger", "090424-M08 JustaMessenger Part 8.mp4"],
["090424-M09", "1.2.0.3", "558.39|26.3 MB", "dItO9eTE9Do", "JustaMessenger", "090424-M09 JustaMessenger Part 9.mp4"],
["090424-M10", "1.2.0.3", "579.13|28.9 MB", "kRJLQ6nc1UI", "JustaMessenger", "090424-M10 JustaMessenger Part 10.mp4"],
["090424-M11", "1.2.0.3", "475.73|21.8 MB", "RzHqNsHKqM4", "JustaMessenger", "090424-M11 JustaMessenger Part 11.mp4"],

//==== Be4TheFire ====

["120812-B01", "0.0.0.3", "114.73|18.9 MB", "pP2vp-Aaseg", "Be4TheFire", "120812-B01 1. The Story of GENESIS - PART I.mp4"],
["120812-B02", "0.0.0.3", "90.93|13.5 MB", "ic_AJWmi9-w", "Be4TheFire", "120812-B02 2. The Story of GENESIS - PART II.mp4"],
["120813-B03", "0.0.0.3", "110.06|12.5 MB", "m76xNnmTKMA", "Be4TheFire", "120813-B03 3. The Story of GENESIS - PART III.mp4"],
["120813-B04", "1.0.1.3", "310.89|60.7 MB", "722w4mrGFoQ", "Be4TheFire", "120813-B04 The Story of GENESIS (Parts I-III).mp4", "note: A repeat"],
["120814-B05", "0.0.0.3", "215.97|24.3 MB", "2m8gB8Mlp8Q", "Be4TheFire", "120814-B05 4. Corruption of The Tree of Life.mp4"],
["120831-B06", "0.0.0.3", "231.34|42.4 MB", "dJBvEmPh1x8", "Be4TheFire", "120831-B06 5. Hieroglyph Decryption 1 - The Creature.mp4"],
["120901-B07", "0.0.0.3", "245.57|47.9 MB", "eXbjs3-vxwA", "Be4TheFire", "120901-B07 6. Hieroglyph Decryption 2 - Half & Half.mp4"],
["120901-B08", "0.0.0.3", "212.86|36.9 MB", "Jbmd2sV7yj8", "Be4TheFire", "120901-B08 7. Old Testament - Slaves To Sin.mp4"],
["120903-B09", "0.0.0.3", "376.49|59.3 MB", "MqijaFvXln4", "Be4TheFire", "120903-B09 8. Be Reconciled to God Through Jesus Christ.mp4"],
["120908-B10", "0.0.0.3", "402.17|64.3 MB", "1ZiRD_X1AYE", "Be4TheFire", "120908-B10 9. What's Printed on the U.S. Currency.mp4"],
["120908-B11", "0.0.0.3", "281.75|48.9 MB", "OEdCHUV_C2I", "Be4TheFire", "120908-B11 10. Rise of the Second Beast in Babylon the Great.mp4"],
["120908-B12", "1.0.1.0", "475.61|105 MB", "ZlbNaMS_uig", "Be4TheFire", "120908-B12 Hieroglyph Decryption - Full (Parts 5 - 6).mp4", "note: A repeat"],
["120909-B13", "0.0.0.3", "393.28|43.7 MB", "hCKFLFkVI9I", "Be4TheFire", "120909-B13 11. Wheat & Tares - The Hive Mind.mp4"],
["120910-B14", "0.0.0.3", "267.12|50.8 MB", "C8ZXrKdrKAY", "Be4TheFire", "120910-B14 12. The Signs of Thy Coming & The End of the Age.mp4"],
["120913-B15", "0.0.0.3", "149.7|22.1 MB", "5YsQrzBComo", "Be4TheFire", "120913-B15 13. The End.mp4"],
["120914-B16", "0.0.0.3", "450.47|73.7 MB", "LYOR7w4Lg8Y", "Be4TheFire", "120914-B16 14. Judgment & Salvation.mp4"],
["121022-B17", "0.0.0.3", "898.52|181 MB", "TgjL0hmMsGU", "Be4TheFire", "121022-B17 Full Analysis of False Flag Events on US Currency.mp4"],
["140107-B18", "0.0.0.3", "256.26|21.4 MB", "caaPxrSAtGU", "Be4TheFire", "140107-B18 Daniel & Belshazzar - God's Handwriting on the Wall.mp4"],

//==== 3rdParty ====

["111111-F01", "6.5.0.0", "0|0", "", "3rdParty", "111111-F01 JKClips.mp4", '*JK Clips Folder|@A collection of Kleck mini clips maintained by Dave Shadow<br>View the <a href="diags.html?clips" target="_blank">/video/JKClips/</a> folder'],
	
["190709-P01", "1.2.0.0", "730.5|65.4 MB", "*LC9v5nAhcrI", "3rdParty", "190709-P01 Know Your Enemy END TIME Message by Jonathan Kleck$by$This Goes Out To You.mp4", "YouTube: This Goes Out To You"],
["170407-P02", "1.2.0.0", "1852.3|226 MB", "", "3rdParty", "170407-P02 Shadow Government Trigger World War 3 To Cover Up The Truth$by$FaithfulBerean.mp4", "YouTube: FaithfulBerean"],
["120612-P03", "1.2.0.0", "8593.61|497 MB", "", "3rdParty", "120612-P03 Destruction of America (Full length movie)$by$Jason Cox.mp4", "YouTube: Jason Cox"],
["180323-P04", "1.2.0.0", "799.83|94.2 MB", "*z_hAsOaG5XU", "3rdParty", "180323-P04 YOU in a WORLD UPSIDE DOWN by Jonathan Kleck MUST SEE$by$This Goes Out To You.mp4", "YouTube: This Goes Out To You"],
["170115-P05", "1.2.0.0", "6138.24|94.2 MB", "*oebvP1lNRjA", "3rdParty", "170115-P05 ZEN GARCIA & JONATHAN KLECK - The Riddle of ALL Things$by$SavedbyGrace0909.mp4", "YouTube: SavedbyGrace0909"],
//["200424-P06", "1.2.0.0", "12417.03|1.87 GB", "*cN0k7cpFU3Y", "3rdParty", "200424-P06 Mystery of Life Souls are Hunted to Birth Locusts in Pit- Frequencies -26 Mind -26 Matter$by$Richard Montbleau.mp4", "YouTube: Richard Montbleau"],
["210124-P07", "1.2.0.0", "4600.04|579 MB", "*E-zTPIvWO0Q", "3rdParty", "210124-P07 Part1-KNOW the SCRIPTURES (with captions).mp4", "YouTube: KleckFiles"],
["210501-P08", "1.3.0.0", "19031.19|678 MB", "*gO4xe-EV_N4", "3rdParty", "210501-P08 X-Factor Winner Reveals World-s Secret Religion.mp4", "Altiyan Childs whistle blower for the Lord God"],
["220413-P09", "1.3.0.0", "9741.35|614 MB", "", "3rdParty", "220413-P09 All 3 Parts - Dr. Bryan Ardis reveals BOMBSHELL origins of covid, mRNA vaccines and treatments.mp4", "Brighteon: Health Ranger Report by Mike Adams"],
["140225-P10", "1.3.0.0", "1701.3|111 MB", "*aS19wuJtYuo", "3rdParty", "140225-P10 American Arrogance - Antichrist-s Arrival Through Nuclear War.mp4", "YouTube: FaithfulBerean"],
["220805-P11", "2.2.0.3", "2470.06|259 MB", "", "3rdParty", "220805-P11 2022 SATANIC RITUAL OPENING CEREMONY - RED PILL COMENTARY.mp4", "*AlistairWilliams|@Video and commentary by AlistairWilliams<br>Original Post: https://rumble.com/v1e2en1-2022-satanic-ritual-opening-ceremony-red-pill-comentary.html"],
["220805-P12", "2.2.0.3", "2470.06|276 MB", "", "3rdParty", "220805-P12 2022 SATANIC RITUAL OPENING CEREMONY - BBC COMENTARY.mp4", "*BBC|@Video edit by AlistairWilliams. Original BBC commentary"],
["230306-P13", "2.2.2.0", "2470.06|23.3 MB", "", "3rdParty", "230306-P13 100-nylon or is it 100-no-lyn (lying).mp4", "*by 73marbren|@The importance of 100% truth!...melt me, mold me, fill me, use me.  Jesus Christ IS THE TRUTH."],
["230309-P14", "2.2.0.0", "1471.82|244 MB",  "MWVRNITBb9s", "3rdParty",  "230309-P14 Angels to Humans to Locusts.mp4", "*produced by Alissa Howard" ],

//==== 2010 ====

["100217-01",  "0.0.0.0", "586.84|27.5 MB", "", "2010", "100217-01 New World Order Nephilim World 1.mp4"],
["100217-02",  "0.0.0.0", "588.79|39.1 MB", "", "2010", "100217-02 New World Order Nephilim World 2.mp4"],
["100217-03",  "0.0.0.0", "588.86|26.4 MB", "", "2010", "100217-03 New World Order Nephilim World 3.mp4"],
["100218",     "1.0.0.0", "586.81|27.4 MB", "", "2010", "100218 Second Coming of Jesus Christ Prophecy countdown 1.mp4", "note: Similar to #1?"],
["100313-01",  "0.0.0.0", "583.01|35.7 MB", "", "2010", "100313-01 Part 1 The New World Order. The KEYS to the Kingdom of Heaven You decide.mp4"],
["100313-02",  "0.0.0.0", "577.76|36.4 MB", "", "2010", "100313-02 Part 2 The New World Order. The KEYS to the Kingdom of Heaven You decide.mp4"],
["100313-03",  "0.0.0.0", "593.06|33.9 MB", "", "2010", "100313-03 Part 3 The New World Order. The KEYS to the Kingdom of Heaven You decide.mp4"],
["100313-04",  "0.0.0.0", "527.05|41.2 MB", "", "2010", "100313-04 Part 4 The New World Order. The KEYS to the Kingdom of Heaven You decide.mp4"],
["100626",     "1.2.0.0", "586.75|27.1 MB", "", "2010", "100626 BP Oil Spill U S under attack false flag.mp4"],
["101108",     "0.0.0.0", "132.63|10.2 MB", "", "2010", "101108 preview of the Mayan calander.mp4"],
["101111-01",  "0.0.0.0", "568.54|44.2 MB", "", "2010", "101111-01 mayan decrypyion Part 1.mp4"],
["101111-02",  "0.0.0.0", "432.24|33.6 MB", "", "2010", "101111-02 mayan decryption Part 2.mp4"],
["101111-03",  "0.0.0.0", "877.83|47.7 MB", "", "2010", "101111-03 mayan decryption Part 3.mp4"],
["101111-04",  "0.0.0.0", "572.19|44.5 MB", "", "2010", "101111-04 mayan decryption Part 4.mp4"],

//==== 2011 ====

["110123-01",  "1.4.0.0", "590.92|25.3 MB", "", "2011", "110123-01 Final Warning Part 1.mp4"],
["110123-02",  "1.4.0.0", "608.85|26.3 MB", "", "2011", "110123-02 Final Warning Part 2.mp4"],
["110123-03",  "1.4.0.0", "596.89|16.2 MB", "", "2011", "110123-03 Final Warning Part 3.mp4"],
["110123-04",  "1.4.0.0", "599.68|27.3 MB", "", "2011", "110123-04 Final Warning Part 4.mp4"],
["110123-05",  "1.4.0.0", "597.58|25.8 MB", "", "2011", "110123-05 Final Warning Part 5.mp4"],
["110123-06",  "1.4.0.0", "604.16|26.4 MB", "", "2011", "110123-06 Final Warning Part 6.mp4"],
["110123-07",  "1.4.0.0", "591.83|28.4 MB", "", "2011", "110123-07 Final Warning Part 7.mp4"],
["110123-08",  "1.4.0.0", "389.99|15.6 MB", "", "2011", "110123-08 Final Warning Part 8.mp4"],
["110204",     "1.2.0.0", "7320.21|123 MB", "", "2011", "110204 FallenAngels.tv Final Warning Show.mp4", "Zen Garcia - FallenAngels.tv"],
["110311",     "1.4.0.0", "817.71|35.2 MB", "", "2011", "110311 Final Warning - Prepare the Way of the Lord.mp4"],
["110418",     "2.2.0.0", "979.55|61.6 MB", "", "2011", "110418 SDV 0123.mp4", "note: DNA encoding found in Egyptian artwork."],
["110428-01",  "2.2.0.0", "938.09|66.6 MB", "", "2011", "110428-01 destruction of the temple.mp4"],
["110428-02",  "2.2.0.0", "768.62|65.2 MB", "", "2011", "110428-02 destruction of the temple 2.mp4"],
["110428-03",  "2.2.0.0", "1297.98|104 MB", "", "2011", "110428-03 destruction of the temple 3.mp4"],
["110511",     "1.3.0.0", "979.32|52.2 MB", "", "2011", "110511 New Prophecy - Time to Stand Fast.mp4"],
["110514-01",  "1.2.0.0", "1091.59|94.0 MB", "", "2011", "110514-01 HAARP New Madrid Attack on Dollar Bills.mp4"],
["110514-02",  "1.2.0.0", "1107.48|97.3 MB", "", "2011", "110514-02 New Madrid HAARP Attack on Dollar Bills.mp4"],
["110520-01",  "1.2.0.0", "1354.54|84.4 MB", "", "2011", "110520-01 More hidden images on US currency and false flags.mp4"],
["110521-02",  "1.2.0.0", "363.58|22.0 MB", "", "2011", "110521-02 More hidden images on US currency and false flags part 2 cut short.mp4"],
["110616-01",  "0.0.0.0", "1465.6|69.6 MB", "", "2011", "110616-01 End of the age- Second Coming of Jesus.mp4"],
["110616-02",  "0.0.0.0", "317.43|17.9 MB", "", "2011", "110616-02 ABCs on getting saved by Jesus the Messiah.mp4", "note: Chris part 1"],
["110621-01",  "0.0.0.0", "1345.53|88.5 MB", "", "2011", "110621-01 Jesus is Coming!!!!Get Your Heart Ready. Get Saved.mp4"],
["110621-02",  "0.0.0.0", "588.67|27.0 MB", "", "2011", "110621-02 SDV_0136.mp4", "note: Chris part 2"],
["110624",     "0.0.0.0", "722.67|45.6 MB", "", "2011", "110624 Chris on how to pray.mp4", "note: Chris part 3"],
["110629-01",  "0.0.0.0", "1225.22|79.3 MB", "", "2011", "110629-01 Behold the great wall which holds back the abundance of the rivers shall burst forth.mp4"],
["110629-02",  "0.0.0.0", "671.31|32.2 MB", "", "2011", "110629-02 choose life.mp4", "note: Chris part 4"],
["110702",     "0.0.0.0", "1573.25|99.2 MB", "", "2011", "110702 atlantis launch july 7 unveiling the challenger conspiracy 3 unclean spirits.mp4"],
["110710-01",  "0.0.0.0", "867.13|41.5 MB", "", "2011", "110710-01 preview of new series.mp4"],
["110710-02",  "0.0.0.0", "342.45|17.6 MB", "", "2011", "110710-02 SDV 0143.mp4", "note: About Chris"],
["110711-01",  "1.2.0.0", "385.4|18.8 MB", "", "2011", "110711-01 jonathan's personal testimony part 1.mp4"],
["110711-02",  "1.2.0.0", "599.82|28.8 MB", "", "2011", "110711-02 jonathan's personal testimony part 2.mp4"],
["110711-03",  "1.2.0.0", "236.56|17.4 MB", "", "2011", "110711-03 jonathan's personal testimony part 3.mp4"],
["110711-04",  "1.2.0.0", "111.78|8.76 MB", "", "2011", "110711-04 jonathan's personal testimony part 4.mp4"],
["110712-01",  "1.2.0.0", "1118.27|85.7 MB", "", "2011", "110712-01 Jonathan's testimony part 5.mp4"],
["110712-02",  "1.3.0.0", "883.15|44.2 MB", "", "2011", "110712-02 continuing disclosure.mp4"],
["110713-01",  "1.3.0.0", "460.91|26.3 MB", "", "2011", "110713-01 Continuing disclosure part 2 sheep and goats pyramid is the enemy.mp4"],
["110713-02",  "1.3.0.0", "481.31|23.1 MB", "", "2011", "110713-02 continuing disclosure part 3 sheep and goats pyramid is the enemy.mp4"],
["110714-01",  "1.3.0.0", "1402.11|88.8 MB", "", "2011", "110714-01 continuing disclosure part 4 sheep and goats pyramid is the enemy.mp4"],
["110714-02",  "1.3.0.0", "1177.7|71.1 MB", "", "2011", "110714-02 Continuing disclosure part 5.mp4"],
["110716-01",  "0.0.0.0", "1309.49|82.1 MB", "", "2011", "110716-01 Mystery SOLVED part 1.mp4"],
["110716-02",  "0.0.0.0", "1382.42|113 MB", "", "2011", "110716-02 Mystery SOLVED Part 2.mp4"],
["110716-03",  "0.0.0.0", "1442.14|86.1 MB", "", "2011", "110716-03 Mystery SOLVED Part 3.mp4"],
["110716-04",  "0.0.0.0", "1195.26|67.4 MB", "", "2011", "110716-04 Chris on Judgement and Grace.mp4"],
["110716-05",  "0.0.0.0", "1179.31|88.2 MB", "", "2011", "110716-05 Mystery Solved Part 4.mp4"],
["110716-06",  "0.0.0.0", "1213.2|78.3 MB", "", "2011", "110716-06 Mystery Solved Part 5.mp4"],
["110718",     "1.2.0.0", "414.13|20.6 MB", "", "2011", "110718 Liberty Broadcasting Network show TONIGHT!!! LET'S TALK.mp4"],
["110719",     "1.2.0.0", "384.07|21.5 MB", "", "2011", "110719 Liberty Broadcasting Network show tonight. U. S. Currency Images of BOMBINGS.mp4"],
["110724",     "1.2.0.0", "672.78|33.8 MB", "", "2011", "110724 Bezcore on LIberty Broadcasting Network Monday 9-11 pm.mp4"],
["110802",     "1.2.0.0", "1598.35|78.0 MB", "", "2011", "110802 On the ROCK,,, Jesus.mp4"],
["110805",     "1.2.0.0", "1472.44|112 MB", "", "2011", "110805 Abomination of Desolation Revealed,,Son of Perdition.mp4"],
["110810",     "1.2.0.0", "290.39|22.0 MB", "", "2011", "110810 Join Jonathan, Chris, and Rick to unravel the mystery of iniquity. we're ringing the BELL.mp4"],
["110814",     "1.2.0.0", "1287.52|71.0 MB", "", "2011", "110814 The hidden world in front of your face. The mystery of iniquity.mp4"],
["110822",     "0.0.0.0", "1901.32|87.2 MB", "", "2011", "110822 Time to wake up. Time to get right with the Lord. Time to Love one another and forgive one another.mp4"],
["110903",     "0.0.0.0", "1236.17|99.3 MB", "", "2011", "110903 SOUND THE ALARM!!!!! 1.mp4"],
["110904-01",  "0.0.0.0", "1598.76|108 MB", "", "2011", "110904-01 SOUND THE ALARM!!!!! 2.mp4"],
["110904-02",  "0.0.0.0", "1212.41|100 MB", "", "2011", "110904-02 SOUND THE ALARM!!!!! 3.mp4"],
["110916",     "0.0.0.0", "1565.57|109 MB", "", "2011", "110916 This is it.mp4"],
["110917",     "0.0.0.0", "1918.35|142 MB", "", "2011", "110917 This is it Part 2.mp4"],
["110923",     "0.0.0.0", "2006.2|123 MB", "", "2011", "110923 Prepare the way !!!!! Here it all is in summary.mp4"],
["111004",     "0.0.0.0", "1107.94|66.7 MB", "", "2011", "111004 Personal update to friends and subscribers.mp4"],

["111008-01",  "1.2.0.0", "1309.61|92.6 MB", "", "2011", "111008-01 communication with the Lord God 101.mp4"],
["111008-02",  "1.2.0.0", "1550.35|129 MB", "", "2011", "111008-02 communication with the Lord God 101 part 2.mp4"],
["111009",     "1.2.0.0", "1657.99|115 MB", "", "2011", "111009 communication with the Lord God 101 part 3.mp4"],
["111011",     "1.2.0.0", "893.86|59.2 MB", "", "2011", "111011 All seeing eye and Obama at ground zero = new species.mp4"],
["111012",     "1.2.0.0", "1425.13|75.6 MB", "", "2011", "111012 What are the odds of all of this.mp4"],
["111013",     "1.2.0.0", "1439.1|85.7 MB", "", "2011", "111013 11-11-11 is it the NWO's Birth Yet.mp4"],
["111016",     "1.2.0.0", "2108.88|145 MB", "", "2011", "111016 Looks like the Target IS the HOOVER DAM.mp4"],

["111019-02",  "2.0.0.0", "2028.82|129 MB", "", "2011", "111019-02 hoover dam catastrophe and the NWO BIRTH part 1.mp4"],
["111019-03",  "2.0.0.0", "2156.65|139 MB", "", "2011", "111019-03 hoover dam catastrophe and the NWO BIRTH part 2.mp4"],
["111019-01",  "2.0.0.0", "852.78|46.5 MB", "", "2011", "111019-01 hoover dam catastrophe and the NWO BIRTH part 3.mp4"],
["111026",     "2.0.0.0", "1611.53|77.9 MB", "", "2011", "111026 11-11 Unleash the beast NWO.mp4"],
["111107-01",  "2.0.0.0", "1736.81|128 MB", "", "2011", "111107-01 Hoover Dam update and encouragement Part 1.mp4"],
["111107-02",  "2.0.0.0", "2087.2|156 MB", "", "2011", "111107-02 Hoover Dam update and encouragement Part 2.mp4"],
["111111",     "2.0.0.0", "312.33|16.6 MB", "", "2011", "111111 What Do You Know Are You in the Rabbit Hole with the Masses.mp4"],
["111112-01",  "2.0.0.0", "1854.48|130 MB", "", "2011", "111112-01 Hoover Dam Not YET !!!! Part 1.mp4"],
["111112-02",  "2.0.0.0", "1066.12|47.0 MB", "", "2011", "111112-02 Hoover Dam NotYET !!!! Part 2.mp4"],
["111114",     "2.0.0.0", "2123.35|141 MB", "", "2011", "111114 time to take this to the studio and do it professionally.mp4"],

["111118-01",  "1.0.0.0", "399.24|30.2 MB", "", "2011", "111118-01 Update on DVD and more info coming in part 2.mp4"],
["111118-02",  "1.0.0.0", "1433.93|99.7 MB", "", "2011", "111118-02 Update on DVD and more info coming in part1.mp4"],
["111122-01",  "1.0.0.0", "503.46|31.1 MB", "", "2011", "111122-01 Production update for DVD.mp4"],
["111122-02",  "1.0.0.0", "89.58|5.08 MB", "", "2011", "111122-02 Production update for DVD Part 2.mp4"],
["111124-01",  "1.0.0.0", "251.59|13.9 MB", "", "2011", "111124-01 update on dvd.mp4"],
["111126-01",  "1.0.0.0", "664.53|39.6 MB", "", "2011", "111126-01 Final week update.mp4"],
["111127",     "1.0.0.0", "380.09|28.2 MB", "", "2011", "111127 update on Part 1 No Worries.mp4"],
["111128",     "1.0.0.0", "899.03|63.4 MB", "", "2011", "111128 Update on Part 1 and conversion.mp4"],
["111130",     "2.0.0.3", "1671.44|101 MB", "", "2011", "111130 (1)Kingdom Divided- Out of the Darkness + Into the Light - PART 1.mp4"],
["111126-02",  "2.0.0.3", "1775.4|94.2 MB", "", "2011", "111126-02 (2)Kingdom Divided- Out of the Darkness + Into the Light - PART 2.mp4"],
["111203",     "2.0.0.3", "1761.49|92.6 MB", "", "2011", "111203 (3)Kingdom Divided- Out of the Darkness + Into the Light - PART 3.mp4"],
["111204-02",  "2.0.0.3", "1782.9|110 MB", "", "2011", "111204-02 (4)Kingdom Divided- Out of the Darkness + Into the Light - PART 4.mp4"],
["111204-01",  "2.0.0.3", "1746.28|104 MB", "", "2011", "111204-01 (5)Kingdom Divided- Out of the Darkness + Into the Light - PART 5.mp4"],
["111204-03",  "2.0.0.3", "1730.19|109 MB", "", "2011", "111204-03 (6)Kingdom Divided- Out of the Darkness + Into the Light - PART 6.mp4"],
["111206",     "2.0.0.3", "979.44|57.8 MB", "", "2011", "111206 (7)Kingdom Divided- Out of the Darkness + Into the Light - PART 7.mp4"],
["111204-04",  "2.0.0.0", "918.88|40.3 MB", "", "2011", "111204-04 DVD ready to go this week Send your self addressed STAMPED envelope.mp4"],
["111207",     "2.0.0.0", "1718.11|103 MB", "", "2011", "111207 Something REALLY weird happened today !!! This is a fun video and mind blowing.mp4"],
["111213",     "2.0.0.0", "379.88|25.1 MB", "", "2011", "111213 dvd final edit.mp4"],
["111218",     "2.0.0.0", "1497.25|96.2 MB", "", "2011", "111218 Have to move now with the current master. Under attack constantly.mp4"],
["111221",     "2.0.0.0", "1601.48|102 MB", "", "2011", "111221 HERE IT COMES !!!! DVD and Something's gotta give.mp4"],
["111224",     "2.0.0.0", "1006.12|67.9 MB", "", "2011", "111224 dvd is ready! Stay Ready! Keep your eyes on JESUS.mp4"],

//==== 2012 ====

["120105",     "0.0.0.0", "1917.02|92.9 MB", "", "2012", "120105 34Jesus answered them, Is it not written in your law, I said, Ye are gods.mp4"],
["120107",     "0.0.0.0", "2100.38|122 MB", "", "2012", "120107 SACRIFICE TO USHER IN THE NEW WORLD ORDER.mp4"],
["120109",     "0.0.0.0", "1943|107 MB", "", "2012", "120109 THIS IS IT Testimony.mp4"],
["120112",     "0.0.0.0", "2231.88|159 MB", "", "2012", "120112 Up and rolling and new currency information.Get Ready!!!.mp4"],
["120116",     "0.0.0.0", "2222.68|127 MB", "", "2012", "120116 US currency revisited and thisisit4321 Open House Radio show tonight.mp4"],
["120124",     "0.0.0.0", "2221.2|156 MB", "", "2012", "120124 Treasures of Darkness.mp4"],
["120126",     "0.0.0.0", "709.09|43.1 MB", "", "2012", "120126 Alien communication interception. Invasion imminent.mp4"],
["120202",     "0.0.0.0", "1356.09|93.9 MB", "", "2012", "120202 Ezekiel 34 The Shepards.mp4"],
["120207",     "0.0.0.0", "1540.32|84.0 MB", "", "2012", "120207 The Hive.mp4"],
["120219",     "0.0.0.0", "44.88|3.73 MB", "", "2012", "120219 Alien Exposure Trailer 2.mp4"],
["120222",     "0.0.0.0", "1794.3|116 MB", "", "2012", "120222 Images for the Alexander Bachman radio show.mp4"],
["120224",     "0.0.0.0", "1685.79|97.6 MB", "", "2012", "120224 The Virgin,Reptiles and You and Me.mp4"],
["120304",     "0.0.0.0", "753.7|40.0 MB", "", "2012", "120304 DVD !!! The Virgin, Reptiles. and God's Remedy. Jesus Christ.mp4"],
["120314",     "0.0.0.0", "600|46.6 MB", "", "2012", "120314 DVD UPDATE.mp4"],
["120318",     "0.0.0.0", "957.87|41.7 MB", "", "2012", "120318 DVD Update 2 & Clip - Director's Cut of Queen of Heaven Mystery Babylon.mp4"],
["120327-01",  "1.2.0.0", "876.72|45.1 MB", "", "2012", "120327-01 MYSTERY BABYLON Part 1.mp4"],
["120327-02",  "1.2.0.0", "869.98|47.6 MB", "", "2012", "120327-02 MYSTERY BABYLON Part 2.mp4"],
["120327-03",  "1.2.0.0", "863.71|51.2 MB", "", "2012", "120327-03 MYSTERY BABYLON Part 3.mp4"],
["120327-04",  "1.2.0.0", "545.16|31.4 MB", "", "2012", "120327-04 HERE IT COMES. Jump in if you can. God Bless All of You.mp4"],
["120327-05",  "1.2.0.0", "882.61|46.8 MB", "", "2012", "120327-05 MYSTERY BABYLON Part 4.mp4"],
["120327-06",  "1.2.0.0", "874.79|47.9 MB", "", "2012", "120327-06 MYSTERY BABYLON Part 5.mp4"],
["120327-07",  "1.2.0.0", "886.91|54.7 MB", "", "2012", "120327-07 MYSTERY BABYLON Part 6.mp4"],
["120327-08",  "1.2.0.0", "893.27|50.0 MB", "", "2012", "120327-08 MYSTERY BABYLON Part 7.mp4"],
["120327-09",  "1.2.0.0", "873.35|51.2 MB", "", "2012", "120327-09 MYSTERY BABYLON Part 8.mp4"],
["120327-10",  "1.2.0.0", "882.66|41.0 MB", "", "2012", "120327-10 MYSTERY BABYLON Part 9.mp4"],
["120327-11",  "1.2.0.0", "893.32|39.0 MB", "", "2012", "120327-11 MYSTERY BABYLON Part 10.mp4"],
["120327-12",  "1.2.0.0", "899.17|48.8 MB", "", "2012", "120327-12 MYSTERY BABYLON Part 11 End.mp4"],

["120401",     "0.0.0.0", "851.38|38.0 MB", "", "2012", "120401 HERE IT COMES!!!! DVD and Something else!!!.mp4"],
["120412",     "0.0.0.0", "253.49|54.8 MB", "", "2012", "120412 What Jesus Did For Everyone.mp4"],
["120414",     "0.0.0.0", "1733.14|256 MB", "", "2012", "120414 I Wilt Drageth thee Across the Finish Line by thy Shoelaces.mp4"],
["120416",     "0.0.0.0", "366.85|59.0 MB", "", "2012", "120416 Get Ready To GO!.mp4"],
["120425",     "0.0.0.0", "715.36|42.3 MB", "", "2012", "120425 Here is the Question. We already have the answer.mp4"],
["120426",     "0.0.0.0", "289.95|12.9 MB", "", "2012", "120426 Good morning. Coincidence HHMMMMM.mp4"],
["120430",     "0.0.0.0", "665.11|42.1 MB", "", "2012", "120430 Update as of Saturday Night (Need self addressed stamped envelopes).mp4"],
["120501",     "0.0.0.0", "390.47|22.4 MB", "", "2012", "120501 Sitting Frog Giving Birth.mp4"],
["120515-01",  "0.0.0.0", "90.19|5.21 MB", "", "2012", "120515-01 Get Ready for the Unexpected.mp4"],
["120515-02",  "0.0.0.0", "340.5|14.8 MB", "", "2012", "120515-02 Destruction of America available on DVD.mp4"],
["120516",     "0.0.0.0", "264.38|15.0 MB", "", "2012", "120516 Come to www.blogtalkradio.com-thisisit4321.mp4"],
["120528",     "0.0.0.0", "435.26|18.8 MB", "", "2012", "120528 What an IMPACT !!!! LET's Continue.mp4"],
["120609",     "0.0.0.0", "505.66|124 MB", "", "2012", "120609 Roll Out The Red Carpet & Bow Down to the KING!.mp4"],
["120611",     "0.0.0.0", "2217.64|407 MB", "", "2012", "120611 Hoover Dam,,, Unleashed - Here We Go Again.mp4"],
["120708",     "0.0.0.0", "1060.66|70.1 MB", "", "2012", "120708 Let Him Who Hath Understanding.mp4"],
["120713",     "0.0.0.0", "926.8|178 MB", "", "2012", "120713 The Foolish Shall Confound the Wise.mp4"],
["120719",     "0.0.0.0", "594.78|31.6 MB", "", "2012", "120719 Barakhenaten DVD - yay or nay.mp4"],
["120721-01",  "0.0.0.0", "2999.41|129 MB", "", "2012", "120721-01 Justin.tv Livestream July, 20th 2012.mp4"],
["120721-02",  "0.0.0.0", "540.7|82.3 MB", "", "2012", "120721-02 This Great Evil.mp4"],

["120802",     "1.2.0.0", "3292.59|143 MB", "", "2012", "120802 Miracle On-Air! Justin.tv Livestream (7-31-2012).mp4"],
["120803",     "1.2.0.0", "4903.78|228 MB", "", "2012", "120803 On-Air Miracles Round 2! Be4 The Fire Ministries Kicks Off (8-2-2012).mp4"],
["120804",     "1.2.0.0", "1779.83|103 MB", "", "2012", "120804 Snatching them out of the fire Jude 123.mp4"],
["120809",     "1.2.0.0", "2390.73|316 MB", "", "2012", "120809 Time To Ring The Bell! - Yvonne's Incredible Testimony (8-8-2012).mp4"],
["120813-01",  "1.2.0.0", "310.89|50.7 MB", "", "2012", "120813-01 The Story of GENESIS (Parts I-III).mp4"],
["120813-02",  "1.2.0.0", "1169.01|213 MB", "", "2012", "120813-02 Octolympics - The Many Arms of the NWO (Olympic Confirmation).mp4"],
["120823",     "1.2.0.0", "887.05|159 MB", "", "2012", "120823 MUST SEE Destruction of Babylon (America) is Imminent - Confirmations.mp4"],
["120826-01",  "1.2.0.0", "628.61|47.0 MB", "", "2012", "120826-01 What a mind blowing moment!!! Again!!!!.mp4"],
["120826-02",  "1.2.0.0", "4897.25|803 MB", "", "2012", "120826-02 Nuclear Strike Confirmations Make BRIGHT the ARROWS JEREMIAH 5111.mp4"],
["120829",     "1.2.0.0", "242.09|11.7 MB", "", "2012", "120829 honor where honor is due.mp4"],
["120830",     "1.2.0.0", "328.1|57.3 MB", "", "2012", "120830 Zechariah 5 Nuclear Fire Offering (D.C. Sleeps Alone Tonight).mp4"],
["120901",     "1.2.0.0", "481.72|84.6 MB", "*8Q4x2gmacik", "2012", "120901 Hieroglyph Decryption Condensed - Be4TheFire Website Videos 5-6.mp4"],
["120902-01",  "1.2.0.0", "1299.27|354 MB", "", "2012", "120902-01 Just One More. To Fall.mp4"],
["120902-02",  "1.2.0.0", "106.32|26.0 MB", "", "2012", "120902-02 BatCat's Quest to Slay the Red Dot!.mp4"],
["120905-01",  "0.0.0.0", "196.51|35.9 MB", "", "2012", "120905-01 Obama's 2012 - 2016 Plan for the Earth - Sherwin Williams Logo.mp4"],
["120905-02",  "0.0.0.0", "376.53|72.5 MB", "*MqijaFvXln4", "2012", "120905-02 Be Reconciled to God Through Jesus Christ (Be4TheFire.com Video 8).mp4"],
["120906",     "0.0.0.0", "837.24|200 MB", "", "2012", "120906 'Eminence' Confirmation - Obama's Sherwin-Williams' Logo.mp4"],
["120907",     "0.0.0.0", "402.24|63.6 MB", "*1ZiRD_X1AYE", "2012", "120907 What's Printed on the U.S. Currency (Be4TheFire.com Video 9).mp4"],
["120908",     "0.0.0.3", "281.75|48.9 MB", "*OEdCHUV_C2I", "2012", "120908 Rise of the Second Beast in Babylon the Great (Video 10 for Be4TheFire.com).mp4"],
["120909",     "0.0.0.0", "393.28|43.5 MB", "*hCKFLFkVI9I", "2012", "120909 Wheat & Tares - The Hive Mind (Be4TheFire.com Video 11).mp4"],
["120910-01",  "0.0.0.0", "267.08|62.7 MB", "*C8ZXrKdrKAY", "2012", "120910-01 The Signs of Thy Coming (Be4TheFire.com Video 12).mp4"],
["120910-02",  "0.0.0.0", "825.7|172 MB", "", "2012", "120910-02 Twin Towers = DNA Markers - The Tares Exposed.mp4"],
["120911",     "0.0.0.0", "781.47|139 MB", "", "2012", "120911 99 Paralympics Closing Ceremony Decrypted - Sheep & Goats Separated.mp4"],
["120913-01",  "0.0.0.0", "1181.5|267 MB", "", "2012", "120913-01 Their UpsideDown Plans FIRE (Paralympics Closing Ceremony Decrypted 2).mp4"],
["120913-02",  "0.0.0.0", "149.77|24.2 MB", "*5YsQrzBComo", "2012", "120913-02 The End (Video 13 - Be4TheFire.com).mp4"],
["120914-01",  "0.0.0.0", "450.47|73.7 MB", "*LYOR7w4Lg8Y", "2012", "120914-01 Judgment & Salvation (Be4TheFire.com's 14th & Final Video).mp4"],
["120914-02",  "0.0.0.0", "592.94|138 MB", "", "2012", "120914-02 More Confirmations - Be4TheFire.com is Up and Running 100%.mp4"],
["120915",     "0.0.0.0", "720.93|206 MB", "", "2012", "120915 Rosh Hashanah Recipe Looks Like a Missile.mp4"],
["120916",     "0.0.0.3", "4126.3|494 MB", "*T-vRid7qAs0", "2012", "120916 Be4TheFire.com FULL Presentation.mp4"],
["120921-01",  "1.2.0.3", "3588.16|227 MB", "", "2012", "120921-01 Queen of Heaven HD (1 of 3).mp4"],
["120921-02",  "1.2.0.3", "2761.64|177 MB", "", "2012", "120921-02 Queen of Heaven HD (2 of 3).mp4"],
["120921-03",  "1.2.0.3", "3083.77|174 MB", "", "2012", "120921-03 Queen of Heaven HD (3 of 3).mp4"],
["120923",     "1.3.0.0", "1187.49|242 MB", "*dUXOMwmK02o", "2012", "120923 Missiles Come Down We Go Up - More Confirming Dreams.mp4"],
["120925",     "0.0.0.0", "158.41|27.3 MB", "", "2012", "120925 The Unlikeliest of Friends by Trin & Clay.mp4"],
["121001",     "0.0.0.0", "2793.85|531 MB", "", "2012", "121001 Psalm 82 Ye are gods - The Spirit & Heart of Disobedience.mp4"],
["121005",     "0.0.0.0", "1157.84|346 MB", "", "2012", "121005 A Plane, A Train & An Earthquake, 1200am 'Freaky Coincidence'.mp4"],
["121006",     "0.0.0.0", "509.31|27.5 MB", "", "2012", "121006 Enjoy Your Salvation & Stay The Course - Jehovah Shammah is with us all.mp4"],
["121008",     "0.0.0.0", "2305.18|458 MB", "", "2012", "121008 The DNArk Knight Phoenix Rising.mp4"],
["121010",     "0.0.0.0", "2806.02|467 MB", "", "2012", "121010 Sudden Death. Final Warnings Get on the Train Now.mp4"],
["121012",     "0.0.0.0", "2259.6|336 MB", "*_fyovTuQHbI", "2012", "121012 X Marks the Antichrist - wWw.666.satanObama.mp4"],
["121019",     "0.0.0.0", "6846.75|289 MB", "", "2012", "121019 Zen Garcia, Jonathan Kleck & Clay Eudaly Our First Estate; Way of Ascent.mp4"],
["121029",     "0.0.0.0", "2409.28|135 MB", "", "2012", "121029 An Ancient Evil Awakens Hoover Dam False Flag Soon.mp4"],
["121102",     "0.0.0.0", "2704.13|146 MB", "", "2012", "121102 Birthing of a Race Within a Race (Hoover Dam Follow-Up).mp4"],
["121114",     "0.0.0.0", "245.64|57.4 MB", "", "2012", "121114 The End Times & Rapture - Emmanuel & Joyce.mp4"],
["121121",     "0.0.0.0", "1292.56|92.3 MB", "", "2012", "121121 The New Jerusalem is Here.mp4"],
["121212",     "0.0.0.0", "2652.62|420 MB", "", "2012", "121212 The DNA Altering Mark of The Beast.mp4"],
["121216",     "0.0.0.0", "632.74|36.8 MB", "", "2012", "121216 Hospital Nuclear Protocols.mp4"],
["121223",     "0.0.0.0", "227.9|64.5 MB", "", "2012", "121223 The Science of Immorality Within Us All.mp4"],

//==== 2013 ====

["130105",     "0.0.0.0", "773.76|44.5 MB", "", "2013", "130105 The Signs Are All Here- Time to get your affairs in order.mp4"],
["130109",     "0.0.0.0", "1341.12|80.7 MB", "", "2013", "130109 The Trap Has Been Set. Don't Be Caught Unawares.mp4"],
["130112",     "0.0.0.0", "3749.72|189 MB", "*dFoI43NYAHo", "2013", "130112 Obama Morphing into a Beast Dreams & Confirmations.mp4"],
["130117",     "0.0.0.0", "2943.57|158 MB", "", "2013", "130117 The Powers of Heaven Shall Be Shaken - Luke 21.mp4"],
["130122",     "0.0.0.0", "703.26|37.6 MB", "", "2013", "130122 The Time Is Near - Encouraging message from a brother in Christ.mp4"],
["130127",     "0.0.0.0", "1872.85|318 MB", "*xHB3ficeE0I", "2013", "130127 The Lord of the Flies is on Fire.mp4"],
["130128",     "0.0.0.0", "1387.46|96.4 MB", "", "2013", "130128 Get Clean & Ready to Fly.mp4"],
["130130",     "0.0.0.0", "247.94|15.0 MB", "", "2013", "130130 Israeli Strike on Syrian Military Site -Trib-Now Radio Simulcast Show Tonight (1-30-12).mp4"],
["130202",     "0.0.0.0", "484.74|79.2 MB", "", "2013", "130202 For Obama Fencesitters New Antichrist DVD Intro & Promo.mp4"],
["130206",     "0.0.0.0", "483.95|29.7 MB", "", "2013", "130206 The Pharaoh of the Internet President Obama.mp4"],
["130213",     "0.0.0.0", "4952.89|555 MB", "*vuQ6bXM43Mw", "2013", "130213 The Son of Perdition Barack Hussein Obama (Part 1 of 2).mp4"],
["130214",     "0.0.0.0", "5482.7|288 MB", "*aTnD-M5JXEE", "2013", "130214 The Son of Perdition Barack Hussein Obama (Part 2 of 2).mp4"],

["130218",     "2.0.0.0", "718.7|39.3 MB", "", "2013", "130218 How To Get Your Free DVDs - Ministry Update 2.18.2013.mp4"],
["130219",     "2.0.0.0", "674.75|156 MB", "", "2013", "130219 2013 Mayan SuperBowl - The Two Have Become One - Obama's Throne of Zeus.mp4"],
["130228",     "2.0.0.0", "450.42|22.0 MB", "", "2013", "130228 Antichrist Globalist Agenda Manifesting Legislatively - DVD Update.mp4"],
["130301",     "2.0.0.0", "777.87|45.6 MB", "", "2013", "130301 When the Sun Rises Over the West the Beast is Unleashed.mp4"],
["130304",     "2.0.0.0", "1149.62|69.8 MB", "", "2013", "130304 Watch therefore, for the Abomination of Desolation (Matthew 2415).mp4"],
["130306",     "2.0.0.0", "1270.97|76.6 MB", "", "2013", "130306 Obama's Triumphal Entry to Jerusalem 2013.mp4"],
["130331",     "2.0.0.0", "711.11|41.6 MB", "", "2013", "130331 Departure Not Falling Away (2 THESS 23).mp4"],
["130401",     "2.0.0.0", "302.16|20.5 MB", "", "2013", "130401 Be4TheFire & Destruction of America Combo DVD Now Ready.mp4"],
["130403",     "2.0.0.0", "649.3|31.1 MB", "", "2013", "130403 The Good Guys in the Government Waking Up To The NWO.mp4"],
["130412",     "2.0.0.0", "856.96|43.1 MB", "", "2013", "130412 Scientific Star Children - The Strong Delusion.mp4"],
["130419",     "2.0.0.0", "466.05|79.5 MB", "", "2013", "130419 The Birth Pains Increasing - Out of Egypt.mp4"],
["130430",     "2.0.0.0", "1363.17|264 MB", "*DabZY24St-w", "2013", "130430 Boston Terror Drills - The Storm is Coming.mp4"],
["130524",     "2.0.0.0", "2865.3|366 MB", "", "2013", "130524 One World Freedom Tower Exposed Crowning The Tyrant.mp4"],
["130531",     "2.0.0.0", "457.57|37.4 MB", "", "2013", "130531 When he sees the sword coming upon the land- Ezekiel 33;1-6.mp4"],
["130602",     "2.0.0.0", "1530.45|352 MB", "", "2013", "130602 Dead Sheep Nike Testimony - The Spirit That Now Worketh.mp4"],
["130607",     "2.0.0.0", "2357.24|365 MB", "*g1wZ9q41a_M", "2013", "130607 The Hidden World Part I - DNA Infection.mp4"],
["130614-01",  "1.2.0.0", "2292.13|409 MB", "*yKzAZpNkU0c", "2013", "130614-01 The Hidden World Part I - DNA Infection (Updated & Mobile Version).mp4"],
["130614-02",  "1.2.0.0", "2196.82|335 MB", "*I9JS1Y0lmN0", "2013", "130614-02 The Hidden World Part II - Spiritual Rebirth.mp4"],
["130707",     "0.0.0.0", "325.31|95.0 MB", "", "2013", "130707 Hello again.mp4"],
["130708",     "1.2.0.0", "139.71|24.1 MB", "*HIgopk0tDO8", "2013", "130708 0) You're Living in a Dreamworld.mp4"],
["130709",     "1.2.0.0", "225.02|43.6 MB", "*htZGHaNEBW0", "2013", "130709 1) These Basic Illuminati Symbols Are Everywhere.mp4"],
["130710",     "1.2.0.0", "344.44|73.9 MB", "*W8CagZOwuvg", "2013", "130710 2) The All Seeing Eye.mp4"],
["130712",     "1.2.0.0", "400.31|57.7 MB", "*AYR18gDO-_Y", "2013", "130712 3) AlienFallen Angel Infection.mp4"],
["130714-01",  "1.2.0.0", "542.21|65.0 MB", "*D0fdTBBhhwc", "2013", "130714-01 4) Half & Half Symbolism.mp4"],
["130714-02",  "1.2.0.0", "537.05|129 MB", "*D0fdTBBhhwc", "2013", "130714-02 4) Half & Half Symbolism (mobile).mp4"],
["130718",     "1.2.0.0", "853.36|188 MB", "*a3wjI9OrySQ", "2013", "130718 5) The Hidden All-Seeing Eye in Washington D.C.mp4"],
["130725",     "1.3.0.0", "3561.5|474 MB", "*rNRekbaj36k", "2013", "130725 Jonathan Kleck's Personal Testimony.mp4"],
["130728",     "1.2.0.0", "963.07|149 MB", "", "2013", "130728 $10 Bill Prophecy - Treason From Within.mp4"],
["130731",     "1.2.0.0", "577.62|99.5 MB", "", "2013", "130731 Foreign Currency Decrypted.mp4"],
["130802",     "0.0.0.0", "609.83|29.8 MB", "LJivBJX5hWU", "2013", "130802 The RAPTURE When A Moment Changes Everything.mp4"],
["130816",     "1.3.0.0", "166.44|44.7 MB", "", "2013", "130816 Keys to the Kingdom Intro.mp4"],
	
["130820",     "3.1.0.0", "876.65|138 MB", "*P7LL8okaXws", "2013", "130820 Part I - Basilica The King Serpent.mp4"],
["130823-01",  "3.1.0.0", "591.44|111 MB", "*j--QmeNkSUk", "2013", "130823-01 Part II - The Key to Knowledge.mp4"],
["130823-02",  "3.1.0.0", "399.55|83.7 MB", "", "2013", "130823-02 Part III - The Red Cleansing.mp4"],
["130826",     "3.1.0.1", "848.83|203 MB", "*wEV_l1Krcs4", "2013", "130826 Part IV - Mitochondria Drain.mp4"],
["130828",     "3.1.0.0", "936.48|224 MB", "*DPAJKTI-_BE", "2013", "130828 Part V - Breath of Life.mp4"],
	
["130908",     "0.0.0.0", "266.59|73.8 MB", "", "2013", "130908 Set The Captives Free.mp4"],
["130926",     "0.0.0.0", "390.4|65.8 MB", "", "2013", "130926 The Final DVD Project is 99p Complete - How to get your free copy.mp4"],
["130929",     "0.0.0.0", "866.01|175 MB", "*MIZwwfClM-4", "2013", "130929 The Satanic HIVE Mind Exposed.mp4"],

["131003",     "3.0.0.0", "2570.31|512 MB", "*7TMhn85cK7A", "2013", "131003 DVD - Breath of Life Setting The Captives Free (1 of 3).mp4"],
["131004-01",  "3.0.0.0", "3929.03|849 MB", "*wC8siN9EQZY", "2013", "131004-01 DVD - Breath of Life Setting The Captives Free (2 of 3).mp4"],
["131004-02",  "3.0.0.0", "2447.38|522 MB", "*55ieC-JU_ZY", "2013", "131004-02 DVD - Breath of Life Setting The Captives Free (3 of 3).mp4"],
["131004-03",  "3.1.0.0", "8938.8|1.24 GB", "paY4JKNIZ2U", "2013", "131004-03 The Breath of Life Setting the Captives Free - FULL PRESENTATION.mp4"],

["131011",     "0.0.0.0", "505.82|84.4 MB", "*b3ddUZn2wW4", "2013", "131011 New $100 Bill Decrypted - Nuclear Devastation.mp4"],
["131015",     "0.0.0.0", "593.64|146 MB", "*Qy9f01m3Vz0", "2013", "131015 New $100 Decrypted - Nuclear Devastation (Mobile & Updated).mp4"],
["131020",     "0.0.0.0", "898.52|103 MB", "*QaL7bRX5B5E", "2013", "131020 For The $keptics US Currency & False Flag Events Confirmed.mp4"],
["131028",     "0.0.0.0", "942.89|169 MB", "", "2013", "131028 Put This To The Test - Alex Jones, James Corbett, Paul Watson, Art Bell.mp4"],
["131111",     "0.0.0.0", "1342.04|213 MB", "", "2013", "131111 2008 Prophecy Fulfilled The Travail Begins.mp4"],
["131115",     "0.0.0.0", "129.87|23.8 MB", "", "2013", "131115 Stay The Course & A Thank You.mp4"],
["131122",     "0.0.0.0", "797.65|187 MB", "", "2013", "131122 Ring the Bell Confirmation - Be at Peace.mp4"],
["131124",     "1.2.0.0", "685.69|141 MB", "", "2013", "131124 The Beast Will Be Unleashed.mp4"],
["131217",     "1.2.0.0", "670.75|131 MB", "", "2013", "131217 The Beast Rising Within Humanity.mp4"],
["131218",     "1.2.0.0", "322.11|64.1 MB", "", "2013", "131218 The Dragon Empowering The Beast.mp4"],
["131220",     "1.2.0.0", "340.92|74.8 MB", "", "2013", "131220 The Dragon, The Queen & The All-Seeing Eye.mp4"],

//==== 2014 ====

["140114",     "1.0.0.3", "418.63|89.8 MB", "*61MUJSxUCYw", "2014", "140114 Instant & Sudden Destruction The Day of the LORD.mp4"],
["140117",     "1.0.0.0", "833.16|151 MB", "", "2014", "140117 Satan's Rebuilt Kingdom - Marduk Returns.mp4"],
["140122",     "1.0.0.0", "526.14|124 MB", "", "2014", "140122 2014 Biblical End Times - Finish the Race.mp4"],
["140125",     "1.0.0.0", "558.39|137 MB", "", "2014", "140125 Spiritual Hosts of Wickedness - Real World Evidence.mp4"],
["140129",     "1.0.0.0", "466.91|92.7 MB", "", "2014", "140129 Allah 666 Abomination of Beyonce & Katy Perry.mp4"],
["140201-01",  "1.0.0.0", "1515.5|317 MB", "*DEWQQ4Gqseg", "2014", "140201-01 The Hidden Hand - Spiritual Wars.mp4"],
["140201-02",  "1.0.0.0", "270.3|63.2 MB", "", "2014", "140201-02 Grammy Worship 2014 - Ye worship what ye know not.mp4"],
["140213",     "1.0.0.0", "466.3|106 MB", "", "2014", "140213 Barack Obama 2014 - It's a Trap!.mp4"],
["140221",     "1.0.0.0", "1134.92|251 MB", "", "2014", "140221 The Birth Must Come - NWO Agenda BudLight 2014.mp4"],
["140223",     "1.0.0.0", "2003.97|276 MB", "*zu_tBrIV0LI", "2014", "140223 These Are Their Plans - The New Race Birthed (BudLight & Maserati Explanation).mp4"],
["140228",     "1.0.0.0", "1395.68|277 MB", "*EOpyMqN4Wf4", "2014", "140228 The Beast Inside - Destruction of the Temple.mp4"],
["140302",     "1.0.0.3", "537.08|60.9 MB", "*IqnMDWHplNg", "2014", "140302 Ye are of your Father the Devil Lady Gaga Telegraphs NYC Destruction.mp4"],
["140303",     "1.0.0.0", "805.48|146 MB", "*KXP5kpnrKmE", "2014", "140303 The Ukraine Maserati Lady Gaga Connection The Trident.mp4"],
["140310",     "0.0.0.0", "1231.47|72.4 MB", "", "2014", "140310 Anti-Christ UNVEILED The Sun Rising in the West.mp4"],
["140316-01",  "0.0.0.0", "565.57|108 MB", "", "2014", "140316-01 Obama Satanic Cult Clone The Renegade President.mp4"],
["140316-02",  "0.0.0.0", "312.33|26.6 MB", "", "2014", "140316-02 Red Alert! Malaysian False Flag Anti-Christ has Risen!.mp4"],
["140327",     "0.0.0.0", "1357.6|185 MB", "", "2014", "140327 Satan's Rule on Earth is Here - The Trident.mp4"],
["140411",     "0.0.0.0", "1691.11|208 MB", "", "2014", "140411 Revelation of the End The Whore, The Dragon, The Devil, The Owl, The Locust, THE END.mp4"],
["140412",     "0.0.0.0", "1690.53|302 MB", "", "2014", "140412 (MOBILE) Revelation of the End The Whore, Dragon, Devil, Owl, Locust, THE END.mp4"],
["140428",     "0.0.0.0", "1337.4|145 MB", "", "2014", "140428 Revelation of THE END DVD Project.mp4"],
["140512-01",  "0.0.0.0", "423.58|29.7 MB", "", "2014", "140512-01 The Horsemen Are Ready to Ride - 3D Pope Abomination.mp4"],
["140512-02",  "0.0.0.0", "550.52|110 MB", "", "2014", "140512-02 Satanic Mainstream Mind Control Tactics Exposed.mp4"],
["140512-03",  "0.0.0.0", "1690.58|96.7 MB", "", "2014", "140512-03 Revelation of THE END DVD (Part 1 of 2).mp4"],
["140512-04",  "0.0.0.0", "9006.53|527 MB", "", "2014", "140512-04 Revelation of the THE END DVD (Part 2 of 2).mp4"],
["140603",     "0.0.0.0", "203.22|29.2 MB", "", "2014", "140603 URGENT MESSAGE.mp4"],
["140620",     "0.0.0.0", "898.87|200 MB", "", "2014", "140620 The Eventuality - ISIS - Basilisk Eggs.mp4"],
["140716",     "0.0.0.0", "278.45|46.7 MB", "", "2014", "140716 It's On The Money.mp4"],
["140717",     "0.0.0.0", "284.63|43.6 MB", "", "2014", "140717 Terroristas De Los Estados Unidos.mp4"],
["140809",     "0.0.0.0", "646.51|85.3 MB", "", "2014", "140809 9th of AV is 911 Destruction of the Temple.mp4"],
["140817",     "0.0.0.0", "224.24|28.8 MB", "", "2014", "140817 The 3rd Temple Birthing a New Race within Humanity.mp4"],
["140823",     "1.2.0.3", "568.49|34.5 MB", "*Y9TzRpoAeYY", "2014", "140823 Part 1 The Enemy is at the Gate.mp4"],
["140824",     "1.2.0.3", "284.05|21.0 MB", "", "2014", "140824 Part 2 WARNING OBAMA-LUCIFER-ISIL.mp4"],
["140826-01",  "1.2.0.3", "107.95|4.81 MB", "*py_0Pp2H9us", "2014", "140826-01 Part 3 S.O.S.! Seat Of Satan.mp4"],
["140826-02",  "1.2.0.3", "154.67|7.92 MB", "*mQDTPq_3VwM", "2014", "140826-02 Part 4 I Beheld Satan, as lightning fall  from Heaven. Luke 1018.mp4"],
["140827-01",  "1.2.0.3", "160.17|8.88 MB", "*Hyyac7PizoI", "2014", "140827-01 Part 5 And with Peace he will Destroy many.mp4"],
["140827-02",  "1.2.0.3", "122.97|6.08 MB", "*jn9gPNK-DJo", "2014", "140827-02 Part 6 Lucifer - Bringer of Dawn.mp4"],
["140828",     "1.2.0.3", "115.06|6.15 MB", "*Bdcow7nwOTA", "2014", "140828 Part 7 The Dawning of Lucifer's World Leader & Caliphate.mp4"],
["140829-01",  "1.2.0.3", "95.23|5.73 MB", "*Wp1lFufvfKU", "2014", "140829-01 Part 8 SATAN - The Father of LIES.mp4"],
["140829-02",  "1.2.0.3", "136.63|7.43 MB", "*IIr2dy_mXMs", "2014", "140829-02 Part 9 ( Lucifer- bringer of Dawn) and  (Subud- rising Sun).mp4"],
["140830",     "1.2.0.3", "318.67|19.7 MB", "*NTBnohUxfLM", "2014", "140830 Part 10 The Devil is a LIAR.mp4"],
["140831",     "1.2.0.3", "280.66|17.9 MB", "*FpIb9Jgd6-M", "2014", "140831 Part 11 OBAMA-NATION in the Eyes of GOD.mp4"],
["140901",     "1.2.0.3", "267.7|14.1 MB", "*yGfgQ_GNATA", "2014", "140901 Part 12 Anti-Christ Checklist.mp4"],
["140902",     "1.2.0.3", "191.05|11.6 MB", "*O5oKFLLj9tI", "2014", "140902 Part 13 - Levant AND The Dawn of Lucifer - ISIL & Obama.mp4"],
["140912",     "0.0.0.0", "181.35|10.2 MB", "", "2014", "140912 Image of the Beast.mp4"],
["140914",     "0.0.0.0", "206.98|11.2 MB", "*iUpFInxYYXQ", "2014", "140914 Additional footage -Image of the Beast (UPDATED).mp4"],
["140916",     "0.0.0.0", "188.06|11.8 MB", "*TGxtfdl2HVc", "2014", "140916 Animating the Beast Patent.mp4"],
["140921",     "0.0.0.0", "473.66|25.7 MB", "", "2014", "140921 U.N. Peace and Security.mp4"],
["140923",     "0.0.0.0", "173.62|10.7 MB", "", "2014", "140923 Khorasan-ISIL-Obama-Dawn-Lucifer.mp4"],
["140924",     "0.0.0.0", "227.93|13.8 MB", "", "2014", "140924 YOUR REDEMPTION DRAWS NIGH !!!!.mp4"],
["141013-01",  "0.0.0.0", "552.15|32.9 MB", "", "2014", "141013-01 EBOLA !!! and its CONNECTION to the QU'RAN,,,(QU'ranteen).mp4"],
["141013-02",  "0.0.0.0", "339.99|19.2 MB", "", "2014", "141013-02 OSIRISEGYPTIAN GOD OF DEATH & What A Bunch of Bull!.mp4"],
["141017",     "0.0.0.0", "41.26|2.37 MB", "", "2014", "141017 REPENT!  JESUS is Coming Quickly!.mp4"],
["141022",     "0.0.0.0", "519.22|29.7 MB", "", "2014", "141022 OSIRIS Revised, Revisited & Updated Part 2.mp4"],
["141118",     "0.0.0.0", "433.73|27.8 MB", "", "2014", "141118 All Mocking Tongue.mp4"],
["141202",     "0.0.0.0", "642.64|32.2 MB", "", "2014", "141202 Skull & Bones!!NEVER BEFORE SEEN REVELATION!! It's OVER for Them.mp4"],
["141210",     "0.0.0.0", "530.85|29.8 MB", "", "2014", "141210 Therefore I say, WATCH!.mp4"],
["141225",     "0.0.0.0", "388.42|22.3 MB", "", "2014", "141225 Merry Celebration of the Birth of Jesus Christ from Be4thefire.com.mp4"],

//==== 2015 ====

["150207",     "0.0.0.0", "3759.75|172 MB", "", "2015", "150207 The Unrolled Scroll ,Here Comes DEATH.Shout it from the Roof Tops.mp4"],
["150216",     "0.0.0.0", "1890.87|111 MB", "", "2015", "150216 The Spirit that worketh DEATH. DEATH IS COMING.mp4"],
["150305",     "0.0.0.0", "625.06|27.0 MB", "", "2015", "150305 Time of Trouble (FEMALE RIVAL) DVD READY.mp4"],
["150415",     "0.0.0.0", "865.85|55.9 MB", "", "2015", "150415 WAR-ning! WW3 & Wedding, Deliverance & Death Coming!.mp4"],
["150510",     "0.0.0.0", "253.86|15.0 MB", "", "2015", "150510 Jade Helm (Breeding- Gestation- Beast Unleashed).mp4"],
["150511",     "0.0.0.0", "322.62|18.9 MB", "", "2015", "150511 UPDATED Jade HelmBroken Arrow (Breeding- Gestation- Beast Unleashed).mp4"],
["150514",     "0.0.0.0", "1936.2|93.9 MB", "", "2015", "150514 Master the Human Domain. The End Game. Alien Invasion Complete and Mission Complete.mp4"],
["150524",     "0.0.0.0", "318.42|45.1 MB", "", "2015", "150524 Waco UP! Waco UP!! WACO UP!!!.mp4"],
["150627-01",  "0.0.0.0", "402.19|19.1 MB", "*eEN04cFPfN4", "2015", "150627-01 As in the Days of Lot. One will be taken and one will be left.mp4"],
["150627-02",  "0.0.0.0", "402.19|19.2 MB", "", "2015", "150627-02 As in the Days of Lot; 1 will be taken & 1 will be left (Augmented Imagery).mp4"],
["150628",     "0.0.0.0", "683.99|27.8 MB", "", "2015", "150628 Be Ready! I AM the first & the last!.mp4"],
["150701",     "0.0.0.0", "1253.69|53.3 MB", "", "2015", "150701 The Sword Cometh. The Rod Has Blossomed. JESUS IS COMING!.mp4"],
["150802",     "0.0.0.0", "696.58|103 MB", "", "2015", "150802 TIME TO FINISH THE RACE!.mp4"],

["150902",     "1.2.0.0", "147.61|22.1 MB", "*JuxYcUynibM", "2015", "150902 Thy Kingdom Come (Introduction - Part 1).mp4"],
["150904-01",  "1.2.0.0", "2022.57|323 MB", "*SkdPligDgzQ", "2015", "150904-01 Thy Kingdom Come (Introduction - Part 1).mp4"],
["150904-02",  "1.2.0.0", "2856.38|554 MB", "*qITf1kCuUY4", "2015", "150904-02 Thy Kingdom Come (Part 2 - FEED MY SHEEP).mp4"],
["150905-01",  "1.2.0.0", "2908.95|571 MB", "*-RuhZIDe_rA", "2015", "150905-01 Thy Kingdom Come (Part 3 - The Seed).mp4"],
["150905-02",  "1.2.0.0", "1412.01|249 MB", "*JSHD1NXo84U", "2015", "150905-02 Thy Kingdom Come (Part 4 - Art Tour).mp4"],
["150905-03",  "1.2.0.0", "2897.27|515 MB", "*rXMvA0sdOBM", "2015", "150905-03 Thy Kingdom Come (Part 5 - Outward Manifestation of THE SEED).mp4"],
["150906",     "1.2.0.0", "2732.25|451 MB", "*nFf-fz6G3AI", "2015", "150906 Thy Kingdom Come ( Part 6 - CERN & The Locust Army).mp4"],

["150915",     "0.0.0.0", "1317.41|173 MB", "", "2015", "150915 SHOUT IT FROM THE ROOFTOPS!!!.mp4"],
["150928",     "0.0.0.0", "260.23|10.9 MB", "", "2015", "150928 Join US as You See the Day Approaching.mp4"],
["151031",     "0.0.0.0", "141.36|5.37 MB", "", "2015", "151031 Get Ready, Get Ready, Get Ready!.mp4"],
["151103",     "0.0.0.0", "3175.4|142 MB", "*HJpO_aSYI_k", "2015", "151103 Jesus Christ is 'the snare' that turns the world upside down.mp4"],
["151105",     "0.0.0.0", "402.75|22.0 MB", "", "2015", "151105 The Snare from the very Beginning.mp4"],
["151126",     "0.0.0.0", "228.58|31.8 MB", "", "2015", "151126 Look Past The Veil and See Your Enemy.mp4"],
["151129",     "0.0.0.0", "4394|342 MB", "", "2015", "151129 Do You KNOW The TRUTH. Do You KNOW THE JESUS of the Gospel.mp4"],
["151130-01",  "0.0.0.0", "890.02|66.2 MB", "", "2015", "151130-01 300 AM OH My Lord. Be Watchful.mp4"],
["151130-02",  "0.0.0.0", "711.02|54.7 MB", "", "2015", "151130-02 Are We at the End NOW.mp4"],
["151202",     "0.0.0.0", "668.01|49.0 MB", "", "2015", "151202 Join us at Hagman and Hagman Tomorrow.mp4"],
["151215",     "0.0.0.0", "134.05|13.5 MB", "*dFEYwCBglGA", "2015", "151215 LOOK! At the SkinSin We're In!!!.mp4"],
["151220-01",  "0.0.0.0", "4217.02|366 MB", "", "2015", "151220-01 The PETRA of Offence to those that stumble at the LOGOS.mp4"],
["151220-02",  "0.0.0.0", "1953.01|151 MB", "", "2015", "151220-02 Who;s your WORST ENEMY.mp4"],
["151221-01",  "0.0.0.0", "189.01|12.1 MB", "", "2015", "151221-01 sorry.mp4"],
["151221-02",  "0.0.0.0", "887|74.1 MB", "", "2015", "151221-02 Did Obama Cryptically say Death has come to America.mp4"],
["151222",     "0.0.0.0", "574.02|48.9 MB", "", "2015", "151222 Test video. Audio failure on last upload.mp4"],
["151223-01",  "0.0.0.0", "1221.02|90.2 MB", "", "2015", "151223-01 Badge 12 66 Hmmmm.mp4"],
["151223-02",  "0.0.0.0", "405|32.0 MB", "", "2015", "151223-02 It's in Everything.mp4"],
["151225",     "0.0.0.0", "5681.02|475 MB", "", "2015", "151225 Antichrist - the serpent - father of lies.mp4"],
["151231",     "0.0.0.0", "906.02|85.1 MB", "", "2015", "151231 New York Nuke Maybe.mp4"],

//==== 2016 ====

["160129",     "0.0.0.0", "629.01|42.1 MB", "", "2016", "160129 Obama Hitler - Jihad  mein Kampf.mp4"],
["160202",     "0.0.0.0", "240|16.8 MB", "", "2016", "160202 Zika,,,the MEANING behind the Bio weapon.mp4"],
["160217",     "0.0.0.0", "2849.02|219 MB", "", "2016", "160217 MUST WATCH SURPRISE ENDING.mp4"],
["160221",     "0.0.0.0", "1855.02|146 MB", "", "2016", "160221 Scalia and the DRAGON Costume CRAZZZZY.mp4"],
["160227",     "0.0.0.0", "1538.02|127 MB", "", "2016", "160227 Scalia BOMB SHELL.mp4"],
["160307-01",  "1.2.0.0", "2243.95|179 MB", "", "2016", "160307-01 Part 1 Obama The SEED of FALSEHOOD Hates Christians without cause(fixed).mp4", "Note: Recompiled to fix playback issues. Please download newer video if required."],
["160307-02",  "1.2.0.0", "289.02|30.2 MB", "", "2016", "160307-02 Part 2 Obama The SEED of FALSEHOOD Hates Christians without cause.mp4"],
["160312",     "0.0.0.0", "1443|116 MB", "*Sd4dzK3rI9c", "2016", "160312 Your Flesh IS the Devil.mp4"],
["160319",     "0.0.0.0", "1316.01|117 MB", "", "2016", "160319 Obama appoints O.K.C.Cover-upJudge Merrick Garland as Supreme Court nominee.mp4"],
["160327",     "0.0.0.0", "3994.02|310 MB", "", "2016", "160327 So, you say you are a Christian,,,Really.mp4"],
["160330",     "0.0.0.0", "226.02|16.2 MB", "", "2016", "160330 test.mp4"],
["160331",     "0.0.0.0", "1440.01|123 MB", "", "2016", "160331 Here comes the SERIES.mp4"],
["160407",     "1.2.0.0", "6769.01|603 MB", "", "2016", "160407 PART 1 NOW THE END COMES,, U.S. Currency COMPLETE BREAKDOWN.mp4"],
["160411",     "1.2.0.0", "8165.02|346 MB", "", "2016", "160411 Part 2 ALIEN Agenda -Proved !! Biblical Proof.mp4"],
["160413",     "0.0.0.0", "2160.01|192 MB", "", "2016", "160413 RED ALERT INFO 911.mp4"],
["160415",     "0.0.0.0", "181.02|13.5 MB", "", "2016", "160415 HERE COMES THE SMACK DOWN!!!!.mp4"],
["160416",     "0.0.0.0", "3127.01|276 MB", "", "2016", "160416 New York Destruction Guaranteed - Satan Smackdown - BUSTED.mp4"],
["160419-01",  "0.0.0.0", "1258.01|104 MB", "", "2016", "160419-01 Arch of Baal telegraphing the beast unleashed,The New race is here.mp4"],
["160419-02",  "0.0.0.0", "1004.01|93.1 MB", "", "2016", "160419-02 Addition to Arch of Baal & Jaguar commercial.mp4"],
["160420",     "0.0.0.0", "1293|111 MB", "", "2016", "160420 Combined ArielTarget Systems.mp4"],
["160422",     "0.0.0.0", "5025.01|445 MB", "", "2016", "160422 The NUKES ARE COMING!!!MUST WATCH.mp4"],
["160423-01",  "0.0.0.0", "1130.02|95.3 MB", "", "2016", "160423-01 the WHOLE thing in 18 minutes.mp4"],
["160423-02",  "0.0.0.0", "609.01|51.7 MB", "", "2016", "160423-02 OhMG. UNBELIEVABLE!!!!LOLOL.mp4"],
["160424-01",  "0.0.0.0", "1685|177 MB", "", "2016", "160424-01 OMG X 100!!!!!!!!!!!!!!!!!!!!!!!!!!!!.mp4"],
["160424-02",  "0.0.0.0", "889.02|87.6 MB", "", "2016", "160424-02 ANOTHER NUKE TELEGRAPH!!!!!!!.mp4"],
["160425",     "0.0.0.0", "623.01|59.8 MB", "", "2016", "160425 THE END IS COMING!!!!.mp4"],
["160426",     "0.0.0.0", "519.01|50.4 MB", "", "2016", "160426 Event Mode 180.mp4"],
["160429",     "0.0.0.0", "1324|111 MB", "", "2016", "160429 Pay ATTENTION !!!!.mp4"],
["160430",     "1.2.0.0", "2190.01|91.3 MB", "", "2016", "160430 Obama RED ALET .OBAMA AND THE QUEEN telegraph nuclear destr.mp4"],
["160501-01",  "1.2.0.0", "1596|115 MB", "", "2016", "160501-01 OBAMA gives the 2 FINGER salute To ALL AMERICANS.mp4"],
["160501-02",  "1.2.0.0", "790.01|59.6 MB", "", "2016", "160501-02 Obama Mocks Us Again!!!WOW.mp4"],
["160506-01",  "1.2.0.0", "1917.02|82.4 MB", "", "2016", "160506-01 Obama Plans a RED WEDDING for America.mp4"],
["160506-02",  "1.2.0.0", "706|56.1 MB", "", "2016", "160506-02 Obama Telegraphs DEATH to AMERICA.mp4"],
["160510-01",  "1.2.0.0", "1092.01|51.3 MB", "", "2016", "160510-01 Michael Michele keeping an eye on herhis carrots.mp4"],
["160510-02",  "1.2.0.0", "1371.02|118 MB", "", "2016", "160510-02 Michael Michele keeping an eye on herhis carrots UPDATED.mp4"],
["160510-03",  "1.2.0.0", "581.01|45.1 MB", "", "2016", "160510-03 Michael and Barack are BUSTED!!!!! No doubt. BUSTED!!!.mp4"],
["160512",     "0.0.0.0", "1630.02|151 MB", "", "2016", "160512 Condemnation before INVESTIGATION is the HIGHEST form of Ignorance.mp4"],
["160520",     "0.0.0.0", "171.01|10.6 MB", "", "2016", "160520 behave like Christians PLEASE.mp4"],
["160525",     "0.0.0.0", "519.01|46.3 MB", "", "2016", "160525 what's the COMMON DENOMINATOR.mp4"],
["160526",     "0.0.0.0", "635.02|50.4 MB", "", "2016", "160526 Vesica Pisces.mp4"],
	
["160527-01",  "2.2.0.0", "832.02|72.1 MB", "", "2016", "160527-01 The Garden OF Eden AGAIN!!.mp4"],
["160527-02",  "2.2.0.0", "853.01|73.9 MB", "", "2016", "160527-02 The Garden AGAIN AND AGAIN!!.mp4"],
["160528",     "2.2.0.3", "894.55|130 MB", "", "2016", "160528 THE DEED Eve & Adam + Serpent = Cain PART 1.mp4"],
["160529-01",  "2.2.0.3", "897.92|129 MB", "", "2016", "160529-01 THE DEED Eve & Adam + Serpent = Cain PART 2.mp4"],
["160529-02",  "2.2.0.0", "895.43|104 MB", "", "2016", "160529-02 THE DEED Eve & Adam + Serpent = Cain PART 3.mp4"],
["160529-03",  "2.2.0.0", "886.7|81.8 MB", "", "2016", "160529-03 THE DEED Eve & Adam + Serpent = Cain PART 4.mp4"],
["160529-04",  "2.2.0.0", "871.31|50.4 MB", "", "2016", "160529-04 THE DEED Eve & Adam + Serpent = Cain PART 5.mp4"],
	
["160531-01",  "1.3.0.0", "884.01|61.5 MB", "", "2016", "160531-01 YOU ARE THE FALLEN Part 1.mp4"],
["160531-02",  "1.3.0.0", "858|76.6 MB", "", "2016", "160531-02 YOU ARE THE FALLEN Part 2.mp4"],
["160531-03",  "1.3.0.0", "891.02|77.5 MB", "", "2016", "160531-03 YOU ARE THE FALLEN Part 3.mp4"],
["160531-04",  "1.3.0.0", "811|66.7 MB", "", "2016", "160531-04 Info.BREAK be4 Part 4.mp4"],
["160531-05",  "1.3.0.0", "540|33.0 MB", "", "2016", "160531-05 Clearing the AIR.mp4"],
["160601",     "1.3.0.0", "866.01|68.9 MB", "", "2016", "160601 Working on the Disclosure of ALL DISCLPOSURES.mp4"],
["160602-01",  "1.3.0.0", "872|69.2 MB", "", "2016", "160602-01 YOUARE THE FALLEN PART ((4)).mp4"],
["160602-02",  "1.3.0.0", "877.02|64.3 MB", "", "2016", "160602-02 ARE THE FALLEN PART 5.mp4"],
["160602-03",  "1.3.0.0", "896.01|72.4 MB", "", "2016", "160602-03 YOU ARE THE FALLEN PART 6.mp4"],
["160602-04",  "1.3.0.0", "897.01|76.8 MB", "", "2016", "160602-04 YOU ARE THE FALLEN PART 7.mp4"],
["160602-05",  "1.3.0.0", "882.01|78.9 MB", "", "2016", "160602-05 YOU ARE THE FALLEN PART 8.mp4"],
["160604",     "1.3.0.0", "891.02|85.1 MB", "", "2016", "160604 OMGoooooodness WOW!!! GET READY.mp4"],
["160605-01",  "0.0.0.0", "898.01|92.0 MB", "", "2016", "160605-01 WOW!!!!!!!!!!! and STAY tuned.mp4"],
["160605-02",  "0.0.0.0", "544.02|47.3 MB", "", "2016", "160605-02 Checkin in. It's Coming Tomorrow - bring some tissues.mp4"],
["160606-01",  "1.2.0.0", "894.01|66.7 MB", "", "2016", "160606-01 THIS IS IT (1).mp4"],
["160606-02",  "1.2.0.0", "888|60.8 MB", "", "2016", "160606-02 Thisisit ((2)).mp4"],
["160606-03",  "1.2.0.0", "880.01|69.8 MB", "", "2016", "160606-03 THISISIT (((3))).mp4"],
["160606-04",  "1.2.0.0", "896.01|39.7 MB", "", "2016", "160606-04 THISISIT ((((4)))).mp4"],
["160606-05",  "1.2.0.0", "892.02|81.6 MB", "", "2016", "160606-05 THISISIT (((((5)))))).mp4"],
["160608",     "0.0.0.0", "846.02|81.3 MB", "", "2016", "160608 In a Nutshell. And brace yourself for what's next.mp4"],
["160610",     "0.0.0.0", "577.02|54.2 MB", "", "2016", "160610 Who's your favorite VESICA ((football))Team.mp4"],
["160611",     "0.0.0.0", "771.02|71.4 MB", "", "2016", "160611 added 2 minutes to the end!!Who's your favorite VESICA Team.mp4"],
["160614",     "0.0.0.0", "540|59.0 MB", "", "2016", "160614 Prepare your mind Prepare your heart - get your homework done.mp4"],
["160616",     "0.0.0.0", "1430|120 MB", "", "2016", "160616 What did you do with this talent .mp4"],
["160617",     "0.0.0.0", "1565|149 MB", "", "2016", "160617 SNOMED,,Can you say DEMONS.mp4"],
["160618",     "0.0.0.0", "1129|100.0 MB", "", "2016", "160618 Lesson for today - Children's version.mp4"],
["160627",     "0.0.0.0", "6195.69|263 MB", "", "2016", "160627 AND YOU SHALL DIE LIKE MEN with Zen Garcia & Jonathan Kleck.mp4"],
["160701",     "0.0.0.0", "2955.02|258 MB", "", "2016", "160701 preview,,,sorry about the double editing.mp4"],
["160704",     "0.0.0.0", "3471.01|314 MB", "", "2016", "160704 SCRIPTURAL REBUKE to Nephtali and ANY other self appointed (false prophet) hunters .mp4"],
["160706",     "0.0.0.1", "4069.02|407 MB", "", "2016", "160706 Uh Oh  lets' look at the PROOF---the SCRIPTURES.mp4"],
["160707",     "0.0.0.0", "3972.01|357 MB", "", "2016", "160707 recap of Exhibitss 1-9.mp4"],
["160709",     "0.0.0.0", "210|18.0 MB", "", "2016", "160709 This Question NEEDS to be Answered.mp4"],
["160710",     "0.0.0.0", "3600.02|338 MB", "", "2016", "160710 If you said NO You are CORRECT!!!.mp4"],
["160711-01",  "0.0.0.0", "2115.01|222 MB", "", "2016", "160711-01 How do you get turned upsidedown.mp4"],
["160711-02",  "0.0.0.0", "1098|90.7 MB", "", "2016", "160711-02 Parole or NO PAROLE That is the question.mp4"],
["160712-01",  "1.0.0.0", "129.01|10.7 MB", "", "2016", "160712-01 Domino's Pizza Bible lesson for the day.mp4"],
["160712-02",  "1.0.0.0", "2351.02|230 MB", "", "2016", "160712-02 Dominos. Two and One.mp4"],

["160714",     "2.0.0.0", "1957|163 MB", "", "2016", "160714 Obama said Break the Bough Busted!! Again!Pre-Wrath Tribulation.mp4"],
["160718",     "2.0.0.0", "461.01|35.2 MB", "", "2016", "160718 working on the Re-edit, DVD's coming SOON.mp4"],
["160719",     "2.0.0.0", "2634|247 MB", "", "2016", "160719 this will replace the Messed up part of the dvd.mp4"],
["160721",     "2.0.0.0", "135.65|6.25 MB", "", "2016", "160721 random upload. Hmmmmmm.mp4"],
["160723",     "2.0.0.0", "388.01|30.2 MB", "", "2016", "160723 Hillary Clinton Kuru Glitch.mp4"],
["160730",     "2.0.0.0", "15700.73|1.70 GB", "", "2016", "160730 FINAL Case Against Lucifer (Final Edit).mp4"],
["160805",     "2.0.0.0", "949.02|75.8 MB", "", "2016", "160805 DVD is READY!!! Get your envelopes in the mail.mp4"],
["160806",     "2.0.0.0", "908.02|59.1 MB", "", "2016", "160806 Olympic Giant Vagina Birthing new RACE.mp4"],
["160808-01",  "2.0.0.0", "1223.02|102 MB", "", "2016", "160808-01 Hitlery's LOGO is the (TWIN TOWER BOMBING). OMG. VIRAL VIRAL VIRAL.mp4"],
["160808-02",  "2.0.0.0", "473.01|41.2 MB", "", "2016", "160808-02 Hillary 911 LOGO !!! Apollyon's candidate.mp4"],
["160810-01",  "2.0.0.0", "1743.01|156 MB", "", "2016", "160810-01 Lucifer is saying He has accomplished his goal.mp4"],
["160810-02",  "2.0.0.0", "253|23.1 MB", "", "2016", "160810-02 18,000 Ft. OhhKaaaay. LOL.mp4"],
["160814",     "0.0.0.0", "563.5|28.4 MB", "", "2016", "160814 The Temple Before 23 & After 46.mp4"],
["160817",     "0.0.0.0", "1761|151 MB", "", "2016", "160817 Watch this BEFORE the New Olympic video.mp4"],
["160823",     "0.0.0.0", "2752.01|248 MB", "", "2016", "160823 What's REALLY Going on. WOW!!.mp4"],
["160825",     "0.0.0.0", "1801.01|175 MB", "", "2016", "160825 Hillary Bill Satan.mp4"],
["160826-01",  "0.0.0.0", "864.01|73.9 MB", "", "2016", "160826-01 Nukes to ROMANIA.mp4"],
["160826-02",  "0.0.0.0", "460.01|39.5 MB", "", "2016", "160826-02 Did our government cryptically raise the white flag  after 911.mp4"],
["160826-03",  "0.0.0.0", "1005.01|93.2 MB", "", "2016", "160826-03 Follow-up on previous vid.mp4"],
["160830",     "0.0.0.0", "1551|152 MB", "", "2016", "160830 U GOTTA BE KIDDING (BEAST UNLEASHED).mp4"],
["160903",     "0.0.0.0", "1641|153 MB", "", "2016", "160903 Lucifer's Party TELEGRAPHING New Race & Nukes.mp4"],
["160905",     "0.0.0.0", "3852|337 MB", "", "2016", "160905 This IS Their KINGDOM COME.mp4"],
["160909",     "0.0.0.0", "3639.01|315 MB", "", "2016", "160909 HowDareYou The FRUIT is RIPE on the TREE.mp4"],
["160910",     "0.0.0.0", "914.01|83.6 MB", "", "2016", "160910 A Murderer is LESS to be Feared.mp4"],
["160911",     "0.0.0.0", "753.02|61.3 MB", "", "2016", "160911 Hillary Looks like a soildier being drug off the Battlefield.mp4"],
["160915",     "1.2.0.0", "560.02|46.5 MB", "", "2016", "160915 New Race of Beings, Part 1.mp4"],
["160916",     "1.2.0.0", "4844.01|457 MB", "", "2016", "160916 Arch of The DEVIL Coming Soon.mp4"],
["160920",     "1.2.0.0", "808.01|56.3 MB", "", "2016", "160920 Image of the Beast TechnologyHillary FRAUD.mp4"],
["160921",     "1.2.0.0", "554|47.7 MB", "", "2016", "160921 Told You So!! LOLOLOL, PHONY PHONY PHONY.mp4"],
["160923",     "1.2.0.0", "1645.02|125 MB", "", "2016", "160923 New Race of Beings, Part 2.mp4"],
["160924",     "1.2.0.0", "1469.01|114 MB", "", "2016", "160924 New Race of Beings, Part 3.mp4"],
["160925-01",  "1.2.0.0", "2491.01|211 MB", "", "2016", "160925-01 Their God is CONTRARY (((Upsidedown))) to our God.mp4"],
["160925-02",  "1.2.0.0", "557|39.6 MB", "", "2016", "160925-02 OMG, Obama uses an ALIAS in deleted Clinton Email.mp4"],
["160927",     "1.2.0.0", "1963.01|181 MB", "", "2016", "160927 New Race of Beings, Part 4.mp4"],
["160928",     "0.0.0.0", "694.02|41.0 MB", "", "2016", "160928 Obama, Quran.mp4"],
["160929",     "0.0.0.0", "1276.01|119 MB", "", "2016", "160929 Recording 109.mp4"],
["161003",     "0.0.0.0", "1247|128 MB", "", "2016", "161003 Soros Lewis family MOCKING the HUMAN RACE.mp4"],
["161006",     "0.0.0.0", "2524.01|227 MB", "", "2016", "161006 The SECRET GOVERNMENTFEMAliens.mp4"],
["161016",     "0.0.0.0", "3512.04|362 MB", "", "2016", "161016 You KNOW It's COMING!!!!!!.mp4"],
["161017",     "0.0.0.0", "1497.01|87.4 MB", "", "2016", "161017 COPY THIS and PASS IT AROUND!!!!!.mp4"],
["161020",     "0.0.0.0", "3197.06|278 MB", "", "2016", "161020 The MOST IMPORTANT of ALL.mp4"],
["161026",     "0.0.0.0", "2155.02|95.4 MB", "", "2016", "161026 OPEN your EYES. See PAST the Puppet Show.mp4"],
["161031",     "0.0.0.0", "812.05|88.4 MB", "", "2016", "161031 The Russians,the Russians,the Russians, Here it Comes!!! The False Flag of ALL false flags.mp4"],
["161101",     "0.0.0.0", "1797.06|163 MB", "", "2016", "161101 NOOSES Around the NeckReally Hillary.mp4"],
["161102",     "0.0.0.0", "2083.06|195 MB", "", "2016", "161102 This is it This is it This is it!!!!.mp4"],
["161104-01",  "0.0.0.0", "349.04|35.8 MB", "", "2016", "161104-01 RED ALERT!!! IT  (((((IS))))) COMING!!!.mp4"],
["161104-02",  "0.0.0.0", "1983.05|183 MB", "", "2016", "161104-02 RED WEDDING (((at the door))).mp4"],
["161104-03",  "0.0.0.0", "853.05|77.5 MB", "", "2016", "161104-03 UNLEASHING THE BEAST!!!!!.mp4"],
["161107",     "0.0.0.0", "2360.05|247 MB", "", "2016", "161107 The TRUMPET (((was))) Blown.mp4"],
["161108-01",  "0.0.0.0", "501.04|42.6 MB", "", "2016", "161108-01 Comey,Clinton.Sewer Rats @ Lockheed Martin.collusion.com  LOL.mp4"],
["161108-02",  "0.0.0.0", "294.06|25.5 MB", "", "2016", "161108-02 NOOOO Waaaaaaaayy!!!!.mp4"],
["161108-03",  "0.0.0.0", "2240.05|196 MB", "", "2016", "161108-03 Chanel,Trump,clinton U Gotta be kidding!!.mp4"],
["161110",     "1.3.0.0", "6906.01|342 MB", "", "2016", "161110 1) Definition of TRUTH.mp4"],
["161114",     "1.3.0.0", "5971.06|516 MB", "", "2016", "161114 2) Those that have been SENT.mp4"],
["161115",     "1.3.0.0", "1761.05|163 MB", "", "2016", "161115 3) Here Comes The INFO.Dump.mp4"],
["161117",     "1.3.0.0", "3963.02|247 MB", "", "2016", "161117 4) Sperma,,Seed,, Jesus said it!!.mp4"],
["161118",     "1.3.0.0", "3599.05|323 MB", "", "2016", "161118 5) It's not ALL yelling,(((surprise ending)).mp4"],
["161119-01",  "1.0.0.0", "1177.04|105 MB", "", "2016", "161119-01 C.A.T.S. for X-MAS  Looks like it.mp4"],
["161119-02",  "1.0.0.0", "1265.05|120 MB", "", "2016", "161119-02 Dead Sheep are guaranteed, just ask the Rolling Stones,,COMING SOON.mp4"],
["161120",     "1.0.0.0", "1963.06|185 MB", "", "2016", "161120 911 COMING AGAIN!!!!!!!!!!!!!!!!!.mp4"],
["161122-01",  "0.0.0.0", "2606.05|205 MB", "", "2016", "161122-01 You KNOW He's the Antichrist.mp4"],
["161122-02",  "0.0.0.0", "1081.05|69.4 MB", "", "2016", "161122-02 Not Many should be Teachers!!!!!!.mp4"],
["161128",     "0.0.0.0", "5803.01|388 MB", "", "2016", "161128 The END HAS COME.mp4"],
["161129-01",  "0.0.0.0", "4639.05|467 MB", "", "2016", "161129-01 END of theBEAST and the World.mp4"],
["161129-02",  "0.0.0.0", "1138.06|108 MB", "", "2016", "161129-02 A KIND REBUKE to Clarence.mp4"],
["161201-01",  "0.0.0.0", "4088.06|394 MB", "", "2016", "161201-01 The SIGN of JONAH.!!! DONE.mp4"],
["161201-02",  "0.0.0.0", "1920.06|190 MB", "", "2016", "161201-02 UH OH!! FEMALE RIVAL,,TIMES UP.mp4"],
["161203-01",  "0.0.0.0", "1392.06|128 MB", "", "2016", "161203-01 It's about to get crazy!!.mp4"],
["161203-02",  "0.0.0.0", "1973.05|177 MB", "", "2016", "161203-02 This Should Be CRYSTAL CLEAR.mp4"],
["161204-01",  "0.0.0.0", "2354.06|234 MB", "", "2016", "161204-01 Here Comes The ABOMINATION.mp4"],
["161204-02",  "0.0.0.0", "422.05|45.5 MB", "", "2016", "161204-02 Hatch I mals feisty Pets.mp4"],
["161204-03",  "0.0.0.0", "1942|110 MB", "", "2016", "161204-03 The ((LORD GOD)) created Adam,((Elohyim created an idol)).mp4"],
["161205",     "1.0.0.0", "3077.06|313 MB", "", "2016", "161205 MYSTERY COMPLETELY SOLVED.mp4"],
["161207",     "1.0.0.0", "2414.06|244 MB", "", "2016", "161207 EARTH SHATTERING BREAKING NEWS.mp4"],
["161209",     "1.0.0.0", "1819|109 MB", "", "2016", "161209 HERE IT COMES!!!!! XTRA INFO before Final Disclosure.mp4"],
["161211-01",  "0.0.0.0", "2760.06|255 MB", "", "2016", "161211-01 THE WORM THAT NEVER DIES!!!!!!!!!!!!!!.mp4"],
["161211-02",  "0.0.0.0", "2755.05|282 MB", "", "2016", "161211-02 New York Nukes as promised.mp4"],
["161214",     "0.0.0.0", "1898.05|170 MB", "", "2016", "161214 You NEEEED To Download and SAVE this data.mp4"],
["161215",     "0.0.0.0", "780.05|88.2 MB", "", "2016", "161215 PRAISE THE MOST HIGH !!! The BEAM is removed from my EYE.mp4"],
["161216-01",  "0.0.0.0", "671.06|70.7 MB", "", "2016", "161216-01 SATAN's HIDDEN KINGDOM is FINISHED.mp4"],
["161216-02",  "0.0.0.0", "2807.06|312 MB", "", "2016", "161216-02 PRICELESS ABSOLUTELY PRICELESS.mp4"],
["161217",     "0.0.0.0", "1829.06|178 MB", "", "2016", "161217 let's just hang out and observe some things.mp4"],
["161221-01",  "0.0.0.0", "447.05|41.6 MB", "", "2016", "161221-01 checking in.mp4"],
["161221-02",  "0.0.0.0", "2745.06|270 MB", "", "2016", "161221-02 SATANS Buuuusssted!! IT's OVER!!!!.mp4"],
["161222",     "0.0.0.0", "1863.05|187 MB", "", "2016", "161222 GRRrrrrrrr,Let's clear this up NOW!!.mp4"],
["161223",     "0.0.0.0", "2171.09|88.1 MB", "", "2016", "161223 Time to FREE your MINDDon't quit listening!! It changes.mp4"],
["161224",     "0.0.0.1", "4443.02|255 MB", "", "2016", "161224 MUST WATCH. IT's COMPLETELY CONCLUSIVE!!! DRAGONs DONE!!!.mp4"],
["161226-01",  "0.0.0.0", "3405.04|324 MB", "", "2016", "161226-01 legitimate  or liscencious freedom.mp4"],
["161226-02",  "0.0.0.0", "2233.06|217 MB", "", "2016", "161226-02 OBAMA signed the ((((( I ))))) Beam.mp4"],
["161227-01",  "0.0.0.0", "3291.06|307 MB", "", "2016", "161227-01 Get THESE Files !!! Here Comes the Final Disclosure.mp4"],
["161227-02",  "0.0.0.0", "1169.06|107 MB", "", "2016", "161227-02 WOW!!!!!!!!!!!!!!!!!  IT's PROVEN!!!!.mp4"],
["161228",     "0.0.0.0", "1848.05|177 MB", "", "2016", "161228 UNLESS You are BORN (upside down) AGAIN,,,you CANNOT ((SEE.mp4"],
["161229-01",  "0.0.0.0", "1759.05|181 MB", "", "2016", "161229-01 How Pathetically OBVIOUS is Satan's Kingdom now.mp4"],
["161229-02",  "0.0.0.0", "2989.06|305 MB", "", "2016", "161229-02 THEY are GOING to KILL ALL the SHEEP in NYC.mp4"],

//==== 2017 ====

["170101",     "0.0.0.0", "1442.05|155 MB", "", "2017", "170101 On the Verge of Eternity.mp4"],
["170103",     "0.0.0.0", "3715.05|355 MB", "", "2017", "170103 THIS IS IT (Final Disclosure) PART 1.mp4"],
["170104",     "0.0.0.0", "1970.05|206 MB", "", "2017", "170104 Part 2 ABSOLUTELY PERFECT.mp4"],
["170105",     "0.0.0.0", "1671.05|151 MB", "", "2017", "170105 Sheep Preview.mp4"],
["170106-01",  "0.0.0.0", "294.06|24.6 MB", "", "2017", "170106-01 ABSOLUTELY INSANE CONFIRMATION.mp4"],
["170106-02",  "0.0.0.0", "1965.06|201 MB", "", "2017", "170106-02 Make SURE you stay tuned till 5 minute mark, the vid starts.mp4"],
["170107",     "0.0.0.0", "4165.06|413 MB", "", "2017", "170107 LUCIFER's Hidden Church is NO LONGER HIDDEN.mp4"],
["170108",     "0.0.0.0", "923.06|87.8 MB", "", "2017", "170108 The LORD God vs. God and a guy named Barrabbas.mp4"],
["170109",     "0.0.0.0", "2611.06|252 MB", "", "2017", "170109 A gift from the LORD GOD ((Mark15)).mp4"],
["170110-01",  "0.0.0.0", "6725.06|641 MB", "", "2017", "170110-01 WARNING to ((ALL MINIONS)) Here are the FACTS.mp4"],
["170110-02",  "0.0.0.0", "688.05|57.5 MB", "", "2017", "170110-02 SEND ME.mp4"],
["170111",     "0.0.0.0", "3978.04|376 MB", "", "2017", "170111 Trump,Apollo, The Queen of Heaven, It is Finished!!.mp4"],
["170114",     "0.0.0.0", "1450.06|136 MB", "", "2017", "170114 The Devil's on his Way!!!.mp4"],
["170116",     "0.0.0.0", "1636.05|140 MB", "", "2017", "170116 I'm Coming HOME I've Done my Time.mp4"],
["170118-01",  "1.2.0.0", "1771.06|170 MB", "", "2017", "170118-01 Coming to the END Part 1.mp4"],
["170118-02",  "1.2.0.0", "3627.05|352 MB", "", "2017", "170118-02 PART 2 IT IS FINISHED.mp4"],
["170119-01",  "0.0.0.0", "591.04|59.9 MB", "", "2017", "170119-01 Here comes their Destruction.mp4"],
["170119-02",  "0.0.0.0", "203.06|20.6 MB", "", "2017", "170119-02 here comes their destruction extended version.mp4"],
["170119-03",  "0.0.0.0", "857.05|91.1 MB", "", "2017", "170119-03 Trump,Fitzgerald,spear of God.mp4"],
["170120",     "0.0.0.0", "1603.06|140 MB", "", "2017", "170120 Recording 262.mp4"],
["170121",     "0.0.0.0", "3854|204 MB", "", "2017", "170121 NOW - Expect (((EVERYTHING))).mp4"],
["170123",     "0.0.0.0", "4098.04|398 MB", "", "2017", "170123 FACT CHECK!Dead Sheep, Queen of Heaven!Trump Tip of the Spear.mp4"],
["170125",     "0.0.0.0", "84.06|5.16 MB", "", "2017", "170125 Stand Fast.mp4"],
["170126-01",  "0.0.0.0", "4165.06|391 MB", "", "2017", "170126-01 Women's March. You R Fuel to be BURNED!!.mp4"],
["170126-02",  "0.0.0.3", "4698.05|384 MB", "", "2017", "170126-02 Get Your SCRIPTURE Now!!.mp4"],
["170128",     "0.0.0.0", "4251.06|416 MB", "", "2017", "170128 MYSTERY Of MYSTERIES,,SOLVED!!.mp4"],
["170129-01",  "0.0.0.0", "3249.05|338 MB", "", "2017", "170129-01 Out of the Darkness and INTO the LIGHT.mp4"],
["170129-02",  "0.0.0.0", "1095.05|112 MB", "", "2017", "170129-02 Try and Go Easy on the Messenger,WHATEVER MAKES MANIFEST IS LIGHT.mp4"],
["170130",     "0.0.0.0", "2145.06|203 MB", "", "2017", "170130 Time for Edited Scriptural GOLD.mp4"],
["170131-01",  "0.0.0.0", "1116.76|129 MB", "", "2017", "170131-01 1 One World Government - The Mote and The Beam.mp4"],
["170131-02",  "0.0.0.0", "1964.06|201 MB", "", "2017", "170131-02 Would you like to see the manifestation of the dragon's world.mp4"],
["170204",     "0.0.0.0", "1676.99|176 MB", "", "2017", "170204 2 Establish yourself on the Rock.mp4"],
["170206",     "0.0.0.0", "3504.05|346 MB", "", "2017", "170206 The Word WILL SILENCE the enemy.mp4"],
["170207",     "0.0.0.0", "3933.02|360 MB", "", "2017", "170207 DATA DUMP!!!!.mp4"],
["170208",     "0.0.0.0", "770.04|73.7 MB", "", "2017", "170208 Hilarious!!!COMPLETELY DEMENTED.mp4"],
["170210",     "0.0.0.0", "1389.04|136 MB", "", "2017", "170210 That which restrains. Look at Brazil & see the writing on the wall.mp4"],
["170211",     "0.0.0.0", "420.05|22.0 MB", "", "2017", "170211 Gearing up for production video.mp4"],
["170212",     "0.0.0.0", "913.06|45.7 MB", "", "2017", "170212 Codec check 3 short bible lesson.mp4"],
["170213-01",  "0.0.0.0", "170.06|14.6 MB", "", "2017", "170213-01 Codec check.mp4"],
["170213-02",  "0.0.0.0", "1425.06|131 MB", "", "2017", "170213-02 Do you Have 23 minutes to have a chat At least half of you does.mp4"],
["170214-01",  "0.0.0.0", "66.06|3.37 MB", "", "2017", "170214-01 Quick Codec check.mp4"],
["170214-02",  "0.0.0.0", "2904.05|286 MB", "", "2017", "170214-02 Cannibalism at the GRAMMY Awards.mp4"],
["170215-01",  "0.0.0.0", "158.06|13.1 MB", "", "2017", "170215-01 let me know in your country if you can view this.mp4"],
["170215-02",  "0.0.0.0", "2509.06|252 MB", "", "2017", "170215-02 IT IS NOW IN THE OPENNothing more to ever fear.mp4"],
["170218-01",  "0.0.0.0", "574.02|29.7 MB", "", "2017", "170218-01 THEY LIVE codec check.mp4"],
["170218-02",  "0.0.0.0", "1478.04|122 MB", "", "2017", "170218-02 Codec check and hanging out with Juanito.mp4"],
["170218-03",  "0.0.0.0", "1099.05|113 MB", "", "2017", "170218-03 sheep sheeep sheeeep sheeeeep sheeeeeep.mp4"],
["170221",     "0.0.0.0", "431.06|39.5 MB", "", "2017", "170221 Jesus of Nazareth codec check.mp4"],
["170222-01",  "0.0.0.0", "3072.05|250 MB", "", "2017", "170222-01 Sneek Preview of DVD - They Eat Us.mp4"],
["170222-02",  "0.0.0.0", "1979.73|150 MB", "", "2017", "170222-02 Cannibalistic World Government WAKE UP!!!.mp4"],
["170224",     "0.0.0.0", "748.43|72.9 MB", "", "2017", "170224 Double ( YOU ), (VV), (W) Means Cannibal.mp4"],
["170227",     "0.0.0.0", "2185.02|97.4 MB", "", "2017", "170227 CNNCannibal News Network.mp4"],
["170301",     "0.0.0.1", "2588.05|236 MB", "", "2017", "170301 WOW!! Statue of Liberty You Mean COMPLETE SLAVERY.mp4"],
["170302",     "0.0.0.0", "6972.05|650 MB", "", "2017", "170302 BUCKLE UP - DVD Project Review in part.mp4"],
["170303-01",  "0.0.0.0", "772.04|62.7 MB", "", "2017", "170303-01 heads up.mp4"],
["170303-02",  "0.0.0.0", "211.05|13.9 MB", "", "2017", "170303-02 Country CODEC check.mp4"],
["170305",     "0.0.0.0", "2126.04|191 MB", "", "2017", "170305 Race Within a Race.mp4"],
["170308",     "0.0.0.0", "1551.05|129 MB", "", "2017", "170308 CIA-Athena Mother Goddess AGAIN!!!.mp4"],
["170310",     "0.0.0.0", "1347.06|114 MB", "", "2017", "170310 LISTEN CLOSELY EXILES-Part 1.mp4"],
["170311",     "0.0.0.0", "2553.06|239 MB", "", "2017", "170311 Exiles Revised.mp4"],
["170312",     "0.0.0.0", "3497.04|300 MB", "", "2017", "170312 Get some popcorn this will help you understand the depth of.mp4"],
["170313-01",  "0.0.0.0", "391.05|29.5 MB", "", "2017", "170313-01 Check out the partial upload to the DVD.mp4"],
["170313-02",  "0.0.0.0", "2981.81|263 MB", "", "2017", "170313-02 You Are Exiles - DVD Part 1.mp4"],
["170314",     "0.0.0.0", "2283.06|180 MB", "", "2017", "170314 More PROOF of a Cannibalistic system.mp4"],
["170316",     "0.0.0.0", "453.04|36.5 MB", "", "2017", "170316 Radio Tonight - Mystery of Mysteries - Done.mp4"],
["170317-01",  "0.0.0.0", "293.06|25.0 MB", "", "2017", "170317-01 Recording 4.mp4"],
["170317-02",  "0.0.0.0", "1203.05|96.0 MB", "", "2017", "170317-02 Your thoughts on the quality of the recording.mp4"],
["170318-01",  "0.0.0.0", "7225.05|568 MB", "*efm_UOmh2Uo", "2017", "170318-01 ANGELS to HUMANS to LOCUSTS.mp4"],
["170318-02",  "0.0.0.0", "462.05|28.1 MB", "", "2017", "170318-02 Heads up!!! New recording on the way.mp4"],
["170319-01",  "0.0.0.0", "1313.02|97.9 MB", "", "2017", "170319-01 K.O. To the MAT Satan!!!!.mp4"],
["170319-02",  "0.0.0.0", "1438.06|114 MB", "", "2017", "170319-02 WOW!! Confirmation plus explanation.mp4"],
["170319-03",  "0.0.0.0", "2258.05|162 MB", "", "2017", "170319-03 Locusts!Wreck it Ralph!Mt.Cola!Shasta.mp4"],
["170321",     "0.0.0.0", "319.04|22.2 MB", "", "2017", "170321 Status Update.mp4"],
["170324",     "0.0.0.0", "1084.05|88.5 MB", "", "2017", "170324 Let's Kick some Locust Ass!!!.mp4"],
["170326",     "0.0.0.0", "3003.06|299 MB", "", "2017", "170326 The Lord said to PUBLISH this video I was going to delete it.mp4"],
["170328",     "0.0.0.0", "2529.05|312 MB", "", "2017", "170328 You Are Exiles Part 2 (not on DVD).mp4"],
["170330",     "0.0.0.0", "3387|269 MB", "", "2017", "170330 United States of Locusts from the Pit!!!!.mp4"],
["170402-01",  "0.0.0.0", "3051.01|251 MB", "", "2017", "170402-01 The Capital of the US Queen of Heaven eating SHEEP.mp4"],
["170402-02",  "0.0.0.0", "1965.01|157 MB", "", "2017", "170402-02 YOU CAN TELL EVERY TREE by its FRUIT, enough of the phonies.mp4"],
["170403",     "0.0.0.0", "1451.01|112 MB", "", "2017", "170403 Exiles DVD insert (((just sharing))).mp4"],
["170407-01",  "0.0.0.0", "1466.02|66.5 MB", "", "2017", "170407-01 Trump the Tip of the Spear.mp4"],
["170407-02",  "0.0.0.0", "3551|191 MB", "", "2017", "170407-02 AWESOME Deep State Follow-up Vid by Clay FaithfulBerean.mp4"],
["170408-01",  "0.0.0.0", "2728.02|112 MB", "", "2017", "170408-01 YES!!! There IS a Rapture ((THE BRIDE))).mp4"],
["170408-02",  "0.0.0.0", "3091.78|176 MB", "", "2017", "170408-02 You.Are.Exiles.DVD.So.Far.mp4"],
["170408-03",  "0.0.0.0", "231.02|12.3 MB", "", "2017", "170408-03 quick addendum.mp4"],
["170408-04",  "0.0.0.0", "823.01|61.7 MB", "", "2017", "170408-04 Little deviants revisit.mp4"],
["170410-01",  "0.0.0.0", "3943|153 MB", "", "2017", "170410-01 Trump & The Queen of Heaven 1 in a gazillion.mp4"],
["170410-02",  "0.0.0.0", "1272.11|167 MB", "", "2017", "170410-02 Mother of Exiles - new DVD content.mp4"],
["170410-03",  "0.0.0.0", "2433.01|88.9 MB", "", "2017", "170410-03 WOW. Public PROOF. Must watch.mp4"],
["170413",     "0.0.0.0", "3861.01|195 MB", "", "2017", "170413 NY WILL be Destroyed 59 Rich Oppressor.mp4"],
["170418",     "0.0.0.0", "1464.02|70.3 MB", "", "2017", "170418 Most recent DVD addition - Double You.mp4"],
["170419-01",  "0.0.0.0", "1558.01|71.6 MB", "", "2017", "170419-01 Papal Regalia The Dragon's Altar!!.mp4"],
["170419-02",  "0.0.0.0", "4815.21|448 MB", "", "2017", "170419-02 You Are Exiles - All DVD Content.mp4"],
["170420",     "0.0.0.0", "977|39.5 MB", "", "2017", "170420 Harpazo.mp4"],
["170423-01",  "0.0.0.0", "804.01|33.2 MB", "", "2017", "170423-01 heads up on new DVD content.mp4"],
["170423-02",  "0.0.0.0", "4737.01|220 MB", "", "2017", "170423-02 Most recent Addition to dvd.mp4"],
["170430",     "0.0.0.0", "4699.02|195 MB", "", "2017", "170430 IN-Surrection RE-Surrection BIBLE TRUTH REVEALED!!.mp4"],
["170501-01",  "1.0.0.0", "572|32.4 MB", "", "2017", "170501-01 Codec country check.mp4"],
["170501-02",  "1.0.0.0", "153.02|9.01 MB", "", "2017", "170501-02 Codec country check 2.mp4"],
["170501-03",  "1.0.0.0", "333.02|31.1 MB", "", "2017", "170501-03 codec 3 kenzo.mp4"],
["170501-04",  "1.0.0.0", "99.01|11.0 MB", "", "2017", "170501-04 Codec check 4 coco.mp4"],
["170501-05",  "1.0.0.0", "158.01|6.87 MB", "", "2017", "170501-05 Codec check 5 Versace.mp4"],
["170501-06",  "1.0.0.0", "194|9.56 MB", "", "2017", "170501-06 Codec check 6 Smirnoff.mp4"],
["170501-07",  "1.0.0.0", "196.02|10.8 MB", "", "2017", "170501-07 Codec check 7 Jaguar.mp4"],
["170502-01",  "1.0.0.0", "455.02|15.6 MB", "", "2017", "170502-01 codec check passion.mp4"],
["170502-02",  "1.0.0.0", "289.02|11.0 MB", "", "2017", "170502-02 Codec check Passion.mp4"],
["170503",     "0.0.0.0", "853.01|79.0 MB", "", "2017", "170503 Russian NUKE, Tidal Wave, New York, It's coming.mp4"],
["170505",     "0.0.0.0", "1815.01|70.1 MB", "", "2017", "170505 KNOW Your Enemy, Isaiah 574.Psalm 3519.mp4", "Isaiah 57:4./Psalm 35:19"],
["170506-01",  "0.0.0.0", "751|27.3 MB", "", "2017", "170506-01 Heads up, DVD almost done, preview today.mp4"],
["170506-02",  "0.0.0.0", "6902.92|575 MB", "", "2017", "170506-02 Updated Exiles DVD Country, Codec check.mp4"],
["170507-01",  "0.0.0.0", "3646.02|155 MB", "", "2017", "170507-01 BAPTISM - MUST SEE.mp4"],
["170507-02",  "0.0.0.0", "2987.01|139 MB", "", "2017", "170507-02 OK it's sponge time story.mp4"],
["170509-01",  "0.0.0.0", "6619.01|310 MB", "", "2017", "170509-01 SUPER NATURAL DATA DUMP Before the Container testimony.mp4"],
["170509-02",  "0.0.0.0", "2049.02|96.0 MB", "", "2017", "170509-02 ANGELS In (((BIG))) Trouble (Genesis 3).mp4"],
["170511-01",  "0.0.0.0", "600|22.6 MB", "", "2017", "170511-01 Container testimony T V commercials update.mp4"],
["170511-02",  "0.0.0.0", "1494.97|120 MB", "", "2017", "170511-02 Commercials Section from Exiles DVD.mp4"],
["170513",     "0.0.0.0", "646.72|71.0 MB", "", "2017", "170513 Bud Light Commercial- Hoover Dam Birth.mp4"],
["170516",     "0.0.0.0", "920.16|78.7 MB", "", "2017", "170516 Trapped Essence - Vesica Piscis Chanel & Versace Commercials.mp4"],
["170517-01",  "0.0.0.0", "1852|73.2 MB", "", "2017", "170517-01 Jose Cuervo, Obama, climate change.mp4"],
["170517-02",  "0.0.0.0", "1168.01|50.2 MB", "", "2017", "170517-02 X-tra CuervoAnswered question.mp4"],
["170518",     "0.0.0.0", "1201.01|44.1 MB", "", "2017", "170518 DVD ALMOST FINISHEDWatch THIS.mp4"],
["170519",     "0.0.0.0", "11126.82|597 MB", "", "2017", "170519 You Are EXILES (minus Maserati commercial and conclusion).mp4"],
["170520",     "0.0.0.0", "4780.5|439 MB", "", "2017", "170520 Sudden Nuclear Strike & New Race Emerging Commercials.mp4"],
["170521",     "0.0.0.0", "465|14.3 MB", "", "2017", "170521 Heads Up on Commercial Section of DVD.mp4"],
["170522",     "0.0.0.0", "1945.02|99.2 MB", "", "2017", "170522 3 Subjects Covered in this Video.mp4"],
["170526",     "0.0.0.0", "846.02|53.0 MB", "", "2017", "170526 Preview of Shipping Container Testimony.mp4"],
["170529-01",  "0.0.0.0", "1150.8|200 MB", "", "2017", "170529-01 Shipping Container Testimony - New Jerusalem.mp4"],
["170529-02",  "0.0.0.0", "5825.26|386 MB", "", "2017", "170529-02 Shipping Container (vid. that was taken down)- Full Explanation WATCH Video FOLLOWING THIS!!.mp4"],
["170530",     "0.0.0.0", "674.01|26.4 MB", "", "2017", "170530 I need 11 minutes of your time.mp4"],
["170531",     "0.0.0.0", "9835.02|575 MB", "", "2017", "170531 It is Finished.mp4"],
["170601-01",  "1.2.0.0", "623.22|41.9 MB", "", "2017", "170601-01 Bug Mania - Locust Aliens from the Pit.mp4"],
["170601-02",  "1.2.0.0", "644.86|79.6 MB", "", "2017", "170601-02 Bug Mania With Xtra edits- - Locust Aliens from the Pit.mp4"],
["170602",     "0.0.0.0", "2230.02|115 MB", "", "2017", "170602 WARNING!!! WARNING!!! WOW!!! CONFIRMATION.mp4"],
["170605-01",  "0.0.0.0", "797|33.7 MB", "", "2017", "170605-01 WOW!!! Breaking News.mp4"],
["170605-02",  "0.0.0.0", "1408.31|118 MB", "", "2017", "170605-02 Locked In! How to Escape Your Prison.mp4"],
["170612",     "0.0.0.0", "2137|89.4 MB", "", "2017", "170612 UN-Edited conclusion to DVD.mp4"],
["170615-01",  "0.0.0.0", "717.01|28.2 MB", "", "2017", "170615-01 Publishing FULL COMPLETE DVD in a few hours.mp4"],
["170615-02",  "7.4.0.3", "13224.32|1.14 GB", "*Xw5ndNkLYQ4", "2017", "170615-02 You Are Exiles Complete DVD.mp4", "*Key Video"],
["170617",     "0.0.0.0", "6354|360 MB", "", "2017", "170617 DEATH IS COMING - Make sure you have The LIFE in YOU.mp4"],
["170621",     "0.0.0.0", "2447.01|104 MB", "", "2017", "170621 9-11 Testimony Coming - Watch this to catch up.mp4"],
["170622",     "0.0.0.0", "807.89|118 MB", "", "2017", "170622 9-11 Container Confirmation - Chet Symbols.mp4"],
["170626",     "0.0.0.0", "1346.94|126 MB", "", "2017", "170626 USA Kingdom is Divided - Red vs Blue.mp4"],
["170627",     "0.0.0.0", "1922.01|89.4 MB", "", "2017", "170627 You can love your Enemies and block their access.mp4"],
["170702",     "0.0.0.0", "2593.02|122 MB", "", "2017", "170702 The SWORD of the SPIRIT,,((The WORD of GOD)).mp4"],
["170703-01",  "0.0.0.0", "464|16.2 MB", "", "2017", "170703-01 Quick check in,,,Container update coming tonight.mp4"],
["170703-02",  "0.0.0.0", "865.5|184 MB", "", "2017", "170703-02 Container Update - Bride of Christ.mp4"],
["170707",     "0.0.0.0", "3601.02|141 MB", "", "2017", "170707 IT's BEEN REVEALED ((THE WEDDING SUPPER of The LAMB))).mp4"],
["170708",     "0.0.0.0", "381.02|14.9 MB", "", "2017", "170708 Now FINISH The WORK!!.mp4"],
["170710",     "0.0.0.0", "980.02|137 MB", "", "2017", "170710 Octagon Wedding TA8LE.mp4"],
["170713-01",  "0.0.0.0", "2301|101 MB", "", "2017", "170713-01 Get Ready for Never before published info.mp4"],
["170713-02",  "0.0.0.0", "2202.78|151 MB", "", "2017", "170713-02 Global Elite Pedophile Network Exposed.mp4"],
["170714",     "0.0.0.0", "1977.02|85.8 MB", "", "2017", "170714 I am the DOOR ((You gotta be Kidding )) God Is AWESOME.mp4"],
["170716",     "1.3.0.0", "400.45|30.5 MB", "", "2017", "170716 Seth Rich's Murder - The Key to Obamagate & Pedo Rings.mp4"],
["170721-01",  "0.0.0.0", "3499.01|231 MB", "", "2017", "170721-01 THE BRIDEGROOM IS COMING - Mind Destroying Testimony.mp4"],
["170721-02",  "0.0.0.0", "3023.54|228 MB", "", "2017", "170721-02 The Antichrist Will Return Amidst Engineered Anarchy.mp4"],
["170727",     "0.0.0.0", "2672.01|137 MB", "", "2017", "170727 U.S. Currency tells the story, USHER in The MARK of the BEAST.mp4"],
["170728",     "0.0.0.0", "2480.1|145 MB", "", "2017", "170728 U.S. Currency (Foreign Country Fix) USHER in The MARK of the BEAST.mp4"],
["170802-01",  "0.0.0.0", "1439.36|293 MB", "", "2017", "170802-01 Container UPDATE Double Mirror & Vesica Piscis Anomaly.mp4"],
["170802-02",  "0.0.0.0", "495.54|111 MB", "", "2017", "170802-02 Passion Flower Vine - Container Update (8.2.2017).mp4"],
["170803",     "0.0.0.0", "720.07|82.7 MB", "", "2017", "170803 Obama's Shadow War Room Exposed.mp4"],
["170804",     "0.0.0.0", "333.65|77.0 MB", "", "2017", "170804 Matt 2427 As Lightning - John 107 I AM the Door - John 151 I AM the True Vine.mp4"],
["170806",     "0.0.0.0", "404.89|68.1 MB", "", "2017", "170806 Vine & Container UPDATE (8.6.2017).mp4"],
["170808",     "0.0.0.0", "904.32|47.8 MB", "", "2017", "170808 What is the Awan Bros. Doing Behind Trey Gowdy.mp4"],
["170810",     "0.0.0.0", "3801.01|169 MB", "", "2017", "170810 In Rust Crust THEY TRUST - Watch it all.mp4"],
["170814",     "0.0.0.0", "2274.02|189 MB", "", "2017", "170814 MUST WATCH for Subscribers!! Infinity Vine.mp4"],
["170815-01",  "0.0.0.0", "3131|126 MB", "", "2017", "170815-01 Trump Tip of The Spear Nuclear Fire & Fury.mp4"],
["170815-02",  "0.0.0.0", "617.14|39.9 MB", "", "2017", "170815-02 Fire & Fury - Nuclear Spear Tip - New York (short version).mp4"],
["170818",     "0.0.0.0", "2157.02|342 MB", "", "2017", "170818 Jorge's Awesome Conversion Testimony.mp4"],
["170819-01",  "1.2.0.0", "291.53|60.7 MB", "", "2017", "170819-01 I Have Called You By Name - Part 1.mp4"],
["170819-02",  "1.2.0.0", "316.6|82.6 MB", "", "2017", "170819-02 I Have Called You By Name - Part 2.mp4"],
["170821",     "0.0.0.0", "1055.02|43.5 MB", "", "2017", "170821 WOW!! oh WOW!!! - Rapid Increase Locusts.mp4"],
["170824-01",  "0.0.0.0", "1279|49.7 MB", "", "2017", "170824-01 (Zeus Virus) attacking Yah lovers.mp4"],
["170824-02",  "0.0.0.0", "226.14|16.4 MB", "", "2017", "170824-02 Battle Ready Body of Christ - Hurricane Harvey.mp4"],
["170826",     "0.0.0.0", "3289.01|159 MB", "", "2017", "170826 Do you KNOW Christ END TIME MESSAGE Last moments are here.mp4"],
["170827",     "0.0.0.0", "1158.03|169 MB", "", "2017", "170827 The Strong Russian DELUSIONAL Lie (Part 1).mp4"],
["170828-01",  "0.0.0.0", "1084|57.9 MB", "", "2017", "170828-01 Big Lie (intermission between Part 1 & Part 2).mp4"],
["170828-02",  "0.0.0.0", "2639.09|157 MB", "", "2017", "170828-02 The Strong Russian DELUSIONAL Lie (Part 2).mp4"],
["170829",     "0.0.0.0", "3030.02|264 MB", "", "2017", "170829 THEY ARE BUSTED!! - Taylor Swift & Adidas.mp4"],
["170831",     "0.0.0.0", "245.25|54.6 MB", "", "2017", "170831 Shipping Container Update (8.31.17).mp4"],
["170902",     "0.0.0.0", "6572.94|330 MB", "", "2017", "170902 Satan's Supernatural Locust Army Rising Mystery Solved! ALL GLORY to the LORD GOD.mp4"],
["170903",     "0.0.0.0", "469.62|117 MB", "", "2017", "170903 DNA Staircase - Container Update (9.3.17).mp4"],
["170905",     "0.0.0.0", "2884.01|166 MB", "", "2017", "170905 Hurricane IRMA What does it have to do with a priest praising LUCIFER.mp4"],
["170906",     "0.0.0.0", "537.7|83.3 MB", "", "2017", "170906 4321 ZERO - Eclipse & Hurricane Warnings from God.mp4"],
["170907",     "0.0.0.0", "400.4|65.8 MB", "", "2017", "170907 More Signs & Confirmations - The End of the Age.mp4"],
["170909",     "0.0.0.0", "797.07|226 MB", "", "2017", "170909 Container Art Update (9.9.2017).mp4"],
["170911",     "0.0.0.0", "861.58|135 MB", "", "2017", "170911 New York City Nuke & Tidal Wave.mp4"],
["170913",     "0.0.0.0", "871.07|161 MB", "", "2017", "170913 The Flashpoint Event New York City Destroyed.mp4"],
["170915",     "0.0.0.0", "501.78|99.8 MB", "", "2017", "170915 The End of America.mp4"],
["170917",     "0.0.0.0", "280.38|71.8 MB", "", "2017", "170917 Sunday Container Update (9.17.17).mp4"],
["170919",     "0.0.0.0", "2942.6|153 MB", "", "2017", "170919 HelioFant - I Pet Goat 2 Decrypted 2017.mp4"],
["170921-01",  "0.0.0.0", "2971.02|141 MB", "", "2017", "170921-01 MUST SEE Video - Crazy Simpsons Connections.mp4"],
["170921-02",  "0.0.0.0", "201.69|29.9 MB", "", "2017", "170921-02 Upside Down EXIT Sign.mp4"],
["170926",     "0.0.0.0", "1364.15|290 MB", "", "2017", "170926 Container Completed (9.25.2017).mp4"],
["170927",     "0.0.0.0", "374.05|102 MB", "", "2017", "170927 Jonathan's 2001 Art Matches the 2017 Container.mp4"],
["170929-01",  "0.0.0.0", "631|26.5 MB", "", "2017", "170929-01 NEW YORK ((DESTROYED!!)) Host body system OVER!!!.mp4"],
["170929-02",  "0.0.0.0", "2701.92|179 MB", "", "2017", "170929-02 U2 & Moby Telegraphing Fall of Babylon NYC.mp4"],
["170930",     "0.0.0.0", "1058.69|190 MB", "", "2017", "170930 Video 777 Game Over.mp4"],
["171001",     "0.0.0.0", "1082.1|195 MB", "", "2017", "171001 Falling Star Lucifer Will Be Cast Down.mp4"],
["171002",     "0.0.0.0", "1417.9|249 MB", "", "2017", "171002 Imminent Rapture Warning - The Struggle is Over.mp4"],
["171004",     "0.0.0.0", "1274.96|272 MB", "", "2017", "171004 We Shall Be Changed in the Twinkling of an Eye.mp4"],
["171005",     "0.0.0.0", "1809.95|140 MB", "", "2017", "171005 Approaching Rapture & New York Destruction.mp4"],
["171007",     "0.0.0.0", "4449.55|860 MB", "", "2017", "171007 This Is It! Ministry Hangout & Reflections.mp4"],
["171008",     "0.0.0.0", "785.02|32.5 MB", "", "2017", "171008 The Group Behind the Scenes.mp4"],
["171010",     "0.0.0.0", "2332.82|133 MB", "", "2017", "171010 is this it THIS IS IT!.mp4"],
["171013-01",  "0.0.0.0", "400.01|41.8 MB", "", "2017", "171013-01 Picture cut off time.mp4"],
["171013-02",  "0.0.0.0", "1454.52|85.9 MB", "", "2017", "171013-02 43210 Ministry Photo Slideshow.mp4"],
["171017",     "1.2.0.0", "834.32|68.1 MB", "", "2017", "171017 Babylon is the Land of Confusion.mp4"],
["171019",     "1.2.0.1", "393.02|58.1 MB", "", "2017", "171019 HUGE SCRIPTURAL REVELATION Tonight on Radio & YouNow.mp4"],
["171022",     "1.3.0.1", "690.5|78.4 MB", "*7Qrlk-2Dfkk", "2017", "171022 Series Intro - System of Control.mp4"],
["171023-01",  "1.2.0.1", "734.01|45.7 MB", "", "2017", "171023-01 Addendum to Series Intro.mp4"],
["171023-02",  "1.2.0.1", "1530.87|93.3 MB", "", "2017", "171023-02 1 They Turn Everything Upside Down.mp4"],
["171024",     "1.2.0.1", "1028.04|66.3 MB", "", "2017", "171024 2 Your Scriptures Say You Are (godsangels).mp4"],
["171026-01",  "1.2.0.1", "1386.7|92.9 MB", "", "2017", "171026-01 3 The Twin System STRONG DELUSION.mp4"],
["171026-02",  "1.2.0.1", "746.24|47.7 MB", "", "2017", "171026-02 4 The Key - Keep Yourselves From Idols.mp4"],
["171027",     "1.2.0.0", "207.84|19.9 MB", "", "2017", "171027 Time to Apply The Knowledge.mp4"],
["171031",     "1.2.0.0", "344.72|38.8 MB", "", "2017", "171031 Suddenly Babylon is Fallen.mp4"],
["171101",     "1.2.0.0", "1592.82|172 MB", "", "2017", "171101 The FALLEN Host Body.mp4"],
["171102",     "0.0.0.0", "695.02|34.8 MB", "", "2017", "171102 For The Record. Don't be Locust food.mp4"],
["171104",     "0.0.0.0", "636.16|73.4 MB", "", "2017", "171104 Light Bending Shapeshifters 1.mp4"],
["171105",     "0.0.0.0", "2907.44|237 MB", "", "2017", "171105 Full Testimony Light Bending Shapeshifters 2.mp4"],
["171109-01",  "0.0.0.0", "4111|255 MB", "", "2017", "171109-01 The Phantom Tyrant Barack Obama Commentary.mp4"],
["171109-02",  "0.0.0.0", "61.42|17.1 MB", "", "2017", "171109-02 Portal.Star.Google.Doodle (10-10-17).mp4"],
["171111",     "0.0.0.0", "2258.74|150 MB", "", "2017", "171111 A Chilling Preview NYC Water Event.mp4"],
["171112",     "0.0.0.0", "2384.16|134 MB", "", "2017", "171112 Ready For It - Genesis to Revelation.mp4"],
["171118",     "0.0.0.0", "497.14|56.8 MB", "", "2017", "171118 The Antichrist is Exposed.mp4"],
["171119-01",  "0.0.0.0", "59|1.80 MB", "", "2017", "171119-01 Test Video YES! New Program WORKS!.mp4"],
["171119-02",  "0.0.0.0", "1407.01|58.1 MB", "", "2017", "171119-02 Tech Test DESTROY SATAN'S KINGDOM.mp4"],
["171121",     "0.0.0.0", "1196.01|146 MB", "", "2017", "171121 It Is Coming to an END. I'm Done with the Radio.mp4"],
["171123",     "0.0.0.0", "1491.02|112 MB", "", "2017", "171123 Our God is an ALL CONSUMING FIRE.mp4"],
["171126-01",  "0.0.0.0", "3438.02|163 MB", "", "2017", "171126-01 Are (((YOU )))) in the Presence of the ENEMY Watch This!!.mp4"],
["171126-02",  "0.0.0.0", "516.5|61.8 MB", "", "2017", "171126-02 The Fruits of Our Labor Ready for HARVEST.mp4"],
["171129-01",  "0.0.0.0", "83.5|13.3 MB", "", "2017", "171129-01 Dobbs Obama Shadowing Trump Again (Unprecedented).mp4"],
["171129-02",  "0.0.0.0", "3676.02|179 MB", "", "2017", "171129-02 Anti Christ & Biology Lesson!!.mp4"],
["171130",     "0.0.0.0", "1441.31|201 MB", "", "2017", "171130 The Wait is Over .mp4"],
["171202",     "1.2.0.0", "3826.74|183 MB", "", "2017", "171202 Livestream 1 Dead Sheep & Aliens.mp4"],
["171203",     "0.0.0.0", "2970.02|200 MB", "", "2017", "171203 THE SECRET.mp4"],
["171204-01",  "0.0.0.0", "1629.02|148 MB", "", "2017", "171204-01 Let's Really Talk about the NAME of The Lord God.mp4"],
["171204-02",  "0.0.0.0", "875.02|66.7 MB", "", "2017", "171204-02 Recording 196.mp4"],
["171204-03",  "0.0.0.0", "1289.01|104 MB", "", "2017", "171204-03 Most ACCURATE of ALL 196.mp4"],
["171205",     "0.0.0.0", "945.12|189 MB", "", "2017", "171205 DAY of RECKONING.mp4"],
["171207",     "0.0.0.0", "1404.02|77.7 MB", "", "2017", "171207 On the Verge!!!.mp4"],
["171210",     "0.0.0.0", "2606.21|470 MB", "", "2017", "171210 The Locust Army Has a King Over Them.mp4"],
["171211-01",  "1.2.0.1", "6030.38|240 MB", "", "2017", "171211-01 Livestream 2 Drawing & Scriptures.mp4"],
["171211-02",  "0.0.0.0", "608.62|140 MB", "", "2017", "171211-02 Perfect & Complete Waiting Period.mp4"],
["171213",     "0.0.0.0", "1655.07|154 MB", "", "2017", "171213 The KEY & The LOCK.mp4"],
["171215",     "0.0.0.0", "1322.66|139 MB", "", "2017", "171215 The Bell Has Rung - Michael vs Lucifer Supernatural War.mp4"],
["171219",     "0.0.0.0", "1200.75|75.7 MB", "", "2017", "171219 BELLUMINATI New Commercial Breakdown.mp4"],
["171220",     "1.2.0.0", "7869.41|389 MB", "", "2017", "171220 Livestream 3.mp4"],
["171221",     "1.2.0.0", "9687.04|428 MB", "", "2017", "171221 Livestream 4.mp4"],
["171223",     "1.2.0.0", "11980.82|565 MB", "", "2017", "171223 Livestream 5.mp4"],
["171228",     "0.0.0.0", "159.01|34.3 MB", "", "2017", "171228 Quick check in before INDICTMENT.mp4"],
["171231",     "0.0.0.0", "1252.02|145 MB", "", "2017", "171231 Lucifer Your Day in Court has Arrived !!!.mp4"],

//==== 2018 ====

["180102",     "0.0.0.0", "582.01|50.3 MB", "", "2018", "180102 Just checking in Getting ready for Delivery.mp4"],
["180104",     "0.0.0.0", "3921.08|198 MB", "", "2018", "180104 Testimony of Events Leading to My Father's Death.mp4"],
["180109",     "0.0.0.0", "5801.02|403 MB", "", "2018", "180109 ORIGINAL SIN !!!!!! SOLVED !! ALL GLORY TO THE LORD GOD.mp4"],
["180112-01",  "0.0.0.0", "7271.05|825 MB", "*LxYo-XoCrW8", "2018", "180112-01 Original Sin - Follow Up.mp4"],
["180112-02",  "0.0.0.0", "2755|163 MB", "", "2018", "180112-02 Update & Application of Knowledge.mp4"],
["180113",     "0.0.0.0", "2883.01|190 MB", "", "2018", "180113 TIME'S UP.mp4"],
["180115",     "0.0.0.0", "831.02|80.9 MB", "", "2018", "180115 OPRAH-HARPO OWN-NWO RA worship.mp4"],
["180116-01",  "0.0.0.0", "170.02|15.6 MB", "", "2018", "180116-01 codec check for new video.mp4"],
["180116-02",  "0.0.0.0", "3818.01|191 MB", "", "2018", "180116-02 MANFESTINGTHEY ARE COMING!!!.mp4"],
["180116-03",  "0.0.0.0", "1422.01|114 MB", "", "2018", "180116-03 NAILED IT !!! They are Finished SOON!!.mp4"],
["180117",     "0.0.0.0", "4330.01|287 MB", "", "2018", "180117 The Angels--HOLY,Erection,( Yep they are THAT Twisted!! ).mp4"],
["180118",     "0.0.0.0", "5170.02|347 MB", "", "2018", "180118 DELUSION and MORE DELUSION.mp4"],
["180121",     "0.0.0.0", "1811.02|177 MB", "", "2018", "180121 DEMONS Say Hello to the Demons.mp4"],
["180122",     "0.0.0.0", "2569.01|241 MB", "", "2018", "180122 WHAT THEY (((WORSHIP))).mp4"],
["180123",     "0.0.0.0", "4217.02|212 MB", "", "2018", "180123 PRELUDE to DONALD TRUMP VIDEO ((refresher)).mp4"],
["180124",     "0.0.0.0", "1220.02|164 MB", "", "2018", "180124 Checking in and DOCUMENTING.mp4"],
["180125",     "0.0.0.0", "1877.01|193 MB", "", "2018", "180125 Tip of the Spear Confirmation and getting started video.mp4"],
["180126-01",  "0.0.0.0", "401.01|17.9 MB", "", "2018", "180126-01 Good Morning Gift of Knowledge.mp4"],
["180126-02",  "0.0.0.0", "914.01|34.5 MB", "", "2018", "180126-02 Same info Time to Burn It!!.mp4"],
["180127-01",  "0.0.0.0", "3244.01|277 MB", "", "2018", "180127-01 Your TOWN CRIER has BEEN ACTIVATED.mp4"],
["180127-02",  "0.0.0.0", "265.01|23.5 MB", "", "2018", "180127-02 Workin on it workin on it!!! LOL.mp4"],
["180128-01",  "0.0.0.0", "140.02|11.2 MB", "", "2018", "180128-01 BOX ONE REady to be Delivered.mp4"],
["180128-02",  "0.0.0.0", "763.01|51.3 MB", "", "2018", "180128-02 TOLD You So ((Sweet Jesus)) You Gotta be Kidding!!.mp4"],
["180128-03",  "0.0.0.0", "156.01|6.17 MB", "", "2018", "180128-03 ((1649 )) Sean Hannity BANNED from Twitter.mp4"],
["180128-04",  "0.0.0.0", "595.01|48.8 MB", "", "2018", "180128-04 Oh My Lord !!.mp4"],
["180128-05",  "0.0.0.0", "317.02|36.9 MB", "", "2018", "180128-05 Dealing with some computer issues. It's gotta be right.mp4"],
["180129-01",  "0.0.0.0", "1458|121 MB", "", "2018", "180129-01 Supernatural Tip Of The Spear Confirmation AGAIN.mp4"],
["180129-02",  "0.0.0.0", "1893.01|115 MB", "", "2018", "180129-02 Fire and Fury Time to look up.mp4"],
["180130-01",  "0.0.0.0", "6276.01|337 MB", "", "2018", "180130-01 TRUMP Tip of The SPEAR ( Part 1 ).mp4"],
["180130-02",  "0.0.0.0", "2292.02|105 MB", "", "2018", "180130-02 Clinton and 911 Kali rising.mp4"],
["180131-01",  "0.0.0.0", "2408|150 MB", "", "2018", "180131-01 Bono Jesus Trump - figure it out!!!.mp4"],
["180131-02",  "0.0.0.0", "575.02|44.3 MB", "", "2018", "180131-02 Train Crash,,, Possible Attempt to Take Out GOP Lawmakers.mp4"],
["180131-03",  "0.0.0.0", "698.02|38.9 MB", "", "2018", "180131-03 CANNIBAL, Crozet, Train Wreck, you gotta be Kidding!!.mp4"],
["180131-04",  "0.0.0.0", "939.01|63.6 MB", "", "2018", "180131-04 TOTALLY IMPOSSIBLE Get Ready.mp4"],
["180201-01",  "0.0.0.0", "1858.01|124 MB", "", "2018", "180201-01 Maybe ALL you Bono Haters were RIGHT. Maybe not.mp4"],
["180201-02",  "0.0.0.0", "1101.02|70.0 MB", "", "2018", "180201-02 Kennedy,Trump, Train Wreck,Spear tip AGAIN!! Gimme a Break !.mp4"],
["180201-03",  "0.0.0.0", "846.02|58.6 MB", "", "2018", "180201-03 Sudden Impact! What is the PIERCING High Pitch Frequency a.mp4"],
["180201-04",  "0.0.0.0", "462.01|32.3 MB", "", "2018", "180201-04 What did He say Let me BOIL it DOWN realsimple.mp4"],
["180201-05",  "0.0.0.0", "304.02|25.6 MB", "", "2018", "180201-05 Recording 254.mp4"],
["180206",     "0.0.0.0", "2717.01|185 MB", "", "2018", "180206 Beast Unleashed Telegraphed and in your FACE.mp4"],
["180207",     "0.0.0.0", "5259.02|294 MB", "", "2018", "180207 ANTI CHRIST (((ARRIVAL))) Times Up.mp4"],
["180209",     "0.0.0.0", "1899.02|129 MB", "", "2018", "180209 Apollyon RISING!! Absolutely Guaranteed!!.mp4"],
["180210",     "0.0.0.0", "7053.01|394 MB", "", "2018", "180210 Antichrist RIGHT on TIME.mp4"],
["180213",     "0.0.0.0", "3332.02|245 MB", "", "2018", "180213 Portrait of APOLLYON.mp4"],
["180214-01",  "0.0.0.0", "3860.02|164 MB", "", "2018", "180214-01 OBAMA 2 SPERM on his HEAD In the Garden YOU GOT IT!!!.mp4"],
["180214-02",  "0.0.0.0", "534.01|28.0 MB", "", "2018", "180214-02 OUCH !!!! BUSTED!!!.mp4"],
["180215",     "0.0.0.0", "5460.01|401 MB", "", "2018", "180215 The Pit is OPENING 100p GUARANTEED (JorgeGeorge) twin system.mp4"],
["180216",     "0.0.0.0", "1108.01|77.4 MB", "", "2018", "180216 13 Time of BETRAYAL.mp4"],
["180217",     "0.0.0.0", "2797.01|158 MB", "", "2018", "180217 The CLINTON's and the Tsunami WHOA!!.mp4"],
["180218",     "0.0.0.0", "1328.02|76.2 MB", "", "2018", "180218 Burning Man;Twin Towers;Sculpture in Georgia.mp4"],
["180222",     "0.0.0.0", "580.01|51.6 MB", "", "2018", "180222 Checking in. BIGGEST REVEAL OF MINISTRY COMING UP!!.mp4"],
["180223",     "0.0.0.0", "1274.01|142 MB", "", "2018", "180223 let's be VERY VERY CLEAR on Something.mp4"],
["180225",     "0.0.0.0", "394.02|35.4 MB", "", "2018", "180225 Working on it!!Getting Over the Hump.mp4"],
["180304-01",  "0.0.0.0", "4931.01|431 MB", "", "2018", "180304-01 Portrait of Obama, The SERPENT from the Garden,,It is FINISHED!!!.mp4"],
["180304-02",  "0.0.0.0", "2029.01|236 MB", "", "2018", "180304-02 Obama the Serpent from the Garden. short version.mp4"],
["180304-03",  "0.0.0.0", "4890.01|441 MB", "", "2018", "180304-03 Obama, The SERPENT from the Garden,,It is FINISHED!!! Redo Audio.mp4"],
["180305-01",  "0.0.0.0", "626.01|70.8 MB", "", "2018", "180305-01 Recording 23.mp4"],
["180305-02",  "0.0.0.0", "765|54.8 MB", "", "2018", "180305-02 TIME's UP!!!!!!!.mp4"],
["180306-01",  "0.0.0.0", "1111.01|59.9 MB", "", "2018", "180306-01 Q Serpent Eye Cindarella Times Up!!!!.mp4"],
["180306-02",  "0.0.0.0", "56.4|12.4 MB", "", "2018", "180306-02 OH MY LORD GOD!!!! Same as AKHENATEN Hieroglyph.mp4"],
["180306-03",  "0.0.0.0", "54.24|15.4 MB", "", "2018", "180306-03 Oh My Lord God. BUSTED!!!!.mp4"],
["180306-04",  "0.0.0.0", "44.58|11.9 MB", "", "2018", "180306-04 Could Not Go to Bed Before this REVELATION !!!WOW!!.mp4"],
["180307-01",  "0.0.0.0", "2750.01|181 MB", "", "2018", "180307-01 YOU GOTTA SEE THESE IMAGES!!!!!!!!!!!!.mp4"],
["180307-02",  "0.0.0.0", "2092|230 MB", "", "2018", "180307-02 Heads up.mp4"],
["180309-01",  "0.0.0.0", "2183|197 MB", "", "2018", "180309-01 Presidential PortraitBelieve it or NOT!!!!.mp4"],
["180309-02",  "0.0.0.0", "3315.02|268 MB", "", "2018", "180309-02 Presidential PortraitBelieve it or NOT! REDO on Audio plus.mp4"],
["180312",     "0.0.0.0", "978|66.1 MB", "", "2018", "180312 Reptilian side of OUR BRAINREALLY BARACK!!.mp4"],
["180313-01",  "0.0.0.0", "1653.01|93.1 MB", "", "2018", "180313-01 OBAMA TYRANT LIZARD KING !!!.mp4"],
["180313-02",  "0.0.0.0", "1329.02|110 MB", "", "2018", "180313-02 LETS Get SOMETHING (((PERFECTLY CLEAR))).mp4"],
["180313-03",  "0.0.0.0", "639.01|188 MB", "", "2018", "180313-03 Pray for your enemies.mp4"],
["180314-01",  "0.0.0.0", "521.01|35.5 MB", "", "2018", "180314-01 TIP of the Spear coming up.mp4"],
["180314-02",  "0.0.0.0", "4952|344 MB", "", "2018", "180314-02 Preparing you for ( tip of the Spear).mp4"],
["180315",     "0.0.0.0", "7577.02|1.09 GB", "*73kULZ3xedg", "2018", "180315 TIP of the SPEAR (Part 2) FINAL ASSAULT.mp4"],
["180317-01",  "0.0.0.0", "3361.02|466 MB", "", "2018", "180317-01 (( FAST ATTACK )) IMMINENT.mp4"],
["180317-02",  "0.0.0.0", "755.02|79.3 MB", "", "2018", "180317-02 The Wicked one is at work.mp4"],
["180318",     "0.0.0.0", "5927.08|302 MB", "", "2018", "180318 VENGEANCE has ARRIVED.mp4"],
["180319",     "0.0.0.0", "901|182 MB", "", "2018", "180319 OH MY LORD It is ALL been prepared beforehand.mp4"],
["180320",     "0.0.0.0", "3332.02|258 MB", "", "2018", "180320 IMPORTANT UPDATE.mp4"],
["180321",     "0.0.0.0", "890.02|69.5 MB", "", "2018", "180321 Prepare by Watching ((Personal Testimony)).mp4"],
["180322-01",  "0.0.0.0", "4129.02|316 MB", "", "2018", "180322-01 Wake UP,,Time to die.mp4"],
["180322-02",  "0.0.0.0", "2287|205 MB", "", "2018", "180322-02 Doodle Destruction of New York and Statue of Liberty.mp4"],
["180323-01",  "0.0.0.0", "3770.02|287 MB", "", "2018", "180323-01 The SWORD (((exposes the lies))) The Word IS the TRUTH.mp4"],
["180323-02",  "0.0.0.0", "1315.02|136 MB", "", "2018", "180323-02 Shipping Container going to its new homejust like the BRIDE.mp4"],
["180324",     "0.0.0.0", "7589|462 MB", "*96flTwkSTos", "2018", "180324 SHIPPING OUT!!! CONTAINER TESTIMONY.mp4"],
["180325",     "0.0.0.0", "3354.01|365 MB", "", "2018", "180325 TREASURE FOUND!!! PERFECTION!!!.mp4"],
["180326",     "0.0.0.0", "5283|567 MB", "", "2018", "180326 For The RECORD Brother will betray brother.mp4"],
["180327",     "0.0.0.0", "5103|570 MB", "", "2018", "180327 Let Me present the Gospel,,,And KNOWING YOU ((KNOW)) the TRUTH.mp4"],
["180328",     "0.0.0.0", "556|55.8 MB", "", "2018", "180328 Quick check in ,,,see you Manana.mp4"],
["180329",     "0.0.0.0", "133|16.1 MB", "", "2018", "180329 Brief check in.mp4"],
["180330",     "0.0.0.0", "2166|195 MB", "", "2018", "180330 Serpent crown CRUMBLES Pope Francis declare hell does not EXIST.mp4"],
["180331",     "0.0.0.0", "1549|94.6 MB", "", "2018", "180331 CRUSHED the Head of the SERPENT.mp4"],
["180401",     "0.0.0.0", "7395.02|517 MB", "*kg64tTcuRwA", "2018", "180401 Recording 66.mp4"],
["180403",     "0.0.0.0", "1851|96.1 MB", "", "2018", "180403 DOODLE and REsist Movement.mp4"],
["180404",     "0.0.0.0", "2148.01|101 MB", "", "2018", "180404 I WILL ((RISE)) No Doubbt Google doodle.mp4"],
["180407",     "0.0.0.0", "291.02|14.7 MB", "", "2018", "180407 The container is (((( IN )))).mp4"],
["180408",     "0.0.0.0", "2419.01|117 MB", "", "2018", "180408 Coming to the Arch almost time to enter in.mp4"],
["180410-01",  "0.0.0.0", "8242.02|397 MB", "*ezwMvAeekCw", "2018", "180410-01 Obama The Tyrant Lizard King.mp4"],
["180410-02",  "0.0.0.0", "1469.01|54.8 MB", "", "2018", "180410-02 Google serpent doodle.mp4"],
["180410-03",  "0.0.0.0", "749.01|40.2 MB", "", "2018", "180410-03 Damascus It's About Damascus & the serpent.mp4"],
["180411-01",  "0.0.0.0", "2939.02|138 MB", "", "2018", "180411-01 GOG. Pay Attention.mp4"],
["180411-02",  "0.0.0.0", "6310.02|951 MB", "*PtYlXMyeHho", "2018", "180411-02 Finish Line Container is IN.mp4"],
["180413",     "0.0.0.0", "5225|313 MB", "", "2018", "180413 WATCH A MIRACLE CONFIRMATION DURING A SCREEN-CAST AT 27 MINUTE MARK.mp4"],
["180415",     "0.0.0.0", "4010.02|213 MB", "", "2018", "180415 HUGE REVEAL Coming Tomorrow!!!.mp4"],
["180416",     "0.0.0.0", "4694.01|236 MB", "", "2018", "180416 Michele Obama Portrait Serpent Hatching.mp4"],
["180419-01",  "0.0.0.0", "178|15.9 MB", "", "2018", "180419-01 UH OH!!! WORLD CHANGER Coming Up!!.mp4"],
["180419-02",  "0.0.0.0", "6544.01|408 MB", "", "2018", "180419-02 Audience Hall Fiery Flying Serpent.mp4"],
["180421",     "0.0.0.0", "2905|189 MB", "", "2018", "180421 Admonishment for those with ONE FOOT STILL IN.mp4"],
["180423",     "0.0.0.0", "3880.01|276 MB", "", "2018", "180423 ANOTHER ((WORLD CHANGING)) REVELATION. Get Prepped.mp4"],
["180424",     "0.0.0.0", "2363|242 MB", "", "2018", "180424 Here is How to Navigate the info Drop Tomorrow.mp4"],
["180425",     "0.0.0.0", "55.01|11.0 MB", "", "2018", "180425 Severe lightning and power outages.mp4"],
["180426",     "0.0.0.0", "4881.02|312 MB", "", "2018", "180426 The KEY,,,,,,,IT's OVER for THEM.mp4"],
["180427-01",  "0.0.0.0", "3289.01|202 MB", "", "2018", "180427-01 WHAT the HELL Russian Tattoo That fits the NARRATIVE.mp4"],
["180427-02",  "0.0.0.0", "3349.01|275 MB", "", "2018", "180427-02 ANTICHRIST Front and Center Stage Please!!.mp4"],
["180430",     "0.0.0.0", "4530|290 MB", "", "2018", "180430 Turning the grace of our God into lasciviousness Unless YOU Repent,, You will ALL likewise Perish.mp4"],
["180501",     "0.0.0.0", "2594.02|167 MB", "", "2018", "180501 Guillotines and Dead Sheep.mp4"],
["180502",     "0.0.0.0", "2676.01|164 MB", "", "2018", "180502 Darkness From the 6th Hour unto the 9th Hour.mp4"],
["180503-01",  "0.0.0.0", "3212.02|170 MB", "", "2018", "180503-01 Google DOODLE Gender-less society WTH.mp4"],
["180503-02",  "0.0.0.0", "435|39.3 MB", "", "2018", "180503-02 Google Doodle,,Coming of the Antichrist.mp4"],
["180505-01",  "0.0.0.0", "1108.01|115 MB", "", "2018", "180505-01 Mark of the Beast NORMALIZED LIARS NORMALIZED.mp4"],
["180505-02",  "0.0.0.0", "2449.01|170 MB", "", "2018", "180505-02 TYPE demons backwards into Google search Snomed Wake the hell up people!!.mp4"],
["180506-01",  "0.0.0.0", "377.02|26.5 MB", "", "2018", "180506-01 Recording 111.mp4"],
["180506-02",  "0.0.0.0", "2780.01|134 MB", "", "2018", "180506-02 Macintosh Son Of Thanos.mp4"],
["180508",     "0.0.0.0", "1833.01|130 MB", "", "2018", "180508 For the Record.mp4"],
["180509",     "0.0.0.0", "1215.01|72.9 MB", "", "2018", "180509 The Dragon was CAST OUT.mp4"],
["180510",     "0.0.0.0", "5355.01|381 MB", "", "2018", "180510 Watch ALL The DATA POINTS LINE UP!!!.mp4"],
["180511-01",  "0.0.0.0", "1024.02|126 MB", "", "2018", "180511-01 Two in One VIDEO LOL.mp4"],
["180511-02",  "0.0.0.0", "2774.02|320 MB", "", "2018", "180511-02 Thank you ((Everybody)) Seho & Gwendolen.mp4"],
["180512",     "0.0.0.0", "800.02|89.2 MB", "", "2018", "180512 UNBELIEVABLE!!! But TRUE!!!.mp4"],
["180514",     "0.0.0.0", "2165.01|313 MB", "", "2018", "180514 Here it Comes. The Revelation Awaits an Appointed Time.mp4"],
["180515",     "0.0.0.0", "1000.01|67.2 MB", "", "2018", "180515 Any (( New Comer's)) Get Caught up NOW!!.mp4"],
["180516",     "0.0.0.0", "11461.02|1.21 GB", "*9e6t1zb4cOU", "2018", "180516 I AM Has Sent Me Unto You.mp4"],
["180517",     "0.0.0.0", "2519.02|246 MB", "", "2018", "180517 Mystery Solved and Let's talk a bit about the future.mp4"],
["180521",     "0.0.0.0", "193|29.4 MB", "", "2018", "180521 COMING SOON!!!.mp4"],
["180522",     "0.0.0.0", "16697|1.12 GB", "*mMroGt4UHms", "2018", "180522 Most VALUBLE INFORMATION ON EARTH.mp4"],
["180524",     "0.0.0.0", "1767.02|129 MB", "", "2018", "180524 Let's see WHAT a JOKE ((((THEY)))) ARE !!!!!!!!!!!!!!!!!!!!!!!.mp4"],
["180525",     "0.0.0.0", "2220.01|158 MB", "", "2018", "180525 NEED a GOOD LAUGH Watch This!!.mp4"],
["180528",     "0.0.0.0", "237.01|33.8 MB", "", "2018", "180528 Thanks for the heads up.mp4"],
["180529-01",  "0.0.0.0", "1468.01|93.2 MB", "", "2018", "180529-01 Directly OVER the Target.mp4"],
["180529-02",  "0.0.0.0", "1585.02|107 MB", "", "2018", "180529-02 BLUE-TOOTH you won't Believe it!! But You Will!!.mp4"],
["180530",     "0.0.0.0", "2186.02|215 MB", "", "2018", "180530 Oh WOW!! What a Encouraging CONFIRMATION.mp4"],
["180601",     "0.0.0.0", "893.02|78.3 MB", "", "2018", "180601 Get Ready for Manana.mp4"],
["180602",     "0.0.0.0", "2576.02|152 MB", "", "2018", "180602 WORKING on the REvelation.touching base.mp4"],
["180605",     "0.0.0.0", "2854.01|195 MB", "", "2018", "180605 Sooooooooooooooooooooo BUSTED!!!.mp4"],
["180606",     "0.0.0.0", "5112.01|366 MB", "", "2018", "180606 More Tolerable for Sodom and Gomorrha.mp4"],
["180607",     "0.0.0.0", "1552.02|102 MB", "", "2018", "180607 Mimic. Yikes.mp4"],
["180608-01",  "0.0.0.0", "693.02|43.7 MB", "", "2018", "180608-01 Oh My LORD,,IT IS Coming (Part 1).mp4"],
["180608-02",  "0.0.0.0", "261.02|20.3 MB", "", "2018", "180608-02 Intermission and equipment check.mp4"],
["180608-03",  "0.0.0.0", "2702.01|203 MB", "", "2018", "180608-03 Part 2 FREAK OUT!!! LOL.mp4"],
["180609",     "0.0.0.0", "2111.02|158 MB", "*fCS6D0H5BTA", "2018", "180609 Birthing of the New race.mp4"],
["180610",     "0.0.0.0", "1341.02|93.2 MB", "", "2018", "180610 The Hunter HAS Become the HUNTED.mp4"],
["180611",     "0.0.0.0", "542|20.6 MB", "", "2018", "180611 They say They WANT the Kingdom But THEY don't want God in it.mp4"],
["180612",     "0.0.0.0", "452.02|48.9 MB", "", "2018", "180612 EPIC (((NEW REVELATION))) Glory to the Lord God!!!.mp4"],
["180613-01",  "0.0.0.0", "301|27.0 MB", "", "2018", "180613-01 Working as diligently as I can. It is Coming.mp4"],
["180613-02",  "0.0.0.0", "4458.02|208 MB", "", "2018", "180613-02 OBAMA;Son of The ARMY Commander; SoS.mp4"],
["180615",     "0.0.0.0", "938.02|66.9 MB", "", "2018", "180615 Isaiah 573 The Adulterer and the Whore coming to the End of The Cycle.mp4"],
["180617-01",  "0.0.0.0", "1063.01|67.1 MB", "", "2018", "180617-01 You Betcha!!Here it Comes.mp4"],
["180617-02",  "0.0.0.0", "550.01|42.6 MB", "", "2018", "180617-02 Coming Up zeroing in.mp4"],
["180618",     "0.0.0.0", "2366.02|203 MB", "", "2018", "180618 There is MORE,,,Here is an update.mp4"],
["180619",     "0.0.0.0", "5288.02|431 MB", "", "2018", "180619 This begins the info drop. need to talk about it first.mp4"],
["180620",     "0.0.0.0", "312.01|34.4 MB", "", "2018", "180620 No Snarkey.mp4"],
["180621",     "0.0.0.0", "2168|141 MB", "", "2018", "180621 Self Cannibalization is COMPLETEJust Watch and Observe.mp4"],
["180622-01",  "0.0.0.0", "984.02|67.1 MB", "", "2018", "180622-01 OBAMA is CROWNED .mp4"],
["180622-02",  "0.0.0.0", "3662.02|235 MB", "", "2018", "180622-02 Most Important hour I've spent understanding this.mp4"],
["180623-01",  "0.0.0.0", "2696.02|280 MB", "", "2018", "180623-01 MIND DESTROYING Confirmation.mp4"],
["180623-02",  "0.0.0.0", "309.01|21.2 MB", "", "2018", "180623-02 Get Your Spatula and Be Ready!!!.mp4"],
["180624-01",  "0.0.0.0", "8015.02|410 MB", "*zZoa5LW7lUs", "2018", "180624-01 Recording 50.mp4"],
["180624-02",  "0.0.0.0", "2172.02|148 MB", "", "2018", "180624-02 WOW!! ANOTHER HUGE CONFIRMATION Strongs 50 My FATHER is RESCUE.mp4"],
["180625",     "0.0.0.0", "1410.01|112 MB", "", "2018", "180625 AnyBody find the balloon and ruby slippers yet LOL.mp4"],
["180627-01",  "0.0.0.0", "1379.01|101 MB", "", "2018", "180627-01 50 meters Victoria,, Marcus hill.mp4"],
["180627-02",  "0.0.0.0", "224|21.8 MB", "", "2018", "180627-02 Oh Yeah Drakma !!!.mp4"],
["180627-03",  "0.0.0.0", "465|39.4 MB", "", "2018", "180627-03 a captive, prisoner.mp4"],
["180628-01",  "0.0.0.0", "2152|123 MB", "", "2018", "180628-01 Silence of the LAMBS. You Gotta be kidding.mp4"],
["180628-02",  "0.0.0.0", "2455.02|251 MB", "", "2018", "180628-02 Extended New info overlapping. Memorializing.mp4"],
["180629",     "0.0.0.0", "1045.01|117 MB", "", "2018", "180629 Peter Pan ,,,Not what you thought.mp4"],
["180630",     "0.0.0.0", "1655|89.3 MB", "", "2018", "180630 As Heads is Tails Just call Him Lucifer.mp4"],
["180701",     "0.0.0.0", "3198.01|217 MB", "", "2018", "180701 Only the ((((BLIND)))) could Not SEE THIS.mp4"],
["180702",     "0.0.0.0", "844.02|80.2 MB", "", "2018", "180702 WHY did Jesus Call SATAN a ((((( SNARE))))) Because It's TRUE!!!.mp4"],
["180703",     "0.0.0.0", "1318.01|119 MB", "", "2018", "180703 Good LORD !!! It Looks like it is GOING to HAPPEN SOON!!.mp4"],
["180705-01",  "0.0.0.0", "1183.01|90.1 MB", "", "2018", "180705-01 OH YES!! THEY ((( ARE ))) Coming!!.mp4"],
["180705-02",  "0.0.0.0", "186.02|15.0 MB", "", "2018", "180705-02 Live Miracle worldwide block. Message CONFIRMED.mp4"],
["180706",     "0.0.0.0", "853.01|55.5 MB", "", "2018", "180706 Prep,, for the Spatula Video.mp4"],
["180708",     "0.0.0.0", "1027.02|127 MB", "", "2018", "180708 Prepping for the Spatula Moment.mp4"],
["180709",     "0.0.0.0", "1131.02|80.9 MB", "", "2018", "180709 A Little Snack before the Main Course.mp4"],
["180710",     "0.0.0.0", "214.02|29.6 MB", "", "2018", "180710 Noooooooooooooooooo!!!! LOLOL.mp4"],
["180711-01",  "0.0.0.0", "538.01|57.4 MB", "", "2018", "180711-01 Going to CLIP and UPLOAD Part 1 Today.mp4"],
["180711-02",  "0.0.0.0", "9072.01|761 MB", "*qVpC54eXFWk", "2018", "180711-02 Part One ((The LORD GOD Solving the Mystery for Us)).mp4"],
["180712",     "0.0.0.0", "2000|170 MB", "", "2018", "180712 30 MINUTE FACT Education BEFORE PART 2.mp4"],
["180713-01",  "0.0.0.0", "576.02|67.7 MB", "", "2018", "180713-01 Codec check SPATULA Ready.mp4"],
["180713-02",  "0.0.0.0", "387.01|46.1 MB", "", "2018", "180713-02 Must watch (((Before))) Part 2 ,,WOW!!.mp4"],
["180715",     "0.0.0.0", "19110.02|1.23 GB", "*Nz4KJ6cyWA8", "2018", "180715 Their Time is Here,( The LORD GOD Solved the Mystery) Part 2.mp4"],
["180719",     "0.0.0.0", "491.01|32.5 MB", "", "2018", "180719 Checking in.mp4"],
["180720",     "0.0.0.0", "1139.01|73.4 MB", "", "2018", "180720 Looks Like the Finish Line is in View.mp4"],
["180721-01",  "0.0.0.0", "5050.02|312 MB", "", "2018", "180721-01 Miracle after Miracle after MIRACLE.mp4"],
["180721-02",  "0.0.0.0", "2971.02|209 MB", "", "2018", "180721-02 Acts of Peter and MORE Miracles.mp4"],
["180722-01",  "0.0.0.0", "1423.01|113 MB", "", "2018", "180722-01 Broadcasting from the container.mp4"],
["180722-02",  "0.0.0.0", "2861|264 MB", "", "2018", "180722-02 Glory to the Lord God And Thank you.mp4"],
["180724",     "0.0.0.0", "1919.01|168 MB", "", "2018", "180724 Just Like an Old Testsment Story !!!.mp4"],
["180725",     "0.0.0.0", "1725.01|139 MB", "*oLB9qHisorE", "2018", "180725 911 BOMBINGS -The (((REAL))) Culprit.mp4"],
["180727",     "0.0.0.0", "3033.01|196 MB", "", "2018", "180727 NO FEAR at all,,, Not Anymore!!!.mp4"],
["180728-01",  "0.0.0.0", "121.02|8.89 MB", "", "2018", "180728-01 Codec check 1.mp4"],
["180728-02",  "0.0.0.0", "3833.01|281 MB", "", "2018", "180728-02 ARE ((YOU)) On the ROCK I HOPE SO.mp4"],
["180729",     "0.0.0.0", "3521|284 MB", "", "2018", "180729 The WORD!!!.mp4"],
["180730",     "0.0.0.0", "2987.01|232 MB", "", "2018", "180730 Are You Blind Or Can You SEE Your Soul is at Stake.mp4"],
["180731",     "0.0.0.0", "1913.02|125 MB", "", "2018", "180731 Salvaged the INSANE Clothing part of video.mp4"],
["180801",     "0.0.0.0", "3134.02|223 MB", "", "2018", "180801 Venus (Lucifer) Fly TRAP. You gotta be Kidding!!!.mp4"],
["180805",     "0.0.0.0", "951.02|80.3 MB", "", "2018", "180805 Checking in Last video Blocked Worldwide.mp4"],
["180806-01",  "0.0.0.0", "173.01|13.0 MB", "", "2018", "180806-01 Codec check especially for forein country's.mp4"],
["180806-02",  "0.0.0.0", "1389.02|89.0 MB", "", "2018", "180806-02 (((PALISADE))) The Mark of the Beast ,,According to the Word.mp4"],
["180806-03",  "0.0.0.1", "5774.01|510 MB", "", "2018", "180806-03 Re-POSTED Matrix Analogy PLUS Definitive Scripture Lesson.mp4"],
["180808",     "0.0.0.0", "2618|126 MB", "", "2018", "180808 Angels in DEEP DEEP TROUBLE.mp4"],
["180809",     "1.2.0.1", "2074.01|161 MB", "", "2018", "180809 Scriptural Atomic Bomb on the Way.mp4"],
["180810",     "1.2.0.1", "3557.02|248 MB", "", "2018", "180810 PART 1 Must Watch Scripture Revelation!!!!.mp4"],
["180813",     "1.2.0.3", "6879|532 MB", "", "2018", "180813 Part 2 -PURE EXALTATION !! Mystery Completely SOLVED.mp4"],
["180814",     "1.2.0.0", "1246.01|102 MB", "", "2018", "180814 Who Wants MORE Revelation Whooo hoooo.mp4"],
["180816",     "1.2.0.0", "170.02|14.4 MB", "", "2018", "180816 SORRY!! Audio Tanked on Last 2hr video.mp4"],
["180817",     "1.2.0.0", "11630.09|624 MB", "*mOZGibgHYnw", "2018", "180817 Part-3-SO-SOLVED-Unarguable-YouTube.mp4"],
["180818",     "1.2.0.0", "3406.02|568 MB", "", "2018", "180818 JUMP Drives and a New Consciousness Forming.mp4"],
["180820",     "1.2.0.0", "1085.02|79.4 MB", "", "2018", "180820 UNBELIEVABLE ((New)) Revelation Coming Today!!!.mp4"],
["180821",     "1.2.0.0", "8038.01|594 MB", "*KHTuznPlvrk", "2018", "180821 Part 4. GIFT FROM GOD. Unbelievable.mp4"],
["180823",     "0.0.0.0", "3497.02|295 MB", "", "2018", "180823 Shells of the Dead”.Qliphoth!!! IT is OVER !!! Unlocked for EVER!! Glory to God!!!!.mp4"],
["180826",     "0.0.0.0", "3371|232 MB", "", "2018", "180826 DNA Statue of LIBERTY You GOTTA Be Kidding.mp4"],
["180830",     "0.0.0.0", "218.01|11.9 MB", "", "2018", "180830 Last video censored - OVER the TARGET!!.mp4"],
["180831",     "0.0.0.0", "8537|516 MB", "*GM_h0EGLD10", "2018", "180831 End of the WORLD !! We are Living in the Last Days,,,Knowledge is increasing.mp4"],
["180902",     "0.0.0.0", "4650|232 MB", "", "2018", "180902 The WORLD and its Inhabitants Will BURN (( Be ready for the Calling AWAY)).mp4"],
["180904",     "0.0.0.0", "7638.02|608 MB", "*AlK365x4JLg", "2018", "180904 CROP Circles Oh TRANSMUTATION Circles!!!.mp4"],
["180905",     "0.0.0.0", "6184.08|308 MB", "", "2018", "180905 Statue of Liberty to CROP Circles ,IT IS ALL MOTHER GODDESS(SD).mp4"],
["180908",     "0.0.0.0", "1602.01|111 MB", "", "2018", "180908 Barack,, In Genesis 1 (to Curse the King as Treason) That's right!!.mp4"],
["180909",     "0.0.0.0", "2386.01|154 MB", "", "2018", "180909 Antichrist Right on TIME!! Obama says,, We don't need a MESSIAH.mp4"],
["180910",     "0.0.0.0", "239|19.9 MB", "", "2018", "180910 Closed captioning adding on many videos.mp4"],
["180911",     "0.0.0.0", "4116.02|240 MB", "", "2018", "180911 YOU want PROOF who OBAMA Really is Here's PROOF.mp4"],
["180912",     "0.0.0.0", "2383.02|183 MB", "", "2018", "180912 Baphomet Article and OBAMA.mp4"],
["180913",     "0.0.0.0", "2051.02|131 MB", "", "2018", "180913 Game of ThronesObamaand Subud.mp4"],
["180916",     "0.0.0.0", "3672|211 MB", "", "2018", "180916 911 was NOTHING compared to WHAT's NEXT.mp4"],
["180917",     "0.0.0.0", "1469.01|88.2 MB", "", "2018", "180917 YEAR of SATAN Really OBAMA Make this VIRAL.mp4"],
["180918",     "0.0.0.0", "2156.02|200 MB", "", "2018", "180918 All Roads lead to - You Know WHO.mp4"],
["180920",     "1.2.0.0", "1095.01|94.8 MB", "", "2018", "180920 Massive Data dump COMING up.mp4"],
["180922",     "1.2.0.0", "2709|200 MB", "", "2018", "180922 Part 1 EXILES,,,YES!! YOU are the EXILES.mp4"],
["180924",     "1.2.0.0", "3917.02|248 MB", "", "2018", "180924 Part 2 EXILES - Yes YOU ARE the EXILES (Genesis 1).mp4"],
["180926",     "1.2.0.0", "4102.01|286 MB", "", "2018", "180926 Part 3 Exiles - YES YOU are the EXILES Jude to Genesis.mp4"],
["180929",     "1.2.0.0", "3535.01|271 MB", "", "2018", "180929 Part 4 EXILES - YES you ARE the EXILES - Hidden in Flesh.mp4"],
["181002-01",  "1.2.0.0", "637.02|57.3 MB", "", "2018", "181002-01 Testimony Coming before PART 5.mp4"],
["181002-02",  "0.0.0.0", "222.38|61.1 MB", "", "2018", "181002-02 IMG 8155.mp4"],
["181002-03",  "0.0.0.0", "679.02|59.3 MB", "", "2018", "181002-03 Codec check for Testimony Video.mp4"],
["181003",     "0.0.0.0", "8853|561 MB", "*oEoFmqpWbtM", "2018", "181003 THIS IS IT !!! Must see. TIME IS ARRIVING.mp4"],
["181005",     "0.0.0.0", "612.24|29.8 MB", "", "2018", "181005 THIS IS IT Get Ready for PART 5 Massive data dump mp4.mp4"],
["181008",     "0.0.0.0", "89|13.3 MB", "", "2018", "181008 E.R. and Ready for Delivery.mp4"],
["181010",     "0.0.0.0", "2446.01|495 MB", "", "2018", "181010 YOU are GOING to FREAK OUT!!! He is COMING.mp4"],
["181015",     "0.0.0.0", "1919.01|178 MB", "", "2018", "181015 Testimony for LEAVING.mp4"],
["181016-01",  "0.0.0.0", "1095.01|46.3 MB", "", "2018", "181016-01 WAKE UP CONFIRMATION !!! AGAIN!!.mp4"],
["181016-02",  "0.0.0.0", "11264.23|709 MB", "*TVjwS8EVlgU", "2018", "181016-02 New Jerusalem CONTAINER History and Testimony New Container Testimony.mp4"],
["181020",     "0.0.0.0", "4169|225 MB", "", "2018", "181020 Oh m LORD how FRIGHTENING!! Part 5 Precursor.mp4"],
["181022",     "0.0.0.0", "525|24.8 MB", "", "2018", "181022 The MONSTER is MANIFESTING EVERYWHERE.mp4"],
["181023",     "0.0.0.0", "2719.01|107 MB", "", "2018", "181023 911 hidden in SILENCE of the LAMBS 116 IS 911 Upside down and Backwards.mp4"],
["181024",     "0.0.0.0", "1318.01|57.0 MB", "", "2018", "181024 WHOA !!Jaw Dropping Confirmation. This is IT,,Final Sting.mp4"],
["181025",     "0.0.0.0", "709.02|26.6 MB", "", "2018", "181025 PIPE BOMBS SUNRISE 10019 REALLY.mp4"],
["181029",     "0.0.0.0", "589.02|22.5 MB", "", "2018", "181029 RUDDY = FLORID,,,Who MIS-SPELLS ( FLORIDA). TOTAL NONSENSE.mp4"],
["181101",     "0.0.0.0", "4702.02|189 MB", "", "2018", "181101 SPIRIT COOKING the WHOLE EARTH ,,from BEGINNING to END.mp4"],
["181104",     "0.0.0.0", "1546.01|63.7 MB", "", "2018", "181104 Recording 267.mp4"],
["181105",     "0.0.0.0", "1685|126 MB", "", "2018", "181105 JUDGEMENT COMING!! GUARANTEED,,,Message Confirmed.mp4"],
["181107",     "0.0.0.0", "2797.01|126 MB", "", "2018", "181107 JUDGEMENT SEAT Confirmation AGAIN!!!!!!!!!!WOW oh WOW!!! No WAY!!!.mp4"],
["181108",     "0.0.0.0", "4641.02|174 MB", "", "2018", "181108 YOU ARE GODS !!! ((( JESUS SAID IT !!))) Anyone think JESUS is a Liar.mp4"],
["181113",     "0.0.0.0", "1505|100 MB", "", "2018", "181113 DATA RECEPTION COMPLETE Analysis Confirmed Ready for Delivery.mp4"],
["181114",     "0.0.0.0", "10358|599 MB", "*y5AtS2iKKvs", "2018", "181114 We were SLAVES to SCORPIONS from the PIT ((Undeniable TRUTH- PROOF)).mp4"],
["181118",     "0.0.0.0", "4661.01|189 MB", "", "2018", "181118 Oh My LORD !! They ARE HERE Child of HEAVEN and EARTH.mp4"],
["181120",     "0.0.0.1", "4347.01|147 MB", "", "2018", "181120 WHO Wants to Talk Frankly about what we Know.mp4"],
["181123",     "0.0.0.0", "5245.02|200 MB", "", "2018", "181123 HIDDEN in PLAIN Sight (Egyptian Hieroglyph Agenda) PROVES the TRUTH of the BIBLE.mp4"],
["181124",     "0.0.0.0", "2201.02|78.3 MB", "", "2018", "181124 They Think You'll Never see Em Coming If you don't believe me just LISTEN to THEM.mp4"],
["181125",     "0.0.0.0", "2372.01|82.3 MB", "", "2018", "181125 WHAT is the BIG SECRET Ya Want to KNOW.mp4"],
["181129",     "0.0.0.0", "1002.01|29.6 MB", "", "2018", "181129 It is DEFINITELY Coming to an END,,,CHECKING IN Before Disclosure.mp4"],
["181201",     "0.0.0.0", "5138.02|168 MB", "", "2018", "181201 PREQUEL to the BRUTAL TRUTH. PLEASE FORGIVE my DIRECT APPROACH to what is coming.mp4"],
["181202",     "0.0.0.0", "14832|537 MB", "*_Pz9d4M3QfM", "2018", "181202 4 HOURS of (IMPOSSIBLE to REFUTE)Humans used to Birth SCORPIONS From the PIT.mp4"],
["181207",     "0.0.0.0", "3620.01|423 MB", "", "2018", "181207 Oh YEAH!!! HERE ((( The Open Book ))) COMES!!!! The Meaning is SURE.mp4"],
["181209",     "0.0.0.0", "3651.01|175 MB", "", "2018", "181209 1201 Miracle !! Watch, LISTEN, Pay Attention, & FREAK OUT!!!.mp4"],
["181210",     "0.0.0.0", "2125.02|90.0 MB", "", "2018", "181210 Total CONFIRMATION ,,, 100p NOLYN (( REVERSAL)) OPEN the Book.mp4"],
["181213",     "0.0.0.0", "795|28.2 MB", "", "2018", "181213 To BURST FORTH with JOY!! ( Open the Scroll & Loosen the Seals).mp4"],
["181214",     "0.0.0.1", "2383.02|89.3 MB", "", "2018", "181214 The DATA is Inescapable The Scriptures are Perfect. Jesus LOVES YOU.mp4"],
["181215",     "0.0.0.0", "2187.02|88.4 MB", "", "2018", "181215 Was Bud Light in the Garden of EDEN. Apparently it WAS -- LOL.mp4"],
["181216",     "0.0.0.0", "3185.01|129 MB", "", "2018", "181216 POISON !!No Doubt at ALL Anymore. How Obvious it has Become.mp4"],
["181218",     "0.0.0.1", "7791.01|962 MB", "*DZIVzwmDCZY", "2018", "181218 Scriptural AWAKENING,,The SCROLL is UNSEALED. WATCH and BELIEVE!!!.mp4"],
["181219",     "0.0.0.0", "1176.02|48.6 MB", "", "2018", "181219 To give vent to joyful emotions - break (forth), burst (with joy).mp4"],
["181220",     "0.0.0.0", "3895.01|165 MB", "", "2018", "181220 You WANTED PROOF!!! LOCUSTS Using ANGELS as an ENERGY SOURCE.mp4"],
["181223",     "0.0.0.0", "617|17.5 MB", "", "2018", "181223 Communion Tomorrow. The King IS Coming Confirmed AGAIN.mp4"],
["181224",     "0.0.0.0", "2217.02|85.6 MB", "", "2018", "181224 Communion WOW The KING is COMING,,Supernatural set of Events.mp4"],
["181225",     "0.0.0.0", "2899.01|106 MB", "", "2018", "181225 To Enter IN=Disoronno=Binary system.mp4"],
["181227",     "0.0.0.0", "4196.01|159 MB", "", "2018", "181227 The LORD has Made Known the Mystery, the MESSAGE is IRREFUTABLE.mp4"],
["181229",     "0.0.0.0", "6126|236 MB", "", "2018", "181229 JESUS Said You Would (( KNOW ABSOLUTELY)) You ARE SAVED!!!.mp4"],
["181230",     "0.0.0.0", "281.01|6.54 MB", "", "2018", "181230 Locked Away in Permanent Slumber WOW!! Carried Away Captive.mp4"],

//==== 2019 ====

["190101",     "0.0.0.0", "4375.01|143 MB", "", "2019", "190101 Here Is What I SEE for the New Year- Buckle Up.mp4"],
["190103",     "0.0.0.0", "12529.02|1.52 GB", "*fz-G81rjNfo", "2019", "190103 DATA Video,,,,THERE can be ONLY ONE CONCLUSION.mp4"],
["190104",     "0.0.0.0", "623.01|26.7 MB", "", "2019", "190104 Bush Funeral, Hakrab Eos (Goddess of the Dawn)) shushes Clinton.mp4"],
["190106",     "0.0.0.0", "2692.01|103 MB", "", "2019", "190106 Now SEE the Obviousness of the TRUTH. System of DEATH.mp4"],
["190107",     "0.0.0.0", "4512.01|259 MB", "", "2019", "190107 WHY did the Chicken Cross the Road Try Not to Freak out!!!.mp4"],
["190109",     "0.0.0.0", "2730.02|103 MB", "", "2019", "190109 Is THIS the LORD GOD TELLING us to Get READY to ENTER The GATE  You Tell Me.mp4"],
["190110",     "0.0.0.0", "4096.02|139 MB", "", "2019", "190110 i-Robot Will Blow Your Mind + Miraculous Biblical Revelation Matthew 24 and 1st Peter 2.mp4"],
["190114",     "0.0.0.0", "347.02|13.2 MB", "", "2019", "190114 Get Ready !!! HERE it COMES!!! Proof Proof Proof.mp4"],
["190115",     "0.0.0.0", "2190.01|71.9 MB", "", "2019", "190115 The LORD GOD Has Revealed their Code. They are COMPLETELY BUSTED.mp4"],
["190116",     "0.0.0.0", "5387.01|207 MB", "", "2019", "190116 The BIBLE i-Robot National Treasure   Statue of Liberty  V Series All the SAME.mp4"],
["190120-01",  "0.0.0.0", "4974.02|495 MB", "", "2019", "190120-01 Oh My LORD Have Mercy!! Try Not to FREAK OUT!!!!!!!!!.mp4"],
["190120-02",  "0.0.0.0", "119|3.92 MB", "", "2019", "190120-02 Blocked Worldwide, Watch the video Below in description box.mp4"],
["190120-03",  "0.0.0.0", "5178|175 MB", "", "2019", "190120-03 Blocked WorldwideOH My LORD Have Mercy! Try Not to FREAK OUT.mp4"],
["190122",     "0.0.0.0", "5416.01|188 MB", "", "2019", "190122 UUNHOLY Cr@ !! BLOOD BATH OF UNIMAGINABLE REALITY!! LORD HELP US ALL !!!.mp4"],
["190127",     "0.0.0.1", "12242|792 MB", "*UheUKfWkGKc", "2019", "190127 Hunted for Dinner NO-Lyn. Time to SILENCE the Hypocrites and Blind Guides !!.mp4"],
["190201",     "0.0.0.0", "2755|91.8 MB", "", "2019", "190201 Coming SOON to a Scorpion Invasion Location Near You!! LOL.mp4"],
["190203",     "0.0.0.0", "4916.01|184 MB", "", "2019", "190203 2491 MURDER BABIES- 2494 SAVE the CANKER WORM- WTH !!! This is No JOKE.mp4"],
["190204-01",  "0.0.0.0", "317.02|10.9 MB", "", "2019", "190204-01 Starting a Parallel Short Video Platform.mp4"],
["190204-02",  "0.0.0.0", "2347|86.7 MB", "", "2019", "190204-02 TRY To COMPREHEND the PERFECTION ; Immânû'EL = H-410=Almighty.mp4"],
["190206",     "0.0.0.0", "4249.02|270 MB", "", "2019", "190206 DIRECT HIT!!! Last Video Ramped UP Hatred and Threats! PERFECT!!.mp4"],
["190207",     "0.0.0.0", "3734|141 MB", "", "2019", "190207 God is a Woman. THEIR God IS a WOMAN.mp4"],
["190210",     "0.0.0.0", "5733.01|236 MB", "", "2019", "190210 EL ,EL Why Hast thou Forsaken Me Scorpion Race took US HOSTAGE.mp4"],
["190211",     "0.0.0.0", "4507.02|165 MB", "", "2019", "190211 WHO RULES the WORLD They Said Satan Let Me PROVE THEM COMPLETELY WRONG!!.mp4"],
["190214",     "0.0.0.0", "13093.01|452 MB", "*Kp8Iu5upAuU", "2019", "190214 CREDIBLE THREAT!! Guaranteed INVASION !! From the LAST Place You would Imagine.mp4"],
["190219",     "0.0.0.0", "6998.01|243 MB", "", "2019", "190219 Do NOT even TRY to Get out of the TRUTH that is COMING. VENGEANCE is COMING.mp4"],
["190223",     "0.0.0.0", "6770.01|254 MB", "", "2019", "190223 THEY are RISING,,We DWELL Among SCORPIONS !!! This is No JOKE. It IS REALITY.mp4"],
["190227",     "0.0.0.0", "4395|161 MB", "", "2019", "190227 The Oscar's Blood Bath Confirmed and Reconfirmed, End Time Event On the Horizon.mp4"],
["190302",     "0.0.0.0", "397.01|12.4 MB", "", "2019", "190302 2 hour video got trashed!!! Sorry,,Be here Manana.mp4"],
["190303",     "0.0.0.1", "6305.01|226 MB", "", "2019", "190303 Scripture to DESTROY the Enemy's Mind Control,,, Perfection in Scripture.mp4"],
["190304",     "0.0.0.1", "5269|182 MB", "", "2019", "190304 Wanna SEE me FREAK OUT!! IT IS WIDE OPEN!!! Watch these Scriptures BLOW YOUR MINDS.mp4"],
["190306",     "0.0.0.0", "3565.01|370 MB", "", "2019", "190306 Blue Tooth = HAIL “Birch Goddess” – Birth, Sanctuary,,NO JOKE!!.mp4"],
["190309",     "0.0.0.0", "3462|112 MB", "", "2019", "190309 EXCEEDING JOY!!! In the TRUTH of the WORD!!! PERFECTION.mp4"],
["190310",     "0.0.0.0", "2211|116 MB", "", "2019", "190310 JOY!JOY! JOY! JOY!! Inexplicable Joy!! Now SEE WITH YOUR OWN.mp4"],
["190314",     "0.0.0.0", "1227.01|41.8 MB", "", "2019", "190314 Preparing for the Event and Checking in Who Likes Peter Pan WTH Told you so.mp4"],
["190316",     "0.0.0.0", "8759.01|612 MB", "*2KUCRJ2jnZI", "2019", "190316 John 316,, HAPPY BIRTHDAY !!! The Greatest Gift!! 100p TRUTH,,,TEARS of JOY!!.mp4"],
["190320",     "0.0.0.0", "3602.02|415 MB", "", "2019", "190320 1st Adam (Genesis 2Adam= (Christs REPRESENTATIVE) in the System.mp4"],
["190324",     "0.0.0.0", "8365.01|958 MB", "*Hj8PwY-zFfc", "2019", "190324 Unveiling= Apocalypse,,It has ALL Become So Ridiculously OBVIOUS, The Bible=TRUTH.mp4"],
["190328",     "0.0.0.0", "6236.02|359 MB", "", "2019", "190328 Does THIS NEW DATA Mean THEY are BUSTED!! YES,, YES IT DOES !!.mp4"],
["190401",     "0.0.0.0", "4196.01|143 MB", "", "2019", "190401 TREASON,, Seen from behind the Veil and Grand Junction Update.mp4"],
["190403",     "0.0.0.0", "7215.02|329 MB", "*xew62lWUQlE", "2019", "190403 1st Hour rant against the enemy,,2nd Hour ART-ROOM and Container.mp4"],
["190405",     "0.0.0.0", "3629|143 MB", "", "2019", "190405 Their God is REVEALING Itself,,Right in Front of OUR Faces Plus container Recollection.mp4"],
["190406",     "0.0.0.0", "776.01|24.2 MB", "", "2019", "190406 Code IS CRACKED!! Grand Junction Update.mp4"],
["190407",     "0.0.0.0", "2527|99.0 MB", "", "2019", "190407 Super-Natural Confirmation!!! Not Making Promises ,but WOW what a Testimony!!!.mp4"],
["190409",     "0.0.0.0", "1118.02|38.1 MB", "", "2019", "190409 SLAUGHTER JESUS THEY are Not Joking!!! Now BEHOLD your Enemy.mp4"],
["190411",     "0.0.0.0", "4125|145 MB", "", "2019", "190411 Shhhhhhhh,,,the SECRET is HORRIFYING!! Oh m Lord!!.mp4"],
["190412",     "0.0.0.0", "1722.02|64.3 MB", "", "2019", "190412 Lucifer Just Got Horrible news!! He did it His Waay, But Too Bad!! Time's UP.mp4"],
["190415-01",  "0.0.0.0", "3872.02|123 MB", "", "2019", "190415-01 Willfully BLIND SLAUGHTER I Begin my RULE.mp4"],
["190415-02",  "0.0.0.0", "1984.01|66.2 MB", "", "2019", "190415-02 Notre Dame Cathedral Fire The Meaning Revealed!! Kill WHO.mp4"],
["190416",     "0.0.0.0", "3354.01|309 MB", "", "2019", "190416 Wanna see MORE Proof!! SEE the DEPTHS of the INFESTATION.mp4"],
["190417",     "0.0.0.0", "5127.01|205 MB", "", "2019", "190417 The FINAL Solution is HERE!! OFWGKTA,,,Kill Them ALL.mp4"],
["190421",     "0.0.0.0", "8708.02|309 MB", "*C9EYWXjVOks", "2019", "190421 The GIFT of LIFE from Imminent DEATH,,, To Escape YOUR Sentence IS the GREATEST GIFT.mp4"],
["190422",     "0.0.0.0", "2295.01|90.3 MB", "", "2019", "190422 Sri Lanka Christian Attack,, SEE PAST the ILLUSION, and SEE the Invisible Enemy.mp4"],
["190423",     "0.0.0.0", "2136|76.6 MB", "", "2019", "190423 And AGAIN THE END OTHER SIDE RISES Antichrist.mp4"],
["190428",     "0.0.0.0", "1907.01|72.2 MB", "", "2019", "190428 Can U SEE the HIVE NOW.mp4"],
["190501",     "0.0.0.0", "632|19.7 MB", "", "2019", "190501 I LOVE You 3000 I Get it !!! Do You.mp4"],
["190502",     "0.0.0.1", "7371.01|264 MB", "*LbRWac0D_qQ", "2019", "190502 DEFINITIVE Scripture !! Who We Are,Why We Are Here, And Understanding the END!!.mp4"],
["190504",     "0.0.0.0", "5131.01|315 MB", "", "2019", "190504 Not Arguable !! WE are in THEIR World,, Jesus' Kingdom is the Kingdom of Heaven.mp4"],
["190509",     "0.0.0.0", "5241.02|195 MB", "", "2019", "190509 Watch EVERYTHING Make Perfect sense Now!! All Glory to the KING of KINGS.mp4"],
["190510",     "0.0.0.0", "3281|117 MB", "", "2019", "190510 OH My LORD !!!! YES THEY are COMING Quickly!!! Just LOOK at This Evidence.mp4"],
["190513",     "0.0.0.0", "2208.01|126 MB", "", "2019", "190513 Think David Beat Goliath___ Uh YEAHHH !!! Round 2 EVEN WORSE!!.mp4"],
["190515",     "0.0.0.0", "2491.01|216 MB", "", "2019", "190515 The LORD Confirms His Coming!!!! Dream Land Coming to an END ! Absolutely Ending.mp4"],
["190518",     "0.0.0.0", "7951|586 MB", "*9s-Boo4NRPw", "2019", "190518 Intro to World Ending Revelation and Event. 4-6 Hours are in the Cue.mp4"],
["190520",     "0.0.0.0", "14871.01|1.55 GB", "*jT_pMsisqNA", "2019", "190520 1st 4 hours of ABSOLUTE CONFIRMATION of ALL DATA DELIVERED !!! Bottomless Pit OPENING !!.mp4"],
["190521",     "0.0.0.0", "12384.01|1.35 GB", "*SAfE4wAGP6I", "2019", "190521 2nd 4 HOURS ,,, REVELATION after REVELATION and Proof of the END.mp4"],
["190524",     "0.0.0.0", "11379.01|698 MB", "*FyJEbTQ5BlY", "2019", "190524 Banned Worldwide!!Why Because they telegraphed their Plans to KILL US.mp4"],
["190528",     "0.0.0.0", "5735|590 MB", "*El1Zz7SzTUM", "2019", "190528 OH MY LORD!! The Most Necessary VIDEO On the EARTH!! HERE THEY COME!!.mp4"],
["190531",     "0.0.0.0", "12676.01|479 MB", "*FEVA9oGd5cg", "2019", "190531 LENGTH of VIDEO -331 anáthema from aná, 'up' concluding a process, (given up) to destruction.mp4"],
["190605",     "0.0.0.0", "5934.02|685 MB", "", "2019", "190605 The GODS of EGYPT,, OUR Hidden Task Masters,,,Hiding Place GONE!!!!.mp4"],
["190606",     "0.0.0.0", "3707.02|433 MB", "", "2019", "190606 X-Games 4 REAL !!! ONLY the LORD GOD Could ORCHESTRATE This Testimony!!!.mp4"],
["190610",     "0.0.0.0", "4138|470 MB", "", "2019", "190610 The Container Update and Testimony !!!! SUPERNATURAL , IMPOSSIBLE!! You are SEEING IT!!.mp4"],
["190614",     "0.0.0.0", "8441.01|925 MB", "*oF81XAhpFfY", "2019", "190614 Time to Let Go !!!! Who saw 'Finding Nemo' Time to let go.mp4"],
["190616",     "0.0.0.0", "5804.01|656 MB", "", "2019", "190616 SET 4 Destruction,,, Watch ENTIRE Litany of PROOF,, WE ARE DONE ,,,Coming Soon.mp4"],
["190621",     "0.0.0.0", "4543.01|715 MB", "", "2019", "190621 Strongs 3140 = To Bear Witness, Strongs 354 = A TAKING UP, To Ascend.mp4"],
["190624",     "0.0.0.0", "5138.02|322 MB", "", "2019", "190624 Ready for the Harvest.mp4"],
["190628",     "0.0.0.0", "2663|279 MB", "", "2019", "190628 The Wh(O)re of Revelation REVEALED! All Glory to the King YESHUA.mp4"],
["190629",     "0.0.0.0", "1225.02|106 MB", "", "2019", "190629 Grand Junction Warning and Admonishment - Date Released tonight.mp4"],
["190630-01",  "0.0.0.0", "2202.02|260 MB", "", "2019", "190630-01 7 Day HEADS UP Grand Junction.mp4"],
["190630-02",  "0.0.0.0", "3911.01|363 MB", "", "2019", "190630-02 Is it FINALLY the END! Only the LORD GOD Knows,,But MYSTERY SOLVED!!.mp4"],
["190703",     "0.0.0.0", "771.02|94.9 MB", "", "2019", "190703 Getting things Ready!! PLEASE Pay Attention if you wish to attend.mp4"],
["190704",     "0.0.0.0", "4522.02|526 MB", "", "2019", "190704 REVELATION 22 is Written ALL OVER This Testimony!!! WOW,,Watch it ALL.mp4"],
["190706-01",  "0.0.0.0", "808.01|89.7 MB", "", "2019", "190706-01 1st Get Together in Grand Junction.mp4"],
["190706-02",  "0.0.0.0", "680.02|174 MB", "", "2019", "190706-02 IMG 0332.mp4"],
["190707-01",  "0.0.0.0", "613.01|110 MB", "", "2019", "190707-01 Recording 97 Grand Junction Event!!! Clips,,,Thank You.mp4"],
["190707-02",  "0.0.0.0", "1075.01|112 MB", "", "2019", "190707-02 Work of FAITH Complete Maybe !!!! We will SEE.mp4"],
["190710",     "0.0.0.0", "3224.02|437 MB", "", "2019", "190710 Recording 99.mp4"],
["190712",     "0.0.0.0", "1979.01|195 MB", "", "2019", "190712 A GOOD Report -Thomas and Jorrie Lamb. Mind destroying testimony NEXT!!.mp4"],
["190714",     "0.0.0.0", "2604|265 MB", "", "2019", "190714 Grand Junction Slide-show and Miracle Trip to EDEN,Consecrated Potter's Clay.mp4"],
["190715",     "1.2.0.1", "3723.02|379 MB", "", "2019", "190715 LEGAL_SERIES 1 Are YOU being Called Delusional or Crazy__ MUST Watch this THEN.Time to hit back.mp4"],
["190716",     "1.2.0.1", "4817|517 MB", "", "2019", "190716 LEGAL_SERIES 2 What is the TRUTH__ PAY Very CLOSE ATTENTION,,, The TRUTH will Make You FREE.mp4"],
["190718",     "1.2.0.1", "7726.02|802 MB", "*FiPEJecsW0Y", "2019", "190718 LEGAL_SERIES 3 This PROVES the WHOLE WORLD Is DELUSIONAL,,I'm am ABSOLUTELY SERIOUS.mp4"],
["190720",     "1.2.0.1", "9126.02|974 MB", "*sNxPho4-5gk", "2019", "190720 LEGAL_SERIES 4 Case Closed. The Jury can Now Make its DECISION.mp4"],
["190722",     "1.2.0.1", "10707.02|0.99 GB", "*wudBqbIuVoo", "2019", "190722 LEGAL_SERIES 5 The WHOLE MYSTERY RECONCILED !!!! IT's OVER!!! Beginning to END.mp4"],
["190728",     "0.0.0.0", "2441.02|246 MB", "", "2019", "190728 Good LORD !!! The FLOOD of INFORMATION is About to Burst the Dam,,No Stopping it!!.mp4"],
["190801",     "0.0.0.0", "4442|541 MB", "", "2019", "190801 START This Video at the 27 minute mark,,watch to the end,,,Then Start Over at the Beginning.mp4"],
["190803",     "0.0.0.0", "9351|1.02 GB", "*lhXL0MBXJ04", "2019", "190803 Banned Worldwide,,Again The Revelation WILL be PUBLISHED .mp4"],
["190805-01",  "0.0.0.0", "7846.02|932 MB", "*P5hoNNj2E18", "2019", "190805-01 A New Race of BEINGS Being Birthed,,,, WTH !! Milk-shaking Twisted.mp4"],
["190805-02",  "1.2.0.0", "531.55|101 MB", "", "2019", "190805-02 Video no1 from Grand Junction Skydive,,,, Plane ride.mp4"],
["190805-03",  "1.2.0.0", "531.55|108 MB", "", "2019", "190805-03 Video no2 PLANE RIDE FOOTAGE.mp4"],
["190805-04",  "1.2.0.0", "521.73|101 MB", "", "2019", "190805-04 Video no3 Raw Footage Grand Junction DEMO Jump at Michael's.mp4"],
["190808",     "0.0.0.0", "727.02|84.7 MB", "", "2019", "190808 They LIVE WE Sleep ,,Hour and a Half video Will be Redone ,,,Sorry.mp4"],
["190810",     "0.0.0.0", "8800.01|950 MB", "*Ept6lXGrzak", "2019", "190810 2424-Better Watch the WHOLE THING,,,Try not to Freak out,,, It is Finished.mp4"],
["190813",     "0.0.0.0", "6301.01|722 MB", "", "2019", "190813 YOU _are_ ALIENS and SOJOURNERS , Rapture = EL coming to get HIS Children =Alien Abduction.mp4"],
["190817",     "0.0.0.0", "381.02|51.1 MB", "", "2019", "190817 Checking in ,,,New Testimony Coming!!! Behold I Come Quickly.mp4"],
["190819",     "0.0.0.0", "7746.01|916 MB", "*5inlNVrQpls", "2019", "190819 EDEN RESTORED !!! SUPERNATURAL TESTIMONY,, IMPOSSIBLE by ALL ACCOUNTS.mp4"],
["190823",     "0.0.0.0", "3367.01|119 MB", "", "2019", "190823 How SIMPLE to DEFEND the TRUTH,,THE TRUTH Completely Defends Itself.mp4"],
["190827",     "0.0.0.1", "242.02|23.6 MB", "", "2019", "190827 Get Ready For Some BREAK THROUGH Mind Blowing  Scripture.mp4"],
["190829",     "0.0.0.0", "2180.01|80.8 MB", "", "2019", "190829 Complete Exposure of the Scorpion Race.Coming next,, Review FOLDER.mp4"],
["190903",     "0.0.0.0", "733.01|22.3 MB", "", "2019", "190903 Ministry Took a Torpedo to the Bow of the SHIP  We are Almost Fully Operational again.mp4"],
["190906",     "0.0.0.0", "6456.01|605 MB", "", "2019", "190906 Bigger Better Battleship and False Prophet hunters Here Ya Go Done!.mp4"],
["190911",     "0.0.0.1", "7564.02|743 MB", "*BcFtaXk7lYE", "2019", "190911 NEW Scripture REVEAL That PROVES it All - AGAIN  Let's also talk about the birds and the Bees.mp4"],
["190914",     "0.0.0.0", "9449.06|371 MB", "*qY92mKmt1nM", "2019", "190914 Nine ONE ONE ,, IMPOSSIBLE to Understand it, without KNOWING what's in this Video !!.mp4"],
["190917",     "0.0.0.0", "1052|117 MB", "", "2019", "190917 The World is ABOUT to Change FOREVER.mp4"],
["190919",     "0.0.0.0", "2950|297 MB", "", "2019", "190919 The Sorceress That cast the Spell on the Whole World from THE OTHER SIDE.mp4"],
["190922",     "0.0.0.0", "5710.09|233 MB", "", "2019", "190922 The Pudenda is CONSUMED WTH You Heard it!! Watch it All.mp4"],
["190925",     "0.0.0.0", "9657.02|1.05 GB", "*PnTnVJie3Gc", "2019", "190925 The BIBLE is RESOLVED!! up, completing a process, vigorously judging down to up,.mp4"],
["190928",     "0.0.0.0", "5056.01|319 MB", "", "2019", "190928 LED ZEPPELIN-Mocking Angels - Ana-Krino -- Now the WHOLE WORLD MAKES SENSE.mp4"],
["190930",     "0.0.0.0", "4625.02|170 MB", "", "2019", "190930 Oh OH !!! Theyy'rrreee HeeeerRrreee!! No DOUBT!! Here Comes the Unleashing!!.mp4"],
["191003",     "0.0.0.0", "1219|123 MB", "", "2019", "191003 Bat-CAT has Passed,,, but, WOW!!! What a Confirmation He was Used for!!.mp4"],
["191007",     "0.0.0.0", "9290|1.01 GB", "*OZPAWb28_rg", "2019", "191007 God is my Strength and will set Himself in Battle AGAINST those without Love of that which is Good.mp4"],
["191011",     "0.0.0.0", "6512.01|223 MB", "", "2019", "191011 No MORE-down- CURSE. You Won't Believe it!! BUT You WILL. Plus Watch a Miracle Manifest LIVE.mp4"],
["191014",     "0.0.0.0", "5934.02|659 MB", "", "2019", "191014 X-TINCTION REBELLION ,,,Can't make this stuff UP,,,No pun Intended,,,Katah!!!.mp4"],
["191020",     "0.0.0.0", "1826.02|147 MB", "", "2019", "191020 The Program Malfunctioned Checkin in ,,,See you all manana.mp4"],
["191021",     "0.0.0.0", "3493|207 MB", "", "2019", "191021 The Mote and the BEAM,, Yesterdays Programs issue Resolved.mp4"],
["191028-01",  "0.0.0.0", "136.02|4.80 MB", "", "2019", "191028-01 Sorting out program issues as well as deleted video issues.mp4"],
["191028-02",  "0.0.0.0", "5553.01|206 MB", "", "2019", "191028-02 I Will Bring you UP, out of the Land of Egypt.mp4"],
["191105",     "0.0.0.0", "4018|265 MB", "", "2019", "191105 Want to KNOW the Actual Reality of the RESURRECTION !! Try Not to Freak Out!! All Glory to Jesus.mp4"],
["191110",     "0.0.0.1", "6360.02|664 MB", "", "2019", "191110 THESE REVELATIONS of THESE SCRIPTURES WILL CHANGE the WORLD FOR-EVER !!  Glory to the KING.mp4"],
["191113",     "0.0.0.0", "5785.02|705 MB", "", "2019", "191113 Supernatural Bell Testimony and Construction update.mp4"],
["191120-01",  "0.0.0.0", "263.27|55.6 MB", "", "2019", "191120-01 Building Art.mp4"],
["191120-02",  "0.0.0.0", "44.81|4.18 MB", "", "2019", "191120-02 IMG 9335.mp4"],
["191120-03",  "0.0.0.0", "43.61|4.11 MB", "", "2019", "191120-03 IMG 9337.mp4"],
["191120-04",  "0.0.0.0", "31.72|8.40 MB", "", "2019", "191120-04 Hey,,,Remember THIS Miracle,,,,, 1st container video upon completion.mp4"],
["191127",     "0.0.0.0", "347.02|46.1 MB", "", "2019", "191127 Happy Thanksgiving. Preparing the Message that the Task has Revealed and Manifested.mp4"],
["191202",     "0.0.0.0", "574.02|16.5 MB", "", "2019", "191202 Cyber Something!!!  I'm Here kinda like contending with the Prince of Persia.mp4"],
["191207",     "0.0.0.0", "6058.02|685 MB", "", "2019", "191207 HERE Comes the Fruition and Miraculous CONFIRMATION.mp4"],
["191208",     "0.0.0.0", "310.01|39.6 MB", "", "2019", "191208 I was Told to Lock the Door,,,Documenting the day ,,Testimony tomorrow.mp4"],
["191209",     "0.0.0.0", "3012.02|385 MB", "", "2019", "191209 The DOOR IS SHUT and LOCKED,,Here is the Testimony,,,.mp4"],
["191218",     "0.0.0.0", "11991.02|1.30 GB", "*ovc5-3209o4", "2019", "191218 The DRAGON will Give his Power to the BEAST--- Wanna SEE ___ Watch it ALL !!!.mp4"],
["191219",     "0.0.0.0", "5032.02|530 MB", "", "2019", "191219 Want to Witness a Real Miracle __ SEE a Confirmation Straight From the Lord God_ Watch !!.mp4"],
["191225",     "0.0.0.0", "388.01|12.7 MB", "", "2019", "191225 The Church is NEARING Completion!!!! N-Tag 216 Operational,,I'll explain later.mp4"],
["191231",     "0.0.0.0", "694.02|19.4 MB", "", "2019", "191231 Just FINISHED the Building and Installed the BELL !!!.mp4"],

//==== 2020 ====

["200102-01",  "1.3.0.0", "8238.02|395 MB", "*H-XcqjOM11E", "2020", "200102-01 The Church is Completed the Bell installed- Miracle After Miracle- Also NTAG 216 and the  Doodle.mp4"],
["200102-02",  "1.3.0.0", "972.96|76.6 MB", "*https://youtu.be/H-XcqjOM11E?t=7124", "2020", "200102-02 NTAG 216 - Mark of the Beast.mp4", "Same as end of previous video (1:58:45 to end)."],
["200109",     "0.0.0.0", "5271.02|632 MB", "", "2020", "200109 It Just Got Very REAL! The End IS Coming.mp4"],
["200114",     "0.0.0.0", "1502.01|176 MB", "", "2020", "200114 God Help Me Deliver these Miracles!!! I am Beyond words watching this Unfold.mp4"],
["200118",     "0.0.0.0", "7155.02|893 MB", "", "2020", "200118 From ADAM  to LOCUSTS! The End of the World. The Impossible TRUTH is HERE.mp4"],
["200121",     "0.0.0.0", "7152|786 MB", "", "2020", "200121 Invasion Imminent- Scorpion Race From Genesis to Ezekiel to REVELATION.mp4"],
["200123",     "0.0.0.0", "2531.02|207 MB", "", "2020", "200123 Adam G76 ( Hebrew 121) - As Christ's REPRESENTATIVE Completely Solved. The POTTER'S CLAY.mp4"],
["200126",     "0.0.0.0", "6558.01|608 MB", "", "2020", "200126 IRREFUTABLY- The BIBLE  Resolved !!THE MYSTERY IS REVEALED ! Now Comes the FIRE to Destroy the EARTH.mp4"],
["200130",     "0.0.0.0", "1627.02|126 MB", "", "2020", "200130 131= Hemorrhage in Strongs. Yesterday the NEWS said 131 People died.The Virus Kills by Hemorrhage.mp4"],
["200131",     "0.0.0.0", "3537|438 MB", "", "2020", "200131 Red Wedding  Blood Bath Corona Virus Adam to Locusts Hmmmm The Signposts Spell it out.mp4"],
["200201",     "0.0.0.0", "994.09|40.9 MB", "", "2020", "200201 Horseman Buses Transporting Corona Virus patients To England Locusts are coming.mp4"],
["200202",     "0.0.0.0", "2137|64.0 MB", "", "2020", "200202 Dani-El - Judge of El - Time of the Female Rival- NOW ARRIVING at GATE 4930.mp4"],
["200207-01",  "1.0.0.0", "146.01|4.74 MB", "", "2020", "200207-01 Test video.mp4"],
["200207-02",  "0.0.0.0", "10982.02|1.11 GB", "*_5BFJ1XlkYM", "2020", "200207-02 We Are GOING HOME WE'VE DONE OUR TIME !! Watch the WHOLE 3;03.mp4"],
["200209",     "0.0.0.0", "6080.01|726 MB", "", "2020", "200209 V 4 VENGEANCE... The Time is Arriving... Time to Prepare your Hearts.mp4"],
["200213",     "0.0.0.0", "7171.02|412 MB", "", "2020", "200213 ANGEL of the BOTTOMLESS PIT-- SHEEP -- SLAUGHTER-- --Time to RING the BELL.mp4"],
["200217",     "0.0.0.0", "4101.02|408 MB", "", "2020", "200217 God of Harvest is Here. SEE it Unfolding. Be Ready. Bell about to Ring.mp4"],
["200220",     "0.0.0.0", "6616.02|720 MB", "", "2020", "200220 Angel of the Abyss Crossing the Finish Line !!! WOW!! Couldn't Even Think This Up.mp4"],
["200221",     "0.0.0.0", "11173|1.08 GB", "*Etm3QB4xQEo", "2020", "200221 The REVELATION Speaks of the END ,,It will Surely Come!!! NOW It Is ALL VISIBLE.mp4"],
["200224",     "0.0.0.0", "9420.01|1.06 GB", "*c7TrdzMkJpI", "2020", "200224 3 Videos in 1 - 1st Brandon's Dad Passing was MIRACULOUS - 2nd Corona Update- 3rd The Locust Mystery.mp4"],
["200229",     "0.0.0.0", "8501.01|818 MB", "*uRi4YFE4nXs", "2020", "200229 The LOCUSTS of REVELATION are Coming!! Confess and REPENT Now!! REPENT!! The Message is Here.mp4"],
["200305",     "0.0.0.0", "1001.01|206 MB", "", "2020", "200305 Getting the House in Order. Getting Ready to Deliver.mp4"],
["200307",     "1.0.0.0", "1742.01|188 MB", "", "2020", "200307 Recording 106 will be Loaded soon Sit tight but in the meantime--.mp4"],
["200308",     "0.0.0.1", "5318.02|572 MB", "", "2020", "200308 Recording 106...The Scripture that Proves EVERYTHING !! --John 316--- 3140 begins John316.mp4"],
["200313",     "0.0.0.0", "573.02|97.5 MB", "", "2020", "200313 Recording 109 ---The Kingdom of Heaven is at Hand ----.mp4"],
["200315-01",  "0.0.0.0", "7993|963 MB", "*OgHrH4rI6mk", "2020", "200315-01 RACE OVER Apollyon Sheep Slaughter!! -Round-Up the Little Rocks.WOW!! Here it Comes!!.mp4"],
["200315-02",  "0.0.0.0", "1862.01|271 MB", "", "2020", "200315-02 Yahweh Has Given a Messenger to Ring the Bell to Gather the Church,,, John 3;16 - Let's Celebrate !!.mp4"],
["200316",     "1.2.0.0", "1023|205 MB", "", "2020", "200316 The Bell is Rung... I believe the Time is Fulfilled ..End of the World Coming Soon.mp4"],
["200319",     "0.0.0.0", "6154.01|783 MB", "", "2020", "200319 The Blood will be the Sign! Locust Race about to Hatch! Couldnt even think this up! Praise God.mp4"],
["200320",     "0.0.0.0", "4159.02|478 MB", "", "2020", "200320 Locusts From the Pit .. The Birthing ..You Better Heed the Warning.mp4"],
["200321",     "0.0.0.0", "5411.02|672 MB", "", "2020", "200321 Cofirmation after CONFIRMATION after CCOONNFFIIRRMMAATTIIOONN THE END of the WORLD is ARRIVING NOW!.mp4"],
["200323",     "0.0.0.1", "6567.02|685 MB", "", "2020", "200323 The TRUTH is SO OBVIOUS NOW !! LOOK at this SCRIPTURAL Nuclear Bomb to SATAN's Falling Kingdom !!.mp4"],
["200324",     "0.0.0.0", "4142.02|502 MB", "", "2020", "200324 The Enemy is Blatently mocking us..Therefore I say WATCH.mp4"],
["200326-01",  "1.2.0.1", "549.01|37.8 MB", "", "2020", "200326-01 World WIDE BLOCK ..Busted!!! Re-Upload in the Morning,,Watch trailer in description box.mp4"],
["200326-02",  "1.2.0.1", "8552.21|865 MB", "*JVArtpMRYHA", "2020", "200326-02 World Wide Block !! I Have Seen the ENEMY, and it WAS ME and U !! GOD Have Mercy and Forgive Us.mp4"],
["200330",     "1.3.0.0", "108.76|7.99 MB", "*4QEwmsfXPWg", "2020", "200330 VACCINE IMPLANTS - HEAD and RIGHT HAND SCANNING IN CHINA.mp4", "Thank you 'Dave Shadow'."],
["200331",     "1.3.0.0", "5254|616 MB", "", "2020", "200331 Trying to Contain the Excitement Over the IMPOSSIBLE TESTIMONY Since the BELL RINGING.mp4"],
["200401",     "0.0.0.0", "6405.02|810 MB", "", "2020", "200401 Can You NOT See the ABOMINATION of DESOLATION I Can ! I can SEE IT ALL. The End IS HERE.mp4"],
["200402",     "0.0.0.0", "4483.01|479 MB", "", "2020", "200402 ABSOLUTE U .. When you Know what it means, You Will KNOW the END Is COME.mp4"],
["200403",     "1.2.0.0", "6688.02|855 MB", "", "2020", "200403 London HAS Fallen, Sure Looks that Way..London = Casa Blanca.mp4"],
["200404",     "1.2.0.0", "486.02|16.2 MB", "", "2020", "200404 Just GOTTA Unburden myself !!! Soooo Over dealing with everything including Myself.. Time to Purge.mp4"],
["200406",     "0.0.0.0", "8440.01|1.12 GB", "*xh8PbokiCLY", "2020", "200406 The NEW Race Is HERE! So IS The NEW JERUSALEM! Here Comes The Sheep Slaughter !! Here Comes JESUS !.mp4"],
["200407",     "1.2.0.0", "4865.02|557 MB", "", "2020", "200407 The Attack is Imminent !! Prepare a Fast and Solemn Assembly ... These ARE my Instructions.mp4"],
["200407-02",  "1.2.0.0", "6221.02|557 MB", "", "2020", "200407-02 Insert at ------39;25------ WOW!!Same Video with UNBELIEVABLE Insert at ---39;28 ---- Whaaaaatt.mp4"],
["200408",     "0.0.0.0", "2204.01|253 MB", "", "2020", "200408 Communion TODAY!!! Here is the Service... See You Soon...Agape Love.mp4"],
["200412",     "0.0.0.0", "8518.01|930 MB", "*ua_fO9IbH_E", "2020", "200412 411. anekdiégétos..Thanks be unto God for his UNSPEAKABLE GIFT.mp4"],
["200414",     "0.0.0.0", "5987.01|685 MB", "", "2020", "200414 WOW!! Stop the No I.D. You Gotta Watch it All to Understand what is RIGHT in FRONT of U.mp4"],
["200418",     "0.0.0.0", "11493.02|1.24 GB", "*2LmMmTmsmq4", "2020", "200418 Did theFrankie Testimony ALERT Us Prepare the way for the Lord, make straight paths for him.mp4"],
["200422",     "0.0.0.0", "9532|1.16 GB", "*6QlcXJbvqL8", "2020", "200422 The Magic Kingdom !! They Got That Right.. Talk About an ILLUSION, WOW!!.mp4"],
["200426",     "0.0.0.1", "8477|882 MB", "*EQA1SPFqjgk", "2020", "200426 The Self-Existent Eternal Jehoshua..One of the MOST PROFOUND Scriptural REVELATIONS of ALL TIME.mp4"],
["200501",     "0.0.0.0", "8471.01|983 MB", "*TFy061bownQ", "2020", "200501 To Receive That which is INTANGIBLE, You MUST Believe,,I received it..Let Me Please Show You.mp4"],
["200503",     "0.0.0.0", "741.02|53.5 MB", "", "2020", "200503 Time To Put Everybody to Work for the KINGDOM...Ill Explain in Next Video.mp4"],
["200506",     "0.0.0.0", "5036.01|516 MB", "", "2020", "200506 MUTATED From Abaddon Sheep Slaughter to - Fruit From the Secret Harvest to PERISH.mp4"],
["200509",     "0.0.0.0", "1884.02|560 MB", "", "2020", "200509 Ana Suramai!! Craaaazzzeeee but she got it..And Here Comes the Series.mp4"],
["200514",     "0.0.0.0", "1339|105 MB", "", "2020", "200514 Here comes the Next Drop of Exposing the Enemys Plan.The Bible, THANK the LORD GOD, explains it ALL.mp4"],
["200515",     "0.0.0.0", "4335|428 MB", "", "2020", "200515 Mark of the BEAST- Forced Vaccination Agenda.. Exact Vocabulary from the BIBLE.mp4"],
["200518",     "0.0.0.0", "5942.01|717 MB", "", "2020", "200518 Luciferase and Bioluminescent quantum dots,The FEMALE Rival and More !!! Brace Yourselves!!!.mp4"],
["200522",     "1.2.0.1", "4391.01|489 MB", "", "2020", "200522 THESE SCRIPTURES CHANGE The WORLD FOR- EVER. - The Identity of Christ Perfectly REVEALED.mp4"],
["200531",     "1.2.0.0", "8076.02|946 MB", "*PM_AMfPKvvA", "2020", "200531 The ONLY Ministry that Opens your Prison - Jesus Read it From ISAIAH - Heads UP.mp4"],
["200601",     "1.3.0.0", "8287.02|1 GB", "*KphFSwn1eDc", "2020", "200601 1st a Discussion -2nd Revelation and Info Ive havent Shared - Do you Think I should Reveal ALL.mp4"],
["200603",     "1.3.0.0", "6383|702 MB", "", "2020", "200603 I Will Bring U UP Out of the Land of Egypt You could NOT Even THINK THIS UP.mp4"],
["200605",     "1.2.0.0", "5504.01|1.13 GB", "", "2020", "200605 Recording No.3 Search Strong's Greek 3 (Abaddón) -- Abaddon, the angel.mp4"],
["200609",     "1.3.0.0", "2549.02|459 MB", "", "2020", "200609 Fashion show - The Helmet designer.mp4"],
["200612",     "1.3.0.0", "4021.02|759 MB", "", "2020", "200612 Wink Tongue = Abaddon Sheep Slaughter again !!! But LOOK Whos Doing it!!.mp4"],
["200615",     "1.2.0.0", "62.02|12.8 MB", "", "2020", "200615 Getting READY to Deliver the Message !!!! The KING IS COMING.mp4"],
["200619",     "1.2.0.0", "343.01|42.2 MB", "", "2020", "200619 Im BACK!!!!!!! Thank GOD!!!!!!!!! Keep an Eye on the Channel.mp4"],
["200622",     "1.2.0.0", "2245.02|263 MB", "", "2020", "200622 Check Out Jackson!! .. Coming Soon, Very Very Soon.mp4"],
["200624",     "1.2.0.1", "4023.02|492 MB", "", "2020", "200624 THEIR MOMENT of GLORY is No Surprise to Those That KNOW the TRUTH.mp4"],
["200625",     "1.2.0.0", "600|85.7 MB", "", "2020", "200625 Brave Guard...Standing UP ..The Resurrection - I Told You So!!! Coming Soon.mp4"],
["200629",     "1.2.0.0", "329|33.6 MB", "", "2020", "200629 V 4 VENGEANCE !!!The Sky-Dive Into the Desert is A GO!!!!! Miracle after Miracle after Miracle.mp4"],
["200704-01",  "4.1.0.0", "2541.05|33.6 MB", "*NB607dVHSyM", "2020", "200704-01 Desert SLIDESHOW -No.1 - PREPARING FOR THE TRIP.mp4"],
["200704-02",  "4.1.0.0", "2188.71|33.6 MB", "*aRsUTufB56o", "2020", "200704-02 Desert SLIDESHOW -No.2 - DESERT.mp4"],
["200704-03",  "4.1.0.0", "370.1|33.6 MB", "*y5KR141gfCA", "2020", "200704-03 Desert SLIDESHOW -No.3 - AT THE LANDING ZONE BEFORE THE JUMP.mp4"],
["200704-04",  "4.1.0.0", "24.08|33.6 MB", "*lyFfSFFDj-s", "2020", "200704-04 Desert SLIDESHOW -No.4 - Boarding the Plane.mp4"],
["200704-05",  "4.2.0.0", "1486.1|33.6 MB", "", "2020", "200704-05 Desert.LiveStream No.1 - Here we go.mp4"],
["200704-06",  "4.2.0.0", "246.04|33.6 MB", "", "2020", "200704-06 Desert.LiveStream No.2 - Here we gooooooo.mp4"],
["200705-01",  "4.1.0.0", "17.55|1.48 MB", "*QOKlpSiOU-U", "2020", "200705-01 Desert No.5 - Pilot Video.mp4"],
["200705-02",  "4.1.0.0", "315.79|27.6 MB", "*pqimW4nDmf0", "2020", "200705-02 Desert No.6 - The LZ and the Creek Bed.mp4"],
["200705-03",  "4.2.0.0", "956.1|76.9 MB", "", "2020", "200705-03 Checking in.mp4"],
["200706-01",  "4.2.0.0", "696.04|57.2 MB", "", "2020", "200706-01 Be Ready.mp4"],
["200706-02",  "4.4.0.0", "140.02|5.58 MB", "", "2020", "200706-02 This IS It.mp4"],
["200708",     "4.2.0.0", "578.01|70.5 MB", "", "2020", "200708 Recording 2 Test Video.mp4"],
["200710",     "1.2.0.0", "3434.02|412 MB", "", "2020", "200710 Recording 3.mp4"],
["200715",     "1.2.0.0", "4252.01|290 MB", "", "2020", "200715 The Revelation Awaits an Appointed Time, at the end it shall speak, and not lie.mp4"],
["200720",     "1.2.0.0", "2065.02|267 MB", "", "2020", "200720 Directly OVER the TARGET --- WOW-- Sitra Achra Scorps PISSED OFF ---.mp4"],
["200724",     "1.3.0.0", "2551.01|317 MB", "", "2020", "200724 DESTRUCTION RUIN and DECAY , Welcome to ACAB for REAL!!!!!!!!!!!!!.mp4"],
["200726",     "1.3.0.0", "5454.02|597 MB", "", "2020", "200726 PROOF!! The -- DRAGON--- will Give His Power to the BEAST __ WOKE_-_.mp4"],
["200731",     "1.3.0.0", "3446|359 MB", "", "2020", "200731 The Beginning of Sorrows ----- SEE the TRUTH with your Own EYES.mp4"],
["200802",     "1.3.0.0", "5106.02|571 MB", "", "2020", "200802 To STRIKE a MUSICAL NOTE = CAIN -- The OTHER VOICE.mp4"],
["200804",     "1.3.0.0", "3794|398 MB", "", "2020", "200804 OH ITS COMING All Right - Watch this and Hold onto your Jaw.mp4"],
["200810",     "1.3.0.0", "965.02|119 MB", "", "2020", "200810 Recording 20.mp4"],
["200812",     "1.3.0.0", "795|78.4 MB", "", "2020", "200812 Saving an Outline for Tomorrows Video ...The End Is Arriving.mp4"],
["200814",     "1.3.0.0", "9036.02|1.01 GB", "*L7xCLgEqUi4", "2020", "200814 You STAND.. ...to WIN ...... EVERYTHING... World Changing Revelation.mp4"],
["200818",     "1.3.0.0", "4106.01|512 MB", "", "2020", "200818 CERN - Dark Matter and Evil---See the Connection I Do.. It is EASY to SEE NOW.mp4"],
["200826",     "1.3.0.1", "7713.07|919 MB", "*YzxS0um3FAY", "2020", "200826 SCORPIONS - Right in FRONT of U - SCRIPTURAL Napalm - Cardi-B and More.mp4"],
["200902",     "1.3.0.0", "5745.01|625 MB", "", "2020", "200902 Devils Roll the Dice,and Angels Roll their EYES! Wow! Taylor Swift Gives it Away!! Don't Forget KATA.mp4"],
["200909",     "5.1.0.0", "1759|146 MB", "", "2020", "200909 Time to PREPARE for Genesis 1 Revelation.mp4"],
["200911",     "5.1.0.0", "2134.01|202 MB", "", "2020", "200911 Equipment Looking Good!! Straightforward Talk about the Methodology of the Upcoming Revelation.mp4"],
["200914",     "5.2.0.0", "2965.05|276 MB", "", "2020", "200914 The Veil is DOWN !!! g ,Just Like the Maserati Commercial said The WE Strike!!!.mp4"],
["200915",     "5.2.0.0", "3086|116 MB", "", "2020", "200915 Ace in the Hole...No Kidding.. See it to Believe it.mp4"],
["200921",     "5.2.0.0", "4548.02|380 MB", "", "2020", "200921 The Veil is Down-- the Deception is So Great Only the Spirit of the LORD GOD could Penetrate it--.mp4"],
["200929",     "5.2.0.1", "6769.01|272 MB", "", "2020", "200929 SCRIPTURE U MUST SEE... NO Idols .. NO EMBODIMENT.. Embodiment puts U into the CANNIBALISTC System.mp4"],
["201002",     "5.2.0.0", "7142.02|880 MB", "", "2020", "201002 GENESIS 1 REVELATION -- PART 1 -- Introduction to TWIN SYSTEM in need of RECONCILIATION.mp4"],
["201010",     "5.0.0.0", "413.01|42 MB", "", "2020", "201010 checking in and update.mp4"],
["201014",     "5.0.0.0", "802.02|36.4 MB", "", "2020", "201014 Trying to get the Genesis 1 Series UP and OUT .... Pray for the Expeditious Delivery of this Gift.mp4"],
["201018",     "5.0.0.0", "2661.01|270 MB", "", "2020", "201018 A Young Girls Sight RESTORED-- MIRACLE For the Books-.. More to Come.mp4"],
["201020",     "5.2.0.0", "6660.02|696 MB", "", "2020", "201020 Genesis 1 Leaked...Bye den and I Flourish Again Cryptic-- Just watch-- Get your Spatulas Out.mp4"],
["201023",     "5.2.0.0", "8450.02|939 MB", "*EIS1eRAMcMo", "2020", "201023 Parthenogenesis.. The Original..TRANSMUTATION--- Statue of LIBERTY Now Makes Sense--.mp4"],
["201025",     "5.2.0.1", "7579.02|773 MB", "*Y_q5r7gyv1E", "2020", "201025 Genesis 1-- Parthenogenesis - Clever Girl Miracle Gift of Knowledge -Scripture.mp4"],
["201027",     "5.2.0.0", "6163.02|612 MB", "", "2020", "201027 Blocked World-Wide...T-REX -- Parthenogenesis- T-REX Nativity Scene Hidden in Plain Sight.mp4"],
["201028",     "5.0.0.0", "2194.01|203 MB", "", "2020", "201028 Freak OUT--- Caught with his Hand in the COOKIE JAR-- We ALL got Caught -- That-s the Real JOKE.mp4"],
["201105-01",  "5.0.0.0", "1020.01|41.4 MB", "", "2020", "201105-01 The Calling AWAY is at Hand ... NOW I am READY for Video after Video after Video till WE GO.mp4"],
["201105-02",  "5.0.0.0", "3141.01|314 MB", "", "2020", "201105-02 The Brutal Truth ... Here it Comes.mp4"],
["201111",     "5.2.0.0", "6904.01|747 MB", "", "2020", "201111 The SERPENT and the End of Days.. THEY r HERE.mp4"],
["201113",     "5.2.0.0", "7865.02|860 MB", "*zhnzuZpDxr0", "2020", "201113 The CURSE will be GONE -- No More --------DOWN -------- Phantom Revealed.mp4"],
["201116",     "5.2.0.0", "10717.01|1.06 GB", "", "2020", "201116 You Wanted to KNOW the TRUTH.. Rap-Tor your Brain around This.mp4"],
["201120",     "4.2.0.0", "10384.01|992 MB", "*SnBbOx9qYRQ", "2020", "201120 The END of the World Really They-re Here--.mp4"],
["201125",     "4.2.0.0", "2482|290 MB", "", "2020", "201125 You KNOW What You KNOW --Whosoever has an Ear let them Hear.. Happy Thanksgiving as well ---.mp4"],
["201127",     "4.2.0.0", "5713.01|630 MB", "", "2020", "201127 Abaddon SHEEP SlaUUghter.. Genesis to Revelation.. Perfection Delivered by ImanuEL----- Astra-Zeneca.mp4"],
["201128",     "4.2.0.0", "1221.02|162 MB", "", "2020", "201128 UP-- Is Their PLAGUE --TRY Not to FREAK OUT--- Jesus WAS a Cult in Their System.The Bible Proves IT-.mp4"],
["201130",     "4.3.0.0", "12995.05|1.10 GB", "*zs2tLeNCrgM", "2020", "201130 Bravo!! BRILLIANT PRESENTATION of the Entire MINISTRY REVELATION .. New Perspective and Presentation.mp4"],
["201201",     "4.3.0.0", "5004.02|506 MB", "*n6QLUP3LGXQ", "2020", "201201 Up UP and AWAY!!!! Getting Ready to GO !! Once U Know U KNOW.mp4"],
["201205",     "4.3.0.0", "2731.01|256 MB", "", "2020", "201205 Match made in Hell --- WOW-- EXACTLY EXACTLY Matches ENTIRE MINISTRY --Recording 61.mp4"],
["201206",     "5.0.0.0", "6300.01|418 MB", "", "2020", "201206 TRUTH - Stranger than - Fiction... Also 2001 Skydive That is NOW IMPOSSIBLE.mp4"],
["201210",     "5.0.0.0", "1680.01|145 MB", "", "2020", "201210 THEY - CONCEALED - UP --They CONCEALED JESUS - I was used to UN-CONCEAL THE KING in their System.mp4"],
["201211",     "5.0.0.0", "389|38.6 MB", "", "2020", "201211 It is COMING on LINE - The EVENTUALITY to the Info...It IS HERE --- -- THEY -- are HERE.mp4"],
["201215",     "5.0.0.0", "167.02|12.0 MB", "", "2020", "201215 The End Is Arriving--- Testimony with witnesses and documented MIRACLES --- The KING is COMING-----.mp4"],
["201217",     "5.0.0.0", "6866|865 MB", "", "2020", "201217 Recording -2369 The Day of the Lord God-s VEVGEANCE has Come. Here THEY Come --.mp4"],
["201221",     "5.0.0.0", "6775|266 MB", "", "2020", "201221 Let their table be made a SNARE- and a trap- and a stumblingblock- and a recompence unto them.mp4"],
["201224",     "5.0.0.0", "547.02|21.5 MB", "", "2020", "201224 Working on EVERYBODY-S CHRISTMAS GIFT -------.mp4"],
["201225-01",  "4.3.0.0", "7459.02|750 MB", "", "2020", "201225-01 Finding the TREASURE The HOLY GRAIL -- Part 1.mp4"],
["201225-02",  "4.3.0.0", "6023|366 MB", "*rGmcSJYq7YQ", "2020", "201225-02 Finding the TREASURE Understanding The HOLY GRAIL -- To Drink from the Cup - Part 2.mp4"],
["201226",     "4.4.0.0", "1026.02|95.1 MB", "*UVZscU4wHx0", "2020", "201226 Before you Watch the Previous 4 hours of Video.mp4"],
["201228",     "4.4.0.0", "3110.01|383 MB", "", "2020", "201228 Never Seen Before PROOF-- TH3 Human Race Is an INSECT HIVE FERTILIZATION SYSTEM.mp4"],
["201231",     "5.0.0.0", "3643|379 MB", "", "2020", "201231 The DRAGON- LOCUSTS -Coming Soon-- TRY to IMAGINE -What You Are Being SHOWN HERE.mp4"],

//==== 2021 ====


["210104",     "0.0.0.0", "1316.01|172 MB", "*G-6Ac74P62A", "2021", "210104 The Dragon- Satan King of the Locusts -- In PLAIN SIGHT.mp4"],
["210110",     "0.0.0.0", "574.02|53.3 MB", "*vnJIPPA_w5w", "2021", "210110 Bourne Guarantee.mp4"],
["210112",     "0.0.0.0", "2952.02|309 MB", "", "2021", "210112 Catching UP with JK - The Raw DATA and Files are ------ Invaluable ------.mp4"],
["210114",     "1.3.0.0", "3951.01|389 MB", "", "2021", "210114 Lucifer-s THRONE--- You Won-t Believe your Eyes- The SERPENT Lifecycle -THEIR Methodology EXPOSED.mp4"],
["210116",     "0.0.0.0", "1309|120 MB", "", "2021", "210116 WHO was Born in CROSS-FIRE Hurricane Hmmmmmmmm Could it Beeeee .mp4"],
["210117",     "0.0.0.0", "3889.02|368 MB", "", "2021", "210117 BEYOND Jaw-Dropping ------- Get Your Spatulas -- PROOF in the WORD Again.mp4"],
["210118",     "0.0.0.0", "3272.02|314 MB", "", "2021", "210118 Is TIME UP Get your SPATULA ----- Try and Wrap your Brain around THIS .. ASAP.mp4"],
["210124",     "6.2.0.1", "4685.02|341 MB", "", "2021", "210124 - 1 - KNOW the SCRIPTURES - Brightness Level UP.mp4"],
["210125",     "6.1.0.0", "4587.01|423 MB", "", "2021", "210125 A RECENT Death Requires This for EVERYBODY-- Pay Attention - Do Not be Deceived.mp4"],
["210126",     "6.1.0.0", "4622|410 MB", "", "2021", "210126 THIS ----- WILL CHANGE ------ The WORLD--- All Glory to the Kings that set us FREE.mp4"],
["210129",     "6.1.0.0", "5128.01|485 MB", "", "2021", "210129 HUNTING GOOD - EVER Been Abused - Goodwill HUNTING..Gotta FEED the Locust-s.mp4"],
["210201",     "6.1.0.0", "5075.02|498 MB", "", "2021", "210201 Toto REVEALS the Wizard. I Guess I-m Toto -- Tell the World -The ILLUSION is OVER. It is Overturned.mp4"],
["210205",     "6.1.0.0", "5058|617 MB", "", "2021", "210205 THIS IS IT -- After This Testimony- What is Left to Say You Decide--.mp4"],
["210206",     "6.1.0.0", "6915.07|621 MB", "", "2021", "210206 Blameless!!! The ONLY Thing That Matters in the End, and The PIT is Opening. Time to Begin Again.mp4"],
["210208",     "6.0.0.0", "210|12.7 MB", "", "2021", "210208 The PIT is GOING to OPEN ... The Testimony will be Delivered Tomorrow.mp4"],
["210209",     "6.1.0.0", "2877.02|332 MB", "", "2021", "210209 Raise the PIT ----- You Gotta Be KIdding The Pit Opening is IMMINENT-- Please Prepare your Hearts.mp4"],
["210211-01",  "1.3.0.0", "3963.02|329 MB", "", "2021", "210211-01 KAHUKU- HOLD the LINE U Gotta Be Kidding Me...Nope I Told You So.. It-s All True.mp4"],
["210211-02",  "1.2.0.0", "249.01|13.7 MB", "", "2021", "210211-02 Qanan WTH Never Supported Never will .... PsyOP.mp4"],
["210211-03",  "1.2.0.0", "105|7.64 MB", "", "2021", "210211-03 Follow UP..... For the Record.mp4"],
["210211-04",  "1.2.0.0", "105|11.6 MB", "", "2021", "210211-04 Follow-UP.mp4"],
["210213",     "1.3.0.0", "3337.01|313 MB", "", "2021", "210213 Q is a PsyOP leading to Nowhere .... There is the TRUTH and then there is EVERYTHING Else.mp4"],
["210219",     "1.2.0.0", "125.02|20.4 MB", "", "2021", "210219 Recording 113.mp4"],
["210220",     "1.2.0.0", "1088.02|70.3 MB", "", "2021", "210220 Freaking OUT --- When you KNOW you Got the Answers- you KNOW you got the Answers.mp4"],
["210221",     "1.3.0.0", "7349.02|789 MB", "*VxDzAN7clXI", "2021", "210221 To be able to show you this is Impossible -- Beyond Unbelievable ---.mp4"],
["210224",     "4.1.0.0", "202.92|15.1 MB", "", "2021", "210224 VAMPIRE SUNGLASSES Marketing Video --- You will become a New Creation .. Compare the PAST.mp4"],
["210225-01",  "4.1.0.0", "573.63|41.0 MB", "", "2021", "210225-01 Let-s REMEMBER the Past-- as HINDSIGHT is 2020.. What-s about to be delivered NEEDS a Juxtaposition.mp4"],
["210225-02",  "4.3.0.0", "5296.01|552 MB", "", "2021", "210225-02 With WHAT is About to be Delivered- YOU should KNOW Exactly -Who- Is DELIVERING Biblical Bombshells.mp4"],
["210301",     "4.4.0.0", "3636.08|145 MB", "", "2021", "210301 Labeled Q Again That is demonstrably False--- Hmmmmmm Weird...HuH THEY are XX.mp4"],
["210304-01",  "4.4.0.0", "242.02|22.5 MB", "", "2021", "210304-01 Catch this Video right away.mp4"],
["210304-02",  "4.4.0.0", "6967.01|414 MB", "", "2021", "210304-02 !!!!! SEE ALL The WAY PAST the ILLUSION !!!.mp4", "Note: Upload date is 210219 but only now published I believe"],
["210309",     "5.1.0.0", "4101.02|404 MB", "https://www.brighteon.com/3f8942bc-18f0-4396-b870-a5c7c26f17a3", "2021", "210309 Rex-s- Raptors- and Sheep- Oh My !!! Absolute must must watch!!! Audio Out from 42 min-44 min..Ooops.mp4"],
["210313",     "5.0.0.0", "2105|93.5 MB", "", "2021", "210313 SHE --- IS --- Here.. Time of the FEMALE Rival ---- Intermission---- video.mp4"],
["210314",     "5.1.0.0", "7447.01|787 MB", "", "2021", "210314 OVER WHELMING Evidence ... Not Arguable.. Prepare for Genesis 1 Revelation.mp4"],
["210319",     "5.2.0.0", "4602.01|451 MB", "https://youtu.be/o0E_U8YbfvA", "2021", "210319 DEPUTYSHIP - How CLEAR it Is ALL Becoming- ALL Glory to Yehoshua.mp4"],
["210325",     "5.2.0.0", "3686.01|351 MB", "", "2021", "210325 IMPOSSIBLE--- COMPLETELY IMPOSSIBLE -- Getting U Ready 4 Let Us make Man in OUR TSLEM.mp4"],
["210328",     "5.3.0.0", "7497|837 MB", "https://www.brighteon.com/2ff65f27-5bdd-4594-9bcc-78512b5062ac", "2021", "210328 COMPLETE Manifestation-Everything I have been Saying - THEY ARE HERE Serpent Race NOW.mp4"],
["210330-01",  "1.1.0.0", "2747.01|303 MB", "https://www.brighteon.com/f6b929d7-b00c-4cf0-aab1-1b87cd5e437f", "2021", "210330-01 ACHTUNG---- A SHOE Represents the SOUL SOLE- The Soul of the World is TURNING to AGENT SMITH-.mp4"],
["210330-02",  "1.1.0.0", "1984.01|178 MB", "https://www.brighteon.com/d4bb86b2-f395-4450-bdc0-554def2b45af", "2021", "210330-02 OH My LORD ------ COMPLETE BUST - NO MORE Reflection of JESUS . Sorry Nas U R Toast.mp4"],
["210331",     "1.1.0.0", "6059.01|585 MB", "https://www.brighteon.com/d7bb0f5b-1d8e-4123-89bc-c2b163adc17a", "2021", "210331 ALERT -- Shout it From the Rooftops-- The MYSTERY of INIQUITY- Hidden from the Beginning is RESOLVED.mp4"],
["210402-01",  "1.0.0.0", "64.02|6.72 MB", "", "2021", "210402-01 Quick Correction.mp4"],
["210402-02",  "1.2.0.0", "5147|532 MB", "https://www.brighteon.com/c0d887b3-9227-443e-8eb5-8ef0f2abdcce", "2021", "210402-02 HERE Is the STRAIGHT TRUTH of it ALL -- Welcome to The KINGDOM of VAMPIRES and TWINS. CAINABLE- Shhh.mp4"],
["210405-01",  "4.5.0.3", "6010.02|619 MB", "https://www.brighteon.com/37c2db6b-46e1-4386-8fd1-37c2d1e411e3", "2021", "210405-01 Man in OUR IMAGE - Part 1 - The LORD Commanded me.. You MUST Divulge the GENESIS 1 Revelation.mp4"],
["210405-02",  "4.5.0.3", "3959|389 MB", "https://www.brighteon.com/7b06ba1b-1d9f-46e5-a74f-2d95cd4e78a3", "2021", "210405-02 Man in OUR IMAGE - Part 2 - ASSIMILATE WHO Pay ATTENTION.mp4"],
["210405-03",  "4.5.0.1", "3478|427 MB", "https://www.brighteon.com/f8ad7240-1cb4-42a2-b0fe-184eb9d12aec", "2021", "210405-03 Man in OUR IMAGE - Part 3 - Scripture and Data. Slight Malfunction,  4, 5, 6.. Whatever it Takes.mp4"],
["210406-01",  "4.5.0.1", "4706.01|430 MB", "https://www.brighteon.com/775183f9-a357-4275-9e5c-8131382d4f9b", "2021", "210406-01 Man In OUR IMAGE - Part 4 - It is ALL about Insects USING the SERPENT -Hunting - Race to Murder Sheep.mp4"],
["210406-02",  "4.5.0.1", "4877|496 MB", "https://www.brighteon.com/4d4b2925-fecf-4cd1-9081-841c390138a8", "2021", "210406-02 Man In OUR IMAGE - Part 5 - Isn-t SATAN the KING of the LOCUSTS from the BOTTOMLESS PIT SEE IT ALL CLEARLY NOW --.mp4"],
["210407-01",  "4.5.0.3", "3609.01|348 MB", "https://www.brighteon.com/a8ae2dfb-9e7a-481e-a2ae-4951b03802a4", "2021", "210407-01 Man In OUR IMAGE - Part 6 - Let (( US )) MAKE MANKIND in (( OUR )) IDOLATROUS VAIN SHEW After ( OUR ) SIMILTUDE.mp4"],
["210407-02",  "4.5.0.1", "2681.02|256 MB", "https://www.brighteon.com/3655a04c-eafd-4225-b49d-ace871cdb801", "2021", "210407-02 Man In OUR IMAGE - Part 7 - Man in OUR IDOLOTROUS VAIN SHEW -- U Wanted To Know -- HERE Is The BRUTAL TRUTH -- EXILED -.mp4"],
["210409",     "1.2.0.0", "3746.01|406 MB", "https://www.brighteon.com/42943115-d4c8-4830-a8bd-286a7bf13c2d", "2021", "210409 Silence of the Lambs- Here is the Way to Do It .Invert and Destroy..IS it OBVIOUS YET Folgers- LOL.mp4"],
["210418",     "5.2.0.0", "2303|226 MB", "https://www.brighteon.com/9d3cc718-ae07-4d9a-b66b-bec11032c2e4", "2021", "210418 UFO Alien Pyramid Disclosure MAIN STREAM MEDIA .. Here They Come !! BTW They is US.mp4"],
["210420",     "5.2.0.0", "3280|332 MB", "https://www.brighteon.com/dcc363e2-28dd-41fd-9c6a-87d8aa1cf205", "2021", "210420 PYRAMID UFO-s CON-firmed by PENTAGRAM- Uh I mean GON - YAY!!!.mp4"],
["210422",     "5.0.0.0", "812|93.3 MB", "https://www.brighteon.com/20f1a352-a07d-415b-877d-99a0e9fd0a5f", "2021", "210422 SHOUT-OUT to CHASE and EVERYBODY for Their Encouragement and Blessings.mp4"],
["210423",     "6.2.0.1", "9106.01|965 MB", "https://www.brighteon.com/1539055a-339b-4079-b347-999c9a560f72", "2021", "210423 The Scriptures ... Never Before Proven -- This is the END of the World.mp4"],
["210424",     "6.2.0.0", "5458.01|515 MB", "https://www.brighteon.com/f3972db0-40db-4fce-a651-643453e46da8", "2021", "210424 To ((((( KNOW ABSOLUTELY )))))) Here is a Litmus Test.mp4"],
["210428",     "6.2.0.0", "5772.02|553 MB", "https://www.brighteon.com/422eb6f6-d17f-4c98-b34c-5157c005b42d", "2021", "210428 BROOD of VIPERS !! The MULTITUDE NOW It IS PROVEN According to the WORD!!! Plus ARC Introduction.mp4"],
["210501-01",  "1.5.0.0", "10522.01|654 MB", "https://www.brighteon.com/75e2bf26-b7d3-4c10-9361-db52902fb626", "2021", "210501-01 SATAN Said ALL POWER Will I GIVE THEE For It Is DELIVERED Unto ME And To WHOM EVER I WILL GIVE IT.mp4"],
["210501-02",  "1.5.0.0", "3913|274 MB", "https://www.brighteon.com/9be4dd88-7bb6-47f0-b22d-cb6787bbc239", "2021", "210501-02 PROVEN Before Your EYES IMPOSSIBLE to DENY the TRUTH of THIS MINISTRY from the BEGINNING.mp4"],
["210504-01",  "6.2.0.0", "177.01|13.2 MB", "", "2021", "210504-01 check it out.mp4"],
["210504-02",  "6.2.0.0", "851.71|25.4 MB", "https://www.brighteon.com/8bba75a0-5a3b-4727-83e8-ff660a08ec76", "2021", "210504-02 check it out.mp4", "*Banned video|@This video was banned by Goog on YouTube and Drive so renamed from '210504-02 5G Cov-19 Euthanasia Immunization.mp4'"],
["210508",     "1.5.0.0", "8764|960 MB", "https://www.brighteon.com/bba803de-f580-492c-9ad4-6e1924f374ec", "2021", "210508 SEE The TRUTH _ The Veil Is Down.mp4"],
["210513",     "0.0.0.0", "5120.02|439 MB", "https://www.brighteon.com/88617f9a-68ef-449f-88e8-e82decc3e5e0", "2021", "210513 I have arrived at my Destination ... The End MUST Be Coming SOON .. Details and MIRACLES Manana.mp4"],
["210514",     "0.0.0.0", "4334|396 MB", "https://www.brighteon.com/c910b4df-ee72-45d8-b372-d205ed297bfa", "2021", "210514 KILL DEVIL HILLS - Trying to Unpack What Just Happened Today .. More Miracles than I can Count.mp4"],
["210515",     "0.0.0.0", "6329.02|636 MB", "https://www.brighteon.com/3d98c56a-3902-42db-b812-f787dbaadb67", "2021", "210515 The Road to KILL DEVIL HILLS - Everything that has a Beginning- has an END.mp4"],
["210517",     "0.0.0.0", "798|115 MB", "https://www.brighteon.com/a7e27b56-af0a-4b72-a20c-70962420f037", "2021", "210517 Had to Move On .... Working on Equipment issues ... Testimony of a Lifetime ready to Take FLIGHT.mp4"],
["210519",     "0.0.0.0", "832.02|34.7 MB", "https://www.brighteon.com/077492d3-3236-448c-afec-d8c600a1d164", "2021", "210519 The Bite - 4 Real.mp4"],
["210520",     "0.0.0.0", "9148.01|936 MB", "https://www.brighteon.com/6ad1404d-0a28-49dc-bd7d-f20e4b5f3453", "2021", "210520 The GATHERING- Kill DEVIL HILL- Part One.mp4"],
["210521",     "0.0.0.0", "7551.11|953 MB", "https://www.brighteon.com/1e6eb950-2d41-4a37-94c5-8a4b3dfeae2f", "2021", "210521 WANT to KNOW How to KILL the DEVIL GREATEST MYSTERY EVER SOLVED.mp4"],
["210524",     "0.0.0.0", "232.01|8.35 MB", "https://www.brighteon.com/e934916d-7418-4ead-8d3a-db5a806bde56", "2021", "210524 Recording 173 -- Tent of the HIGH PLACE.mp4"],
["210528",     "1.2.0.0", "3270.02|353 MB", "https://www.brighteon.com/d6127c08-dc21-4ee7-b558-c3e8ec71b52c", "2021", "210528 Check-Mate For REAL- The Message cannot be misunderstood. The King is COMING.mp4"],
["210529",     "1.2.0.0", "463.01|53.7 MB", "", "2021", "210529 The Reality is Setting In.mp4"],
["210531",     "1.2.0.0", "6393.13|934 MB", "", "2021", "210531 The PHARAOH Diet, Shhh !!!.mp4"],
["210602",     "1.2.0.0", "4476.02|510 MB", "https://www.brighteon.com/e26df4b7-2601-46dc-912b-fbbe2382bb39", "2021", "210602 The GREATEST HORROR The World has EVER Seen- Do You Believe Me NOW.mp4"],
["210612",     "1.2.0.3", "5119|644 MB", "https://www.brighteon.com/c52b9d7d-54c1-4c5b-bfa1-e406d8b8320e", "2021", "210612 THE MOST IMPORTANT UNERSTANDING Of THIS MINISTRY... Do NOT Miss This !!!!!!!!!.mp4"],
["210614",     "1.3.0.3", "3832.01|535 MB", "https://www.brighteon.com/e667900b-c3bc-490b-8228-5478a8426953", "2021", "210614 How Do you EVEN EXPLAIN THIS Miraculous Insane Insanely Miraculous Or Just the LORD GOD.mp4"],
["210615",     "5.1.0.1", "6037|585 MB", "DnIacdGecYw", "2021", "210615 Want to EXPERIENCE a MIRACLE WATCH One !! THIS VIDEO LIVE YOU Will KNOW The END Has COME !!!!!.mp4", "*H320 'The End'.. Next the main Youtube ch is permently removed."],
["210617",     "1.4.0.3", "8958|965 MB", "", "2021", "210617 WATCH !! You Will Ginōskō.. The BEGINNING has COME.mp4", "@THIS Shows they LIVE Miracles which were DELETED By the Prince of the Power of the AIR.... Stay Connected"],
["210619",     "4.3.0.3", "4589.01|465 MB", "", "2021", "210619 The ALMIGHTY GOD- To Understand the Bible- You Better KNOW THIS !!!!!.mp4", "*Super session #1|@These Scriptures RESOLVE what GENERATIONS Could Not Resolve... All Glory to the King of KINGS .... Jehoshua"],
["210622-01",  "4.3.0.3", "5925.01|776 MB", "", "2021", "210622-01 LUCIFER set His HEART as the HEART Of ELOHIYM.. He Wanted To Overthrow (( EL )) the ALMIGHTY GOD.mp4", "*Super session #2|@Here is The PERFECT Puzzle Piece From EZEKIEL That SLAM DUNKS THE  JONATHAN KLECK Ministry from Beginning to End"],
["210622-02",  "0.0.0.0", "57|3.32 MB", "", "2021", "210622-02 EMERGENCY ALERT !! ; to cross over; a crossing place - ferry, Cross to the Other Side.mp4", "@The Lord KEEPS Showing me \" IT Is Time \" Too Many  Miracles to keep track of"],
["210629",     "0.0.0.0", "218.01|57.0 MB", "", "2021", "210629 Jesus IS COMING !!!! How Do I Know !! HOW COULD (( not )) KNOW.mp4", "@THEW TESTIMONY IS LIKE NOTHING YOU HAVE EVER SEEN .... Stay Tuned"],
["210704",     "0.0.0.0", "222.01|15.4 MB", "", "2021", "210704 Time is UP.mp4", "@The King IS coming .... Working Hard to Deliver the TESTIMONY..."],
["210706-01",  "4.2.0.1", "3471.01|399 MB", "", "2021", "210706-01 Intro -JESUS Is COMING - Here is The Layout BEFORE the Testimony, you Need to Know Where I had to Go.mp4", "@This Video SETS The STAGE , So you Know where I was Going and the Significance of WHERE I was Going and What the Errand Was... I was sent to Pick UP the Containers From Rainbow Dr. and Send them to the A.R.C. (Angel Refugee Center)  Now I Have set the Stage for the Most Awe inspiring REALITY that JESUS IS COMING For SURE"],
["210706-02",  "4.2.0.1", "5315|797 MB", "", "2021", "210706-02 Part 1-  HERE IS THE TESTIMONY,, The KING Is COMING,, The KING IS COMING, THE KING IS COMING.mp4", "@Just watch the Evidence Speak For Itself"],
["210706-03",  "4.0.0.1", "9601.36|649 MB", "I_B1Pmergnw", "2021", "210706-03 DUAL_CONTAINER_VIDS_edit_1.mp4", "*Looking back at 2 Container history. Youtube published date: 19 Nov 2018"],
["210708",     "4.2.0.0", "10891.02|1.84 GB", "", "2021", "210708 Jesus ((( IS ))) Coming,,, Watch the Evidence till the END.. THEN Watch AGT Episode VICTORY BRINKER.mp4", "@AGT EPISODE https://youtu.be/vrRfBmMWpLY  Watch this IMMEDIATELY ((( AFTER THIS TESTIMONY ))))"],
["210710",     "4.1.0.0", "1136.01|143 MB", "BzeTPYBVBvU", "2021", "210710 Recording 22 -- Look UP Strongs 22 - (( Abiel - El is my father )) -- Rainbow ELOPE !!!!!.mp4", "@This is Recording # 22 because an Unusual set of circumstances Again!! Almost Toooooo hard to keep Track of ALL the Impossibilities !!!!!!!!!!!!!!!!!!!!!!!!! Beyond Description<br>KleckFiles: 22 = El is my Farther & Unmarried, of a person not in a state of wedlock. Wow!"],
["210714",     "4.1.0.3", "4611.02|607 MB", "", "2021", "210714 The END ((( IS ))) Here !! The Manifestation could ONLY have Been Orchestrated by the LORD GOD.mp4", "*3 songs|@This is HOW the LORD GOD COMMUNICATES the Message.<br>KleckFiles: Link to songs: https://youtube.com/playlist?list=PLNfDBl2sbmPBeJseNJ23UkfN0SQqHS-3T|3 Song PlayList"],
["210717",     "4.2.0.3", "6924|869 MB", "", "2021", "210717 LIFE ETERNAL !!!!! THIS TRUTH - WILL CHANGE - THE WORLD - GUARANTEED.mp4", "@The Lord Has let me Deliver what has NEVER Been Delivered .. The Scripture with a Visual Confirming witness of Supernatural SIGHT. You are  being hunted by  Insects from the Pit ... the Serpent Race is Hunting you"],
["210721",     "4.1.0.3", "1066|125 MB", "", "2021", "210721 Belshazzar-s feast .. PAY ATTENTION.mp4", "@2 Videos to watch before next time:<br>https://youtu.be/FhBnW7bZHEE<br>https://youtu.be/orJSJGHjBLI"],
["210723",     "4.2.0.3", "5870|892 MB", "", "2021", "210723 The LOCUSTS Are COMING- GUARANTEED - Just ask Iron Maiden, THEY KNOW, !! Shouldn-t YOU !!!!!!!!!.mp4", "@https://www.show-notes.net/thisistheend/index.php?/category/115 Just watch this video and TRY Not to Freak Out"],
["210724",     "4.2.0.3", "4229|463 MB", "", "2021", "210724 The HORRIFYING TRUTH -- Here Comes the JUDGE !!!! Whoa !! It is Going to Get UGLY !!.mp4", "@Watch this Video till the END -- I Rest My Case"],
["210731",     "4.2.0.0", "7674.01|1.13 GB", "", "2021", "210731 MUST WATCH !!! MOST INVALUABLE - MING BOGGLING_ JAW DROPPING _ PROOF of WE_ARE_XX SERPENT RACE !.mp4", "@you ARE going TO freak out!!!!  This is Soooooooo conclusive that it is inescapable .... The Most Insane Realty is Proven .... Let US create MAN in OUR (( Phantom Image )) (( Representative ESPECIALLY an IDOL )) <br> ((((((((((((((((((((((  WRAPPING For an INSECT Race ))))))))))))))))))))<br>((((((((  THAT HUNTS ))))))))<br>(((((((  US )))))))<br>((((( Angels HUNTED by Demons )))))"],
["210801",     "4.3.0.3", "3006.01|483 MB", "", "2021", "210801 Tesla - Dragnets and Beasts - Oh MY ! You-ve Been Living in a DREAM WORLD.. Down is UP -Game Over !.mp4", "@https://www.brighteon.com/84d99e07-e1ee-4700-9ced-b786f2e70956"],
["210802",     "3.2.0.0", "2226.29|63.0 MB", "https://www.brighteon.com/84d99e07-e1ee-4700-9ced-b786f2e70956", "2021", "210802 VXTRUTH-SEEING IS BELIEVING.mp4", "*Collection of current vackscene concerns"],
["210803",     "4.3.0.0", "7456.02|998 MB", "", "2021", "210803 U R Gonna NEED to HEAR ALLLLLLLLL Of THIS , OUTTA TIME , The Feet -O-Clay Taking The SYSTEM,, NOW!!.mp4", "@Please just watch and Listen Well<br>https://brandnewtube.com/watch/kchChHajs9mVQVF"],
["210804",     "4.3.0.3", "2590|318 MB", "", "2021", "210804 Seriously It is a JOKE at this Point .. Scorpion Goddess of the Dawn.mp4", "@Just watch the WHOLE video"],
["210805",     "4.3.0.3", "2693|366 MB", "", "2021", "210805 GREATEST REVELATION Of My MINISTRY - The TRUTH Is PROVEN, The MYSTERY Is SOLVED. We Are GOING HOME !.mp4", "@You Must Watch it ALL .... FREEEEEEEEEEEEEEEEAAAAAAAAKKK OUT!@!!!!!"],
["210808",     "4.3.0.3", "3987.01|611 MB", "", "2021", "210808 HERE is WHY They MURDERED Jesus. The UNDENIABLE TRUTH . LOOK UP, Get UP, STAND UP, Go UP.. SOLVED !!.mp4", "@Here we go..........................................."],
["210812",     "4.3.0.1", "6280.02|770 MB", "", "2021", "210812 When he shall begin to sound, the MYSTERY of GOD should be FINISHED.mp4", "@The Mystery of God is Looking you in the EYES Right NOW"],
["210813",     "4.3.0.0", "4477.02|773 MB", "", "2021", "210813 Take it AWAY.mp4", "@REMINDS me of the craaaaazzeeee -ness I went through"],
["210817",     "4.3.0.0", "3150.02|403 MB", "", "2021", "210817 CHIP IN, 600 60 or 6 !! Hmmmm -The ULTIMATE Bully ... and the ULTIMATE BUST !!!!!.mp4", "@THE Most Important Data you could see at this point in the History of the World,, You Will KNOW Right where the Worls is AT!!!"],
["210820",     "4.0.0.0", "2805.02|343 MB", "https://archive.org/details/blocked-worldwide-v-4-vengeance-freedom-from-fear-.-just-watch-and-listen", "2021", "210820 Blocked Worldwide -- V4 VENGEANCE --FREEDOM From FEAR --- .JUST WATCH and LISTEN.mp4", "@1st - https://youtu.be/QNAKXFa7d30\, 2nd https://youtu.be/6qxQ2l1DC6Y"],
["210821",     "4.4.0.0", "5697.92|199 MB", "", "2021", "210821 Now we can see what's REALLY going on!! CHIP-IN 666 LOL We get it!.mp4", "@This video is the last 2 blocked videos combined.<br>And again links to V4V movie clips: 1st - https://youtu.be/QNAKXFa7d30\, 2nd https://youtu.be/6qxQ2l1DC6Y"],
["210823",     "4.3.0.0", "1304.01|192 MB", "", "2021", "210823 Poltergeist  They're Here --- Let's play ketchup ---.mp4", "@See last video \"Now we can see what's REALLY going on!!\""],
["210831",     "6.0.0.0", "4035|456 MB", "", "2021", "210831 Ancient EGYPT -- The Pyramid is Your Best Friend!! Just Kidding.mp4", "@https://youtu.be/2fS9ixfQ_no?t=4829<br>For those who Know the Personal Testimony, this will Blow your mind"],
["210902",     "6.1.0.0", "4643.02|617 MB", "", "2021", "210902 ONLY Reason I Posted this Video -I PRAYED if it was ACCEPTABLE -Answer was - HONEST SINCERE FRANK.mp4", "@The WHEAT HARVEST ((((((((((((((((( IS )))))))))))))))))))) COMING"],
["210903",     "6.2.0.0", "3843.02|556 MB", "", "2021", "210903 MUST MUST WATCH !!! LIL Nas Aint the Only One Pregnant and about to BIRTH.mp4", "@IT ((((( IS ))))) HERE --- The Birthing Event is at Hand !!!!!"],
["210906",     "6.2.0.0", "2486.02|287 MB", "", "2021", "210906 Congrats Nas X !!! T-REX and UNICORN ... That is a INTERESTING Combo.mp4", "@No Words ,,,,Just Watch"],
["210911",     "6.2.0.0", "5942.01|816 MB", "", "2021", "210911 WANT to UNDERSTAND EVERYTHING!! SERIOUSLY !! E.V.E.R.Y.T.H.I.N.G. -Heres The RANT !!!! WOW!!.mp4", "@This video Puts things together in a way that is enough to go on a COMPLETE TIRADE !!!!!!!!!!!!!!!!!!!!!!!!!"],
["210917",     "6.0.0.0", "131.01|19.4 MB", "", "2021", "210917 checking in.mp4", "@I'll be here manana"],
["210918",     "5.3.0.0", "818.62|22.6 MB", "https://www.bitchute.com/embed/t5ngUecpRRcA/", "2021", "210918 ENGLISH TRANSLATION - GRAPHENE-VERSACE BRIGHT CRYSTAL - REAL-TIME SELF-ASSEMBLING GRAPHENE IN PFIZE.mp4", "@Real-Time Self-Assembling Graphene Oxide Nanotech in Pfizer Comirnaty Vaccine - German Subtitles"],
["210919",     "4.2.0.0", "5083.01|803 MB", "", "2021", "210919 SEE THE EVIDENCE and ALL THE MIRACLES - Has The END ARRIVED - See The Evidence and Decide - FULL NET.mp4", "@TOO MANY MIRACLES to Witness to ... More Vids to come SOON"],
["210921",     "5.3.0.0", "818.33|22.3 MB", "", "2021", "210921 RE-EDIT w Original Audio - ENGLISH TRANSLATION - GRAPHENE-VERSACE BRIGHT CRYSTAL - Real-Time Self-A.mp4", "@Real-Time Self-Assembling Graphene Oxide Nanotech in Pfizer Comirnaty Vaccine - German Subtitles"],
["210922",     "4.3.0.0", "4615.01|741 MB", "", "2021", "210922 The World is NOT Your Home.. ARE YOU -- READY -- TO LEAVE IT !!!! Here is the Confirmation.mp4", "@The king (((((((((((((((((((((((((((((((((( is )))))))))))))))))))))))))))))))))))) coming"],
["210923",     "4.3.0.0", "1827.02|298 MB", "", "2021", "210923 FINISH LINE ---------------------------------------------------- FINISH LINE - CONFIRMED --------.mp4", "@No-One could even think this....."],
["210924-02",  "6.1.0.0", "670.01|92.2 MB", "", "2021", "210924-02 The LORD said.- SOUND The SHOFAR Blow It TODAY ----- PART 2 Occlusion -------.mp4", "@It is Time"],
["210924-01",  "6.1.0.0", "2788.02|387 MB", "", "2021", "210924-01 SOUND The SHOFAR ---- Part 1 -----Sound the Shofar --- SOUND THE SHOFAR.mp4", "@This is t6he Video that I had to Recover ---- Part 1"],
["210924-04",  "6.2.0.0", "2839.71|587 MB", "", "2021", "210924-04 shofar.mp4", "*Live Stream|@Streamed live 1 (lost sound)"],
["210924-03",  "6.2.0.0", "997.62|173 MB", "", "2021", "210924-03 now.mp4", "*Live Stream|@YouTube Live Stream 2"],
["210925-01",  "6.2.0.0", "3861.41|740 MB", "", "2021", "210925-01 Abomination of Desolation(LiveStream).mp4", "*Live Stream|@Live Stream on Youtube"],
["210925-02",  "6.3.0.0", "927.01|121 MB", "", "2021", "210925-02 ABOMINATION That Causes DESOLATION --I AM BEARING WTNESS -THE END OF THE WORLD -- 4 SURE -- FINISHED.mp4", "@WE are ALL about to Witness the End of the World to some degree ......Hopefully you are saved ......"],
["210927-01",  "6.2.0.0", "3610.01|760 MB", "", "2021", "210927-01 UNNNNNNNN-BEEEEELIEVABLE!!!!!!!!!!!!!!!!!!!!!!!!But I Got The PROOF and A WITNESS !!!!!!!!!!!!.mp4", "*Live Stream|@The Time Has ARRIVED"],
["210927-02",  "6.3.0.0", "2940.02|488 MB", "", "2021", "210927-02 Tsunami as EXPECTED - When,, GOD Only Knows.. INSECT RACE as EXPECTED - When SEE FOR YOURSELF!!!.mp4", "@The Bugs are Hunting Right in front of your face...Masters of Disguise... Beast Planet Live"],
["210928-01",  "6.2.0.0", "1971|252 MB", "", "2021", "210928-01 LOCUST ARMY - This is Today-s Message --- How Impossible are ALL theses Testimonies.mp4", "*Live Stream|@Again Today !!!!! The Day IS at Hand (Live Stream)"],
["210928-02",  "6.2.0.0", "1804|366 MB", "", "2021", "210928-02 Not SURE What to SAY---- Checking In.mp4", "*Live Stream|@TOOOOOOOOOOOOOOOOOOOOOOOOOO Many Coincidences ... CONFIRATIONS"],
["210929-01",  "7.2.0.0", "3808|553 MB", "", "2021", "210929-01 What could I Possibly say- Other than HERE ARE THE FACTS The Record will speak for Itself.mp4", "@The Victoria PD Badge is a Insect, The Alter is an Insect, The Behavior is the Same as the Night I was Saved..A Swarm as Insects.. Hmmmmmm Joel 2 looks like it is about to Roll Out"],
["210929-02",  "7.2.0.3", "5235.01|778 MB", "", "2021", "210929-02 NOW The TRUTH CONVICTS The GUILTY !!!! INSECT FARMING PARTY ..... (((((((((((( OVER ))))))))))))).mp4", "@SEE the WORLD as it TRULY IS ....  The Scariest Movie EVER ,,, and You are In IT"],
["210930",     "7.2.0.3", "4211.01|590 MB", "", "2021", "210930 EPLURIBUS UNUM - THEY LIVE - THIS IS REALITY.mp4", "@My Job for the KINGDOM was to EXPOSE  \"Those who Hide their Plans from the Lord\" ---Mission Accomplished"],
["211001",     "7.3.0.0", "1644.02|214 MB", "", "2021", "211001 2110 Shhh... Ok OK I Get it Hoboken Girl Shhh.mp4", "@The Symbols say it all"],
["211002",     "7.3.0.3", "2301|251 MB", "", "2021", "211002 Prometheus Shhh !!!.mp4", "@Wow Oh WOW!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"],
["211003-01",  "7.4.0.0", "956.97|308 MB", "", "2021", "211003-01 Dr. Carrie Madej First U.S. Lab Examines Vaccine Vials, HORRIFIC Findings Revealed.mp4", "*Published by StewPeters.tv|@See StewPeters.tv"],
["211003-02",  "7.3.0.3", "3966.01|485 MB", "", "2021", "211003-02 More Prometheus Reality than a brain can Absorb.mp4", "@See the Reality of Prometheus...Don't know what to say except -My Help Comes from the LORD"],
["211003-03",  "7.5.0.0", "132.87|9.01 MB", "1xV5M7i994c", "2021", "211003-03 KLECK - TITAL WAVE CONFIRMATION - 0.9.28.21.mp4"],
["211004",     "7.3.0.3", "5933|768 MB", "", "2021", "211004 The Self Existent Eternal Jehovah V.S. The Devil ,,,, We Win Because of HIM.mp4", "@We Win because of HIM"],
["211005",     "7.3.0.0", "5854.01|621 MB", "", "2021", "211005 EVEN The GEOGRAPHY Bears Witness to the TRUTH -- TWINS Descending - Red Cleansing or ETERNAL DEATH.mp4", "@Just WRAP Your Mind Around This...WOW"],
["211008-01",  "7.4.0.0", "430.29|8.87 MB", "", "2021", "211008-01 HAIL HYDRA - COVID VAX SYNTHETIC BIOLOGY AND NANOBIOELECTRONICS - SHORTER DURATION VERSION.mp4", "*Published by XtremeRealityCheck|@See Odysee channel XtremeRealityCheck"],

["211008-02",  "7.4.0.0", "583.79|25.1 MB", "", "2021", "211008-02 HORROR EXCLUSIVE VIDEO CAPTURES “ORGANISM” FROM VAXXED SOLDIER’S BODY - EDITED VERSION.mp4", "*Published by StewPeters.tv|@See StewPeters.tv"],
["211010-01",  "2.0.0.0", "261.02|25.8 MB", "", "2021", "211010-01 How AWESOME Is Our GOD ..... I'll Be Sharing His Revelations Tonight ... Tune In.mp4", "@Off the Hook !!!!!! The Lord is My Hero For Sure"],
["211010-02",  "2.0.0.0", "333.02|29.3 MB", "", "2021", "211010-02 Update.... Don't Wait Up Tonight.....mp4", "@Just don't want anyone waiting up for a Late video"],
["211011",     "2.1.0.3", "3046.02|482 MB", "", "2021", "211011 END Of The ROAD _____ U DECIDE ..... GALLAGHER ......mp4", "@This Video cannot be explained in this box"],
["211012",     "2.1.0.3", "3628|429 MB", "", "2021", "211012 WE (((((((( ARE )))))))) Converted ANGELS - Prepare for Departure !!!!!.mp4", "@Your Identity is Hidden in Christ....Do Not Let Others Contradict the TRUTH of the WORD"],
["211016-01",  "2.2.0.3", "9195.01|1.10 GB", "", "2021", "211016-01 The GREAT DECEPTION- You Better ((( KNOW ))) This ... The OVERLOARDS Reveal themselves..Mark Time.mp4", "@The Deception will be So GREAT that ONLY Being on the ROCK will sustain you"],
["211016-02",  "2.2.0.3", "4186|665 MB", "", "2021", "211016-02 The (((( WHY )))) Short Series Coming !! ( DEAD SHEEP ) - (( WHY )) Easy to Share in Small Doses.mp4", "@Follow us on YouTube: <br>Happy Hippy Crochet <br>To purchase beanies follow links below:<br>happyhippycrochet6764@gmail.com<br>https://paypal.me/thawkins4767"],
["211017-01",  "2.3.0.3", "970.01|111 MB", "", "2021", "211017-01 It-s Your Decision... WOW ... Hunnid 4 Dinnuh ..... 4REAL.mp4", "@And AGAIN...The Same Agenda Carried through Music the Same as Clothingt"],
["211017-02",  "4.2.0.3", "677|71.0 MB", "", "2021", "211017-02 The (((((( Y ))))) SERIES ,, WHY Is there SCULTURE of a HUMAN in AGONY Under the List of POPES.mp4", "@This Begins the Y SERIES"],
["211017-03",  "4.2.0.3", "973.01|134 MB", "", "2021", "211017-03 The ((Y )) SERIES ,, No.2 WHY Would Women Tattoo the Backs of their Hands With Skull Faces.mp4", "@Can you tell a Green Field from a Cold Steel Rail ?? A Smile From a VEIL ?? Do  You THINK You CAN TELL ????"],
["211018-01",  "4.0.0.3", "710.02|92.3 MB", "", "2021", "211018-01 The PIT Was OPENED and OUT of the Pit Arose Smoke- and Out of the SMOKE CAME LOCUCTS UPON The EARTH.mp4", "@WoW!!!!!!!!!!!  Could Be Kicking Off VERY VERY QUICKLY"],
["211018-02",  "4.0.0.0", "98.62|4.66 MB", "", "2021", "211018-02 La Palma!! UFO Flies Out Of Volcano!!!.mp4", "*From 'DubJay 315'"],
["211018-03",  "4.2.0.3", "1364.01|166 MB", "", "2021", "211018-03 (( Y )) Series .. WHY is the VATICAN BUILT to RESEMBLE a SERPENT WEARING A CROWN.mp4", "@The word “Vatican” literally means “Divining Serpent,” and is derived from Vatis = Diviner and Can = Serpent. Vatican City and St. Peter’s Basilica were built on the ancient pagan site called in Latin vaticanus mons or vaticanus colli, which means hill or mountain of prophecy."],
["211019",     "4.0.0.3", "1903.01|215 MB", "", "2021", "211019 THIS is MIND BOGGLING !!!!! How Is this even POSSIBLE !!!!!.mp4"],
["211021",     "4.0.0.3", "3394.01|403 MB", "", "2021", "211021 Daniel 2 - PROPHECY 100- CONFIRMED - The IRON Mixed With CLAY -Guaranteed !! MANIFESTED - CONFIRMED.mp4", "@Jesus is Coming to Crush All the Other Previous Kingdoms.<br>The ((((((((((((((((((((( DOMINANT RULER  )))))))))))))))  is TOAST"],
["211022",     "6.5.0.3", "2120.66|92.8 MB", "XGF6UZo8gzg", "2021", "211022 Kleck Files Complete Tutorial.mp4", "*Tutorial|@Thanks Jim, Dave and Robert. It's not ADOBE standard but it may help someone."],
["211023",     "4.0.0.3", "2445.01|294 MB", "", "2021", "211023 A great mountain burning with fire was cast into the sea; the third part of the ships were destroyed.mp4", "@The STAGE APPEARS To Be SET... Nothing Guaranteed , But What are the ODDS ?????????????????"],
["211024",     "4.0.0.3", "3052.01|390 MB", "", "2021", "211024 I Had To REITERATE The TRUTH- Just to deal with it- I Thought to include you in my Struggle. Sadness.mp4", "@Pay ATTENTION at TEN MINUTE Mark........WOW .... IT IS ALL REAL and ALL TRUE --- 100% NO LYN -- Serpent rACE HAS BEEN CONSUMING OUR SOULS FROM THE BEGINNING.... Broken heart for Johnnye... Reality is setting in.. God Have Mercy,,,  My WHOLE FAMILY Was Catholic....PREWIRED To KILL Their Own Family members into ETERNAL Destruction...How SAD SAD Sad sad sad sad"],
["211025-01",  "4.0.0.3", "1679.01|169 MB", "", "2021", "211025-01 LA PALMA ,, PREDICTED !! Or By DESIGN !! You Decide !! Watch This!!! Is This Even Possible!!.mp4", "@The Simpsons showed 911 before it Happened on several Episodes.. The Twin Towers were printed on the 20 made in 1996... and On and On the Nonsense Goes... Is THIS what is next ?? God Only Knows"],
["211025-02",  "2.0.0.0", "100.57|3.73 MB", "", "2021", "211025-02 LA PALMA PREDICTIVE PROGRAMMING FROM THE GAME SECRET FILES 2 DESTROYING THE USA WITH A TUSNAMI.mp4"],
["211026-01",  "4.1.0.1", "4751.01|541 MB", "", "2021", "211026-01 P(art ONE -- The LEGEND ( Key) to the MAP.mp4", "@part 1"],
["211026-02",  "4.1.0.1", "1597.02|185 MB", "", "2021", "211026-02 Commercial Word From THEIR Sponsors ... WATCHMUST.mp4", "@Juswatch the commercials then on to the Legend"],
["211026-03",  "4.1.0.1", "7218.02|827 MB", "", "2021", "211026-03 The LEGEND (( KEY )) to the MAP of EXISTENCE and DAMNATION is Incontrovertible ... RETURN or PERISH.mp4", "@The Revelation is incontrovertible and cannot be disputed .. The End is here and the TRUTH will Judge us all... God have Mercy"],
["211027",     "4.1.0.1", "3024|387 MB", "", "2021", "211027 Eli Eli - Aylee Aylee ( In Come Free ) -Lama Sabachthani .....Come in Without a Penalty with Jesus.mp4", "@I needed to thank HIM Publicly... Hide and Seek is Over ... Come in without a penalty NOW  or deal with the Horror to come"],
["211028",     "4.1.0.1", "5542.12|864 MB", "", "2021", "211028 IF You THOUGHT You KNEW What Life Was ((( THINK AGAIN ))).mp4", "@7 But in the days of the voice of the seventh angel, when he shall begin to sound, the mystery of God should be finished, as he hath declared to his servants the prophets."],
["211029",     "4.1.0.1", "1777.74|202 MB", "", "2021", "211029 The 456 wants 325 !!! ARE You F_ing JOKING!!!! It Just Got REAL Detective Spooner 4084 will get em.mp4", "@WTH ????? Time to roll in the Insects... Boy have they earned it<br>Hey Folks --- GREAT NEWS!!!!!!!!!!!!! The 456 Just approved the the KIddos !!!! Gotta LOVE the 456"],
["211030",     "2.0.0.0", "247.39|34.6 MB", "bAXh68LImQo", "2021", "211030 CHILDHOOD-S END Childhood Ended SYFY.mp4", "from SYFY"],
["211102",     "4.1.0.1", "2460.01|359 MB", "", "2021", "211102 Working on a Slam Dunk.mp4", "@checkin in"],
["211105",     "0.0.0.0", "708.02|106 MB", "", "2021", "211105 ENOUGH OF THE BS.mp4", "@Anyone that oversteps can DEAL with the consequences"],
["211106",     "4.2.0.0", "6435.02|688 MB", "", "2021", "211106 The (MOST) CONCLUSIVE SCRIPTURAL VIDEO OF OUR TIME !! The Mystery is SOLVED and PROVEN BIBLICLY !!.mp4", "@The ((( MOST ))) CONCLUSIVE SCRIPTURAL VIDEO Of OUR WORLD !! The Mystery is SOLVED and UNDENIABLY Proven,, The Churches and Their Rhetoric and Dogmatic NONSENSE ((( CANNOT ))) Stand Against THIS TRUTH .... ALL GLORY to the KING and the ROCK of AGES"],
["211109",     "4.2.0.0", "2807.01|377 MB", "", "2021", "211109 ALERT ALERT !! MESSAGE RECEIVED !! PIT WILL OPEN - LOCUSTS WILL EXIT!! THE Hour of TESTING at HAND.mp4", "@It Has to Arrive Some Time .... Here is the 100% truthful TESTIMONY <br>((((((((((((((((((((((((((( YOU DECIDE )))))))))))))))))))))))))))))))<br>I Have Received My Heads UP ////  Just Passing the Info to You"],
["211110",     "4.2.0.0", "2438|296 MB", "", "2021", "211110 ALERT AGAIN !!!! MORE PROOF !!! The PUPPETS Are MANIFESTING Even The STING... Travis SCOTT - Bingo -.mp4", "@Even the Sting of the Scorpion was Made Manifest in the Drake / Travis Scott Concert ... You Couldn't even Think This Up  .... From the Upside-Down Cross  Stage, to the People being (Pricked -Stung) in the Neck and suffering Heart attacks  WTH ??? Fiery Phoenix Coming out of the Pit ??? You Gotta Be Joking ....Total Bullseye in Relation to the Bible"],
["211111",     "4.2.0.0", "3625.01|404 MB", "", "2021", "211111 ALERT!! TRAVIS means CROSSING -The Pit Is CROSSING ITS CONSCIENTIOUSNESS into THIS DIMENTION.mp4", "@The REALITY is Setting in...No way to argue against what is going on now///<br>THEY Are Coming No Matter what anyone thinks and the evidence speaks for itself"],
["211115",     "4.2.0.0", "4243.01|536 MB", "", "2021", "211115 SCORPIONS FROM THE PIT !! NO WAY OUT OF IT!! WE Are Living In The Book Of REVELATION GUARANTEED !!!!.mp4", "@The Facts are all SAYING THE SAME THING ... THE REVELATION GIFT THE LORD HAS GIVEN ME TO SHARE IS NIDISPUTABLE"],
["211116",     "4.2.0.0", "6003.01|775 MB", "", "2021", "211116 NOW YOU KNOW The MYSTERY !!!! Forbidden Fruit = You Became FOOD For Locusts. THEY ARE COMING SOON !.mp4", "@Watch the Reality Unfold as I continue to Deliver the Lord's Final Truth ... The Locusts are Coming... The Scorpions are Coming .... Guaranteed"],
["211117",     "4.2.0.0", "4253.01|544 MB", "", "2021", "211117 SCORPION GODDESS Of The DAWN ... You Couldn't Even Imagine This Insanity, But It Is REAL!!!.mp4", "@The End is Coming and It is EASY To SEE It COMING BECAUSE IT IS ALL BIBLICLY SUPPORTED AND THE SPIRITUAL GIFT OF KNOWLEDGE SLAMS THE DOOR IN THE FACE OF ANY OPPOSITION..... THEY ARE GUILTY AND THE TIME OF THEIR JUDGEMENT HAS COME"],
["211118",     "4.2.0.0", "4681|426 MB", "", "2021", "211118 YOU (( NEED )) To Be (( SURE )) .... When This Happens ... YOU ARE GOING TO NEED THE ASSURANCE.mp4", "@Without the Assurance of the Scriptures, You Will ((((( NOT ))))) Be Able to Stand,,,,, You Must have your 100% TRUST in GOD"],
["211119",     "4.2.0.0", "648.02|85.3 MB", "", "2021", "211119 The Temple REBUILT !!!!!! The Testimony Will Speak For ITSELF !!!!! The MANIFESTATION Is IMPOSSIBLE.mp4", "@The ROCK That Was Cut From the Quarry Without Hands ..... LOOKS LIKE It Is TIME To CRUSH The OTHER KINGDOMS ..... I will give a Clear Witness to the TRUTH and a TESTIMONY Before You AND The LORD GOD !!!!!!!!!!!!!!!!! The KING Is COMING"],
["211120",     "4.3.0.0", "5746.01|850 MB", "", "2021", "211120 THIS IS NOT EVEN POSSIBLE !! Documented and DELIVERED !! SEE The Manifestation with your Own EYES.mp4", "@SEE The Manifestation with your Own EYES... The LORD GOD ARRANGED EVERY MIRACLE YOU ARE GOING TO SEE....."],
["211122",     "4.3.0.0", "2093|307 MB", "", "2021", "211122 OH My LORD !!!! This Is REALLY REALLY HAPPENING, The EVIDENCE Is INSANE !!!! It Is SO IMPOSSIBLE !!.mp4", "@Please get ready for the End All Be all Mind blasting truth .... it has been communicated and documented... The Delivery comes Next !!!! The Rock Is Put Back TOGETHER !!!!! ((((( WE ))))))) Are Put Back Together.. The (((((((((((((( NEW TEMPLE )))))))))))))  (((((((((((((((((((((((((( IS )))))))))))))))))))<br>  ((((((((((((((((((((((((((((((((((((((((((( US ))))))))))))))))))))))))))))))))))))))... The Testimony and Miracles coming in the Next Video are Toooooooooo Much!!!"],
["211125",     "2.3.0.0", "1184.84|237 MB", "", "2021", "211125 The Matrix Has Been Penetrated.mp4", "@I have DELIVERED the ROCK to Its destination and the Manifestation SPEAKS For ITSELF... I am currently trying to Download the Info to Produce the Video...... Even though WE are Tech Savvy, The Obstacles are going to Delay the Production and the Delivery of the TESTIMONY..... The LORD GOD ((( IS )))) in Control ..... It is Ready When it Is READY"],
["211127",     "2.4.0.0", "11269.02|1.50 GB", "", "2021", "211127 Omicron!! Sounds Like a _B_ Rated Mexican Movie!!! Because it IS ! LOL.mp4", "@You Have to see this to Believe it5.... Also I am working on the Testimony video from The ARC,, I have uploaded part of the Raw footage here and noticed there was a Problem with the TRANSFER,,,, The DATA Is Perfect on my PHONE but the Transfer seems to have changed the video COLOR drastically .....I will be working on it Until it is done"],
["211130-01",  "2.4.0.0", "1060.01|123 MB", "", "2021", "211130-01 In the BIBLE AYIN Means EYE.... OMICRON Is Derived From Hebrew (AYIN).... ALL- Seeing OMICRON.mp4", "@Just did a 2 hour video but it will be loaded in the morning .... This is the Most important Data on the Planet.... Omicron is derived from Phoenician and Hebrew...In Both Cases it is AYIN..... In the BIBLE AYIN Translates as EYE ....Like the All-seeing Eye   or All Seeing Omicron ....WOW!!!!!!!!!!!!!!!!!!! Can you day \"IT's OVER \" !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"],
["211130-02",  "2.4.0.0", "7934|973 MB", "", "2021", "211130-02 The WORD (( SPEAKS )) For ITSELF. The END IS COME..AYIN = EYE. The EYE Has ARRIVED!!.mp4", "@These Scriptures will explain it all"],
["211201",     "2.4.0.0", "5565.01|746 MB", "", "2021", "211201 The UNBELIEVABE ((((( TRUTH))))) - Omicron - The NOMAD SOUL _ The SERIAL KILLER - You Lose U Pay !!.mp4", "@The WORD IS PERFECT, Just Watch the DEPTH of the TRUTH"],
["211202",     "0.0.0.0", "4369.02|561 MB", "", "2021", "211202 K= 11, ( Strongs 11 = Place of DESTRUCTION ) U ARE GONNA FREAK OUT!!! Wanna SEE What the FUTURE IS.mp4", "@ust brace yourself!!!!!!!!!!!!!!!!!!!!!  I TOLD YA SO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Buckle UP"],
["211206",     "0.0.0.0", "2702.01|335 MB", "", "2021", "211206 Can You SEE It ALL NOW !! Serpent Buildings, Sheep alters, SS Rings, Lie after Lie. Hmmm SATAN !!!.mp4", "@The Satanic Take-over is in Full Swing ... More to see here day after day"],
["211207",     "0.0.0.0", "8257.02|970 MB", "", "2021", "211207 On AIR was the beginning- Here is some Scripture Roll Out.mp4", "@ON AIR Testimony of getting here and the scripture Roll-Out...Sorry for the minor background noise ... Program malfunction on headset maybe"],
["211212",     "0.0.0.0", "123.02|16.6 MB", "", "2021", "211212 Be Back Manana..... The Veil is Coming Down.mp4", "@here it comes ... the veil is coming down"],
["211213",     "0.0.0.0", "8302.02|1.02 GB", "", "2021", "211213 Totally Freeee KING OUT !!!!! Gotta Start Somewhere...LOL.mp4", "@OH MY LORD ... It Is ALL Been TRUE and PERFECT Delivery of Info....Gotta Spazzzz OUT First ,,Then I will deliver in Order"],
["211215",     "2.0.0.0", "8827.02|1000 MB", "", "2021", "211215 The ANNOINTED Cherub that COVERETH !!!! Try Not to Break Out Into Singing and Dancing!!! Busted ,,,,.mp4", "@Just watch the whole thing .... See The Delivery of TRUTH"],
["211218",     "2.3.0.0", "10194|1.38 GB", "", "2021", "211218 V.I.C.T.O.R.Y. The WORD is Perfect. The KEY Has PROVEN The ROCK Is The Inversion Of the SYSTEM.mp4", "@JESUS IS THE ROCK ---HE IS THE INVERSION OF THE SYSTEM   ..This is a Must Watch Video JESUS IS THE ROCK ---HE IS THE INVERSION OF THE SYSTEM  JESUS IS THE ROCK ---HE IS THE INVERSION OF THE SYSTEM  JESUS IS THE ROCK ---HE IS THE INVERSION OF THE SYSTEM  JESUS IS THE ROCK ---HE IS THE INVERSION OF THE SYSTEM  JESUS IS THE ROCK ---HE IS THE INVERSION OF THE SYSTEM  JESUS IS THE ROCK ---HE IS THE INVERJESUS IS THE ROCK ---HE IS THE INVERSION OF THE SYSTEM  SION OF THE SYSTEM  JESUS IS THE ROCK ---HE IS THE INVERSION OF THE SYSTEM  JESUS IS THE ROCK ---HE IS THE INVERSION OF THE SYSTEM"],
["211219",     "2.3.0.0", "5294.01|770 MB", "", "2021", "211219 ((((( THIS MIRACLE ))))) Is TOPPING the List In My MINISTRY ... The Depth of the Ehben is Beyond.mp4", "@The Orchestration to DELIVER the END TIME MESSAGE Of The RESTORED TEMPLE Is (((((((( BEYOND )))))))) Comprehension......The Magnitude of UNDERSTANDING (((( THE ROCK ))))) is Understanding the MEANING of LIFE..... The LORD GOD IS MY ROCK And My SALVATION"],
["211220",     "2.3.0.0", "5158.01|634 MB", "", "2021", "211220 The ((STONE )) - ( UP ) Rejected by the BUILDER'S, Has Become the CHIEF CORNER-STONE. ( Now We KNOW).mp4", "@The GREATEST Mysteries Of the WORD Are Being Revealed Now DAILY--This is the Most AMAZING TIME In the Wolrd to SEE THIS MANFESTATION UNFOLDING....The Word ( as NEVER Before ) Completely Understood, Is Pouring out like Water ...All Glory to the KING!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"],
["211223",     "2.4.0.0", "5548.01|743 MB", "", "2021", "211223 This IS OBVIOUSLY a GRAND ILLUSION. Can You SE IT NOW !! The OBVIOUSNESS Is IRREFUTABLE .. SOLVED !.mp4", "@I'M Going to FLOOD the WORLD WITH TRUTH"],

//==== 2022 ====

["220101",     "4.1.0.0", "4328.01|495 MB", "", "2022", "220101 IT is PROVEN!!!!!!!! The SERPENT Race CONSUMES The SHEEP...NOW WE HAVE ((( BIBLICAL PROOF ))).mp4", "@Get ready to Shout for Joy"],
["220103",     "4.1.0.0", "4345.01|533 MB", "", "2022", "220103 Just (( OH My LORD )) !!!!! OH MY LORD - THANK YOU !!!! WHO COULD'VE SOLVED THIS , But (((( YOU )))).mp4", "@TO BE Able to See This Is More Valuable than ANYTHING This World has to Offer...... WE ARE OTHER-WORLDLY ...The Time of Our EXILE Is Coming to an END,,,,,,, The EXILE Is ENDING !!!!! Praise God --El the ALMIGHTY GOD"],
["220105",     "4.1.0.0", "8698.01|1.07 GB", "", "2022", "220105 Best 2 HOURS I've Spent in a Minute!! Make Sure You Watch the Last 2 Minutes of This Video ANA-BLEPO.mp4", "@This WILL CONVINCE ANYONE WHO DOUBTED THE GIFT Or the REVELAION....Series in the Making"],
["220108",     "4.2.0.0", "6683|837 MB", "", "2022", "220108 PARTHENO = VIRGIN - GENESIS .....The Whole SYSTEM EXPLAINED and PROVEN.mp4", "@The GREATEST Gift from God --The TRUTH"],
["220110-01",  "4.1.0.0", "2493.01|331 MB", "", "2022", "220110-01 OH NO!! Not Scooby Doo ... Starting a Short Videos channel so I can Post Daily.mp4", "@The Flood Gates Are OPEN.... I will Give it my best effort as WE Approach the End"],
["220110-02",  "4.1.0.0", "590.02|68.0 MB", "", "2022", "220110-02 Mary Jane is a Man in a Mask... Reminds me of Starbucks and Alex.mp4", "@https://www.youtube.com/channel/UCPqJ...<br>Just checking a shortie on this channel"],
["220111",     "4.1.0.0", "6892.01|849 MB", "", "2022", "220111 WINK MURDER !! WTH! IT-s ALL TRUE.This FULL Video Captures the OVERALL Understanding of ENTIRE BIBLE.mp4", "@MUST Watch ENTIRE VIDEO...Maybe the Most Important Video I have Ever Done"],
["220116",     "7.2.0.0", "966.32|229 MB", "", "2022", "220116 Get READY To FREAK OUT-- Here is a Testimony PREVIEW that is Going to Stand as an Eternal Witness !!.mp4"],
["220118",     "7.4.0.0", "6561.01|874 MB", "", "2022", "220118 WHOLE Thing was A MIRACLE - JESUS Is Coming! Not on a Donkey's Colt THIS Time --- V - 4 Vengeance..mp4", "*Stars|@Here is a Testimony You NEED To Hear .... The Witnesses  saw and Testified to the Message that WAS Written in the LORD GOD'S Handwriting..."],
["220122",     "7.4.0.0", "1162.02|100 MB", "", "2022", "220122 When ABBA Wants Me to Know Something- I KNOW IT - Want to see something REALLY AMAZING.mp4", "@Just Watch"],
["220124",     "7.2.0.0", "2274.02|306 MB", "", "2022", "220124 Time to Meet Under the STARS..... Here we Goooooooo!!!!!.mp4", "@Looks Like It is Time to meet and Greet...Coming just in Time for the Eventuality..... The End Is Coming"],
["220126",     "7.2.0.0", "2016|286 MB", "", "2022", "220126 SPIRIT COOKING 4-REAL.. The Earth is OVER.. Prepping ARC get together,, Also- Need a Plumber PDQ.mp4", "@the Signs are EVERYWHERE and are Overwhelming.. The Host Body System is Being Taken by ((( DOWN ))) .... Also we ((( NEED ))) a Plumber to help us at the ARC ...PDQ... Our Plumber has Turned to the world"],
["220127",     "7.2.0.0", "5108.02|744 MB", "", "2022", "220127 Here COME The MIRACLES !! A Night Under the STARS at The ARC .Want to Witness MIRACLES ! Watch !!.mp4", "@Just WATCH the ENTIRE THING ,,,FREEEEEEEK OUT"],
["220201",     "4.0.0.0", "510.3|95.4 MB", "", "2022", "220201 The PARTY Is ON!!!!!!! Working on Receiving Guests...We WILL Be Having a Get Together.mp4", "@The Information where to Go Will Be available tomorrow... For anyone flying in,the Houston Hobby Airport is your Closest Landing Zone... Check in Manana"],
["220202",     "6.6.0.0", "1856.02|266 MB", "", "2022", "220202 CRAZY Crazy CRAAZZeeeeee ..You Tell Me !! And, Here are The Details to the Night Under the STARS.mp4", "*Invitation|@Make Sure You WATCH This Video.<br> ❯ Jonathan's invite is at the 21min point of the video - https://youtu.be/imjKNrf7gh4?t=1277. He says text RSVPs under this video.<br> ❯ Here is the Map / Information Sheet - https://www.show-notes.net/thisistheend/picture.php?/29638"],
["220203",     "4.0.0.0", "1195.01|188 MB", "", "2022", "220203 Need a Ride or Looking for Someone to share expenses !! UPDATE on Gathering!! Here We Goooooooooo !!.mp4", "@the video is self explaining"],
["220204",     "4.0.0.0", "2227|282 MB", "", "2022", "220204 Clap ClaP---- ClapClapCLAP -- CLAP CLAP!!!!!!!!! On the Horizon !!!!.mp4"],
["220207",     "4.1.0.0", "2216.02|283 MB", "", "2022", "220207 The Hidden World.. NOT So Hidden NOW!! Plus Update - Grace ( Up ) Fulfilled.mp4", "@Anna- Up or Grace&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Purna -Fulfilled ..."],
["220209",     "6.6.0.0", "1410.01|261 MB", "", "2022", "220209 Please Watch and Pay Attention here we go.mp4", "*Gathering Update|@this is a video to show you a glimpse into the Get together"],
["220212",     "4.1.0.0", "1153.01|191 MB", "", "2022", "220212 The Building is Finished and the 19th & 20th are a GO!!!!!.mp4", "@We are Getting ready for a PARTY !!!!! Looking forward to meeting My Brother's and Sister's ...The Day is Coming soon"],
["220213",     "8.0.0.0", "18014.41|2.12 GB", "q14_rdtbFpg", "2022", "220213 Why Jonathan Kleck is the Angel of the Church of Philadelphia ( Prophet ).mp4", "*Kleck Anthology Vol.1|@This anthology was composed by our brother Ryan Winter"],
["220215",     "4.0.0.0", "82.01|22.3 MB", "", "2022", "220215 Getting a BIG Art Intersection READY For Group.mp4"],
["220218",     "4.1.0.0", "1617.87|70.0 MB", "", "2022", "220218 Stars Stars STARS ... and Entering the ARC....WOW.mp4", "@Just watch the vid"],
["220222-01",  "6.2.0.0", "856.45|70.9 MB", "", "2022", "220222-01 NIGHT UNDER THE STARS 1.mp4", "@More Coming!!"],
["220222-02",  "4.0.0.0", "298.86|18.3 MB", "9tMDKsgQ2HM", "2022", "220222-02 KLECK - NEW ARC BUILDING FILLED WITH LIGHT - 02.18.22.mp4"],
["220224",     "4.0.0.1", "793.84|127 MB", "", "2022", "220224 WWW 3 Right on Time...THISisIT 4321 B4 TheFire.mp4", "@Just a reminder of ALL The Miracles and Our future looks Bright as the world descends into Chaos"],
["220225-01",  "4.1.0.0", "1280.19|300 MB", "", "2022", "220225-01 Here is MY Confirmation From th LORD. The End Is Coming!! Video Later Today from get together.mp4", "@Just Listen"],
["220225-02",  "6.2.0.0", "8416.91|415 MB", "", "2022", "220225-02 Night Under The Stars Part ll.mp4", "@Just Listen"],
["220227",     "4.3.0.0", "1438.01|303 MB", "", "2022", "220227 Tsunami Tsunami TSUNAMI , Water as High as the Walls of Jerusalem.mp4", "@The Eventuality Confirmed....pRAY TO BE ACCOUNTED WORTHY TO ESCAPE all THE HORRORS COMING ON THE EARTH"],
["220228",     "4.3.0.0", "9459.02|1.60 GB", "", "2022", "220228 Ukraine, ALL the WAY Now.. Heaven or Bust.. This is where the the fabric of the Universe Rips Open.mp4", "@Try to Wrap your Brain around this"],
["220302",     "4.3.0.0", "7046|1.25 GB", "", "2022", "220302 Final Countdown!! White Horse Ready to Go. MIND Completely BLOWN -- What a RIDE. She's READY 2 KILL.mp4", "@This is Beyond Explanation...But I am Trying..."],
["220305",     "4.3.0.0", "4977.01|832 MB", "", "2022", "220305 YOU Pick The TITLE... ILL Just Say INSANE ..Told Ya So.mp4", "@Here We Go.. Leaving Soon and this should settle it in your heart"],
["220306",     "4.4.0.0", "4080|751 MB", "", "2022", "220306 If - THIS DOES NOT CONVINCE YOU, Then How Could You Be One of US.. WE are The ALIENS Captured HERE.mp4", "@The EARTH Is NOT MY HOME.... Here is the BIBLICAL PROOF"],
["220308",     "4.4.0.0", "4766.01|939 MB", "", "2022", "220308 The LAST Scene of SCHINDLERS LIST, Is the ONLY Way To CONVEY What I AM Dealing With Right Now.mp4", "@https://youtu.be/VggxQHoEZw8\ (KleckFile: index.html?1&151103\)<br>Here we are at the End and ALL I can Think of is HOW do I continue to Help Save Others...... The Emotional Distress is Completely Overwhelming .. . GOD HAVE MERCY On This Fallen World... He Had Mercy and the Time of Vengeance is NOW ... Draw Close to God and He will Draw near to you..."],
["220310",     "4.4.0.0", "4272.01|713 MB", "", "2022", "220310 1-4 of the earth, to kill with sword, and with hunger, and with death, and the beasts of the earth.mp4", "@It is ALL Lining up to the Obvious conclusion"],
["220311",     "4.4.0.0", "5855|902 MB", "", "2022", "220311 V 4 VENGEANCE !! WHAT a Complete PULP FICTION BUST !! Talk About No Way Out Of Busted.mp4", "@The Lord God has communicated the END of ALL Things is at Hand and I am Sharing what I have been shown... WE Were Sold Into Slavery and the Time of Our Father's Vengeance Has Come"],
["220312",     "4.4.0.0", "1885.02|298 MB", "", "2022", "220312 Alert...This is IMPOSSIBLE.. The TRUTH is INESCAPABLE...Vengeance.mp4", "@IMPOSSIBLE Is this channel's Normal....WOW!!! All Glory to Jehoshua,...The KING of KINGS"],
["220314",     "4.3.0.0", "653.25|135 MB", "", "2022", "220314 Here Comes the End and A Scripture Revelation -- I Have Done What I Was Told..The Bell Has Been Rung.mp4", "@The Up coming Revelation of Scripture says it ALL...And Proves it ALL"],
["220315",     "4.3.0.0", "2604|455 MB", "", "2022", "220315 Behold a WHITE Horse.. The (Bow) SOLVED the BREEDING Riddle,,, Sat = DOWN - KATA ...Game OVER!!.mp4", "@I was Looking at the Scripture and then it Exploded ,,,,,LOLOL"],
["220316",     "4.5.0.1", "4369.02|748 MB", "", "2022", "220316 Time to Say Goodbye ! WOW! This is Beyond My Ability to span 20+ Years and KNOW The LORD Planned IT.mp4", "@The LORD GOD PLANNED This MINISTRY From Beginning to END ,,,, <br>(4321  = MIKAYEHU ) WHO Is LIKE YAH ??????????????????????? My Mind is BEYOND BLOWN"],
["220317",     "4.5.0.1", "2844|512 MB", "", "2022", "220317 I have fought a good fight, I have finished my course, I have kept the faith- Jonathan FRANZEN WOW.mp4", "@No One could even write this script.... Thank you for letting me Share this with you....A New Heavens and a New EARTH...."],
["220321",     "8.1.0.1", "1470.01|232 MB", "", "2022", "220321 IT Is ALL Right-Side Up + Upside Down ... Even The WW3 at the Door.mp4", "@Just watch https://youtu.be/CSvFpBOe8eY<br>https://youtu.be/CDl9ZMfj6aE"],
["220322",     "8.1.0.1", "3379.01|594 MB", "", "2022", "220322 The Speaker is Rubbing her Hands together like FLY Inside of The Capital Shaped as a Bug. WTH !!.mp4", "@Just watch and figure it Out"],
["220325",     "8.1.0.1", "4977.01|843 MB", "", "2022", "220325 ELOHIYM Created Man is HIS REPRESENTATIVE FIGURE -Especially an IDOL,, The TRUTH is OUT ..Insects.mp4", "@Just watch it all"],
["220326",     "8.1.0.1", "4345.01|751 MB", "", "2022", "220326 Shhhhhhhhhhhhh,,,, They Do NOT want you to KNOW... The World is a Vampire.mp4", "@Cain / Abel - RSU / USD -- Light/Dark -- Up/Down -- US/THEM ...Wake UP... Time to Goooooooo"],
["220327",     "8.1.0.1", "6135.01|1.01 GB", "", "2022", "220327 How do you CONQUER the WORLD With a BOW!! Easy!! You Bind together the Serpent Race with the Sheep !.mp4", "@It's a BOW ((( That you Tie things together with ))) NOT a Bow that shoots an Arrow ....Hey why not change the world's biology!!! That ought to do it!   Already Done"],
["220330",     "8.1.0.1", "1870.02|330 MB", "", "2022", "220330 CHRIS Rock -- Will SMITH .... Who Wants to See PAST The BS Puppet show.mp4", "@Try Not to laugh ay HOW Obvious it is ALL Becoming"],
["220403",     "8.2.0.1", "4494.01|786 MB", "", "2022", "220403 ALERT !! New World Order & CURRENCY ANNOUNCED !! Locusts from PIT Confirmed! ALL ABOUT 2 HAPPEN !!.mp4", "@It is SELF-EVIDENT"],
["220404",     "8.2.0.1", "4977.01|894 MB", "", "2022", "220404 When does a Theory Become the Truth-- When PROVEN Using Data that supports it.. Truth LIVES HERE !!.mp4", "@Self Evident TRUTH"],
["220406",     "8.2.0.1", "4603.01|690 MB", "", "2022", "220406 Super Bowl INSANITY But TRUE!! The ABSOLUTE TRUTH ( PROVEN ) WE ARE The ANGELS the Bible Proves IT !.mp4", "@You MUST WATCH ENTIRE Video ..... The Greatest Scriptural TRUTH is HERE"],
["220407",     "8.2.0.1", "1170.01|230 MB", "", "2022", "220407 Watch Start of VIDEO !! (Equipment problems)) -- Part 2 COMING TODAY !!.mp4", "@started a video but equipment went south .... I will pick up the Scripture NEXT Video"],
["220410",     "0.0.0.1", "2735.01|302 MB", "", "2022", "220410 Peace is being Removed ... Here is the TESTIMONY.mp4", "@Nothing left to say ... The Lord is Removing his peace from the TWIN FEMALE SYSTEM"],
["220411",     "0.0.0.1", "4892|1.05 GB", "", "2022", "220411 Parthenogenesis-Twin Female-Rebel Rd.-Choate - Contempt- Indictment Delivered- ALL SEEING EYE 4 REAL.mp4", "@This has been the a very difficult 3 weeks but NOW It ALL Makes Sense.. Please watch and Pray for everyone involved"],
["220412",     "0.0.0.1", "4021.02|885 MB", "", "2022", "220412 To RESTORE Your Sight From the Beginning. Watch it ALL Prove Out to Absolute Miraculous Perfection!.mp4", "@The Ministry is Self-Evident..."],
["220417",     "1.2.0.1", "26.54|3.74 MB", "", "2022", "220417 Happy Resurrection Sunday.mp4", "@This is Cory, Jonny is checking in real quick. he's on his way back home, he will check in shortly."],
["220419",     "1.2.0.1", "73|11.7 MB", "", "2022", "220419 Been fighting an Infection.mp4", "@just checking in"],
["220422",     "1.2.0.1", "338.01|44.9 MB", "", "2022", "220422 It Is ALL Going to get Very Very Real.mp4", "@The Pit will open"],
["220426",     "4.1.0.1", "2491.01|288 MB", "", "2022", "220426 Time to KNOW Where you Stand.... The TRUTH has Been UNCONCEALED.mp4", "@I am Here to Proclaim the Coming of the King"],
["220428",     "4.1.0.1", "3582|627 MB", "", "2022", "220428 Spirit Cooking 101 .. Statue of Liberty.mp4", "@How Obvious is all this Now??"],
["220429",     "4.1.0.1", "2975.01|487 MB", "", "2022", "220429 The Inevitable Reality of This Ministry... Confirmed -- You Decide.mp4", "@Crazy Confirmation and impossible timing and Message as well"],
["220502",     "4.3.0.1", "4890.01|1.14 GB", "", "2022", "220502 This is PART 2 !! PLEASE WATCH ASAP !! ALERT ALERT !! Part 1 Tomorrow.. Tech Issues. Nukes Coming...mp4", "@This is Part 2...Part  1 with the TESTIMONY will be FIXED Tomorrow...Must Watch this asap .... Tomorrow is the testimony"],
["220503",     "4.3.0.1", "8069|1.44 GB", "", "2022", "220503 Confirmed-- Same as Chinati. Now the STEP of FAITH.....WARN The PEOPLE . Please Listen To Everything.mp4", "@This is The Most difficult message I could bring but there is HOPE in CHRIST"],
["220509-01",  "0.0.0.1", "676|124 MB", "", "2022", "220509-01 GET READY .... LOTS and Lots of Info coming today.mp4", "@Here is a brief What the Heck is Going On?? and letting you know what is coming, and that we were able to counter the Coincidental Destruction of the most important Resource I Use.."],
["220509-02",  "1.2.0.1", "5262.01|761 MB", "", "2022", "220509-02 Dropping the TRUTH BOMB !!! Watch and SEE ... Being MonitoredU Decide.I Recorded it Happening.mp4", "@Just gotta SEE all this info together with the Scripture"],
["220509-03",  "0.0.0.1", "3262.01|701 MB", "", "2022", "220509-03 Follow-Up to Show-Note sever -- COINCIDENCE -- LOLOL... They Do NOT want the 100- Nylon out at all.mp4", "@Welcome to New Age 1984  ....What happened here is a JOKE... The ODDS are Slim to None...Coincidence?? Who could Even begin to believe That ??"],
["220509-04",  "0.0.0.1", "1234|289 MB", "", "2022", "220509-04 Quick explanation of the Attempt to Disrupt the Show-Note RESOURSE at the Moment of Delivery.mp4", "@Here is a brief What the Heck is Going On?? and letting you know what is coming, and that we were able to counter the Coincidental Destruction of the most important Resource I Use...."],
["220512",     "1.2.0.1", "6922.03|290 MB", "2lbW1xn6cvo", "2022", "220512 THEIR HIDING PLACE Is DISCOVERED -- Now ((THEY)) are NAKED.mp4", "@This PROVES that Satan's Hiding Place IS the HOST BODY"],
["220517",     "1.0.0.1", "373.01|43.7 MB", "", "2022", "220517 Make sure you check out the other ways to get together.mp4", "@checking in"],
["220519",     "1.2.0.1", "3815.02|576 MB", "", "2022", "220519 ANAKRINO, This Solved EVERYTHING , Even Who WE ARE.mp4", "@350 anakrínō (from 303 /aná, \"up, completing a process,\" which intensifies 2919 /krínō, \"to select by separating/judging\") – properly, to distinguish by vigorously judging \"down to up,\" i.e. closely examining (investigating) through \"the process of careful study, evaluation and judgment\" (L & N, 1, 27.44); \"to examine, investigate, question (so J. B. Lightfoot, Notes, 181f).<br><br>[The prefix 303 /aná (\"up\") shows the process involved that takes krinō (\"judging/separating\") up to its needed conclusion. Accordingly, 350 (anakrínō) is often used in its forensic sense in the ancient world. It can even refer to \"examination by torture\" (see Field, Notes, 120f, Abbott-Smith).]"],
["220523",     "2.2.0.1", "3826.02|623 MB", "", "2022", "220523 Oh My LORD!!! Parthenogenesis..It WAS THE BEGINNING and They WILL Demote Jesus With it, Guaranteed.mp4", "@Just PLEEEEEEEEEZZZZZZZZZZZZzzzzzzzzzzzzzzzz Watch ...LOL"],
["220526-01",  "2.3.2.1", "8613|1.36 GB", "", "2022", "220526-01 The BEST News in the WORLD !! Also the WORST News in the World.. This is a MUST SEE COMPLETELY Video.mp4", "@PARTHENOGENESIS ..It's REAL and It is The Reason for the Weirdness of the World, But is ALL Makes PERFECT SENSE"],
["220526-02",  "2.3.2.1", "6303.01|1.06 GB", "", "2022", "220526-02 SHOUT IT FROM THE ROOFTOPS !!!!!!!!!!!!!!!! Wanna See Johnny Shout it!! OKay... Im Shouting IT !.mp4", "@Shout!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"],
["220601",     "2.3.2.1", "3459.01|654 MB", "", "2022", "220601 Cory is Pregnant !!! W.T.Heck is GOIN-On Around these Here Crazy Indigenous Reptile Folk!! .LOL.mp4", "@At His Point it is Sooooooooooo Obvious, that People are sending us Posters to Memorialize the Current Disposition of the Failing Build Back Parthenogenesis style... Folks, It Just AINT Gonna Work!! LOL"],
["220602",     "2.3.0.1", "5573.02|1.0 GB", "", "2022", "220602 So ((((( NOW ))))) You KNOW... And That Means Time's UP.mp4", "@here ya go"],
["220605",     "2.0.0.1", "905.02|165 MB", "", "2022", "220605 Shofar !!!! WOW , You GOTA Be KIDDING .. This Really Happened !!.mp4", "@Here we Go"],
["220608",     "2.0.0.1", "658.01|115 MB", "", "2022", "220608 FAITH - HOPE - LOVE .... Looks Promising- Stay Tuned - Watch Video below in description box.mp4", "@https://youtu.be/JdLPCADw2MI/  -   must watch<br>Lyrics: Come Sail Away - https://g.co/kgs/4cBmSf\ + Let It Go - https://g.co/kgs/ZVLn8U/"],
["220609",     "2.0.0.1", "220.01|31.0 MB", "", "2022", "220609 Check In ...Get ready for the Documented - Almost not Believable- Roll out.mp4", "@Getting ready"],
["220610",     "2.0.0.1", "6208.02|1.00 GB", "", "2022", "220610 I BELIEVE This Set Of MIRACULOUS EVENTS SPELLS OUT ONLY 1 THING. THE END HAS COME! BLOW The SHOFAR!!.mp4", "@https://youtu.be/JdLPCADw2MI\<br>I have done as I was Told and the Rest is yet to be seen.. I Believe therefore I act on what has been communicated ,,,LET THE RECORD SPEAK FOR ITSELF"],
["220611",     "2.0.0.1", "2831|425 MB", "", "2022", "220611 The DETAILS for the SUNRISE FLIGHT !!.mp4", "@Here are the Details of the Morning Flight"],
["220612-01",  "2.0.0.1", "382.43|26.7 MB", "2yY_Huhlg9M", "2022", "220612-01 KLECK - THE BALLOON RIDE - 06.12.22.mp4"],
["220612-02",  "2.0.0.1", "2815|365 MB", "", "2022", "220612-02 MY LORD & Miracles Keep Me Believing.There is ZERO Doubt, The End is Coming.. Hebrews 11 SAYS it ALL.mp4", "@What an EXPERIENCE !!!! Fill Up The Basket  Don't be Tired in Doing Well"],
["220614",     "2.0.0.1", "2186.02|433 MB", "", "2022", "220614 Here IT COMES ! OH BTW ..The Thumbnail represents what happened to Those that hide Their Plans.mp4", "@Here comes the Judge.... as the saying goes.."],
["220619",     "2.0.0.1", "2735.01|555 MB", "", "2022", "220619 No such thing as Coincidence.... A Flag represents an idea- or an ideal.mp4", "@The Picture is clear"],
["220621",     "2.0.2.1", "3532.01|574 MB", "", "2022", "220621 Have You SEEN the NEW Quarter-- Mankiller - Do You KNOW What 1Peter 2-9 Says-- Coincidence - No WAY.mp4", "@My mind is Obliterated ! LOL. BTW The Cherokee Use the 7 pointed star and the occult symbols are commonly used in MOST EVERY CULTURE"],
["220625",     "2.1.2.1", "4388.01|858 MB", "", "2022", "220625 WHITE HORSE= Bind w-Bow. RED Horse =Take Peace from the Earth. Black Horse= Balances -Yoke together.mp4", "@The WORD Of GOD Is Perfect...The Times are visible and EASY to SEE"],
["220626",     "2.1.2.1", "442.02|111 MB", "", "2022", "220626 History making scripture Tomorrow...Too Late to Move the Vatican-- It-s a Serpent wearing a Crown.mp4", "@Now We KNOW 4-SURE..It was ALL TRUE"],
["220627",     "2.2.0.1", "5792.01|1.0 GB", "", "2022", "220627 I Will Give You the TREASURES of Darkness, And You WILL KNOW That I AM The Lord, The GOD of ISRAEL!!.mp4", "@The Scriptures are PERFECTION...The Opposition is TOAST"],
["220629",     "2.2.2.1", "7111.06|917 MB", "", "2022", "220629 BEYOND Comprehension - Not ANY MORE!! KNOWING -The TRUTH - The GREATEST GIFT EVER GIVEN - JEHO-SHUA.mp4", "@The Mystery is SOLVED --The KING is COMING in GLORY"],
["220704",     "2.3.0.1", "9169|1.47 GB", "", "2022", "220704 Parthenogenesis, The Twin Female From the Beginning. Once you REALLY SEE It, EVERYTHING Makes Sense.mp4", "@This video just shows how obvious the most hidden TRUTH is Also the MOST OBVIOUS... The Inversion of the WORLD is the ANSWER to the World"],
["220706",     "2.3.2.1", "4848|962 MB", "", "2022", "220706 Who is HEARING From the LORD GOD _ And Who is Not_ This is an account of events at the ARC. U Decide.mp4", "@https://odysee.com/@DavidShadow:0/KAREN-1---April-18,-2022:b <br>https://odysee.com/@DavidShadow:0/KAREN-2---April-18,-2022:a <br>THESE WERE DONE APRIL 18 ..The Evidence Speaks for itself...Also these videos were hidden when we went to (her) channel ???? WHY ?????"],
["220707",     "2.3.0.1", "2955.02|134 MB", "", "2022", "220707 STAND As A WITNESS ... Then Off the Much BETTER THINGS.mp4", "@The Bible says..... \"Whosoever hateth his brother is a murderer: and ye know that no murderer hath eternal life abiding in him.\"<br>The Word Also says..... For let not that man think that he shall receive any thing of the Lord.<br>8 A double minded man is unstable in all his  ways."],
["220709",     "2.0.2.1", "6052|0.99 GB", "", "2022", "220709 What Does it MEAN that the Vatican is BUILT To Represent a SERPENT Jesus is COMING.. That-s What.mp4", "@Just watch"],
["220711",     "2.0.0.1", "4285.01|706 MB", "", "2022", "220711 Liberal World Order ... HAPPENING RIGHT NOW... THE ESSENSE is the SAME as the Maserati Commercial.mp4", "@THEY ARE RIGHT IN FRONT OF YOU ..... WAKE THE HECK (((((( UP ))))))"],
["220712",     "2.0.0.1", "3425.01|507 MB", "", "2022",  "220712 IT Is ALL XX -- We Wait until they get so big they can Barely Move, Then We STRIKE !!.mp4", "@https://youtu.be/DqPj-E_8f3c<br>They are Seeable Now!! LOOK For Yourself" ],
["220713",     "2.0.0.3", "5728.01|943 MB", "", "2022",  "220713 OH YEAH !! You Better Believe It's Coming.. What R The ODDS On This Lunacy.. It's Right On The Money.mp4", "@It Is Sooooooooo In your face it is Stupid at his point.. Just completely Daft" ],
["220714",     "2.4.2.3", "4245|665 MB",  "", "2022",  "220714 Raptors- Robbers- Insects- Serpents wearing Crowns- Twin Female- You TELL ME .. WTW Just WATCH.mp4", "@just watch" ],
["220715-01",  "2.4.0.3", "3614.05|145 MB",  "", "2022",  "220715-01 3=Destroying angel in the Bible and Ovid means sheep in Latin and 19 Strongs = RED WEDDING.mp4", "@Evidence speaks for itself... Look Past the Illusion Red Wedding = Slaughter" ],
["220715-02",  "2.4.0.3", "4986.02|915 MB",  "", "2022",  "220715-02 The WORLD Is a SHAM.. In Heaven There is Neither Male Nor Female.. Now Comes the NEW MAN- Pure EVIL.mp4", "@The TRUTH ... Is the Inversion of the LIE, And The Lie is the Inversion of the TRUTH" ],
["220717",     "2.4.0.3", "4300.01|757 MB",  "", "2022",  "220717 Please UNDERSTAND This (Before ) I drop The Man of 2 Faces Prophecy, Foundational Scriptures First.mp4", "@https://youtu.be/bTzjJNgAlTk<br>https://youtu.be/pnYDc4UmUfw<br>The Unlocking of the Mystery WITH the WORD Supporting IT Is KEY" ],
["220718",     "7.3.0.0", "60|2.62 MB",  "a7F-v_nsUv4", "2022",  "220718 GO HERE TO SEE JON-S VIDEOS.mp4", "@YouTube suspended JK for 2 weeks - Go to other channels:<br>https://odysee.com/@CoryBarbee:8<br>https://www.brighteon.com/channels/thejonathankleck<br>https://www.bitchute.com/channel/thejonathankleck/<br>https://archive.org/details/@daveshadow71?sort=-addeddate" ],
["220727",     "2.5.0.1", "10641.02|1.97 GB",  "", "2022",  "220727 The Most Comprhensive Understanding of the Mark of the Beast and End of the WORLD.mp4", "@This video incorporates ALL the DATA You have probably never been exposed to .. This is a MUST WATCH from Beginning to END<br>Ozzy Osbourne - Patient Number 9 - https://youtu.be/h_6DfxA6LiI" ],
["220728",     "2.5.0.1", "4663.02|744 MB",  "386QofGoNgs", "2022",  "220728 TWIN FEMALE aka (Pure Evil) is in Travail about to BIRTH.mp4", "@Another MUST WATCH Video to compleatly understand the earth and our relationship to the earth!" ],
["220729",     "2.5.0.1", "7849.02|1.13 GB",  "UuMY7NO_41s", "2022",  "220729 DRIVING THE POINT HOME!!!!.mp4", "@Stop and read the definitions. Very important to understand this data." ],
["220730",     "2.5.2.1", "7647.02|1.53 GB",  "rBMA3SO0gic", "2022",  "220730 Satans GOAL VS Jesus MINISTRY..... WE WIN BECAUSE OF YEHO-SHUA.mp4", "@THIS SHOWS THE RELATIONSHIP BETWEEN US AND GOD AND SATANS ATTEMPT TO DESTROY US AND HOW JESUS INTERVENES TO SAVE US." ],
["220801-01",   "2.0.0.1", "3113.02|595 MB",  "", "2022",  "220801-01 The EYE is OPEN, The DRAGON'S FEET are On the GROUND.mp4", "@The LORD Has Used the Manifestation of their Own attributes to EXPOSE THEIR PLANS.. The LORD has Also Supernaturally <br>Proven that the EYE IS OPEN and the DRAGON will Give His Power to the BEAST" ],
["220801-02",   "3.0.0.1", "220.06|24.4 MB",  "", "2022",  "220801-02 Get some POPCORN and a Soda and get to the VIDEOS waiting for you... The TIME IS At Hand.mp4" ],
["220803-01",   "3.0.0.0", "130.08|5.12 MB",  "", "2022",  "220803-01 Just Checking In.mp4" ],
["220803-02",   "3.0.0.0", "168.09|12.1 MB",  "", "2022",  "220803-02 Checking In Redo - Equipment Problems Sorry.mp4" ],
["220803-03",   "2.0.0.2", "2348.02|440 MB",  "", "2022",  "220803-03 Mark of the beast magnetic net guaranteed.mp4", "@Watch the entire video." ],
["220804-01",   "4.0.2.0", "2378.05|221 MB",  "", "2022",  "220804-01 7 SHOFARS !!!!!!! CAN You SEE What Time it Is  The King is Coming !!.mp4", '@Just doing s little shofar practice and Rejoicing in the Inevitable .. The END !! A NEW BEGINNING !! All Glory to El the ALMIGHTY GOD... Time to Judge Elohiym<br>Revelation 8 read by Max - https://www.biblegateway.com/audio/mclean/kjv/Rev.8' ],
["220804-02",   "4.0.2.0", "233.06|28.7 MB",  "", "2022",  "220804-02 Raptors....Not my favorite TEAM at All....mp4", "@Go check this one out" ],
["220804-03",   "2.0.0.0", "1564.02|355 MB",  "b1_Ak-zYQ_w", "2022",  "220804-03 RAPTORS and LIES and BOW TIES OH MY!!!!!.mp4", "@Watch the entire video" ],
["220804-04",   "2.0.2.0", "2119.05|226 MB",  "", "2022",  "220804-04 I AM In POSSESION Of the EARTH ...Abaddon.mp4", "@The Revelation says it all" ],
["220804-05",   "2.0.2.0", "1210.06|157 MB",  "iNpjCaUf9u4", "2022",  "220804-05 I AM In POSSESION Of The EARTH AND ALL COUNTRIES ..Abaddon.mp4", "@I did a short redo on a different computer because of Audio problems" ],
["220805",      "2.0.0.0", "4837.02|558 MB",  "", "2022",  "220805 Covid vaccine everything they don't want you to know- RAPTOR RNA.mp4", "@This is the reason I was kicked off youtube. The video will speak for its self." ],
["220806",      "2.0.0.1", "5982.07|753 MB",  "", "2022",  "220806 HOLY Leaping SeXX LIZARDS From the Abyss Bat-Man.. ROOM 237 Is WIDE OPEN !!.mp4", "@The Pictures Say it ALL...Don't Open room 237 --That's where Raptors come from and those that EAT the SHINING..REDRUM  REDRUM REDRUM" ],
["220811",      "2.0.0.1", "2893.02|495 MB",  "", "2022",  "220811 This is the Message -- A DEVOURING... and DARKNESS and GLOOM.....See how THIS Rolled Out...mp4", "@This is a Jaw Dropper...It Was for Me" ],
["220813",      "2.0.2.0", "1125.01|223 MB",  "", "2022",  "220813 I AM DEFINITELY ENCOUNTERING Face to FACE the OTHER TEAM... WOW oh WOW Are THEY Becoming Visible.mp4", "@The Wheat and the WEEDS Are3 Manifesting like Nothing I have ever seen .... Stay Ready ....they ARE COMING !!!!!! So IS the KING of KINGS" ],
["220814",      "2.0.2.0", "4608.02|287 MB",  "", "2022",  "220814 I WAS Told to BLOW The Shofar.mp4", "@I WAS Told to BLOW The Shofar !!!!!  I HAVE BLOWN The TRUMPET And Sounded the Alarm... The Prophesy is unfolding ..The Time is Here" ],
["220815",      "2.0.0.0", "3146.05|505 MB",  "", "2022",  "220815 Whosoever heareth the sound of the trumpet, and taketh not warning, his blood is upon his own head.mp4", "@I HAVE Delivered the Warning for 20 years.. The Time of the Female Rival Is COME...." ],
["220816",      "2.0.2.0", "1305.06|245 MB",  "", "2022",  "220816 ANOTHER Count-Down What's Going On APPARANTLY a COUNTDOWN.mp4", "@Just Try to Recon the Odds of this.... IMPOSSIBLE.....Message RECEIVED" ],
["220817",      "2.0.0.0", "7731.01|1.17 GB", "", "2022",  "220817 Lucifer set his Heart as the Heart of Elohiym. NOW SEE THE TRUTH With Your Own Eyes. RIDDLE SOLVED.mp4", "@THIS SCRIPTURE Lesson will Blow your Mind and Give you Great Peace" ],
["220818",      "2.1.0.0", "1415.05|218 MB",  "", "2022",  "220818 TIME To DIG Through The FOLDERS TOGETHER and have Your Mind Blown.mp4", "@I am working diligently on the delivery of the Info the Lord has Blessed me with....." ],
["220819-01",   "2.0.2.0", "4673.02|822 MB",  "", "2022",  "220819-01 Robert Downey - SAME Message as Birmingham Games. ANGEL of The Bottomless PIT Is TAKING HIS THRONE.mp4", "@Just Gotta Watch the Whole video" ],
["220819-02",   "2.0.2.0", "2275.02|440 MB",  "", "2022",  "220819-02 Communion OUT of No-Where !!!!! MUST LISTEN To This COMMUNICATION.. Why Now!! Hmmmmmm.mp4", "Fascinating event unfolding.. Looks Very very Interesting..." ],
["220822",      "2.1.2.0", "3956.05|182 MB",  "", "2022",  "220822 THANK YOU For Allowing me to Show You the TRUTH.mp4", "@The Record will speak for itself....." ],
["220824",      "2.0.0.0", "5279.06|535 MB",  "", "2022",  "220824 The ARC is LEAVING or At Least WE ARE.. Count the Coincidences.. Miracles .. Call em as you Will.mp4", "@The Job Looks Like It is FINISHED!! Thank GOD. How Fascinating it ALL was.." ],
["220825",      "2.0.0.1", "4491.06|829 MB",  "", "2022",  "220825 As We ALL Must Give an Account, Let us move with Prayer for those That OPPOSE Us,, No Bitter Roots...mp4", "@The King Is Coming, Forgive Others and BE Forgiven... AMEN" ],
["220828",      "6.4.2.0", "2982.07|101 MB",  "", "2022",  "220828 Could the Time Be Here,  Now, Im hopeful and Trying to Get Out a Testimony, Hindsight is Important.mp4", "@LOOK AT THE SERIOUSNESS Of What has been exposed and CONSIDER The REALITY Of Today's Society ....WE ARE On The BRINK" ],
["220829",      "6.5.0.0", "5418.05|926 MB",  "", "2022",  "220829 IMPOSSIBLE !! Two Halves of the SAME ROCK!! BRILLIANT!! Solved!! JESUS The KING of KINGS Is COMING!!.mp4", "@The Face of Our King is about to Appear... Glory to GOD!!!!!" ],
["220830",      "6.5.2.0", "5263.06|508 MB",  "", "2022",  "220830 yes-or-no-will-this-happen-it.mp4", "@Just watch and decide" ],
["220831",      "6.5.2.0", "4373.06|716 MB",  "", "2022",  "220831 ANGEL Of the PIT --TAKING -- CONTROL !! WANNA SEE.mp4", "@INSANE Connections --Impossible Not to be TRUE" ],
["220901",   	 "6.6.0.0", "4373.06|736 MB",  "", "2022",  "220901 TOO MANY COINCIDENCES.. This Must Be ABOUT To HAPPEN.. The BOW has Already Gone Out to CONQUER.mp4", "@This Is ALL IMPOSSIBLE, The RECORD Will Speak For Itself" ],
["220902",      "6.6.2.0", "4853.02|691 MB",  "", "2022",  "220902 Good LORD -- It Couldn-t Be MORE OBVIOUS.. Thank you For the TRUTH of the WORD.. Here IT COMES.mp4", "@We ARE In FULL SWING ...Either you Have Been Converted to Christ or Not.. The Future Has ARRIVED !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" ],
["220904",      "6.6.0.0", "4033.00|627 MB",  "", "2022",  "220904 BEAST (( UNLEASHED )) Look at the EVIDENCE Of What Is CERTAINLY COMING Right Away.. No Denying it !!.mp4", "@The Record will Always Speak for Itself" ],
["220905",      "6.6.2.0", "4142.02|761 MB",  "", "2022",  "220905 Good GREIF!! This is PAST OBVIOUS - OZYMANDIAS - Says It ALL ...THE TIME IS ARRIVING,, WAKE UP.mp4", "@THE WRITING IS ON THE WALL" ],
["220907",      "6.6.2.0", "4954.05|432 MB",  "", "2022",  "220907 alien-covenant-did-you-think.mp4", "@The Depths of the Enemy is beyond the Human Mind" ],
["220908",      "6.1.0.0", "3635.13|618 MB",  "", "2022",  "220908 If I AM Hearing Correctly.. Be Ready With Joyful, Hopeful Expectancy !!!!!.mp4", "@REALITY Is Only Scary if you do not know it..... This Insanity just got So Real that it Warrants a Good Laugh .... Wow Oh Wow!!" ],
["220909",      "6.1.0.0", "2337.65|349 MB",  "", "2022",  "220909 RESOLUTE PROTECTOR aka (Billy)- IDOL.. Tslem LORD This Is Stupid Obvious at this point .Altogether.mp4", "@Super exhausted but You MUST Keep Watching IT ALL ROLL OUT" ],
["220910",      "6.1.2.0", "3736.02|615 MB",  "", "2022",  "220910 You Want- ABSOLUTE PROOF- We Are Being ASSIMILATED By INSECTS From the Bottomless Pit - ADD This UP!.mp4", "@How COMPLETELY LIBERATING To  ((((((((((((( KNOW ))))))))))))))))) The Complete Horrifying TRUTH...." ],
["220911",      "5.2.0.0", "5568.05|550 MB",  "", "2022",  "220911 MUST WATCH !! The LOGIC of The WORD Is NOW IMPECCABLE !! RESOLVED What Next The KING Is COMING !!.mp4", "@The Logic Now Is Perfect...The Whole Thing Is Perfect....The Lord Is PERFECT..... My Mind is Mush In a Perfect Way LOL !!!!!!!!!!!!!!!!!! I LOVE JESUS  and HE LOVES ALL OF US THE SAME" ],
["220912",      "6.3.0.0", "2312.06|397 MB",  "", "2022",  "220912 I AM FREAKIN_OUT! (264-OfAnotherRace)+Shackled, -(101-Unable), (305-To Ascend or Rise). EL REY VIENE.mp4", "@Goodness gracious there is NOTHING That could Confirm This More Than What Happened" ],
["220914",      "6.3.2.0", "4331.01|739 MB",  "", "2022",  "220914 Starlink Then Go UP to Jerusalem Then God WILL Come With VENGEANCE Get a Spatula- KING-s Coming.mp4", "@I Love you guys ...Trying my best to Share and Keep you All Informed ...This was all mind Boggling" ],
["220915",      "6.4.2.0", "3742.01|618 MB",  "", "2022",  "220915 Tell the stars, if thou be able to number them; and he said unto him, So shall thy seed be. PROFOUND.mp4", "@It WAS ALWAYS RIGHT In FRONT Of US" ],
["220916",      "6.4.0.0", "3970.01|774 MB",  "", "2022",  "220916 How INSANE and UNBELIEVABLE !! This Is ALL PROVEN !! TRIED-TRUED - And TESTED.. KING of KINGS COMING.mp4", "@Just Wrap Your SINGLE EYES Around All of This" ],
["220918",      "2.0.0.0", "7646.01|1.36 GB", "", "2022",  "220918 Rollercoaster Vid.! Make a record, Then GIVE a TESTIMONY to THE COMING of the KING of KINGS. LOOK-UP.mp4", '@Noah\'s Ark - https://youtu.be/iEI0DzoSjzo' ],
["220920",      "2.0.0.0", "5470.02|1.04 GB",  "", "2022",  "220920 OVERWHELMING !! Overflowing Hope Fueled by Continuous Confirmations and Also SEEING The Brutal END.mp4", "@OVERWHELMING !! Overflowing Hope Fueled by Continuous Confirmations and Also SEEING The Brutal END" ],
["220921-01",   "2.0.0.0", "2903.05|492 MB",  "", "2022",  "220921-01 ARISE and JUDGE The EARTH !! ((( NOW ))) We KNOW Exactly What it Means The Enemy is OUT of Time...mp4", "@Here comes the Judge.. The King is at the Door . Destruction is a Moment Away.. Your soul is YOUR own Prize.. The LORD Is Our Inheritance" ],
["220921-02",   "2.0.0.0", "3832.06|194 MB",  "", "2022",  "220921-02 Feels Like a Ton of Bricks Dropped. The TRUTH is COMPLETELY OBVIOUS The World Finally Makes SENSE.mp4", "@NOW It Is Easy to Laugh at ALL OF IT!!!!!!!!!! Amen....It is Obviously OVER" ],
["220922",      "6.1.0.0", "347.02|80.3 MB",  "", "2022",  "220922 Here it Comes .....Past Obvious.mp4", "@no Brainer....The Host Body System is Taken" ],
["220923",      "6.1.2.0", "2447.06|356 MB",  "", "2022",  "220923 Oh My LORD ! THIS COMPLETES THE BUST.. Thy Bow was Made Quite Naked It IS OVER, Their TRAP EXPOSED.mp4", '@MUST WATCH   -----   https://youtu.be/1MJDvr-1Z-A --  watch my  till the VERY End SURPRISE<br>This SCRIPTURE IS BEYOND WORDS ...THEY Have been MADE NAKED" By the LORD GOD and the WORD Completely Confirms it !!!!!!!!!!!!!' ],
["220925",      "6.2.2.0", "4856.06|706 MB",  "", "2022",  "220925 THEIR BOW Was Made Quite NAKED-This Is Genesis 3 Turned Around On THEM !! This is Beyond Words !!.mp4", "@The Entire System CRASHED Mid Project...I am Rerecording immediately...... This is the PROOF We Are at the END.." ],
["220926",      "6.2.0.0", "2435.01|239 MB",  "", "2022",  "220926 Just Watch the BOW Be Made Naked and Remember the Vatican is a SERPENT aka SATAN who Inverted US.mp4", "@The Time of Trouble is Upon the Whole World.. The Israeli Prime Minister is set for a 2 STATE Solution ...Perfect Manifestation in the END..The Bow is Now Visible and THEY are NAKED"],
["220927",      "4.3.0.0", "162.38|27.0 MB",  "", "2022",  "220927 Mission Impossible ACCOMPLISHED.. Thank you Eli.mp4", '@Eli sent this as a "Just encouragement" video and the TIMING was enough for me to simply THANK GOD for the Perfectly Timed encouragement while I Sat there Crying./...Thank You Jesus and Thank You Eli' ],
["220928",      "6.3.2.0", "4427.12|394 MB",  "", "2022",  "220928 MY LORD Have Mercy on This World.. Prepare Our Hearts for What Is IMMINENT. The End Is EASY to SEE.mp4", "@The End is easy to see now for Sure and the opposition has shown their Hateful TRUE Nature.. Time to call Evil Evil" ],
["220929",      "6.3.0.0", "3652.06|433 MB",  "", "2022",  "220929 BUSTED! COMPLETELY NAKED !! Absolutely Naked as Adam and EVE.. This is WORLD Changing. KING'S Coming.mp4", "@The Scriptures are Prefect and the Gift is a Confirming Witness to the Word.. The Bible says \"every tongue that shall rise against thee in judgment thou shalt condemn. This is the heritage of the servants of the Lord, and their righteousness is of me, saith the Lord.\"<br>The Evidence SPEAKS For Itself...The Virgin = A DEAD SHEEP.....End of Story... <br>16 When I heard, my belly trembled; my lips quivered at the voice: rottenness entered into my bones, and I trembled in myself, that I might rest in the day of trouble: when he cometh up unto the people, he will invade them with his troops.<br><br>17 Although the fig tree shall not blossom, neither shall fruit be in the vines; the labour of the olive shall fail, and the fields shall yield no meat; the flock shall be cut off from the fold, and there shall be no herd in the stalls:<br><br>18 Yet I will rejoice in the Lord, I will joy in the God of my salvation.<br><br>19 The Lord God is my strength, and he will make my feet like hinds' feet, and he will make me to walk upon mine high places. To the chief singer on my stringed instruments." ],
["221001",      "6.2.0.0", "8652.1|647 MB",  "", "2022",  "221001 Let US Go UP.. Out Of The Land of EGYPT- WOW , The TRUTH is SELF-SUSTAINING and Never Fails.mp4", "@This was very edifying for me just to look over the shoulder" ],
["221004",      "2.0.0.0", "2642.01|284 MB",  "", "2022",  "221004 1st the UNVEILING aka Apocalypse (Already Done ) - 2nd ARMAGEDDON aka End of the World (AT THE DOOR).mp4", "@The Time is Staring you in the face ... No way to escape the reality os where we are in the timeline//" ],
["221005",      "2.0.2.0", "3577.06|414 MB",  "", "2022",  "221005 You Decide! On The Money or Not Assimilated to Satan Assimilated to The Almighty! U Decide.mp4", "@This is as Obvious as it can be presented, The Mystery of the Origin of Everything is in View,,, The Treasure just keeps Rolling Out!! All Glory to El the Almighty GOD!!!!!!" ],
["221006",      "2.0.0.0", "3673.05|268 MB",  "", "2022",  "221006 Imagine that WE were ( completely Caught ) Made Naked.. We WERE !! Now IMAGINE (THEY) ARE ! THEY ARE.mp4", "@The Enemy has been made naked and They are In the Snare They made for us....." ],

["221007",      "2.0.2.0", "5174.06|608 MB",  "", "2022",  "221007 Start at 12 Minutes to (SEE) ABSOLUTE PROOF Of The EXISTENCE Of The ALMIGHTY CREATOR  US and THEM.mp4", "@This Video CUTS the Fabric of the  Illusion that all humanity has lived under..The Nakedness of Our ENEMY is the Most Apparent and MOST PROFOUND REVELATION of OUR Lifetime.. This Disclosure is Beyond the Human brain and the Perfection is beyond Orchestration by any Human" ],
["221009",      "2.0.0.0", "7239.01|1.13 GB",  "", "2022",  "221009 THEY ARE NOW ((((((((((( NAKED )))))))))))) The Vision awaits an appointed Time.. The TIME is NOW !!.mp4", "@This Video Changes the World For EVER...All Glory to the Lord GOD" ],
	
// cap 1
["221014",   "1.2.0.0", "354.01|84.2 MB", "", "2022",  "221014 Heads UP!!!! LOTSA Lunatics.. Be careful.. Working with Dave the Wave to get a Barn Burner Video out.mp4", "@Staying in touch while I'm working on the Next video...Time to Let the Evidence Speak for Itself...." ],
["221016",   "1.2.0.0", "7289.02|1.41 GB","", "2022",  "221016 The lady doth protest too much, methinks is a PERFECT way to Describe the obvious weird behaviour.mp4", "@It is commonly used to imply that someone who denies something very strongly is hiding the truth;<br>The wrath of God is being revealed from heaven against all the godlessness and wickedness of men who suppress the truth by their wickedness." ],
["221019-01","1.2.2.0", "453.02|53.8 MB", "", "2022",  "221019-01 The Lords Sending Me On An Errand.mp4" ],
["221019-02","1.2.0.0", "437.02|111 MB",  "", "2022",  "221019-02 CRAZY How There seems to BE an OPPOSITION Force to getting THIS Video Out!!!!! The King Is COMING.mp4", "@the King is Coming ..Working on this delivery" ],
["221019-03","1.4.2.0", "5451|959 MB",    "", "2022",  "221019-03 Could There Be ANY Other Message Watch the Entire Video and ask Yourself. Is This Even POSSIBLE.mp4", "@What is Impossible with man is MORE Than Possible with GOD.. Again, I will let the Record SPEAK for ITSELF... The Duration Proves the Validity and there could be no explanation but the Obvious.. The Enemy is Naked and the KING Is COMING...." ],
["221021",   "1.2.0.0", "896.01|103 MB",  "", "2022",  "221021 Angel to Scorpion Mosaic...Friend being Rushed to the Hospital... Gonna Keep Working.mp4", "@A friend on mine called in tears because his common law wife is being rushed to the hospital. I was starting a video then ran into MORE tech attacks..." ],
["221022",   "1.2.0.0", "4530|650 MB",    "", "2022",  "221022 EL, The ALMIGHTY GOD is COMING!! To Know the WORD ( IS ) to KNOW HIM.. Do Not Be DECEIVED. Be READY!.mp4", "@The Reason many people do not endure is because they do Not Love the Word and What the WORD Says... The WORD of GOD Is WITHOUT Error and is Stupefying to read and see and comprehend the PERFECTION.. The Posers will ALWAYS be POSERS ...They Started the Place..VAIN SHEW" ],
["221023",   "1.4.0.0", "3569.02|591 MB",  "", "2022",  "221023 ISAIAH 61 shows Us the Ministry, AND The RESOLUTION .. This is PURE GOLD. Sorry about the ENDING....mp4", "@The Equipment was attacked AGAIN Toward the end of the Video but I'm Posting it as is....." ],
["221026",   "2.0.0.0", "3480.02|758 MB",  "", "2022",  "221026 Time for confession! Do NOT Let THIS Happen to You. Jesus said If they hated me, They WILL Hate You.mp4", "@Do NOT Take the Bait..The Time is Too Close.. Being unjustly accused is just a TRAP.. Watch Out, the Record Always speaks for itself. Pray for your Enemies, the More they hate you the more you pray for them.The TIME Is too close" ],
["221028",   "6.0.0.0", "444.01|83.7 MB",  "", "2022",  "221028 Twitter is a New Way to see what was Taken Down...Don't want to Miss That!! Your Mind will be BLOWN.mp4", "@So it Appears there is a Free Speech Platform, so Let's hit it immediately.. No Time to waste in view of what is Taking place in today's Insane World View..... I will be posting another video hopefully by the time the sun Rises ... Please Join Us on Twitter.. Jonathan's videos can also be found on these venues:<br>Odysee (new channel):  https://odysee.com/@CoryBarbee:8<br>Odysee (old channel):  https://odysee.com/@thejonathankleck:b<br>Brighteon (new channel, Cory Barbee):  https://www.brighteon.com/channels/eebrabyroc<br>Brighteon (old channel):  https://www.brighteon.com/channels/thejonathankleck<br>BitChute: https://www.bitchute.com/channel/thejonathankleck/<br>Internet Archive:  https://archive.org/details/@daveshadow71<br>KleckFiles: http://www.kleckfiles.com<br>Jonathan Kleck's video archives: https://tinyurl.com/2d8d2j8n" ],
["221029",   "6.1.2.0", "4732.02|658 MB",  "", "2022",  "221029 NOW! RIGHT NOW Is the Time To SEE What You MUST SEE. If This Is TRUE and THESE ARE FACTS. What NEXT.mp4", "@I'll Tell you what's next.. The End of the World as you Know it.. The Writing is All Over the Wall and there is No More Running from the TRUTH. We are ALL About to DIE" ],
["221030-01",   "2.0.2.0", "865.01|128 MB",  "", "2022",  "221030-01 Food Processing Plants Mysteriously burning up WHAT-S Next Oil Refineries Going up Flames Yep.mp4", "@It is very apparent there is a force behind the Unnatural Number of Coincidences concerning food supply ...Now OIL ?? Yeah OK ??  What's Next ? A nuke mysteriously printed on the 10 dollar bill ACTUALLY Happening !!?? Looks That Way" ],
["221030-02",   "2.0.0.0", "2147.01|344 MB",  "", "2022",  "221030-02 Blow the TRUMPET in ZION....It Just Sounds Right!! Hmmmmm.mp4", "@Just watching things Manifest" ],
["221030-03",   "2.0.0.0", "525|82.2 MB",  "", "2022",  "221030-03 LOOOOOOK How RELEVANT This Is Now!!!!! The REALITY Has Set In...The END of the WORLD IS HERE !!!!.mp4", "@The Data Speaks for Itself" ],
["221030-04",   "2.0.2.0", "2098.02|277 MB",  "", "2022",  "221030-04 Why do Austin Police Cars have a SERPENT Being on the Vehicle Maybe because It-s the TRUTH.mp4", "@It is ALL becoming Toooooo Obvious" ],
["221102",   "1.1.0.0", "371.01|73.0 MB",  "", "2022",  "221102 YOU Almost Won't Believe What's been Delivered ...Coming manana !!!!!.mp4", "@The Lord Just PUT A Confirmation that EVERYONE following this ministry should should receive as one of the greatest confirmations you could ever get to KNOW Your Salvation IS SECURE" ],
["221105",   "1.2.0.0", "5349.02|732 MB",  "", "2022",  "221105 HERE IT IS !!!!! The RECORD That was (DOWN)and (COVERTLY) Our ENEMY aka OPPONNENT is MADE NAKED !!.mp4", "@It is Time to RECOGNIZE The Reality of the Perfection of the Word HAS Manifested and NOW BEARS RECORD to the TRUTH.....  As Don Meridith used to say ..turn out the lights the party's Over!! Satan's reign is beginning and that means the End is Arriving and Jesus is Coming!! Faith is Essential to continue,,,,, and Knowing the TRUTH will sustain you..." ],
["221107",   "1.3.2.0", "6077.01|889 MB",  "", "2022",  "221107 THIS Is PAST CONCLUSIVE!!! Every Kingdom Divided (AGAINST ) -Down- Itself, Is Brought to DESOLATION.mp4", "@100% NOLYN _ This is Beyond Proven Now!!!!!_ The KINGDOM Divided is the EARTH and the MALE Energy is Contrary to FEMALE .. There are Some Serious Horrifying Realities for those who have set themselves AGAINST The TRUTH.. The BIBLE Declares the Absolute TRUTH of the WORD and The LORD GOD Whom I Serve Has Made an Open SHEW Of the Principalities through the Presentation of the Mystery that was hidden from our Sight.. The MYSTERY is Solved and the Hidden Enemy is Now Naked and Exposed. The Time of the LORD GOD'S VENGEANCE Upon the Inhabitants of the EARTH has Made Itself Manifest as well. The Time of the FEMALE Rival is Here......Prepare the way of the LORD." ],
["221110",   "1.4.0.0", "1491.02|250 MB",  "", "2022",  "221110 Intro to NEW SCRIPTURE BOMBS!! This is Beyond Priceless.. WE are being Gathered Out of THEIR SNARE.mp4", "@This is an Intro and Checking equipment" ],
["221111",   "1.4.0.0", "4961.01|740 MB",  "", "2022",  "221111 Part 2- WE Are Being Gathered Out of their Snare-The HUNTER has Become the HUNTED -PREPARE The WAY.mp4", "@NOW WE KNOW Why The SYSTEM and HELL are REFERRED to as (((( HER )))<br>The Time of (((((((((((((((((((((((((( HER )))))))))))))))))))))) Judgement has Come...Hell hath Enlarged (((((((((((((((((((((( HERSELF))))))))))))))))) beyond measure......... ((((((((((((( She ))))))))))))) Brewed a Cup of TERROR for ((MY)) People.. ... The (((((((((((((((( WOMAN )))))))))))) That Rides the BEAST,,, and NOW (((((((((((((((((((( She ))))))))))))))))) is BUSTED" ]	
	
	
// normally capped here online
];

var KleckFiles_new = // Beyond capped -- Normaly hidden online
[
	
["221112",   "6.0.2.0", "1550|256 MB",  "", "2022",  "221112 I'm Overwhelmed. WE are His Witnesses. The Bible declares what I Have Testified to.. 100NoLYN.mp4", '@The Warning - "REVENANT" (Official Lyric Video) - https://youtu.be/bTzjJNgAlTk<br>Level up brings in a Whole new meaning' ],
["221113",   "6.1.0.0", "5024.01|874 MB",  "", "2022",  "221113 YOU Are My Witnesses-REDUPLICATED PRINCES - The Time is Fulfilled Level Up_ The QUEEN is Naked, Done.mp4", "@This was fun to see" ],
["221115-01","6.0.0.0", "1044.02|172 MB",  "", "2022",  "221115-01 Time Is Fulfilled.. Leveled UP.....mp4", "@Something BIG is about to Happen<br>Here is the link: https://www.youtube.com/watch?v=dsp48tKTaTk" ],
["221115-02","6.0.0.0", "331|41.8 MB",  "", "2022",  "221115-02 Its' a SERPENT WORLD ====WAKE _((((((( UP ))))))).mp4", "@WAKE UP!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" ],
["221115-03","7.1.0.0", "117.54|4.88 MB",  "", "2022",  "221115-03 SHORT VERSION - VATICAN POPE - PRIESTS DECLARE LUCIFER AS GOD compilation - 11.14.22.mp4", "@6 priests singing to Lucifer" ],
["221123-01","2.1.0.0", "508.01|107 MB",  "", "2022",  "221123-01 Does he not leave the ninety and nine in the wilderness, and go after that which is lost, CROSSOADS.mp4", "@The Crossroad is Directly ahead" ],
["221123-02","2.1.0.0", "5127.01|784 MB",  "", "2022",  "221123-02 ONLY The LORD GOD Could Orchestrate THIS - 1967. epiousios is BEYOND a MIRACLE !! TIME'S UP-Look UP.mp4", "@For the Lord to do a LIVE Miracle that Intersects the Night I got Saved by Using (( 1967 - epiousios )) while Looking at the Painting by Melvin Warren when He communicated that I was The Chief watchman for this generation, Is ALMOST Too Much to Even try to Explain to the World" ],
["221125",   "2.2.0.0", "561.02|92.0 MB",  "", "2022",  "221125 IT'S ((((((((((((((((((((((((((((( ALL ))))))))))))))))))))))))))))))) Been a MIRACLE.mp4", "@you saw it!!Here is a Follow up documentation from the other night...." ],
["221126",   "2.3.2.0", "1428|171 MB",  "", "2022",  "221126 NOW Can You See !! It is a Double ( U )Twin System. Right in front of your Face. Twin Towers and ALL.mp4", "@One eye Takes OVER the OTHER ...Down takes over UP...East takes over West....I will arise ABOVE the STARS of EL the almighty GOD....System completely Busted .......SERPENTS Take Over SHEEP" ],
["221127",   "2.2.3.0", "3121.02|446 MB",  "", "2022",  "221127 New York Now You Decide...What are the Odds.mp4", "@https://youtu.be/vUV7BAXyJUk - Look at the REFLECTION of the Jerusalem Army" ],
["221201",   "2.2.2.0", "7905|1.30 GB",  "", "2022",  "221201 Is NEW YORK Going UNDER Are the Events Described Here even Possible for ONE Person to Witness NO-.mp4", "@This is a description of events that I MUST bear witness to.. The Other events( such a Chinati and Grand Junction ) SPEAK For themselves. This WILL Speak For Itself as well. I Must Bear Witness or Break Faith...I WILL BEAR WITNESS... THE KING IS COMING !! The Beginning of the END Is Here.. Prepare the WAY of the LORD.." ],
["221205",   "2.2.2.0", "4572.06|703 MB",  "", "2022",  "221205 Win The WAR on X-MAS Hmmm.. Secret Agenda Hmmm.. Nuke - Tsunami Printed on U.S. Currency Hmmmmm.mp4", '@The Arrogance gives it away!! Lightning from Heaven?? I\'m sure THAT"s Possible considering ALL the Other evidence !! LOLLOLOLOLOL!! Soooo Busted it is a Joke!! Well I KNOW What the Word Says...<br>" 10 And the devil that deceived them was cast into the lake of fire and brimstone, where the beast and the false prophet are, and shall be tormented day and night for ever and ever."' ],
["221207",   "2.2.2.0", "2034.02|281 MB",  "", "2022",  "221207 Prince of DARKNESS --FULLY EXPOSED -- VISABLE__ SEE 4 Yourself, Get Ready NYC Tsunami Coming Soon !!.mp4", "@WOW!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! If It is not REAL then WHY HIDE IT ?? Busted" ],
["221217",   "4.0.0.0", "279.01|29.5 MB",  "", "2022",  "221217 The Writing is ON the WALL.. (((( BOMBSHELL )))) Revelations And (((WORLD CHANGING ))) SCRIPTURE.mp4", "@I Just got Off of suspension .But here comes a WORLD_CHANGER !!" ],
["221218-01","4.0.0.0", "988.01|179 MB",   "", "2022",  "221218-01 Getting EVERYTHING READY !! Check Out the Beanies!! Video coming TONIGHT !!!!!!!.mp4", "@Make sure to subscribe and like. If you would like contact me or make an order please email me @ happyhippycrochet6764@gmail.com <br>https://www.paypal.me/thawkins4767<br><br>Check out and subscribe to:<br>Jonathan Kleck <br>https://youtube.com/c/CoryBarbee<br><br>Get your Beanies Please...I Forgot to run this a week ago.... Please support the Beanie makers.. They just need a little work to help with bills..Thanks and see you tonight" ],
["221218-02","4.0.0.0", "107.02|19.2 MB",  "", "2022",  "221218-02 Had to leave on an Emergency,,,Video tomorrow God willing.mp4", "@Susie needs Prayer<br>Listen to Prophetic Utterance: https://youtu.be/oNpvVB-vRwY?t=308<br>Watch wormhole video: https://youtu.be/uOJCS1W1uzg" ],
["221219",   "4.2.0.0", "2592.02|331 MB",  "", "2022",  "221219 The BIRTH of OUR New Jerusalem -- The Miracle and the Scriptures Speak for Themselves.. Coming Soon.mp4", "@The Prophetic Utterance speaks for itself.. The Scriptures speak for themselves.; The Evidence Speaks for itself" ],
["221220",   "4.0.0.0", "95.02|17.3 MB",   "", "2022",  "221220 here we go again!! I will not quit trying to get this out.mp4", "@going out" ],
["221221",   "4.2.0.0", "5619.02|822 MB",  "", "2022",  "221221 The RAPTURE !! The REALITY and PERCEPTABILITY.. The ROCK ..The TRUTH.. Never ENDING Peace.mp4", "@How does Anyone Give a description to This ?? SUPERNATURAL,  SUPERNATURAL,  SUPERNATURAL,  SUPERNATURAL, SUPERNATURAL" ],
["221222",   "4.2.2.0", "2569.01|261 MB",  "", "2022",  "221222 All Aboard! Are you READY!! Eyes Made SINGLE!! Must WATCH!! The Door Will Open and those READY-LEAVE.mp4", "@This is the short version of the previous video" ],
["221223",   "4.3.2.0", "2603|455 MB",     "", "2022",  "221223 Again!!!--- Billow (as a bursting or toppling) WAVE!! -- Luke 21-18 LOOOOOOOOOK UP !! Impossible.mp4", "@This is Soooooooooooooooooooooooo Encouraging...Jesus IS Coming !! This just adds to the Ever Increasing List of Miracles" ],
["221224",   "2.0.0.0", "1298.02|225 MB",  "", "2022",  "221224 Do This in Remembrance of Me..... Jesus ALONE accomplished Your Salvation.. Let Us Remember.mp4", "@Communion Video" ],
["221225",   "2.0.0.0", "4919.02|395 MB",  "", "2022",  "221225 Sitting by the Fire BLOWING ALL The Shofar's.. He is Coming !!Just hanging out with the Family -YOU!.mp4", "@we are ONE" ],
["221226",   "2.1.2.0", "1344.06|223 MB",  "", "2022",  "221226 22;41 aletheuo and 22;41 The End of the World!! Just WATCH!!!!!!!.mp4", "@Unbelievable !!!!!" ],
["221230",   "2.0.0.0", "382.01|49.9 MB",  "", "2022",  "221230 tomorrow.mp4", "@c u" ],
["221231",   "2.1.0.0", "2640.02|512 MB",  "", "2022",  "221231 New Beginning!! Coming 4 SURE.mp4", "@the king is coming" ],

["230105",   "2.0.0.0", "331|38.3 MB",  "", "2023",  "230105 Heads Up for the PatheticTROLL -- There will be Weeping and the Gnashing of Teeth.mp4", "@There is a Troll, Please be careful not to pass out info" ],
["230106",   "2.1.0.0", "2669.02|420 MB",  "", "2023",  "230106 The Coming Race and The OBVIOUS Connections.mp4", "@http://www.kleckfiles.com/?140310 - Anti-Christ UNVEILED The Sun Rising in the West<br>https://youtu.be/PFfY6_hcfxk - Arpaio: Obama's birth certificate a phony<br>Glad to be feeing better" ],
["230109",   "2.1.0.0", "4288.01|641 MB",  "", "2023",  "230109 Johnnye Tsunami and the Temple Destroyers !! Get your ticket so you DON'T Have to Go to the Show!!!!.mp4", "@The writing is on the Wall and the Serpent race is progressing.. The End is Coming" ],
["230112",   "2.1.0.0", "4316.01|690 MB",  "", "2023",  "230112 The REALITY Is, WE Sinned against the Most High and We were SHUT-Up In Prison Houses (Divers SEEDS).mp4", "@Now WE ARE THE TEMPLES OF TRUTH. The TRUTH LIVES IN US and it has been proven by the WORD. Those that try to Maliciously attack us ARE the OTHER seed.. Hate is their Calling Card and is EASY to SEE. They are caught and Now comes the Judgement of the World and those that are OF the World..... End of Stroy" ],
["230113",   "2.3.0.0", "458.41|153 MB",  "", "2023",  "230113 PARTHENOGENESIS MICHELLE 2.mp4", "@older banned video" ],
["230114",   "2.1.0.0", "6132.02|783 MB",  "", "2023",  "230114 Crevice of a serpent ! WOW --This is ALL so Perfect it is Frightening ! The TRUTH is Self-Sustaining.mp4", "@The LORD Never fails His people..... ALL GLORY TO THE KING Of KINGS" ],
["230115",   "2.3.0.0", "7533.02|1.15 GB", "", "2023",  "230115 The PICTURE Is COMPLETELY CLEAR & PROVEN. This is MORE of a Science Fiction Reality than WE IMAGINED.mp4", "@Buckle you boots because we are getting in DeeeeeeeeeeeeeeeeeeeeeeP This is beyond our minds to see and comprehend" ],
["230117",   "2.2.0.0", "4710.01|570 MB",  "", "2023",  "230117 The REALITY is Taking Hold.. Just Imagine, The END of The SERPENT Race.. Talk about Triggered.mp4", "@It is Tooooooo Obvious to ignore from ANY Perspective" ],

["230118-01","4.0.0.0", "84.01|7.67 MB",  "", "2023",  "230118-01 Game Over-- SERPENT Race Busted in less than 2 Minutes.mp4", "@done" ],
["230118-02","4.0.0.0", "843|76.3 MB",  "", "2023",  "230118-02 Blitzkrieg.....Time to Throw it ALL at them at Once.mp4", "@Twitter storm brewing !!" ],
["230120",   "4.0.2.0", "1235.02|176 MB",  "", "2023",  "230120 6 and 9 AGAIN .. right-side up - upside-down This is STUPID Obvious.mp4", "@getting ready for a new drop" ],
["230121",   "4.0.0.0", "2058.01|365 MB",  "", "2023",  "230121 Production Altercations Again!! MUST MUST Watch.. Time to Reconvene at ODYSEE.mp4", "@The Serpent Race is on their way to Total World Domination... What should YOU Do ????? Make Sure you watch these videos and get your Spiritual House in Order<br>https://tinyurl.com/jkshownotes" ],
["230122-01","4.0.2.0", "357.01|42.2 MB",  "", "2023",  "230122-01 Here We GO !!!!! Ill just refer to the Issue at Hand as Challenges to Overcome - On the Rock-.mp4", "@Working around the challenges with the Lord's Help" ],

["230122-02","6.1.0.0", "5419|1.27 GB", "", "2023",  "230122-02 The Serpent Sheep Slaughter.mp4", "@This video ties together the covid vaccine with the Vaticans roll in the destuction of God's children (the sheep). The serpent race destroys the sheep race. The final solution, same as the Jews." ],
["230123-01","6.1.2.0", "4343.02|1.21 GB",  "", "2023",  "230123-01 The serpentsheep slaughter part 2.mp4", "@This is a continuation from yesterdays video" ],
["230123-02","6.0.2.0", "1031.06|175 MB",  "", "2023",  "230123-02 Join Me for the Veil Being Torn Down.mp4", "@https://odysee.com/@CoryBarbee:8/Recording--88:b<br>Continuation of Yesterday<br>Could it Be any MORE OBVIOUS ??" ],
["230123-03","6.0.2.0", "762.06|102 MB",  "", "2023",  "230123-03 Watch these commercials... Are they selling something OR are they ALL pointing to the SAME AGENDA.mp4", "@The GIGS ((((( UP ))))) Brood of Vipers are in Plain View" ],
["230126",   "6.1.2.0", "5415.01|566 MB",  "", "2023",  "230126 TSUNAMI NUKES Serpents Killing Sheep Over and Over Again Giant BUG ALTERS It-s ALL Coming.mp4", "@Just get into the video" ],
["230127-01","6.1.2.0", "752|97.7 MB",  "", "2023",  "230127-01 Tsunami Nuke Watch This.mp4", "@If it Happened before ( Did it ?) Will it Happen Again soon ?? You be the Judge" ],
["230127-02","6.1.2.0", "689.01|105 MB",  "", "2023",  "230127-02 Lots and Lots of Tanks ! What would Yoy do if You were Putin sitting on the biggest nuclear arsenal.mp4", "@Many countries are NOW sending Tanks" ],
["230128-01","6.0.2.0", "124.02|10.3 MB",  "", "2023",  "230128-01 Shadow Ban on Twitter - Do you Know How CRAZY That IS Make Sure You Watch the ABSOLUTE TAKEDOWN.mp4", "@coming in a few hours" ],
["230128-02","6.2.2.0", "6461.02|1.42 GB",  "", "2023",  "230128-02 SEPENT SHEEP SLAUGHTER This wouldn't be believable without all this data, now its proven.mp4", "@This video cuts tot the chase of the current scamdemic and the coming mark of the beast." ],
["230129",   "6.0.0.0", "312.08|13.6 MB",  "", "2023",  "230129 This Is CRAZZEEEEEE.. Twitter Hiding the Videos.mp4", "@Just watch" ],
	
["230130-01",   "7.1.0.0", "1545.01|204 MB",  "", "2023",  "230130-01 Statue In New York is MORE Significant than ANYONE Realized. The End Is Come. Dead Sheep Mask OFF!!.mp4", "@I warned the World and NOW THEY ARE HERE.. Society is Crumbling and the AC Spirit is in full swing" ],
["230130-02",   "7.1.2.0", "1242.01|160 MB",  "", "2023",  "230130-02 ALERT UKRAINE Begins DIGITAL Currency.. WEF Pitches DIIA. Did You KNOW DIIA Means GODS.mp4", "@The writing is on the wall .. The Obvious is NOW The Realty.. Transworld Airlines Has arrived !!!" ],
["230131",   "7.1.0.0", "597.01|113 MB",  "", "2023",  "230131 Descendant of a Foreign Helper!! This WAS Impossible. TIME To Revisit the Reality of LIFE or DEATH!.mp4", "@This Just Came across my desk again!! Unbelievable" ],
["230201",   "7.0.0.0", "695.07|67.2 MB",  "", "2023",  "230201 I am Freeeeeeeeeaaking Out!!!! Working on Delivering the Communication and Confirmation.He's COMING!.mp4", "@My Mind Is BLOWN...No Other way to Interpret this ....He is Coming" ],
["230203",   "7.2.0.0", "1730|258 MB",  "", "2023",  "230203 Biden Announces WW3 without even realizing it.. Make NO Mistake. Tanks and Planes to Ukraine IS WW3.mp4", "@Hear It from the Mouth of the Sell-out that said it" ],
["230204",   "7.2.2.0", "3615.02|514 MB",  "", "2023",  "230204 Biden SaysMake No Mistake- Sending Tanks would MEAN WW3 He Forgot He said it- He was GASLIGHTING U.mp4", "@This Is STUPID OBVIOUS" ],
["230206",   "7.2.0.0", "3428.01|476 MB",  "", "2023",  "230206 The ( FINAL SOLUTION ) for the Sheep Is WAY Way WAY Past Obvious _NOW_ Watch THIS ASAP-Get Ready.mp4", "@The Next Video Will Sum It ALL UP ....The SERPENT RACE IS CAUGHT" ],
["230207",   "7.3.0.0", "4321|599 MB",  "", "2023",  "230207 This VIDEO Is Past INSANE !! Must watch the WHOLE Vid, SEE The MIRACLE at the END- Sophies Choice.mp4", "@This Video has a Live Miracle when you see the Plot and Manifestation of the Current World Nonsense serpent sheeeeep slaughter" ],
["230208",   "7.3.2.0", "4189.02|554 MB",  "", "2023",  "230208 Vision So Clear It-s Frightening-SOPHIE-S Choice- Brought to You By The SAME Sponsor as The Grammy-s.mp4", "@Just Watch the whole thing" ],

["230210",   "8.1.0.0", "589.02|63.4 MB",  "0hq-wQrcGj8", "2023",  "230210 HEADS UP!!.mp4", "@This will SHOW YOU WHAT IS GOING ON AND WHERE TO GO.." ],
["230211-01",   "8.1.0.0", "3691.02|1.77 GB",  "", "2023",  "230211-01 When you know the end of all flesh has come, YOU KNOW! Here it comes.mp4", "@This is what we need to talk about. It's all that matters that you understand this." ],
["230211-02",   "8.1.0.0", "990.01|170 MB",  "zoU4sY1pnIc", "2023",  "230211-02 The END of the HOST Body, as we Know It- IS HERE.. They Have Proclaimed it.mp4", "@here comes the end. please pay attention and Download ALL the Folder info" ],
["230212-01",   "8.2.0.0", "5085.02|1.54 GB",  "", "2023",  "230212-01 The (( END )) of the Host Body as we know it! The time of FEMALE RIVAL!.mp4", "@The Book of Daniel say there will be a time of trouble (( FEMALE RIVAL ))... the GREAT Tribulation IS the Time of the FEMALE RIVAL and That Time Has Arrived!! This is part 1 leading up to the Placing of the GOLD FEMALE Statue o ntop of the NYC Courthouse.. The Time of Her Judgement" ],
["230212-02","8.2.0.0", "1246.01|167 MB",  "xkphc0BsILk", "2023",  "230212-02 UNBELIEVEABLE!! THEY Just Manifested Everything The Lords Let Me Teach You!.mp4", "@Odysee link (230212-01): https://odysee.com/@CoryBarbee:8/Recording-111:6<br>Absolute (( MUST WATCH ))" ],
["230213",   "8.2.0.0", "2232.18|287 MB",  "e7cPzOnbByY", "2023",  "230213 The RAPTURE When WORLDS Collide.mp4", "@The writing is on the wall. AKA right on your TV set. Do you have eyes to see and ears to hear?" ],
["230214",   "8.1.0.0", "149.07|7.87 MB",  "bYZqubctYyQ", "2023",  "230214 AKIMBO POWER position and Judgement -coming soon.mp4", "@working on it!!" ],
["230215",   "8.2.2.0", "959.01|138 MB",  "qGgxrDZ_lPI", "2023",  "230215 LOCK Your Doors!! Read between the Line. This Just Validates even More the Upcoming NY Courthouse.mp4", "@he comes out and tells you without telling you" ],

["230216-01",   "8.2.2.0", "819.01|105 MB",  "", "2023",  "230216-01 Wanna See a Miracle ! There is a (( Lets get on the same mental page )) video coming tonight.mp4", "@King is coming" ],
["230216-02",   "8.2.0.0", "5746.01|916 MB", "", "2023",  "230216-02 Getting the mental stage set !!! Join me in some testimonies.mp4", "@just wanting to CONNECT with you spiritually..Let's hang out and get ready" ],

["230218",   "4.3.0.0", "8715.02|3.00 GB",  "", "2023",  "230218 If You Want To UNDERSTAND The End of The WORLD, UNDERSTAND THIS!!!!.mp4", "@This shows the end of the human host body system in their language" ],
["230219",   "4.2.0.0", "657.01|128 MB",    "", "2023",  "230219 Big APPLE Courthouse TELEGRAPHS End of the WORLD.. HAVA At The Courthouse.mp4", "@watch the video on the other platforms" ],
["230220",   "4.3.0.0", "5999.02|1.86 GB",  "", "2023",  "230220 THIS IS IT HERE IT COMES.mp4" ],
	
["230224-01","9.0.0.0", "716.06|105 MB",  "", "2023",  "230224-01 We MUST Revisit the Past to KNOW The Future...Coming SOON.mp4", "@https://odysee.com/@CoryBarbee:8/Recording--123:f<br>Remember the Sun Rising in the WEST Vid ??" ],
["230224-02","9.1.0.0", "3228|855 MB",    "", "2023",  "230224-02 Anti-Christ unveiled the Sun Rising From the Place of its Setting.mp4", "@The evidence speaks for its self."],
["230226",   "9.1.2.0", "4084.06|313 MB",  "", "2023",  "230226 Akhenaten AGENDA is TODAYs AGENDA, Must see Sequel.mp4", "@The End of the Wondering about the meaning of Life...It is here" ],
["230227",   "9.0.0.0", "187.06|33.7 MB",  "", "2023",  "230227 THEY Do NOT Want This Out! Working to Produce video on Other Platform. It's a struggle in many ways.mp4", "@I'M NOT Stopping stay tuned" ],
["230228-01","9.0.0.0", "104.05|21.1 MB",  "", "2023",  "230228-01 Still at it.mp4", "@keep an eye on the channel" ],
["230228-02","9.0.0.0", "113.08|1.92 MB",  "", "2023",  "230228-02 Happened AGAIN!! WOW!!.mp4", "@Frustration sets in" ],
["230228-03","9.1.2.0", "4814.05|338 MB",  "", "2023",  "230228-03 why-is-it-insects-and-insects.mp4", "@It is ALL too obvious now" ],
["230303",   "9.2.0.3", "5482.02|1.01 GB",  "XNrtc7695YE", "2023",  "230303 THE SWORD ( X ) Coming on The ELDER TWIN of JACOB! Beyond Impossible! Almost Beyond Conveying. Watch.mp4", "@To understand this you would have to KNOW the Reality of the Twin System.. This is V4 Vengeance on steroids" ],

["230304",   "7.1.2.1", "2414.02|459 MB",  "OYz67rqUFHY", "2023",  "230304 Beyond a Miracle!! An OPEN Door of Communication as Prophesied in Revelation 3-8 - New Jerusalem NOW.mp4", "@This is irrefutable proof of the TRUTH of the ONE that I serve. The Testimony Speaks for itself as does ALL the EVIDENCE" ],
["230309",   "7.2.2.1", "1498.01|244 MB",  "UbG-5jbGJu4", "2023",  "230309 Non-stop Miracles!! The TIME of Judgement is NOW.. Just sharing as I received it. Ready or Not.mp4", "@Trying to get the record out against the Wiles of the Enemy" ],
["230310",   "7.2.0.1", "3058.02|439 MB",  "9DT6ZbrqO6g", "2023",  "230310 COMPLETELY Impossible !! There's Only US, There is No THEM !! Take it from the TOP. The Eventuality.mp4", "@There is No way to be able to PLUG what was plugged here without Knowing the time was arriving" ],
["230311",   "7.2.0.1", "2266.01|235 MB",  "rIX9un1C9Ig", "2023",  "230311 STUPID OBVIOUS a this point. Everything secret will be made public.. WE ARE TRAPPED Light Beings !!.mp4", "@This will frame up Chinati and the miracles to come" ],
["230312",   "7.3.0.1", "2639.02|476 MB",  "X3fgB6MohFQ", "2023",  "230312 2am and STILL TRYING !!! LOL.. This is getting good !! The End is coming. I think A.I. No Likey Me !.mp4", "@just Wow!! What IS GOING ON ? lol" ],
["230315",   "7.3.0.1", "2048.02|346 MB",  "3BuCB6rL1xE", "2023",  "230315 To Strip Off !! This will Intersect Chinatti AND Black Rock. Video coming after this.. Please watch.mp4", "@As prophesied .. The Stripping Off is Coming , Please stay tuned for the video Coming Tonight.." ],
["230316",   "7.4.2.1", "9368.02|1.35 GB",  "xu5upkzWEn8", "2023",  "230316 The Second the Video Finished 236, the Lord said look up 236, ( we will be changed.) ODDS !! ZERO!.mp4", "@The End -- Only the Lord God could orchestrate this..... God Have Mercy on this World!!" ],
	
["230319-01","9.1.2.1", "1001.01|139 MB",  "OfCFfJtfp2s", "2023",  "230319-01 SO Easy to See, How can THEY (NOT) SEE !! The Serpent Race is becoming Very VERY Visible.Part 1.mp4", "@They are the Deceivers.. They are the Nephilim  - Bullies by definition. Look" ],
["230319-02","9.1.0.1", "3772.01|454 MB",  "j3zNiVsijcQ", "2023",  "230319-02 Part 2 -The CLOAK is Gone !!. They are Manifesting because THEY Must!! In Plain Sight!! UNBELIEVABLE.mp4", "@So so easy to see them them. Here it comes !!" ],
["230322",   "9.2.0.1", "721|108 MB",  "nZY-4FPbLmw", "2023",  "230322 Tsunami of TRUTH Folder,,,It doesn't get any better.. The Time of HER Judgement Is Come.mp4", "@the Word Never Fails and the Data bears witness as do the Princes of El the Almighty god" ],
["230323-01","9.2.0.1", "6465.02|924 MB",  "", "2023",  "230323-01 The Time of HER Judgment Is Come. The TRAP They set has Become Their OWN. Now the Trap is LAID BARE!.mp4", "@The Bible told us that we would Redouble our eyes and become witnesses against the prostitute that sits on many waters,  That time has come" ],
["230323-02","9.1.0.1", "231.02|40.1 MB",  "", "2023",  "230323-02 Here is What the Serpent Queen DOESNT Want You to See.mp4", "@Link to the deleted video here. Same link in the comment section.<br>https://odysee.com/@zackwintz4414:a/the-time-of-her-judgment-is-come.-the:4" ],

["230325",   "7.4.0.1", "514.02|95.0 MB",  "dEQHr6FbepY", "2023",  "230325 Major SOUND Issues on this video But Please listen through it.. WE Must Migrate.mp4", "@https://odysee.com/@thejonathankleck:b<br>the time has come to headline other channels...Not here.. (JK posted this on Youtube)" ],
["230326",   "7.3.0.1", "388.01|74.5 MB",  "K8OdGvV11Wg", "2023",  "230326 1st upload of a deleted video.mp4", "@https://www.show-notes.net/thisistheend/index.php?/category/115<br>https://odysee.com/@thejonathankleck:b<br>Just watch and pay attention" ],
["230327",   "7.5.2.1", "9494.01|1.22 GB",  "NkBNqZWayHQ", "2023",  "230327 The STARS are Not Pure in His Sight, How Much MAN that is a (WORM) ! This PROVES AGAIN EVERYTHING!.mp4", "@The Scriptures and collateral material are PRICELESS..ABSOLUTELY PRICELESS .. WE are being Farmed by Insects,, The Word is Perfectly Clear and has remained Completely consistent. V4Vengeance.. You can say That again!!" ],

["230330",   "4.1.0.1", "2998.02|490 MB",  "Z2ZEHuVl31A", "2023",  "230330 You MUST Find the SERIAL KILLER (( BEFORE )) the Game Ends or LOSE Your Soul!! Omicron Says it ALL!!.mp4", "@Look how In your face this all is...Get ready for some Oddysee insanity /" ],
["230331-01","4.0.0.1", "2297.01|317 MB",  "3Xhs4_6mhFQ", "2023",  "230331-01 Oddysee Video on standby.. More coming soon.mp4", "@another computer down" ],
["230331-02","4.0.0.1", "187.25|13.2 MB", "BEfquTuAZIo", "2023",  "230331-02 Made in the image ((ELOHIYM )) - NOT Made in the Image of the (( LORD GOD )) CONVERSION Necessary !.mp4", "@If we were made in the Image of the Father, Son and the HOLY Ghost, then WE WOULDN'T NEED to Be Converted" ],
["230403",   "4.1.2.1", "3513.02|415 MB",  "cGg_J-5uMVc", "2023",  "230403 Extraordinary! MIRACULOUS ! God's Vengeance Confirmed! You tell me is it time to GO!! Looks Like It!.mp4", "@2 To proclaim the acceptable year of the Lord, and the day of vengeance of our God; to comfort all that mourn;<br>0 Go through, go through the gates; prepare ye the way of the people; cast up, cast up the highway; gather out the stones; lift up a standard for the people.<br><br>11 Behold, the Lord hath proclaimed unto the end of the world, Say ye to the daughter of Zion, Behold, thy salvation cometh; behold, his reward is with him, and his work before him." ],
	
["230404-01","4.1.2.1", "1023|144 MB",  "BpFmt8MsGJE", "2023",  "230404-01 The END of The LINE !! Sure Appears That Way!! Only the Lord could Orchestrate this. Passover at 7pm.mp4", "@Again, Only the Lord could Orchestrate this" ],
["230404-02","4.1.0.1", "1158|158 MB",  "S_VIurbYBfw", "2023",  "230404-02 Pass Over, Because we are Passed Over from Death, Born Into Eternal LIFE.mp4", "@Another Miraculous surprise" ],
["230404-03","4.2.0.1", "2069|553 MB",  "", "2023",  "230404-03 Antichrist Unveiled.mp4", "@Told you so.." ],
["230405",   "4.0.2.1", "214.02|28.3 MB","kF_MbDgbmRI", "2023",  "230405 From the INSIDE !! How Obvious Has it ALL Become !! Transmutation is an understatement.mp4", "@watch new video Antichrist Unveiled http://www.kleckfiles.com/?230404-03" ],

["230406",   "7.3.2.1", "2806.02|353 MB",  "rvNwFT2sThY", "2023",  "230406 INTO The LIGHT!! The Miracles Just KEEP Coming!! The Moment You've been WAITING For has ARRIVED !!!.mp4", "@The Confirmations are staggering and Impossible to discount or ignore..... The King Is Coming to Take His People" ],

["230409",   "2.0.0.1", "1998.01|249 MB",  "iqsyngN1OGE", "2023",  "230409 TRU-MAN Show !! They are completely Visible.. The Little XX Party is gonna be their Own Trap. Done.mp4", "@Confirmation after CONFIRMATION" ],
["230410",   "2.0.0.1", "2191.01|277 MB",  "20UVXAetV28", "2023",  "230410 The Deceit is EASY to SEE Now.. The Data is Not Arguable.. You can Tell EVERY TREE By Its FRUIT.mp4", "@too obvious at this point<br>See video - PARTHENOGENESIS MICHELLE 2 http://www.kleckfiles.com/index.html?230113" ],
["230412",   "2.0.2.1", "5417.01|548 MB",  "V2cpq9nhRQM", "2023",  "230412 The Language of Angels KATA-Dunesteo. The Language and Mystery Woven together- PROVE It-s OVER.mp4", "@The Obviousness of the Language proves the Lord God has Revealed to His Servant that the serpent IS taking Over the World and Our time is UP" ],
["230413",   "2.0.2.1", "2581.01|299 MB",  "pzZkhpDgtVk", "2023",  "230413 Would You BELIEVE -The Mystery of the BIBLE ..SOLVED- BELIEVE IT !!!!! The LORD GOD DELIVERED IT!!!.mp4", "@3 Blessed is he that readeth, and they that hear the words of this prophecy, and keep those things which are written therein: for the time is at hand." ],	
["230415-01","2.3.2.1", "446.01|60.2 MB",  "", "2023",  "230415-01 What the HELL is GOING On!! Just watch.mp4", "@go to the OTHER Platforms<br>http://www.kleckfiles.com/?230415-02" ],
["230415-02","2.3.2.1", "6482.02|757 MB",  "", "2023",  "230415-02 The Great and Powerful Oz Completely Exposed.. Banned From Youtube! Why!! Isn't It Obvious.mp4", "@This video shows that we are all in a false reality like the truman show. please watch it all the way through. Do you want to see the ghost in the machine? Then watch this video." ],
	
["230416",   "5.1.2.0", "915.4|183 MB",  "3jJbcLUePmk", "2023",  "230416 Here is Another Way of Communicating the Message.mp4", "@We're caught in a twin system and Jesus resolves that on the cross. <br>http://www.kleckfiles.com/" ],

["230419",   "9.2.0.1", "4718.02|569 MB",  "ZjLMZUklDYY", "2023",  "230419 ALERT! Beyond Our Brain REALITY! The SERPENT Deceived Us is a UNDERSTATEMENT, MUST SEE NEW EVIDENCE.mp4", "@The Lid Has BEEN RIPPED OFF the SERPENTS PUPPET SHOW. This is Empirical Evidence that AGAIN SUPPORTS the Reality That We are the Angels Trapped by a Host Body System and We have become the serpent race and we must be born again in order to Understand and KNOW the LORD GOD" ],
["230424-01","9.1.0.1", "1404.06|141 MB",  "hjmnRJnotw0", "2023",  "230424-01 DEAD Ringers.mp4", "@This continues to expose the twin female energy as the enemy." ],
["230424-02","9.2.0.1", "985.01|99.7 MB",  "mtenDkx9Mjc", "2023",  "230424-02 The Abomination That Causes DESOLATION! Could It Be Any More Obvious At This Point.mp4", "@The hieroglyph of Akhenaten said it all! Add that to the FACT that the Vatican is also a snake and we've seen serpents strangling sheep left and right, the abomination is the serpent race destroying the sheep from the inside." ],

["230424-03","7.0.0.1", "4675.01|553 MB",  "5ZLTD5Dh6Qc", "2023",  "230424-03 And he shall send his angels with a great sound of a trumpet, they shall gather together his elect.mp4", 
   "@15 When ye therefore shall see the abomination of desolation, spoken of by Daniel the prophet, stand in the holy place, (whoso readeth, let him understand:)(more)<br><br>16 Then let them which be in Judaea flee into the mountains:<br><br>17 Let him which is on the housetop not come down to take any thing out of his house:<br><br>18 Neither let him which is in the field return back to take his clothes.<br><br>19 And woe unto them that are with child, and to them that give suck in those days!<br><br>20 But pray ye that your flight be not in the winter, neither on the sabbath day:<br><br>21 For then shall be great tribulation, such as was not since the beginning of the world to this time, no, nor ever shall be.<br><br>22 And except those days should be shortened, there should no flesh be saved: but for the elect's sake those days shall be shortened.<br><br>23 Then if any man shall say unto you, Lo, here is Christ, or there; believe it not.<br><br>24 For there shall arise false Christs, and false prophets, and shall shew great signs and wonders; insomuch that, if it were possible, they shall deceive the very elect.<br><br>25 Behold, I have told you before.<br><br>26 Wherefore if they shall say unto you, Behold, he is in the desert; go not forth: behold, he is in the secret chambers; believe it not.<br><br>27 For as the lightning cometh out of the east, and shineth even unto the west; so shall also the coming of the Son of man be.(more)" ],
["230428-01",   "7.0.0.0", "2400.00|1.07 GB",  "", "2023",  "230428-01 Introduction for J. O'Keefe.mp4", "@Trying to open the door for the truth." ],
["230428-02",   "7.1.0.0", "5126.55|586 MB",  "ji4BRlftp9Y", "2023",  "230428-02 Therefore I say Watch He Will Come In a Hour You Do Not Expect.mp4", "@This is to encourage everybody that Jesus is coming, and YOU SHOULD BE LOOKING AND WAITING for Him, according to the scriptures. Also, defending the word." ],
["230430",      "7.1.0.0", "7408|941 MB",  "BVvVjS8DtdY", "2023",  "230430 Talk About a Confirmation ..The Time to Watch Is Now!! This was ALL Orchestrated !Must Watch.mp4", "@The last 48 Hours have beejn so over the top that it is gonna be a complete Mind Blower ....You Must Watch THIS Video BEFORE The Upcoming TESTIMONY where the Lord God Took me to The ART GALLERY For a Chinati Style Message to the Body of Christ.....PAY ATTENTION" ]

];
// Cap off
//if (isUncapped && KleckFiles_new.length) // local or end param '=' http
  KleckFiles = KleckFiles.concat(KleckFiles_new);


// 4.01 -- data unserver reorg to /KleckFiles.media/ + html/NewSettings.js
// 4.04 -- Updated 221112. Was first capped in 221014. 
var KleckFiles_RevNo = "4.45.00";  // Rev No  // Tools version in tools.html (top)

var KleckFiles_UpdateMessage = {
	active : false,   // enable / disable
	updateNum : 2,    // new number triggers new update message - user can dismiss
	textHrd : "Site Refresh 4.04",
	text : 'Welcome back. KleckFiles.com has been updated with the latest Jonathan Kleck video content.'
};


var ColorMap = [  // Default color is [1][1] or [0][0] or [0][n]
   ["#CFD8DC", "#CFD8DC", "#CFD8DC", "#CFD8DC", "#CFD8DC", "#CFD8DC"],
   ["#ECEFF1", "#CFD8DC", "#B0BEC5", "#90A4AE", "#90A4AE", "#90A4AE" ], // Gray Blue - Light to Dark
   ["#FAFAFA", "#f6f1f9", "#e6e1e9", "#d6d1d9", "#c1ccc9", "#d1ddd9" ], // Gray Light & Darker
   ["#efebe9", "#d7ccc8", "#c7bcb8", "#d7ccc8", "#d7ccc8", "#d7ccc8" ], // Brown L&D
   ["#ffddb0", "#ffc77d", "#ffaf49", "#ff9e22", "#fa8100", "#f47100" ], // [4] Orange 0 - 5
   ["#f5b6da", "#f186c0", "#ef4fa6", "#ee0290", "#ef0078", "#dd0074" ], // [5] Pink 0 - 5
   ["#c1dff4", "#9dcbee", "#7db7e5", "#67a8e0", "#579adb", "#4f8cce", "#2266dd" ], // [6] Blue 0 - 6
   ["#FBE9E7", "#FFCCBC", "#FFAB91", "#FF8A65", "#e15130", "#BF360C" ],  // [7] red 0 - 5
	["#E54756", "#c94", "#BF8D35", "#9C732C", "", ""], // [8] 1 Ryans Anthology
	["#f2e6ff", "#d9b3ff", "#bf80ff", "#a64dff", "#7300e6", "#5900b3"], // [9] purple - https://www.w3schools.com/colors/colors_picker.asp?colorhex=34568B
	["", "", "", "", "", ""]  // [10]
];
function ColorMap_UseWhiteText(v1, v2) {
	return (
		(v1 == 7 && v2 >= 4)
	|| (v1 == 6 && v2 >= 5)
	|| (v1 == 4 && v2 >= 5)
	|| (v1 == 5 && v2 >= 2)
	|| (v1 == 8)
	|| (v1 == 9 && v2 >= 3)
	);
}












// Atribs: "A.B.C.D" ; A.B=Index into Color Map; C=1 Skip Autoplay (non-playlist)
// File ID | Attrib | File Size | YouTube Link |  Rel Dir | Filename |  

// File count: 1,305 
// Total size: 247,599,136,768 B | 241,796,032 KB | 231 GB


// VID | Alt Youtube Mirrors |
var MissingYouTubeVideos = [
   [ "140620",      "lJ_eVqSnlMc"],         // mirror - Orig removed - The Eventuality ISIS Basilisk Eggs
	[ "200102-01",   "kpAfbyozU-A"],         // mirror - Orig not availabe in some countries
	[ "200102-02",   "kpAfbyozU-A?t=7124"],  // mirror - Orig not avail in some countries - This is NTag section of prev vid (I cut this out)
	[ "200124",      "VrvQjFkqU2k"]          // Mirror - Orig removed 
];

// level 1,2,3
var ccTranscriptionText = [
	"",
	"Status: Raw Machine Transcription",
	"Status: Editing Transcription",
   "Status: Published Transcription", "","","",""];

// given an idx into FleckFiles[] return the section (as array of indexes xx[]) it belongs to
function KleckFiles_FolderItems(idx, xx) {  // Given Idx into KleckFiles[] return xx[] of all indexs in folder
   var i;
   if (idx >= KleckFiles.length || idx < 0)
      return false;
	xx.length = 0;  // object - returns values by reference 
	var folder = KleckFiles[idx][4];
	var folderLen = folder.length;
   for (i = 0; i < KleckFiles.length; i++) { 
		if (folderLen === KleckFiles[i][4].length
		&& folder === KleckFiles[i][4]) 
			xx[xx.length] = i;             // build array of KleckFile[] indexes
		else if (xx.length) 
         return true;
   }
   return true;
}

function KleckFiles_GetTitle(idx) {
  var id = KleckFiles[idx][0];
  var dir = KleckFiles[idx][4];
  var fn = KleckFiles[idx][5];      // param 5 = filename
  fn = fn.replace(/%23/g,"#");       //  -> #
  fn = fn.replace(/%26/g,"&");       // & -> &
  var title = fn.substr(id.length + 1, fn.length - (id.length + 1) - 4);   // 4 is length '.mp3' ext
                   
  // 3rdParty section (last PlayList) items can have $by$ 
  if (dir === "3rdParty") {
		var xx = title.split("$by$");
		if (xx.length === 2)
			 title = xx[0]; /// + " - Author: " + xx[1];                      
  }
	
  // flag attribut x.x.2.x for alternative title?
  var flags = parseInt(KleckFiles[idx][1].split('.')[2]); 
  if (!isNaN(flags) && (flags & 2) == 2 && typeof _SMList == "object") 
	  title = _SMList.GetAltTitle(id) || title;
	
  return title;
}

function KleckFiles_Find(ID) {          // KFID -> return int index into KleckFiles[]
	var len = (typeof ID == "string") ? ID.length : 0;
	if (len != 6 && len != 9 && len != 10)  // range check: "201221" or "201221-01" or "201221-P01"
      return -1; 
   var i;
   for (i = 0; i < KleckFiles.length; i++) {
      if ((len === KleckFiles[i][0].length)  // first field is ID only Str param
      && (ID === KleckFiles[i][0]))        
        return i;
   }
   return -1;     
}

// new  4/3/2022
function KleckFiles_FindInPL(ID) {  // return true if ID is in a PlayList
  var iPL, n;
  for (iPL = 0; iPL < PlayLists.length; iPL++) 
  {
    for (n = 0; n < PlayLists[iPL][2].length; n++) 
    { 
       var kfId = PlayLists[iPL][2][n];
		 if (ID == kfId)
			 return true;
    }
  }
  return false;
}


function KleckFiles_PlayListItems(idx, xx) {  // Idx: idx of playlist. returns Idx of all KleckFiles videos as xx[]
   var n;
	xx.length = 0;
	for (n = 0; n < PlayLists[idx][2].length; n++) {
      var ID = PlayLists[idx][2][n];
		xx[xx.length] = KleckFiles_Find(ID);      //could be -1 item if ID not found
	}
   return (xx.length > 0);
}

function KleckFiles_PlayListItems_Total() {  // Returns total number of playlist videos
   var idx;
	var cc = 0;
	for (idx = 0; idx < PlayLists.length; idx++) {
      cc = cc + PlayLists[idx][2].length;
	}
   return (cc);
}

//const dNow = new Date();
//const dComplete = new Date(2021,6,5);  // 5th July 2012 - should complete project by this date
//(dNow > dComplete)


// Set this as soon as JS file is loaded
//var __SETTINGS_video_data_path = null;
//var __SETTINGS_video_poster_thumb = true;  // thumb poster path follows video path
//var __SETTINGS_Override = null;
function KleckFilesData_SetVideoDataPath(path, video_poster_thumb) {
	//__SETTINGS_video_data_path = path;
	//if (typeof video_poster_thumb == "boolean")
	//	__SETTINGS_video_poster_thumb = video_poster_thumb; // switch off to follow site
}
function KleckFilesData_Override(overrideRec) { // newer version
	//if (typeof overrideRec !== "undefined")
	//  __SETTINGS_Override = overrideRec;
}
function PackageOverride() // This just checks and packages __SETTINGS_Override settings we use  
{
	return {
		embedLocal : false, 
		useYoutube : true, 
		testing : false,
		debug : false
	};
}

  // ECMAScript 2015 allows default parameter values in the function declaration
   // But not Safari on my iPAd 4

function KleckFiles_Video(idx, params) { // YY is now returned
	var YY = {}; // return
	if (typeof idx == "string") // kfId passed in
		var idx = KleckFiles_Find(idx); // find ID
	
	var params = {
		// include SM:true for Social Media linkdata YY["yt"] & YY["youtube"]
		SM : (typeof params == "object" && typeof params.SM == "boolean") ? params.SM : false 
	};
	
	// Future
   var unlockCode = "";  
	if (typeof unlockCode === "undefined" || unlockCode == null) unlockCode = "";
	
	// Future
	var _override = PackageOverride();  // default = allow YouTube = true
	YY["override"] = _override;

   var 
	  kfid = KleckFiles[idx][0],
	  linkdata = null,
	  socialMedia = KleckFiles[idx][3];
	
	// Old System - Keep for backward compatibility
	//
	if (socialMedia.startsWith("*"))  //skip star (old method)
		socialMedia = socialMedia.substr(1); 
   if (socialMedia && socialMedia.indexOf("/") < 0) {  // youttube = 11 char asset id - no path -- others assets have a / 
		// 2 remaining youtube playlists
		if (kfid.length == 10) {
		  if (kfid.charAt(7) == "B") // Be4theFire folder "120812-B01"  ...
				socialMedia = socialMedia + "&list=PL2E9F6AEAD63939E1";
		  else if (kfid.charAt(7) == "M") // Just a Messenger Series "090424-M00"
				socialMedia = socialMedia + "&list=PL649FB566437C77C0"; 
		}
		socialMedia = 'https://youtu.be/' + socialMedia;
   }
		
	// New Social Media Link System -- Requires Social Media flag params.SM
	// Any use of YY["yt"] = YY["youtube"]
	// 
	if (params.SM) 
	{
		if  (typeof __LINKDATA == "function") {
			linkdata = new __LINKDATA(idx);        
			if (linkdata.data.length)	                  // garenteed every KF item has link data in pref order
				socialMedia = linkdata.data[0].fullLink;  
		}
		else alert('*** Please Refresh page or Clear your browser cache: Function KF_EXTRA.js > __LINKDATA() not available');	

	} 
	YY["linkdata"] = linkdata;   // social media link data
   YY["yt"] = socialMedia.replace("/$/embed/", "/");   // make sure an odysee embed link flatterned
   YY["youtube"] = YY["yt"];  


   var 
	  folder = KleckFiles[idx][4],
     filename = KleckFiles[idx][5];
   
   YY["id"] = kfid;
	var lenSize = KleckFiles[idx][2].split('|');
	YY["duration"] = parseFloat(lenSize[0]);
   YY["size"] = lenSize[1];
   YY["date"] = "20" + kfid.substr(0, 2) + "-" + kfid.substr(2, 2) + "-" + kfid.substr(4, 2);
   YY["file"] = "video/" + folder + "/" + filename;
 	YY["poster"] = "video/poster/" + kfid + '.jpg';
	YY["thumb"] = "video/thumb/" + kfid + '.jpg';
	YY["poster_thumb_dir"] = "video/";
	YY["vdir"] = "video/";
	
   YY["filename"] = filename;
   YY["dir"] = folder;
   YY["folder"] = folder;
	
   // Apply __GLOBALS.path data 
	//
	YY["file"] = __GLOBALS.path.video + folder + "/" + filename;
	YY["poster"] = __GLOBALS.path.video_poster + kfid + '.jpg';
	YY["thumb"] = __GLOBALS.path.video_thumb + kfid + '.jpg';
	  var thmPos = __GLOBALS.path.video_thumb.indexOf('/thumb/'); // '/KleckFiles.media/video/thumb/'
	YY["poster_thumb_dir"] = __GLOBALS.path.video_thumb.substr(0, thmPos+1);
	YY["vdir"] = __GLOBALS.path.video;	
		
   YY["koofr_folder"] = "https://k00.fr/KFILES_"+folder;
   YY["koofr"] = "https://k00.fr/KF"+kfid.replace("-","_"); // KF+ID with underscore
	
	// short rel web path
	
   //YY["wwwfile"] = "video" + unlockCode + "/" + folder + "/" + filename; 
	//YY["wwwPoster"] = "video" + unlockCode + "/poster/" + kfid + '.jpg'; 
	
   YY["wwwfile"] = __GLOBALS.path.video + folder + "/" + filename.replace(/[+]/g,"%2B"); 
	YY["wwwPoster"] = __GLOBALS.path.video_poster + kfid + '.jpg'; 
	YY["wwwThumb"] = __GLOBALS.path.video_thumb + kfid + '.jpg'; 
	
	// full server path
	
   //YY["www"] = "http://www.kleckfiles.com/" + YY["wwwfile"]; // full server path
	//YY["www2"] = "http://www.kleckfiles.com/" + YY["wwwfile"].replace(/ /g,"%20");
	//YY["www_poster"] = "http://www.kleckfiles.com/" + YY["wwwPoster"];   
	
	YY["www"] = __GLOBALS.webDataPath + "video/" + folder + "/" + filename.replace(/[+]/g,"%2B");
	YY["www2"] = YY["www"].replace(/ /g,"%20");
	YY["www_poster"] = __GLOBALS.webDataPath + "video/poster/" + kfid + '.jpg';
	YY["www_thumb"] = __GLOBALS.webDataPath + "video/thumb/" + kfid + '.jpg';
   
   YY["title"] = KleckFiles_GetTitle(idx);
   YY["attribs"] = KleckFiles[idx][1].split('.');  // c.c.0.s -- color.color.0.scribeStatus
   YY["scribe"] = "scribe.html?" + kfid;  // path to scribe file
	
	return YY;
}




var __unique_embed_Id = 0;
// this kills the spinner in the DIV iFrame wrapper
function KillLoadingSpinner(id) {
	var el = document.getElementById("_spinnerDivWrap_"+id);
	if (el)
		el.style.backgroundImage = "none";
}



	function StripALinks(text) {
	  do { // no markup
		 var text = text.replace("</a>", "");
		 var p1 = text.indexOf('<a');
		 var p2 = text.indexOf('>', p1);
		 var ok = (p1 >= 0 && p2 > p1);
		 if (ok) {
			 var text = text.substring(0, p1) + text.substring(p2+1);
		 }
		 //if (text.indexOf(' invite') >= 0)
		 //	 alert([p1, p2, text]);
	  } while (ok);
	  return text;
	}

  // Video comments start with @ in paparm 6
  function KF_GetItemSubTitle(idx, flat) {
      var subTitle = '';

      // Extra Param Sub-Title? Video comment starts with @
      if (KleckFiles[idx].length >= 7 && KleckFiles[idx][6].length !== 0) 
      {   
			var ss = KleckFiles[idx][6].split('|');

			if (ss[0].startsWith('@'))
			   subTitle = ss[0].substr(1);
			else 
			if (ss.length >= 2 && ss[1].startsWith('@'))
			   subTitle = ss[1].substr(1);  
			
			// take the shorter version
			if (subTitle == '') {
				if (ss[0].startsWith('*'))
				  subTitle = ss[0].substr(1); 
				else 
				if (ss.length >= 2 && ss[1].startsWith('*'))
				   subTitle = ss[1].substr(1);  				
			}
			
			// Take whatever is left
			if (subTitle == '')
				subTitle = ss[0];
			
			
			// flatten in to one liner
			if (typeof flat == "boolean" && flat) {
				subTitle = StripALinks(subTitle);
				// Encode stuff that screws up display
				subTitle = subTitle.replace(/["]/g, "&#34;"); 
				// the title="" uses \n not <br>
				subTitle = subTitle.replace(/<br>/g, "\n"); 
				//subTitle = subTitle.replace("<br>", "\n").replace("<br>", "\n").replace("<br>", "\n"); 
			}
			
      }
      return subTitle;
  }


  // onclick="__page1.goto('+idx+')"

  function KF_GotoVideoPageItem(kfId) {
	  var idx = KleckFiles_Find(kfId);
	  // try opening KleckFiles tab 1 at the video
	  if (idx >= 0 && typeof __page1 != "undefined" && typeof __page1.goto == "function")  // local function in index.html
		  __page1.goto(idx);
	  else 
		  window.open('index.html?1&' + kfId);  // index.html?1&121022-B17	  	  
  }

  function KF_CopyToClipboard(str) {
		var el = document.createElement('textarea');
		el.value = str.replace(/[|]/g, "\n");
		el.setAttribute('readonly', '');
		el.style = {position: 'absolute', left: '-9999px'};
		document.body.appendChild(el);
		el.select();
		document.execCommand('copy');
		document.body.removeChild(el);
		alert('Text was copied to clipboard');
  }

  function iFrame_vidLoad(el, uniqueEmbedId) {

	  // kill spinner
	  KillLoadingSpinner(uniqueEmbedId);

	  //var isLoaded = el && el.contentWindow && el.contentWindow.window.length; // 0 or 1
	  //if (!isLoaded) {
	  //	  el.outerHTML = '<div style="padding:12px 4px;"><mark>** Could not load web media</mark></div>';
	  //}
	  
  }
  function iFrame_vidLoadError(el, uniqueEmbedId) {  //doesn't fire on <iframe>
	  
	  // kill spinner
	  KillLoadingSpinner(uniqueEmbedId);
	  
	  //var isLoaded = el && el.contentWindow && el.contentWindow.window.length; // 0 or 1
	  //alert('iframe Error Hello: uniqueEmbedId='+uniqueEmbedId + ', window.length='+isLoaded);

 }



var _fallbackCode = [];


  // This will never fire under preload="metadata"
  function Local_vidLoad(el, uniqueEmbedId) {
	  // kill spinner
	  KillLoadingSpinner(uniqueEmbedId);	
	  
	  // scrap fallback code
	  if (typeof _fallbackCode[uniqueEmbedId] == "string")
	    _fallbackCode[uniqueEmbedId] = null;
  }

  // This will fire under preload="metadata"
  function OnLoadedMData(el, uniqueEmbedId) { // onloadedmetadata -- video dimentions now available
		// retrieve dimensions - grow height
		var height = el.videoHeight;
		var width = el.videoWidth;
		var rect = el.getBoundingClientRect(); //left, top, right, bottom, x, y, width, height
		if (height > 0 && width > 0 && height !== width) {
			var newH = (rect.width * height) / width;
			//alert('vid file: '+ width +' x '+ height +', vid ctrl dim: '+rect.width+' x '+rect.height + ", newH="+newH);
			//calculate correct ctrl height
			if (newH > 327)  // default set below
			  el.style.height = newH + "px";
		}
	   
	   // kill spinner
	   KillLoadingSpinner(uniqueEmbedId);	
	  
	   // scrap fallback code
	   if (typeof _fallbackCode[uniqueEmbedId] == "string")
	     _fallbackCode[uniqueEmbedId] = null;
  }

  function Local_vidLoadError(el, uniqueEmbedId) {  // this does fire for <video> el
	  // kill spinner
	  //KillLoadingSpinner(uniqueEmbedId);
	  
	  // probably poster not found -- Reload without poster
	  if (el) {
		  var poster = el.getAttribute("poster");
		  if (poster) {
			  el.removeAttribute("poster");
			  el.load();  // try reload - most local vids don't have a poster
		  }
		  else {
	       //el.outerHTML = '<div style="padding:12px 4px;"><mark>** Local video file not found</mark></div>';
			 if (typeof _fallbackCode[uniqueEmbedId] == "string") {
			 	 el.outerHTML = _fallbackCode[uniqueEmbedId]; 
				 _fallbackCode[uniqueEmbedId] = null; // mark used
			 }
			 else 
				 KillLoadingSpinner(uniqueEmbedId);
		  }
	  }
  }

  function PauseAllVideos(el) { //pause all except el
	  var i, vids = document.getElementsByTagName('video'); // <video >
	  for (i = 0; i < vids.length; i++) {
		 if (vids[i] != el && !vids[i].paused)
		    vids[i].pause();
	  }
  }

  function OnPlayEvent(el) {  // onplay="OnPlayEvent(this)"
	  PauseAllVideos(el);
  }





// params.className = supply a class name we can look up
// params.titles = show video title (on home page)
// params.small = small videos
// params.altSrc = alternate video source
// params.forceSM = If SM data can be found then use it
// params.smIdx = Supply a social media index. Value also returned.
// params.callbackID = a callback ID string used by a function VideoLoad_Callback(el, callbackID); listener

// size of thumb 320 x 180 

function GetSocialMediaType(idx, params) {
	var fObj = (typeof params == "object");
	var params = { 
		titles : (fObj && typeof params.titles == "boolean") ? params.titles : false,
		small : (fObj && typeof params.small == "boolean") ? params.small : false,
		altSrc : (fObj && typeof params.altSrc == "boolean") ? params.altSrc : false,
		forceSM : (fObj && typeof params.forceSM == "boolean") ? params.forceSM : false,
		smIdx : (fObj && typeof params.smIdx == "number") ? params.smIdx : 0,
		className : (fObj && typeof params.className == "string") ? params.className : "",
		callbackID : (fObj && typeof params.callbackID == "string") ? params.callbackID : ""
	}; 
	var UsingKleckFiles = params.smIdx == -1;  // caller want to show KleckFiles hosted video
	
	// container width - Video WidthHeight
	if (params.small) 
	{ var CMaxWidth = '300px', WidthHeight = 'width:300px;height:170px;'; }  // add fudge 160 +10
	else 
	{ var CMaxWidth = '600px', WidthHeight = 'width:600px;height:335px;'; }  // add fudge 320 +15

	
	var YY = KleckFiles_Video(idx, {SM : true});
	
	// Cap at escential 5 Media types
	// 
	if (YY.linkdata &&  YY.linkdata.data 
	 && YY.linkdata.data.length > 5 && typeof _SMList.TrimData_OneOfEach == "function") 
		 YY.linkdata.data = _SMList.TrimData_OneOfEach(YY.linkdata.data);	
	
	var socialMedia = '';
	var mType = mediaType.none;
	if (YY["linkdata"] && YY["linkdata"].data.length > 0 && params.smIdx >= 0) {    
		if (params.smIdx > YY["linkdata"].data.length)  // range check
				params.smIdx = 0;
		socialMedia = YY["linkdata"].data[params.smIdx].embedLink;
		mType = YY["linkdata"].data[params.smIdx].mType;
	}
		
	
	// DIV Container for iframe
	__unique_embed_Id++;
	
	// onLoad callback code 
	var onLoadCallback = 'if (typeof VideoLoad_Callback == \'function\') VideoLoad_Callback(this, \''+params.callbackID+'\');';
	
	var altStyle = '';
	if (params.titles) altStyle = 'vertical-align:top;padding:8px 8px 12px 8px;margin:6px;text-align:left;';
		
	// vid container with BG spinner -- No Height going to expand to 600px max
	var divStyle = altStyle+'width:100%; max-width:'+CMaxWidth+'; display:inline-block;border:1px #eee none; margin:auto;',
	    SpinnerStyle = 'background:url(\'html/images/spinner1.gif\') no-repeat 50% 30%;',
	    divLoading = '<div id="_spinnerDivWrap_'+__unique_embed_Id+'" style="'+SpinnerStyle+divStyle+'" >',
		 divNormal = '<div style="'+divStyle+'" >',
		 iframeClassName = (params.className) ? 'class="'+params.className+'" ' : '',
	    
		 iFrame_onLoadEvent = 'frameborder="0" '
	      +iframeClassName 
	      +'allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; fullscreen" '
	      +'webkitallowfullscreen="true" mozallowfullscreen="true" allowfullscreen="true" '
		   +'onload="iFrame_vidLoad(this, '+__unique_embed_Id+');'+onLoadCallback+'" '
	      +'onerror="iFrame_vidLoadError(this, '+__unique_embed_Id+')"'; //doesn't fire on iframe
		
	var divEnding = '</div>',
		 titleBlock = '';
	
	if (params.titles) {  
		
		var vidTitle = StripALinks(YY.title);
		var subTitle = KF_GetItemSubTitle(idx, true); // true to flatten into one line
		
		var okSelect = '-webkit-user-select:text;-ms-user-select:text;user-select:text;';
		
	   var onclickCode = ' onclick="event.stopPropagation();event.stopImmediatePropagation();KF_GotoVideoPageItem(\''+YY.id+'\')" ';
		var kFileLink = '<span '
		  +' style="cursor:pointer;text-decoration:underline" '
		  +' title="KleckFile Id: '+YY.id+'" '
		  +onclickCode+'>KleckFile '+YY.id+'</span>';
		
		var published = 'Published ';
		if (params.small) published = ''; // tight for space
		
		titleBlock = '<div style="cursor:pointer;margin-right:14px;" '+onclickCode+'>'
						  +'<div style="color:#777;padding:6px 0px 4px 0px;font-size:70%;white-space: nowrap;overflow: hidden;text-overflow: ellipsis;">'
								+published+YY.date+' 🕓 Texas time GMT-6, '+kFileLink+'</div>'
						  +'<div style="color:#777;padding:4px 0px 3px 0px;font-size:100%;font-weight:bold;white-space: nowrap;overflow: hidden;text-overflow: ellipsis;" title="'+vidTitle+'">'
								+vidTitle+'</div>'
						  +'<div style="color:#777;padding:0px 0px 4px 0px;font-size:80%;white-space: nowrap;overflow: hidden;text-overflow: ellipsis;" title="'+subTitle+'">'
								+subTitle+'</div>'
		           + '</div>';
   
	}
	
   var sm = {mType : mType,
				 smIdx : params.smIdx,
				 linkdata : YY["linkdata"],
		
		       type : 0, 
				 color : '#ddd', 
				 site : '', 
				 class : '', 
				 embed : '',
				 core : ''}; 

	

	// Default : embed Koofr img + link. You would see this if Local display failed 
	//
	sm.type = 5; 
	sm.color = 'LimeGreen';
	sm.site = 'Koofr';
	sm.class = 'info_Koofr';
	sm.core = '<div onclick="event.stopPropagation();event.stopImmediatePropagation();window.open(\''+YY["koofr"]+'\');"><img style="display:inline-block;width:100%;max-width:600px;" src="html/images/Koofr.jpg"></div>' 
	sm.embed = divNormal 
		       +sm.core 
		       +titleBlock 
		       +divEnding;


	// no path or full YouTube path ==> YouTube
	if (mType == mediaType.youtube) {
	  sm.type = 1;
	  sm.color = 'red';
	  sm.site = 'Youtube';
	  sm.class = 'info_youtube';			  
	  sm.core = '<iframe '+iFrame_onLoadEvent+' title="YouTube" style="'+WidthHeight+'max-width:100%;max-height:100%;border:none;" src="'+socialMedia+'"></iframe>'; 
	  sm.embed = divLoading
					+sm.core +titleBlock
					+divEnding; 
	}
	else if (mType == mediaType.brighteon) {
		  sm.type = 2;
		  sm.color = 'blue';
		  sm.site = 'Brighteon';
		  sm.class = 'info_bright';
		     //var __wh = 'width:600px;height:355px;';  // need extra  height for Brighteon banner adds
		  //sm.core = '<iframe '+iFrame_onLoadEvent+' title="Brighteon" style="'+__wh+'max-width:100%;max-height:100%;border:none;" src="'+socialMedia+'"></iframe>';
		  sm.core = '<iframe '+iFrame_onLoadEvent+' title="Brighteon" style="'+WidthHeight+'max-width:100%;max-height:100%;border:none;" src="'+socialMedia+'"></iframe>';
		  sm.embed = divLoading
						 +sm.core +titleBlock
						 +divEnding;		
  	}
  	else if (mType == mediaType.odysee) {	  
		  sm.type = 3;
		  sm.color = 'orange';
		  sm.site = 'Odysee';
		  sm.class = 'info_odysee';
		  sm.core = '<iframe '+iFrame_onLoadEvent+' title="Odysee" style="'+WidthHeight+'max-width:100%;max-height:100%;border:none;" src="'+socialMedia+'"></iframe>';
		  sm.embed = divLoading
						 +sm.core +titleBlock
						 +divEnding;
   }
   else if (mType == mediaType.bitchute) {
		  sm.type = 4; 
		  sm.color = 'black';
		  sm.site = 'Bitchute';
		  sm.class = 'info_bitch';
		  sm.core = '<iframe '+iFrame_onLoadEvent+' title="Bitchute" style="'+WidthHeight+'max-width:100%;max-height:100%;border:none;" scrolling="no" src="'+socialMedia+'"></iframe>';
		  sm.embed = divLoading
						 +sm.core +titleBlock
						 +divEnding;
   }      
   else if (mType == mediaType.archive) { 
		  sm.type = 6; 
		  sm.color = 'black';
		  sm.site = 'Archive';
		  sm.class = 'info_archive';
 		  sm.core = '<iframe '+iFrame_onLoadEvent+' title="Internet Archive" src="'+socialMedia+'" style="'+WidthHeight+'max-width:100%;max-height:100%;border:none;"></iframe>';
		  sm.embed = divLoading
						 +sm.core +titleBlock
						 +divEnding;
	}
   else if (mType == mediaType.rumble) { 
		  sm.type = 7; 
		  sm.color = 'LimeGreen';
		  sm.site = 'Rumble';
		  sm.class = 'info_rumble';
 		  sm.core = '<iframe '+iFrame_onLoadEvent+' title="Rumble" src="'+socialMedia+'" style="'+WidthHeight+'max-width:100%;max-height:100%;border:none;"></iframe>';
		  sm.embed = divLoading
						 +sm.core +titleBlock
						 +divEnding;
	}

	// Local embed
	//
	var doEmbedLocal = ( !isHTTP   // local download -- try it
			  || mType == mediaType.none
			  || socialMedia == ''
	        || YY["override"].embedLocal  // force local enabled
	);                    
	
	// force alt source 
	if (params.altSrc && socialMedia && mType) {  // socialMedia == something to flip between
		if (isHTTP)
		  doEmbedLocal = true;  // not the norm - web site usually embeds web social media
		else 
		  doEmbedLocal = false;  // not the norm - local install uses uses local files
	}
	
	// override - want SM site
	if (doEmbedLocal && params.forceSM && mType && socialMedia) {
		doEmbedLocal = false;
	}
	
	
	if (doEmbedLocal)
	{
		_fallbackCode[__unique_embed_Id] = sm.core; // as calculated above
		
		var videoFile = YY["file"];
		var posterFile = YY["poster"];
	
		// container div constraint is 600px max -- autoplay
		var eStyle = ' style="'+WidthHeight+'max-width:100%;max-height:100%;object-fit:cover;"'; 
		
		sm.core = '<video ' 
			  + eStyle 
			  + ' src="'+videoFile+'" '
		     +' onclick="event.stopPropagation();event.stopImmediatePropagation();"' //stop propafation to expando
		     +' poster="'+posterFile+'"'
		
		     +' preload="metadata"'  // This will cause early fire to get size
		
		     +' onloadedmetadata="OnLoadedMData(this, '+__unique_embed_Id+');'+onLoadCallback+'"' // Load event works with preload="metadata"
		     +' onload="Local_vidLoad(this, '+__unique_embed_Id+');"'  // this wont fire with preload="metadata"
		
			  +' onplay="OnPlayEvent(this);"'   // stop others playing
		     +' onerror="Local_vidLoadError(this, '+__unique_embed_Id+');"'

		     +' type="video/mp4" controls></video>';
		
		sm.embed = divLoading
					 +sm.core +titleBlock
					 +divEnding;
		
		
		// the fallback is Kleckfiles.com web site
		if (UsingKleckFiles) 
		{
			var videoFile = YY["www"];
		   var posterFile = YY["www_poster"];	
			
			_fallbackCode[__unique_embed_Id] = '<video ' 
				  + eStyle 
				  + ' src="'+videoFile+'" '
				  +' onclick="event.stopPropagation();event.stopImmediatePropagation();"' //stop propafation to expando
				  +' poster="'+posterFile+'"'

				  +' preload="metadata"'  // This will cause early fire to get size

				  +' onloadedmetadata="OnLoadedMData(this, '+__unique_embed_Id+');'+onLoadCallback+'"' // Load event works with preload="metadata"

				  +' onplay="OnPlayEvent(this);"'   // stop others playing
				  +' onerror="Local_vidLoadError(this, '+__unique_embed_Id+');"'

				  +' type="video/mp4" controls></video>';		
		}
		
	}	
	        
   return sm;
}






// Notes
/*  -- Note - Use Color to group sections - Bold with white text for section headings. Else pale colour & black text. 

 illegal filename chars
 Windows / ? < > \ : * | " (and ^ for FAT)
 
Removed duplicate 
"200124 The MOST PROFOUND REVELATION of Scripture and Evidence EVER that I have Received! ALL Glory to Jesus.mp4" ],


*/


